<?php
/**
* Weryfikacja danych formularza.
*
* @author  m@sote.pl
* @version $Id: FormPinFunctions.inc.php,v 1.1.1.1 2006/09/02 13:23:47 marek Exp $
* @package    admin_users
* @subpackage pin
*/

/**
* Klasa z funkcjami weryfikujcymi dane dot. pinw.
*
* @package admin_users
* @subpackage pin
*/
class FormPinFunctions extends FormCheck {
    
    /**
    * Sprawd, czy poprawny jest aktualny PIN.
    *
    * @param string $pin PIN
    * @return bool
    */
    function f_pin($pin) {
        global $config;
        if (md5($pin)==$config->md5_pin)
        return true;
        return false;
    } // end f_pin()
    
    /**
    * Sprawdzenie nowego wprowadzonego PINu.
    * Sprawdzenie jest pominite, ale mona rozszerzy to w przyszosi. Obecnie system zapamituje
    * wprowadzon warto do porwnania powtrzenia PINu.
    *
    * @param string $new PIN
    * @return bool
    */
    function f_new($new) {
        if (! empty($new)){
            $this->new=$new;
            return true;
        } else return false;
    } // end d_new()
    
    /**
    * Sprawd, czy poprawnie wprowadzono potwierdzenie PIN.
    *
    * @param string $new2 PIN - powtrzenie
    * @return bool
    */
    function f_new2($new2) {
        if (@$this->new==$new2) return true;
        return false;
    } // end f_new2()
    
} // end class FormPinFunctions
?>
