<?php
/**
* Sprawd poprawnosc formularza, dodatkowe funkcje.
*
* @author m@sote.pl
* @version $Id: form_check_functions.inc.php,v 1.2 2007-09-03 13:21:55 bartek Exp $
* @package    admin_users
*/

/**
* Obsluga kodowania + klucze.
*/
require_once ("include/keys.inc.php"); global $__key,$__secure_key;
/**
* Klasa kodowania danych.
*/
require_once ("include/my_crypt.inc");
require_once ("include/security.inc");
$my_crypt = new MyCrypt;

/**
* Klasa z dodatkowymi funkcjami validacji pl formularza.
* @package admin_users
* @ignore
*/
class FormCheckFunctions extends FormCheck {

    /**
    * Sprawd, zapamitaj numer ID.
    *
    * @param int $id ID
    * @return true
    */
    function id($id) {
        $this->id=$id;
        return true;
    } // end id()

    /**
    * Sprawd, zapamitaj id grupy uytkownikw.
    *
    * @param int $type ID grupy
    * @return true 
    */
    function id_admin_users_type($type) {
        $this->type=$type;
        if ($type==1) $this->superadmin=1;
        else $this->superadmin=0;
        return true;
    } // end id_admin_users_type()

    /**
    * Sprawd stare/obecne haso.
    * Opcja ta pojawia si tylko gwnemu adminowi (super admin), wic 
    * weryfikacja zostaa pominita.
    *
    * @param string $password stare haslo
    * @return true
    */
    function password($password) {
        return true;
        /*
        global $db;
        global $my_crypt;
        global $__secure_key;

        if  ($this->superadmin!=1) return true;

        // sprawdz obecne haslo uzytkownika
        $query="SELECT password FROM admin_users WHERE id=?";
        $prepared_query=$db->PrepareQuery($query);
        if ($prepared_query) {
        $db->QuerySetInteger($prepared_query,1,$this->id);
        $result=$db->ExecuteQuery($prepared_query);
        if ($result!=0) {
        $num_rows=$db->NumberOfRows($result);
        if ($num_rows==1) {
        $crypt_password=$db->FetchResult($result,0,"password");
        // odkoduj haslo dla celow porownania
        $decrypt_password=$my_crypt->endecrypt($__secure_key,$crypt_password,"de");
        if ($decrypt_password==$password) {
        return true;
        } else return false;
        } else die ($error->error("admin_users_not_found"));
        } else die ($db->Error());
        } else die ($db->Error());

        return false;
        */
    } // end password()

    /**
    * Sprawd, czy zostao wprowadzone nowe haso.
    *
    * @param string $password nowe haso
    * @return bool
    */
    function new_password($password) {
        $this->new_password=$password;
     
        return SSecurity::systemPassword($password);
    } // end new_password()

    /**
    * Sprawd, czy potworzone nowe haslo jest poprawne.
    *
    * @param string $password2 nowe haso - powtrzone
    * @return bool
    */
    function new_password2($password2) {
        if ($this->new_password==$password2) return true;
        return false;
    } // end new_password2()

    /**
     * Sprawdzamy czy istnieje ju taki login
     * Wywoywane tylko podczas dodawania nowego admina
     *
     * @author ukasz
     * @param string $login
     * @return bool
     */
    function login($login) {
        global $db;
        // robimy update czy dodajemy nowego ?
        if (empty($this->id)) {
            $query = "SELECT id FROM admin_users WHERE login=?";
        } else {
            $query = "SELECT id FROM admin_users WHERE login=? AND id!=?";
        }
        $preparedquery = $db->PrepareQuery($query);
        if ($preparedquery) {
            $db->querySetText($preparedquery,1,$login);
            if (empty($this->id)) {
                $db->querySetText($preparedquery,2,$this->id);
            }
            $result=$db->ExecuteQuery($preparedquery);
            $num_rows=$db->NumberOfRows($result);
            if ($num_rows!=0) {
                // jeeli znalazlem jakies wiersze w bazie - to znaczy ze mam juz usera o takim loginie i innym id
                $__id=$db->FetchResult($result,0,"id");
                if ($__id!=$this->id) {
                    return false;
                }
            }
            return true;
        }
    } // end login()
} // end class FormChceckFunctions
?>
