<?php 
/**
 * Klasa obslugujace wywolania ajaxowe dla formularzy allegro
 *
 * @author lukasz.andrzejak@sote.pl
 * @package edit
 * @subpackage editAllegro
 * @version $Id: ajax_allegro.inc.php,v 1.3 2007/01/22 11:52:13 lukasz Exp $
 */


include_once("plugins/_allegro.pl/include/allegro.inc.php");
include_once("plugins/_allegro.pl/include/paramsParser.inc.php");
include_once('lib/xajax/xajax.inc.php');

/**
 * Klasa jest rozszerzeniem klasy allegro, ale dodaje modul ajaxa i wymagane metody
 *
 */
class ajaxAllegroParams extends SAllegro {
    
    /**
     * ??? Chyba do wywalenia, zapomnialem do czego to jest, ale mialo trzymac jakis obiekt
     *
     * @deprecated 
     * @ignore 
     * @var unknown_type
     */
    private $_allegro=NULL;
    
    /**
     * Obiekt ajaxa do ktorego trzeba sie za kazdym razem odwolywac
     *
     * @var object
     */
    public $xajax=NULL;
    
    /**
     * Konstruktor
     * Tworzymy obiekt ajaxa i nadajemy mu odpowiednie metody
     *
     */
    public function __construct() {
        parent::__construct();
        $this->xajax= new xajax(NULL,NULL,'iso-8859-2');
//        $this->xajax->debugOn();
        $this->register();
    }
    
    /**
     * Sprawdzamy sumy kontrolne parametrow
     * (zeby wiedziec czy sie zmienily)
     * 
     * 
     * @todo jezeli zmienia sie tylko idi kategoria to musimy odmalowac formularz.
     * Jezeli dany parametr wystepuje w kilku kategoriach naraz to jest robiony duplikat
     * Jezeli jest robiony duplikat to nadawane jest nowe id
     * Jezeli id nie byloby kluczem to mozna by nadawac jednemu id kilka kategorii
     * I nie trzeba byloby odmalowywac formularza
     * Przyklad - patrz "Komputery klasy PC >> Klasy Pentium III"/ "Pentium II"
     * @param array $params parametry wyciagnenie z bazy
     * @return bool
     */
    private function _checksum ($params) {
        // jezeli paramsy sa puste to mozemy wyslac zero, i skasowac poprzednia md5
        if (!is_array($params)) {
            $_SESSION['allegro_params_md5']='';
            return false;
        }
        // zahashuj mnie jezeli chcesz miec dobre id, ale czesto przeladowywac formularz
//        foreach ($params as $key=>$value) {
//            $params[$key]['sell_form_id']='';
//            $params[$key]['sell_form_cat']='';
//        }
        $checksum=md5(serialize($params));
        $old_checksum=@$_SESSION['allegro_params_md5'];
        $_SESSION['allegro_params_md5']=$checksum;
        if ($checksum==$old_checksum) return true;
        return false;
    }
    
    /**
     * Pobieramy parametry i pokazujemy je jezeli sie nie zmienily
     * Jezeli nie ulegly zmianie - nie ma sensu pokazywac
     * Szczegolnie ze niektore przegladarki resetuja na nowo namalowany formularz
     * W skutek tego uzyktownik musi wprowadzac dane jeszcze raz mimo ze nie zmienil sie formularz
     * 
     *
     * @param int $cat_id id kategorii
     * @return object xajaxResponse
     */
    public function getAllegroParams($cat_id) {
        $response=new xajaxResponse('iso-8859-2',true);
        $params=$this->getParametersById($cat_id);
        if ($this->_checksum($params)) {
            return $response;
        }
        $parser=new SAllegroParamsParser($params);
        $data=$parser->parse();
        if (empty($data)) $response->addClear('allegroParams','innerHTML');
        else
            $response->addAssign('allegroParams','innerHTML',$data);
        return $response;
    }
    
    /**
     * Rejestrujemy metody ajaxowe
     *
     * @return void
     */
    private function register() {
        $this->xajax->registerFunction(array('getAllegroParams',$this,'getAllegroParams'));
        return (0);
    }
}
?>
