<?php
/**
 * Konfiguracja importu danych z SOTEeSKLEP 3.0 do 3.1
 *
 * Definicje funkcji transferujcych i metod transformacji danych.
 * 
 * @author rdiak@sote.pl m@sote.pl
 * @version $Id: soteesklep25-config.inc.php,v 1.1.1.1 2006/09/02 13:34:33 marek Exp $
 * @package importshop
 */

$this->config=array
(
   	"users"=>array(
		"key"=>"id",
		"table"=>"users",
		"data"=>array(
			"id"=>array("function"=>"get_users_id"),
			"crypt_login"=>array("function"=>"null"),
			"crypt_password"=>array("function"=>"null"),
			"crypt_firm"=>array("function"=>"users_data_recode"),
			"crypt_name"=>array("function"=>"null"),
			"crypt_surname"=>array("function"=>"null"),
			"crypt_street"=>array("function"=>"users_data_recode"),
			"crypt_street_n1"=>array("function"=>"users_data_recode"),
			"crypt_street_n2"=>array("function"=>"users_data_recode"),
			"crypt_country"=>array("function"=>"users_data_recode"),
			"crypt_postcode"=>array("function"=>"users_data_recode"),
			"crypt_nip"=>array("function"=>"users_data_recode"),
			"crypt_city"=>array("function"=>"users_data_recode"),
			"crypt_phone"=>array("function"=>"users_data_recode"),
			"crypt_email"=>array("function"=>"null"),
			"crypt_cor_firm"=>array("function"=>"users_data_recode"),
			"crypt_cor_name"=>array("function"=>"users_data_recode"),
			"crypt_cor_surname"=>array("function"=>"users_data_recode"),
			"crypt_cor_street"=>array("function"=>"users_data_recode"),
			"crypt_cor_street_n1"=>array("function"=>"users_data_recode"),
			"crypt_cor_street_n2"=>array("function"=>"users_data_recode"),
			"crypt_cor_country"=>array("function"=>"users_data_recode"),
			"crypt_cor_postcode"=>array("function"=>"users_data_recode"),
			"crypt_cor_city"=>array("function"=>"users_data_recode"),
			"crypt_cor_phone"=>array("function"=>"users_data_recode"),
			"crypt_cor_email"=>array("function"=>"users_data_recode"),
			"date_add"=>array("function"=>"null"),
			"date_update"=>array("function"=>"null"),
			"crypt_ext_info"=>array("function"=>"null"),
			"last_ip"=>array("function"=>"null"),
			"checksum"=>array("function"=>"null"),
			"hurt"=>array("function"=>"null"),
			"id_discounts_groups"=>array("function"=>"null"),
			"record_version"=>array("function"=>"recordVersion"),
//			"limits"=>array("function"=>"_upgradeUser"),
		),
	),
	"order_register"=>array(
		"key"=>"id",
		"table"=>"order_register",
		"data"=>array(
			"id"=>array("function"=>"null"),
			"order_id"=>array("function"=>"null"),
			"session_id"=>array("function"=>"null"),
			"delivery_cost"=>array("function"=>"null"),
			"id_currency"=>array("function"=>"null","field"=>"user1"),
			"id_pay_method"=>array("function"=>"null"),
			"date_add"=>array("function"=>"null"),
			"time_add"=>array("function"=>"null"),
			"remote_ip"=>array("function"=>"null"),
			"crypt_email"=>array("function"=>"null","field"=>"user1"),
			"crypt_xml_user"=>array("function"=>"null","field"=>"user1"),
			"id_status"=>array("function"=>"null"),
			"crypt_name"=>array("function"=>"null","field"=>"user1"),
			"id_delivery"=>array("function"=>"null"),
			"confirm"=>array("function"=>"null"),
			"checksum"=>array("function"=>"null"),
			"id_partner"=>array("function"=>"null","field"=>"partner_name"),
			"confirm_partner"=>array("function"=>"null"),
			"confirm_user"=>array("function"=>"null"),
			"description"=>array("function"=>"null"),
			"send_date"=>array("function"=>"null"),
			"send_number"=>array("function"=>"null"),
			"send_confirm"=>array("function"=>"null"),
			"crypt_xml_user"=>array("function"=>"null","field"=>"user1"),
			"crypt_xml_description"=>array("function"=>"upgradeAll","field"=>"user1"),
			"record_version"=>array("function"=>"recordVersion"),
			"id_user"=>array("function"=>"null","field"=>"id_users"),
			"id_users_data"=>array("function"=>"get_order_id_users_data"),
			"amount"=>array("function"=>"null"),
		),
	),
	"main"=>array(
	    "key"=>"user_id",             
		"table"=>"main",              
 		"data"=>array(
 		    "id"=>"id",
 		    "user_id"=>"user_id",
 		    "photo"=>"photo",
 		    "xml_description"=>"xml_description_L0",
 		    "xml_short_description"=>"xml_short_description_L0",
 		    "xml_options"=>"xml_options",
 		    "promotion"=>"promotion",
 		    "newcol"=>"newcol",
 		    "bestseller"=>"bestseller",
 		    "main_page"=>"main_page",
 		    "active"=>"active",
 		    "date_update"=>"date_update",
 		    "date_add"=>"date_add",
 		    "name"=>"name_L0",
 		    "producer"=>"producer",
 		    "id_producer"=>"id_producer",
 		    "category1"=>"category1",
 		    "id_category1"=>"id_category1",			
 		    "category2"=>"category2",
 		    "id_category2"=>"id_category2",
 		    "category3"=>"category3",
 		    "id_category3"=>"id_category3",
 		    "category4"=>"category4",
 		    "id_category4"=>"id_category4",
 		    "category5"=>"category5",
 		    "id_category5"=>"id_category5",
			"price_brutto"=>"price_brutto",
            "id_currency"=>"id_currency",
            "vat"=>"vat",                     
			"price_brutto_detal"=>array("function"=>"changeOrZero"),	
			"id_available"=>"id_available",					
			"price_brutto_2"=>array("function"=>"changeOrZero"),
			"hidden_price"=>"hidden_price",
			"discount"=>"discount",
			"accessories"=>"accessories",
			"onet_category"=>"onet_category",
			"price_currency"=>"price_currency",
//			"url"=>"url",
			"user_score"=>"user_score",
			"max_discount"=>"max_discount",
			"onet_export"=>"onet_export",
			"onet_status"=>"onet_status",
			"onet_image_export"=>"onet_image_export",
			"onet_image_desc"=>"onet_image_desc",
			"onet_image_title"=>"onet_image_title",
			"onet_attrib"=>"onet_attrib",
		    ),
		),
	
	"newsedit"=>array(
		"key"=>"id",
		"table"=>"newsedit",
		"data"=>array(
			"id"=>"id",
			"date_add"=>"date_add",
			"active"=>"active",
			"ordercol"=>"ordercol",
			"subject"=>"subject",
			"category"=>"category",
			"short_description"=>"short_description",
			"description"=>"description",
			"photo_small"=>"photo_small",
			"photo1"=>"photo1",
			"photo2"=>"photo2",
			"photo3"=>"photo3",
			"photo4"=>"photo4",
			"photo5"=>"photo5",
			"photo6"=>"photo6",
			"photo7"=>"photo7",
			"photo8"=>"photo8",
			"id_newsedit_groups"=>array("function"=>"id_newsedit_groups"),
			),
		),
	
	"newsletter"=>array(
		"key"=>"id",
		"table"=>"newsletter",
		"data"=>array(
			"id"=>"id",
			"email"=>"email",
			"date_add"=>"date_add",
			"date_remove"=>"date_remove",
			"status"=>"status",
			"active"=>"active",
			"md5"=>"md5",
			"groups"=>"groups",
			),
		),	
	
	"newsletter_send"=>array(
		"key"=>"id",
		"table"=>"newsletter_send",
		"data"=>array(
			"id"=>"id",
			"user_id"=>"user_id",
			"date_add"=>"date_add",
			"time_start"=>"time_start",
			"time_stop"=>"time_stop",
			"active"=>"active",
			"subject"=>"subject",
			"message"=>"message",
			"mail_from"=>"mail_from",
			"category"=>"category",
			),
		),
	"onet_category"=>array(
		"key"=>"id",
		"table"=>"onet_category",
		"data"=>array(
			"id"=>"id",
			"id_user"=>"id_user",
			"name"=>"name",
			"description"=>"description",
			"display_name"=>"display_name",
			"sub_category"=>"sub_category",
			"id_over_category"=>"id_over_category",
			),
		),
	"onet_main_category"=>array(
		"key"=>"id",
		"table"=>"onet_main_category",
		"data"=>array(
			"id"=>"id",
			"name"=>"name",
			),
		),
	"order_id"=>array(
		"key"=>"order_id",
		"table"=>"order_id",
		"data"=>array(
			"order_id"=>"order_id",
			),
		),	
	"order_status"=>array(
		"key"=>"id",
		"table"=>"order_status",
		"data"=>array(
			"id"=>"id",
			"user_id"=>"user_id",
			"name"=>"name",
			),
		),	
	"producer"=>array(
		"key"=>"id",
		"table"=>"producer",
		"data"=>array(
			"id"=>"id",
			"producer"=>"producer",
			),
		),	
	"reviews"=>array(
		"key"=>"id",
		"table"=>"reviews",
		"data"=>array(
			"id"=>"id",
			"id_product"=>"id_product",
			"description"=>"description",
			"date_add"=>"date_add",
			"state"=>"state",
			"score"=>"score",
			"author"=>"author",
			"user_id"=>"user_id",
			"md5"=>"md5",
			),
		),
	"scores"=>array(
		"key"=>"id",
		"table"=>"scores",
		"data"=>array(
			"id"=>"id",
			"id_product"=>"id_product",
			"score_amount"=>"score_amount",
			"scores_number"=>"scores_number",
			),
		),
	"vat"=>array(
		"key"=>"id",
		"table"=>"vat",
		"data"=>array(
			"id"=>"id",
			"vat"=>"vat",
			),
		),		
);	
?>