<?php
/**
* Klasa gwna obslugi importu danych z innych porgramw.
*
* @author  m@sote.pl
* @version $Id: importshop_main.inc.php,v 1.6 2007/06/12 09:07:24 marcin Exp $
* @package importshop
*/

/**
* ImportShop
*/
require_once ("./include/importshop.inc.php");
require_once("include/image.inc");
require_once("include/ftp.inc.php");
require_once("include/httpFileDownload.inc");
require_once('lib/SProgress/SProgressMessage.inc.php');

/**
* Klasa gwna obslugi importu danych z innych porgramw.
* @package importshop
*/
class ImportShopMain extends SProgressMessage {
	var $offset=0;

	var $table;

	var $max_rows=100;
	/**
    * Skryt wykonujcy import danych.
    */
	var $action="import.php";

	/*
	* Zapamitane wartoi dla danego rekordu
	*/
	var $values=array();

	var $request;


	public function __construct($offset, $table, $request)
	{
		$this->offset=$offset;

		$this->table=$table;


		foreach ($request as $key=>$val) {
			$request[$key]=trim($val);
		}

		$this->request=$request;

		$this->db2=$this->connectDB2();
		$this->db2->Query("SET NAMES 'latin2'");
	}

	public function getDB2() {
		
		return $this->db2;
	}
	/**
    * Lista tabel do aktualizacji. Informacja.
    */
	function tablesInfo() {
		global $lang;
		print '<div style="text-align: center">';
		print "<p><b>$lang->importshop_warning_delete</b></p>\n";
		print "<p>".$lang->importshop_tables_info."</p>\n";
		print '<ul style="text-align: left">';
		reset($this->config);
		foreach ($this->config as $key=>$val) {
			print "<li>$key</li>\n";
		}
		print "</ul>";
		$this->_startForm();
		print "</div>";
		return;
	} // end _tablesInfo()

	/**
    * Formularz wywoania startu importu
    * 
    * @access protected
    */
	function _startForm() {
		global $lang,$_REQUEST, $theme;
		print "<p />\n";
		print "<form action=\"$this->action\" method=\"post\" id=\"startForm\" target=\"import\">\n";
		print "<input type=\"hidden\" name=\"item[type]\" value=\"".$this->request['type']."\">\n";
		print "<input type=\"hidden\" name=\"item[host]\" value=\"".$this->request['host']."\">\n";
		print "<input type=\"hidden\" name=\"item[database]\" value=\"".$this->request['database']."\">\n";
		print "<input type=\"hidden\" name=\"item[port]\" value=\"".$this->request['port']."\">\n";
		print "<input type=\"hidden\" name=\"item[login]\" value=\"".$this->request['login']."\">\n";
		print "<input type=\"hidden\" name=\"item[password]\" value=\"".$this->request['password']."\">\n";
		print "<input type=\"hidden\" name=\"item[shop_url]\" value=\"".$this->request['shop_url']."\">\n";
		$theme->new_button("",$lang->importshop_submit,"","window.open('', 'import', 'width=525,height=380,scrollbars=1,menubar=0,status=0,location=0,directories=0,toolbar=0,resizable=0');document.getElementById('startForm').submit();","center");
		//print "<input type=\"button\" value=\"$lang->importshop_submit\" onclick=\"\">\n";
		print "</form>\n";
	} // end _startForm()

	/**
    * Ustanw 2 poczenie z baz danych.
    *
    * @return mixed uchwyt bazy danych
    */
	function connectDB2() {
		global $_REQUEST,$import_shop;

		$import_shop = new ImportShop();
		$import_shop->_host=$this->request['host'];
		$import_shop->_port=$this->request['port'];
		$import_shop->_login=$this->request['login'];
		$import_shop->_password=$this->request['password'];
		$import_shop->_dbname=$this->request['database'];
		$import_shop->connectDB();
		
		return $import_shop->db2;
	} // end connectDB2()


	function getTableConfig()
	{
		return $this->config;
	}
	/**
    * Wykonaj import
    */
	function goImport() {
		return $this->_importTable();
	} // end goImport()

	/**
    * Importuj dane do wskazanej tabeli.
    *
    * @param string $table nazwa tabeli, do ktrej s importowane dane
    * @param mixed  $data  dane dot. metody transformacji danych do tabeli
    *
    * @access private
    * @return void
    */
	function _importTable() {
		global $db,$db_copy,$lang;

		$s_key=$this->config[$this->table]['key'];        // klucz tabeli rdowej (source key)
		$s_table=$this->config[$this->table]['table'];    // bazwa tabeli rdowej
		$s_data=$this->config[$this->table]['data'];      // opis co robimy z jakimi polami - tablica
		
		// usu rekordy zenowej tabeli
		if (!$this->offset) {

			$query="DELETE FROM $this->table";

			$result=$db->query($query);
			if ($result!=0) {
				// dane usunicie
				// @todo wykonanie kopii
			} else return ($db->error());
		}
		
		if (isset($this->config[$this->table]['max_rows'])) {
			$this->max_rows=$this->config[$this->table]['max_rows'];
		}
		
		$query2="SELECT * FROM $s_table ORDER BY $s_key LIMIT $this->offset,$this->max_rows";
		$prepared_query2=$this->db2->prepareQuery($query2);
		if ($prepared_query2) {
			$result2=$this->db2->executeQuery($prepared_query2);
			if ($result2!=0) {
				$num_rows2=$this->db2->numberOfRows($result2);
				for ($i=0;$i<$num_rows2;$i++) {
					$r=$this->_importRecord($result2,$i,$s_key,$s_data,$this->table);
				}
			} else return $this->db2->error()."<br />\n";
		} else {
			// prawdopodobnie nie ma wskazanej domeny w wersji programu
			// config moze odwoywa si do nowszej wersji
			return $db->error()."<br />\n";
		}

		return $num_rows2;
	} // end _importTable()
	/**
	 * Usuwa niedozwolone znaki z ciagu
	 *
	 * @param string $text
	 * @return string
	 */
	function replace_titles($text)
	{
		$search=array('.',' ','/','\'','\\','%','','','','','','','','','','','','','','','','','','');
		$replace=array('_','_','_','_','_','_','c','s','a','z','o','l','z','n','e','C','S','A','Z','O','L','Z','N','E');

		$text=str_replace($search,$replace,$text);

		return $text;
	}
	/**
    * Importuj dane z 1 rekordu do nowej tabeli.
    *
    * @param mixed  &$result wynik zapytania z bazy danych
    * @param int    $row    numer wiersza z wyniku zapytania
    * @param string $s_key  klucz tabeli rdowej (source key)
    * @param array  &$s_data opis co robimy z jakimi polami - tablica
    * @param string $table nazwa docelowej tabeli
    *
    * @access private
    * @return array tablica z danymi z danego recordu np. array("key"=>"1","name"=>"Monitor",...)
    */
	function _importRecord(&$result2,$row2,$s_key,&$s_data,$table) {
		global $db, $image,$theme;

		$r=array();   // SELECT result ze starej tabeli
		$new=array(); // tablica z danymi przetworzoymi, ktre bd wsatwiane do nowej tabeli array("pole"=>"warto")
		$r['key']=$this->db2->fetchResult($result2,$row2,$s_key);
		// odczytaj wszystkie pola ze starej tablicy
		reset($s_data);



		foreach ($s_data as $field=>$f_data) {
			$r[$field]=$this->db2->fetchResult($result2,$row2,$field);
			$this->values[$field]=$r[$field];

			// sprawd czy wartoci jest tablica czy string
			if (! is_array($s_data[$field])) {
				// przypisanie 1:1 np. "photo"=>"photo"
				$new[$s_data[$field]]=$r[$field];
			} else {
				/**
                 * przypisanie postaci
                 
                  "name"=>array(
				  	            "function"=>"changeFieldName",
				  	            "field"=>"name_L0",
				  		        )
                */

				
				if (isset($s_data[$field]['function']) && !empty($s_data[$field]['function'])) {
					$func=$s_data[$field]['function'];
					if (isset($s_data[$field]['target_table']) && $s_data[$field]['target_table']==true) {
						$this->$func($r[$field]);
					} elseif (! empty($s_data[$field]['field'])) {
						$new[$s_data[$field]['field']]=$this->$func($r[$field]);
					} else {
						$new[$field]=$this->$func($r[$field]);
					}
				} else {
					if (! empty($s_data[$field]['field'])) {
						$new[$s_data[$field]['field']]=$r[$field];
					} else {
						$new[$field]=$r[$field];
					}

				} // end if (! empty($func))

			}

		}
		
		unset($r);

		if (isset($new['user_id'])) {
			$new['user_id']=$this->replace_titles($new['user_id']);
		}

		// importowanie zdjec
		
		if ($table == 'main') {

			$this->importPhoto($new);
		}
		
		// generuj Query INSERT do abzy danych
		$query=$this->_recordQuery($table,$new);
		$result=$db->query($query);
		if ($result!=0) {

		} else {
			//        	print "<pre>";
			//        	print_r ($db);
			//        	print "</pre>";

			// nie udao si zaadowa rekordu
			// @todo logowanie bdu
		}

		return $new;
	} // end _importrecord()

	function importPhoto(&$row) {
		global $image,$DOCUMENT_ROOT,$ftp,$photoconfig,$config, $lang;

		$httpFile=new httpFileDownload($this->request['shop_url']);
		
		$image_path=$DOCUMENT_ROOT."/tmp/";
		$photo_count=0;
		$photo_uid=0;
		$photo_uid=$image->gen_photo_uid($row['user_id']);

		$tmp=$image->get_name_ext($row['photo']);
		$photo_name=$tmp[0];$photo_ext=$tmp[1];
		
			for ($i=0; $i <= 10; $i++)
			{
				$current_image_name='';
				if ($i==0) {
					$current_image_name=$photo_name.".".$photo_ext;
					$current_image=$image_path.$current_image_name;
				} else {
					$current_image_name=$photo_name."-".$i.".".$photo_ext;
					$current_image=$image_path.$current_image_name;
				}
				$file_data=$httpFile->getFile("/photo",$current_image_name);
				if ($httpFile->getDownloadStatus() == HFD_ALL_OK) {
					file_put_contents($current_image,$file_data);
					unset($file_data);
				} else {
					if ($httpFile->getDownloadStatus() == HFD_NO_HOST) {
						$this->setMessage($lang->importshop_error['no_host']);
					}
					break;
				}
				if (is_file($current_image)) {
					$photo_count++;
					$photo_part=$image->get_image_name($photo_count,$photo_uid).".jpg";
					$image->create_photo_from_conf($photoconfig->product_orig,$current_image,IMAGE_ORIG,$photo_part);
					$image->create_photo_from_conf($photoconfig->product_big,$current_image,IMAGE_BIG,$photo_part);
					$image->create_photo_from_conf($photoconfig->product_info,$current_image,IMAGE_INFO,$photo_part);
					$image->create_photo_from_conf($photoconfig->product_small,$current_image,IMAGE_SMALL,$photo_part);
					$image->create_photo_from_conf($photoconfig->product_icon,$current_image,IMAGE_ICON,$photo_part);
					$image->create_photo_from_conf($photoconfig->product_thumb,$current_image,IMAGE_THUMB,$photo_part);
					$ftp->connect();
					if ($i==0) {
						$ftp->delete($config->ftp['ftp_dir']."/admin/tmp",$photo_name.".".$photo_ext);
					} else {
						$ftp->delete($config->ftp['ftp_dir']."/admin/tmp",$photo_name."-".$i.".".$photo_ext);

					}
				}
				
			}
			
			$ftp->close();
			
			if ($photo_count > 0)
			{

				$row['photo']=$row['photo_small']=1;
				$row['photo_count']=$photo_count;
				$row['photo_uid']=$photo_uid;
				$rec->data['photo_count']=$photo_count;
				$rec->data['photo_uid']=$photo_uid;
				$size=$image->get_max_size($rec,IMAGE_INFO);
				$row['photo_info_width']=$size['width'];
				$row['photo_info_height']=$size['height'];
			}
	}


	/**
    * Generuj insert do bazy danych na podstawie odczytanych wartoci i definicji tabeli
    *
    * @param string $table nazwa tabeli docelowej, do ktrej bd dodawane dane
    * @param array  $new
    *
    * @access private
    * @return string SQL
    */
	function _recordQuery($table,$new) {
		$query="INSERT INTO $table (";
		reset($new);
		foreach ($new as $key=>$val) {
			$query.="$key,";
		}
		$query=substr($query,0,strlen($query)-1);
		$query.=") VALUES (";
		reset($new);
		foreach ($new as $key=>$val) {
			$val=addslashes($val);
			$query.="'$val',";
		}
		$query=substr($query,0,strlen($query)-1);
		$query.=")";
		return $query;
	} // end _recordQuery()

	// ---------------------------------- FUNCKJE TRANSFORMUJCE ----------------------

	/**
    * Ustaw warto pola na 1 lub 0
    */
	function boolSet01($value) {
		if ($value!=1) return 0;
		else return 1;
	} // end boolSet01()

	/**
    * Ustaw warto pola na 1
    */
	function boolSet1() {
		return 1;
	} // end boolSet1()

	/**
    * Ustaw warto pola na 0
    */
	function boolSet0() {
		return 0;
	} // end boolSet0()

} // end class ImportShopMain
?>