<?php
/**
 *
 * Xajaxowa wersja przenoszenia danych z 3.5 -> 4.0
 * 
 * @author marcin.butlak@sote.pl
 * @package xajaxImportShop
 * @version $Id: xajaxImportShop.inc.php,v 1.2 2007/06/12 06:34:49 marcin Exp $
 * @copyright sote 
 */
require_once('lib/SProgress/SProgressBar.inc.php');
require_once('lib/SProgress/SProgressMessage.inc.php');
require_once ("importshop_main.inc.php");

class xajaxImportShop extends SProgressMessage implements SProgressInterface {
	private $imShop;

	private $tablesArr=array();

	private $tablesArrOffset=0;

	private $countAll=0;

	private $request;

	private $sessionEnabled=true;

	public function __construct() {

		$this->loadSession();

		$class_file=$this->request['type'].".inc.php";
		require_once ("./include/class/$class_file");

		if (isset($__import_class) && class_exists($__import_class)) {
			/**
    		* Obsuga importu ze wskazanego oprogramowania
    		*/   
			if (empty($this->tablesArr)) {
				$this->imShop = new $__import_class(0,'main',$this->request);
			} else {
				if ($this->tablesArr[$this->tablesArrOffset]['offset'] >= $this->tablesArr[$this->tablesArrOffset]['count']) {
					$this->tablesArrOffset++;
				}
				if (isset($this->tablesArr[$this->tablesArrOffset])) {
					$this->imShop = new $__import_class($this->tablesArr[$this->tablesArrOffset]['offset'],$this->tablesArr[$this->tablesArrOffset]['name'],$this->request);
				}
			}
		} else {
			$this->cleanSession();
			$this->throwError("Unknown class ./class/$class_file");
		}
	}

	public function __destruct() {
		$this->saveSession();
	}
	/**
	 * Wymagane przez pasek postepu
	 *
	 * @return int
	 */
	public function progressCountPackage() {
		return 1;
	}

	/**
	 * policz wszystkie wiersze importowanych tabel
	 *
	 * @return zwraca liczbe wszystkich wierszy w importowanych tabelach
	 */
	public function progressCountAll() {
		if (!$this->countAll) {
			$tableConfig=$this->imShop->getTableConfig();
			$index=0;
			foreach ($tableConfig as $tableName=>$val) {
				$res=$this->imShop->getDB2()->Query("SELECT count(*) AS row_count FROM $tableName");
				// pobranie liczby wierszy w danej tabeli
				$this->tablesArr[$index]['count']=$this->imShop->getDB2()->FetchResult($res,0,"row_count");
				// ustalenie przesuniecia w danej tabeli
				$this->tablesArr[$index]['offset']=0;
				// nazwa tabeli
				$this->tablesArr[$index]['name']=$tableName;
				// liczba wierszy ze wszystkich tabeli
				$this->countAll+=$this->tablesArr[$index]['count'];
				$index++;
			}
		}

		return $this->countAll;
	}

	public function progressNext($offset=0) {
		$processed=0;


		
		if (isset($this->tablesArr[$this->tablesArrOffset])) {
			$processed=$this->imShop->goImport();
			$this->setMessage("Importuje tabele: '".$this->tablesArr[$this->tablesArrOffset]['name']."'".$this->imShop->getMessage());
			if (!is_numeric($processed)) {
				$this->cleanSession();
				$this->throwError($processed);
			}

			$this->tablesArr[$this->tablesArrOffset]['offset']+=$processed;
		} elseif ($this->tablesArrOffset > 0) {
			$this->cleanSession();
			$this->endMessage("Import danych zakonczony sukcesem");
		}

		return $offset+$processed;
	}

	/**
	 * Zaladuj zmienne sesyjne
	 *
	 */
	private function loadSession()
	{
		if (isset($_SESSION['xajaxImportShop']['tablesArr'])) {
			$this->tablesArr=unserialize($_SESSION['xajaxImportShop']['tablesArr']);
		}
		if (isset($_SESSION['xajaxImportShop']['tablesArrOffset'])) {
			$this->tablesArrOffset=$_SESSION['xajaxImportShop']['tablesArrOffset'];
		}
		if (isset($_SESSION['xajaxImportShop']['countAll'])) {
			$this->countAll=$_SESSION['xajaxImportShop']['countAll'];
		}
		if (isset($_SESSION['xajaxImportShop']['request'])) {
			$this->request=unserialize($_SESSION['xajaxImportShop']['request']);
		}

		if (isset($_REQUEST['item']) && !empty($_REQUEST['item'])) {
			$this->cleanSession();
			$this->request=$_REQUEST['item'];
			$_SESSION['xajaxImportShop']['request']=serialize($this->request);
		}
	}
	/**
	 * Zapisz zmienne sesyjne
	 *
	 */
	private function saveSession()
	{
		if ($this->sessionEnabled) {
			$_SESSION['xajaxImportShop']['tablesArr']=serialize($this->tablesArr);
			$_SESSION['xajaxImportShop']['tablesArrOffset']=$this->tablesArrOffset;
			$_SESSION['xajaxImportShop']['countAll']=$this->countAll;
			$_SESSION['xajaxImportShop']['request']=serialize($this->request);
		}
	}

	private function cleanSession() {
		unset($_SESSION['xajaxImportShop']);
		$this->sessionEnabled=false;
	}

}

?>