<?php
/**
 * Klasa importu do tabeli depository
 *
 * @author lukasz.andrzejak@sote.pl
 * @package SImportCSV
 * @subpackage SImportCSVdepository
 * @license SOTE
 * @version $Id: SImportCSVdepository.inc.php,v 1.4 2007-09-25 13:39:40 lukasz Exp $
 */

require_once("include/SImportCSV.inc.php");
class SImportCSVdepository extends SImportCSV {
    public $table='depository';
    public $filename='/tmp/depository.csv';
    
    
    private function checkProdAvailableId ($num) {
		global $mdbd;
		$res2 = $mdbd->select("user_id,num_from,num_to", "available", "1=1", array(), '', 'array');
		if(!empty($res2)) {
			$av_id = 0;
			reset($res2);
			while (($av_id == 0) && (list($key, $val) = each($res2))) {
				$a = $val['user_id'];
				$from = $val['num_from'];
				$to = $val['num_to'];
				if($to != '*') {
					if (($from <= $num) && ($num <= $to)) {
						$av_id = $a;
					}
				}
				else {
					$last_id = $a;
				}
			}
			if($av_id == 0) {
				$av_id = $last_id;
			}
			$id_avail = $av_id;
		}
		return $id_avail;
	}
    
	private $__id=0;
	
    protected function _cleanup($num) {
    	global $mdbd,$db;
    	$uid=$this->_row['user_id_main'];
    	$main_data=$mdbd->select('user_id,id','main','user_id=?',array($uid=>'text'));
//    	print "<pre>";
//    	print_r($main_data);
//    	print "</pre>";
    	if (empty($main_data['id'])) {
    		$this->__id=0;
    		$this->_logError(array(),'Brak produktu o podanym id ('.$uid.') w sklepie');
    	} else {
    		$id=$main_data['id'];
    		$this->__id=$id;
//    		$result=$db->Query($sql);
//    		if ($result!=0) {
//    		} else {
//    			$this->_count_bad++;
////    			$this->_count_updated--;
//    			$this->_logError(array(),$db->Error().$sql); 
//    		}
    	}
    	
    	
    	if ($this->__id!=0) $mdbd->update('main','id_available=?','id='.$this->__id,array($this->checkProdAvailableId($num)=>"int"));
//    	unset($this->_row['price']);
    	global $db;
    	global $config;
    	$def_min=$config->depository['general_min_num'];
    	$sql="UPDATE depository SET min_num=$def_min WHERE min_num IS NULL";
    	$db->Query($sql);
    	$sql="UPDATE depository SET id_deliverer=0 WHERE id_deliverer IS NULL";
    	$db->Query($sql);
    	return $num;
    }
	
    protected  $_required=array('user_id_main'); 
    protected  $_code='13310';
    protected  $_config=array(
        'ID' => 'user_id_main', // sprawdzi spacje itd
        'NUM'=>array('_cleanup','num'),
        'MIN_NUM'=>'min_num',
        'ID_DOSTAWCY'=>'id_deliverer',
    );
}
?>