<?php
/**
 * Klasa importu do tabeli main
 *
 * @author lukasz.andrzejak@sote.pl
 * @package SImportCSV
 * @subpackage SExportCSVmain
 * @license SOTE
 * @version $Id: SExportCSV.inc.php,v 1.13 2007-09-11 11:12:51 lukasz Exp $
 */


require_once("lib/SProgress/SProgressBar.inc.php");

class SExportCSV implements SProgressInterface {
    
	private $_sep=';';
	
    public function progressCountPackage() {
        return 100;
    }
    
    public function progressCountAll() {
        global $mdbd;
        $count=$mdbd->select('count(1)','main');
        return $count;
    }
    
    public function progressNext($last=0) {
        return $this->load($last);
    }
    
    private $_handle=NULL;
    
    private function _clearFile() {
        global $DOCUMENT_ROOT;
        fclose ($this->_handle);
        $this->_handle=fopen($DOCUMENT_ROOT.$this->file,'w+');
        $line='STATUS'.$this->_sep;
        foreach ($this->_config as $key=>$value) {
            $line.=''.$key.$this->_sep;
        }
        $line=preg_replace('@'.$this->_sep.'$@','',$line);
        $line.="\r\n";
        $this->_writetofile($line);
    }
    
    private function _writetofile($string='') {
        if (!empty($string)) {
            fwrite($this->_handle,$string,strlen($string));
        }
        return (0);
    }
    
    public $file='/tmp/export.csv';
    
    public function load($last=0) {
        global $db;
        global $DOCUMENT_ROOT;
        $this->_handle=fopen($DOCUMENT_ROOT.$this->file,'a+');
        if ($last==0) {
            $this->_clearFile();
        }
        $sql='SELECT * FROM main ORDER BY user_id LIMIT '.$last.','.$this->progressCountPackage();
        $result=$db->Query($sql);
        if ($result!=0) {
            $num_rows=$db->NumberOfRows($result);
            if ($num_rows!=0) {
                for ($i=0;$i<$num_rows;$i++) {
                    $line='U'.$this->_sep;
                    foreach ($this->_config as $key=>$value) {
                        $val=$db->FetchResult($result,$i,$value);
                        $val=preg_replace('@"@',"'",$val);
                        $val=preg_replace("@\r@","",$val);
                        if (in_array($key,$this->_toReencode)) $val=$this->_reencode($val);
                        if (preg_match("@\"@",$val) || preg_match("@\r@",$val) || preg_match("@;@",$val) || preg_match("@\n@",$val)) {
                        	$line.='"'.$val.'"'.$this->_sep;
                        } else $line.=$val.$this->_sep;
                    }
                    $line=preg_replace('@'.$this->_sep.'$@','',$line);
                    $line.="\r\n";
                    $this->_writetofile($line);
                }
            }
            if ($num_rows<$this->progressCountPackage() || (($last+$this->progressCountPackage())>$this->progressCountAll())) $this->_finish();
            return $last+$this->progressCountPackage();
        }
    }
    
    private function _reencode($string) {
//    	return $string;
    	$string = strtr($string, 
	    				"\xA1\xA3\xA6\xAC\xAF\xB1\xB3\xB6\xBC\xBF\xC6\xCA\xD1\xD3\xE6\xEA\xF3",
    					"\xA5\xA3\x8C\x8F\xAF\xB9\xB3\x9C\x9F\xBF\xC6\xCA\xD1\xD3\xE6\xEA\xF3"
                        );
        return $string;
    }
    
    private function _finish() {
        global $lang,$theme;
//        $message=$lang->export_messages['get_file']." <a href='".$this->file."'>".$lang->export_messages['get_file2']."</a><br />";
        $message=$lang->export_messages['get_file']." <a href='export2.php?get_file=1'>".$theme->downloadIMG()."</a><br />";
        throw new SProgressException($message,1);
        return(0);
    }
    
    private $_toReencode=array('NAZWA','OPIS_SKR','OPIS','ATR_ZAAW','PRODUCENT','KAT1','KAT1','KAT2','KAT3','KAT4','KAT5','EKSTRA_KAT','EKSTRA_KAT2','DOSTEPNOSC','META_TITLE','META_DESC','META_KEYWORDS','LINK_NAZWA','DOD_POLE1','DOD_POLE2','DOD_POLE3');
    
    private $_config=array(
        'ID' => 'user_id', // sprawdzi spacje itd
        'NAZWA' => 'name_L0', // ponisze przekodowa
        'NAZWAL1' => 'name_L1',
        'NAZWAL2' => 'name_L2',
        'NAZWAL3' => 'name_L3',
        'NAZWAL4' => 'name_L4',
        'OPIS_SKR' => 'xml_short_description_L0',
        'OPIS_SKRL1' => 'xml_short_description_L1',
        'OPIS_SKRL2' => 'xml_short_description_L2',
        'OPIS_SKRL3' => 'xml_short_description_L3',
        'OPIS_SKRL4' => 'xml_short_description_L4',
        'OPIS' => 'xml_description_L0', 
        'OPISL1' => 'xml_description_L1',
        'OPISL2' => 'xml_description_L2',
        'OPISL3' => 'xml_description_L3',
        'OPISL4' => 'xml_description_L4', // ju nie kodowa
        'ATR_ZAAW' => 'xml_options',
        'PROMOCJA' => 'promotion',
        'NOWOSC' => 'newcol',
        'STR_GL' => 'main_page',
        'BESTSELL' => 'bestseller',
        'AKTYWNY' => 'active',
        'ZA_PUNKTY'=> 'points',
        'PUNKTOW'=> 'points_value',
        'CENEO'=>'ceneo_export',
        'ZA_SMS'=>'sms',
        'ONLINE' => 'main_keys_online',
        'ZAPYTAJ_O_CENE' =>'ask4price',
        'UKRYJ_CENE' =>'hidden_price',
        'PRODUCENT' => 'producer', // funkcja
        'KAT1' => 'category1', // to s funkcje
        'KAT2' => 'category2',
        'KAT3' => 'category3',
        'KAT4' => 'category4',
        'KAT5' => 'category5',
        'EKSTRA_KAT' => 'category_multi_1',
        'EKSTRA_KAT2' =>'category_multi_2',
        'CENA_BRUTTO' => 'price_brutto',
        'CENA_HURT' => 'price_brutto_2',
        'STARA_CENA'=>'price_brutto_detal',
        'MAX_RABAT' => 'max_discount',
        'RABAT'=> 'discount',
//        'CENA_NETTO' => 'price_netto',
//        'WALUTA' => array('_curr','id_currency'), // id waluty - sprawd czy istnieje
        'DOSTEPNOSC' => 'id_available', // int - wybierz jeeli istnieje, jeeli str - dodaj tak
        'VAT' =>'vat',
        'AKCESORIA' => 'accessories', // sprawd czy s takie produkty ?
        'ONET_KAT' => 'onet_category', // sprawd czy taka istnieje
        'ONET_USUN' => 'onet_status', // negatyw tego co podadz - tak jest w bazie
        'ONET_EXP' => 'onet_export', // negatyw tego co podadz - tak jest w bazie
//        'URL' => 'url', // sprawd czy domena istnieje
        'ONET_OBRAZEK' => 'onet_image_export',
        'ONET_OBRAZEK_TYTUL' => 'onet_image_title',
        'ONET_ATRYBUTY' => 'onet_attr',
//        'FLASH' => 'flash', // sprawd czy istnieje
        'PDF' => 'pdf', // sprawd czy istnieje
//        'FLASH_HTML' => 'flash_html', // czy jest razem z pdf
        'META_TITLE' => 'google_title',
        'META_DESC' => 'google_description',
        'META_KEYWORDS' => 'google_keywords',
        'VAT?' => 'status_vat',
        'WAGA' => 'weight',
        'DOC' => 'doc', // czy istnieje
        'LINK' => 'link_url', // czy istnieje
        'LINK_NAZWA' => 'link_name',
        'DOD_POLE1' => 'additional_field_1',
        'DOD_POLE2' => 'additional_field_2',
        'DOD_POLE3' => 'additional_field_3',
        '!PHOTO_UID' => 'photo_uid',
        '!PHOTO_NORMAL' => 'photo',
        '!PHOTO_SMALL' => 'photo_small',
    );
}

?>