<?php
/**
 * Klasa importu do tabeli main
 *
 * @author lukasz.andrzejak@sote.pl
 * @package SImportCSV
 * @subpackage SImportCSVmain
 * @license SOTE
 * @version $Id: SImportCSVmain.inc.php,v 1.15 2007-09-24 19:17:28 lukasz Exp $
 */


require_once("include/SImportCSV.inc.php");
require_once("config/auto_config/csv_config.inc.php");
class SImportCSVmain extends SImportCSV  {
    
    
    /**
     * Nazwa tabeli na ktrej operujemy
     *
     * @var unknown_type
     */
    public $table='main';
    
    /**
     * Nazwa pliku ktry jest parsowany
     *
     * @var unknown_type
     */
    public $filename='/tmp/soteesklep.csv';
    
    /**
     * Wymagane - pola klucze
     * Po nich wyszukiwane s rekordy i po nich s aktualizowane.
     * Zawsze musz by w pliku
     *
     * @var array
     */
    protected $_required=array(
    "user_id"
    );
    
    /**
     * Jeeli wprowadzane - nie mog by puste
     *
     * @var array
     */
    protected $_notNull=array(
    'user_id','price_brutto','name_L0'
    );
    
    /**
     * Pola ktore trzeba przekodowac na z cp1250 iso
     *
     * @var array
     */
//    public $_toReencode=array('NAZWA','OPIS_SKR','OPIS','ATR_ZAAW','PRODUCENT','KAT1','KAT1','KAT2','KAT3','KAT4','KAT5','EKSTRA_KAT','EKSTRA_KAT2','DOSTEPNOSC','META_TITLE','META_DESC','META_KEYWORDS','LINK_NAZWA','DOD_POLE1','DOD_POLE2','DOD_POLE3');
    public $_toReencode=array('name_L0','xml_short_description_L0','xml_description_L0','xml_options','producer','category1','category2','category3','category4','category5','category_multi_1','category_multi_2','google_title','google_description','google_keywords','link_name','additional_field_1','additional_field_2','additional_field_3');
    
    /**
     * Kod autoryzacyjny
     *
     * @var string
     */
    protected $_code='1388';
    
    /**
     * Obiekt do sprawdzania ile jest obrazkow w katalogu
     *
     * @var object Image
     */
    private $_image=NULL;
    
    public function __construct() {
//        $this->_code=
		  global $image;
		  require_once("include/image.inc");
		  $this->image=$image;
          parent::__construct();
    }
    
    
    /**
     * Robimy zapytanie o id producenta, jezeli nie znajdziemy go to wstawiamy i ponawiamy zapytanie.
     *
     * @todo zrobic to na prywatnym prepareQuery
     * @param string $producer
     * @return int
     */
    private function _selectProducerId($producer) {
        global $db;
        $producer=$this->_reencode($producer);
    	$producer_safe=addslashes($producer);
//    	print $producer;
        $sql="SELECT id FROM producer WHERE LOWER(`producer`) = LOWER('$producer_safe') LIMIT 1;";
        $result=$db->Query($sql);
        if ($result!=0) {
            $num_rows=$db->NumberOfRows($result);
            if ($num_rows==1) {
                $id=$db->FetchResult($result,0,'id');
            } else {
                $sql2="INSERT INTO producer (`producer`) VALUES ('$producer_safe')";
                $result2=$db->Query($sql2);
                if ($result2!=0) {
                    $id=$this->_selectProducerId($producer);
                } else echo "4".$db->Error($result2);
            }
        } else {
        	echo "3".$db->Error($result);
        }
        return $id;
    }
    /**
     * Okreslamy identyfikator producenta i dodajemy go do inserta
     *
     * @uses $this->_row
     * @param string $producer
     * @return string
     */
    protected function _producer($producer='') {
        global $mdbd;
        $producer=trim($producer);
        if (empty($producer)) {
            $this->_row['id_producer']='';
            return '';
        }
        $id=@$this->_selectProducerId($producer);
        $this->_row['id_producer']=$id;
        return $producer;
    }
    
    /**
     * Zmieniamy kodowanie danych
     *
     * @param string $text
     * @return string
     */
    protected function _encoding($text) {
        return $text;
    }
    
    /**
     * Zwracamy identyfikator uzytkownika w akceptowalnym formacie
     *
     * @param string $uid
     * @return string
     */
    protected function _sane_uid($uid) {
        $uid=trim($uid);
        $n_uid=preg_replace('@[^a-zA-Z0-9\- _]@','',(string) $uid);
        $n_uid=preg_replace('@ @','_',$n_uid);
        if ($n_uid!==$uid) $this->_logError(array(),'Niewaciwy identyfikator '.$uid.' zamieniony na '.$n_uid);
        return $n_uid;
    }
    
    /**
     * Zwracamy 1 jezeli $bool zawiera 1,TAK,YES lub JA, w przeciwnym wypadku zwracamy 0
     *
     * @param string $bool
     * @return bool
     */
    protected function _bool($bool) {
        $bool=trim($bool);
        $yes=array('TAK','YES','JA','1');
        if (array_search(strtoupper($bool),$yes)!==false) return '1';
        return '0';
    }
    
    /**
     * Pola wymagane do wykonania inserta
     *
     * @var array
     */
    protected $_required_for_insert=array('user_id','name_L0','price_brutto','id_category1');        
            
    
    /**
     * Uniwersalna funckja do sprawdzania kategorii i wstawiania jej jezeli nie istnieje
     *
     * @todo zoptymalizowac wykorzystujac prepareQuery
     * @param string $cat nazwa kategorii
     * @param int $num lewel kategorii (category1/2/3/4/5)
     * @return int id kategorii
     */
    private function _catSel($cat,$num=1) {
        global $db;
        $cat_name="category$num";
        $sql_cat=addslashes($cat);
        if (empty($cat)) return 0;
        $sql="SELECT id FROM $cat_name WHERE LOWER(`$cat_name`) = LOWER('$sql_cat') LIMIT 1;";
        $result=$db->Query($sql);
        if ($result!=0) {
            $num_rows=$db->NumberOfRows($result);
            if ($num_rows==1) {
                $id=$db->FetchResult($result,0,'id');
            } else {
                $sql2="INSERT INTO $cat_name (`$cat_name`) VALUES ('$sql_cat')";
                $result2=$db->Query($sql2);
                if ($result2!=0) {
                    $id=$this->_catSel($cat,$num);
                } else die("1".$db->Error($result2));
            }
        } else {
//            echo $sql;
            echo "2".$db->Error($result);
        }
        return $id;
    }
    
    /**
     * Wyciagamy id kategorii 1 i dodajemy do row
     *
     * @param string $cat1 nazwa kategorii
     * @return string
     */
    protected function _cat1($cat1) {
        $cat1=trim($cat1);
        $id=$this->_catSel($cat1,1);
        $this->_row['id_category1']=$id;
        return $cat1;
    }
    
    /**
     * Wyciagamy id kategorii 1 i dodajemy do row
     *
     * @param string $cat2 nazwa kategorii
     * @return string
     */
    protected function _cat2($cat2) {
        $cat2=trim($cat2);
        $id=$this->_catSel($cat2,2);
        $this->_row['id_category2']=$id;
        return $cat2;
    }
    
    /**
     * Wyciagamy id kategorii 1 i dodajemy do row
     *
     * @param string $cat3 nazwa kategorii
     * @return string
     */
    protected function _cat3($cat3) {
        $cat3=trim($cat3);
        $id=$this->_catSel($cat3,3);
        $this->_row['id_category3']=$id;
        return $cat3;
    }
    
    /**
     * Wyciagamy id kategorii 1 i dodajemy do row
     *
     * @param string $cat4 nazwa kategorii
     * @return string
     */
    protected function _cat4($cat4) {
        $cat4=trim($cat4);
        $id=$this->_catSel($cat4,4);
        $this->_row['id_category4']=$id;
        return $cat4;
    }
    
    /**
     * Wyciagamy id kategorii 1 i dodajemy do row
     *
     * @param string $cat5 nazwa kategorii
     * @return string
     */
    protected function _cat5($cat5) {
        $cat5=trim($cat5);
        $id=$this->_catSel($cat5,5);
        $this->_row['id_category5']=$id;
        return $cat5;
    }
    
    /**
     * Przetwarzamy dodatkowe kategorie, rozdzielone znakami / (ale nie </)
     * UWAGA!<br>
     * Kazdy znak @ wystepujacy w kategoriach bedzie zamieniony na (at)
     *
     * @param string $cat sciezka kategorii
     * @return string
     */
    protected function _multi_cat1($cat) {
        $cat=trim($cat);
        $cat=preg_replace('/@/','(at)',$cat);
        $cat_at=preg_replace('@([a-zA-Z0-9 _>])/([a-zA-Z0-9 _<])@','\1@\2',$cat);
        $cat_arr=split('@',$cat_at);
        $id_str='';
        for ($i=1;$i<5;$i++) {
            if (isset($cat_arr[$i-1])) {
                $id_str.=$this->_catSel($cat_arr[$i-1],$i).'_';
            }
        }
        $id_str=preg_replace('@_$@','',$id_str);
        $this->_row['id_category_multi_1']=$id_str;
        return $cat;
    }
    
    /**
     * Przetwarzamy dodatkowe kategorie, rozdzielone znakami / (ale nie </)
     * UWAGA!<br>
     * Kazdy znak @ wystepujacy w kategoriach bedzie zamieniony na (at)
     *
     * @param string $cat sciezka kategorii
     * @return string
     */
    protected function _multi_cat2($cat) {
        $cat=trim($cat);
        $cat=preg_replace('/@/','(at)',$cat);
        $cat_at=preg_replace('@([a-zA-Z0-9 _>])/([a-zA-Z0-9 _<])@','\1@\2',$cat);
        $cat_arr=split('@',$cat_at);
        $id_str='';
        for ($i=1;$i<5;$i++) {
            if (isset($cat_arr[$i-1])) {
                $id_str.=$this->_catSel($cat_arr[$i-1],$i).'_';
            }
        }
        $id_str=preg_replace('@_$@','',$id_str);
        $this->_row['id_category_multi_2']=$id_str;
        return $cat;
    }
    
    /**
     * Sprawdzamy czy podano id istniejacej dostepnosci lub jej opis tekstowy
     * Jezeli jest taki wpis w liscie dostepnosci - to go zwracamy
     *
     * @todo zoptymalizowac dodajac wykorzystanie prepareQuery
     * @param string/int $available dostepnosc
     * @return int
     */
    protected function _available($available) {
        global $mdbd,$db;
        $available=trim($available);
        $id=0;
        $av_int=(int) $available;
        if ((string) $av_int==(string) $available) {
            $available = (int) $available;
            $id=$mdbd->select('user_id','available','user_id='.$available);
        } else {
            $available=addslashes($available);
            $available=$this->_reencode($available);
            $sql="SELECT user_id FROM available WHERE LOWER(`name`) = LOWER('$available') LIMIT 1;";
            $result=$db->Query($sql);
            if($result!=0) {
                if ($db->NumberOfRows($result)==1) {
                    $id=$db->FetchResult($result,0,'user_id');
                }
            }
        }
        return $id;
    }
    
    /**
     * Odwrotny bool
     *
     * @param string $bool
     * @return bool
     */
    protected function _neg_bool($bool) {
        if ($this->_bool($bool)) return '0';
        return '1';
    }
    
    /**
     * Rzutujemy wartosc na inta
     *
     * @param string $int
     * @return int
     */
    protected function _int($int) {
        $int=(int) $int;
        return $int;
    }
    
    /**
     * Nadajemy cenie poprawny format (zamieniamy ',' na '.' i usuwamy spacje, po czym rzutujemy na float)
     *
     * @param string $price
     * @return float
     */
    protected function _price($price) {
        $price=preg_replace('@,@','.',$price);
        $price=preg_replace('@ @','',$price);
        $price=floatval($price);
        $price=number_format($price,2,".","");
        return $price;
    }
    
    /**
     * Ustawiamy cene brutto i id waluty na 1
     *
     * @param string $price
     * @return string
     */
    protected function _price_brutto($price) {
    	global $mdbd;
        $price=$this->_price($price);
        $this->_row['id_currency']=1;
        $id=$this->_row['user_id'];
        /**
         * wstrzykujemy, musi byc zanim wywolamy _price_currency
         */
        $this->_row['price_brutto']=$price;
        if (isset($this->_row['vat'])) $this->_price_currency();
        else {
        	$this->_row['vat']=$mdbd->select('vat','main','user_id=?',array($id=>'text'));
        	$this->_price_currency();
        }
        return $price;
    }
    
    
    /**
     * Obliczamy kwote w walucie bez vatu (czyli kwote netto)
     *
     */
    protected function _price_currency() {
    	$vat=$this->_row['vat'];
    	$price=$this->_row['price_brutto'];
    	$price_netto=$price/(($vat/100)+1);
    	$price_netto=$this->_price($price_netto);
    	$this->_row['price_currency']=$price_netto;
    }
    
    /**
     * Okreslamy stawke vat - jezeli w sklepie nie bylo zdefiniowanej takiej stawki to dodajmy ja
     *
     * @todo zoptymalizowac wykorzystujac prepare_query zamiast mdbd
     * @param string $vat
     * @return int
     */
    protected function _vat($vat) {
        global $mdbd;
        $vat=intval($vat);
        $id=$mdbd->select('id','vat',"vat=$vat");
        if ($id==0) {
            $mdbd->insert('vat','vat',"$vat");
        }
        /**
         * wstrzykujemy, musi byc zanim wywolamy _price_currency
         */
        $this->_row['vat']=$vat;
        if (isset($this->_row['price_brutto'])) $this->_price_currency();
        return $vat;
    }
    
    protected function _print($str) {
    	print $str;
    	return $str;
    }
    
    /**
     * Jezeli ktos chce wrzucic tedy zdjecia - to liczymy ile fotek jest w systemie i aktualizujemy ta liczbe
     *
     * @param string $uid id zdjecia
     * @return int
     */
    protected function _photocount($uid) {
    	global $image;
    	require_once("include/image.inc");
    	$this->_row['photo_count']=$this->image->count_files($uid);
    	return $uid;
    }
    
    /**
     * string - pole w tabeli main
     * array(funkcja,pole) - wywolujemy $this->funkcja, i zwrocona wartosc wstawiamy do tabeli
     *
     * @var array
     */
    protected $_config=array(
        'STATUS' => 'action',
        'ID' => array ('_sane_uid','user_id'), // sprawdzi spacje itd
        'NAZWA' => 'name_L0', // ponisze przekodowa
        'NAZWAL1' => 'name_L1',
        'NAZWAL2' => 'name_L2',
        'NAZWAL3' => 'name_L3',
        'NAZWAL4' => 'name_L4',
        'OPIS_SKR' => 'xml_short_description_L0',
        'OPIS_SKRL1' => 'xml_short_description_L1',
        'OPIS_SKRL2' => 'xml_short_description_L2',
        'OPIS_SKRL3' => 'xml_short_description_L3',
        'OPIS_SKRL4' => 'xml_short_description_L4',
        'OPIS' => array ('_encoding','xml_description_L0'), 
        'OPISL1' => 'xml_description_L1',
        'OPISL2' => 'xml_description_L2',
        'OPISL3' => 'xml_description_L3',
        'OPISL4' => 'xml_description_L4', // ju nie kodowa
        'ATR_ZAAW' => 'xml_options',
        'PROMOCJA' => array ('_bool','promotion'),
        'NOWOSC' => array ('_bool','newcol'),
        'STR_GL' => array ('_bool','main_page'),
        'BESTSELL' => array ('_bool','bestseller'),
        'AKTYWNY' => array ('_bool','active'),
        'ZA_PUNKTY'=>array ('_bool','points'),
        'PUNKTOW'=> array ('_int','points_value'),
        'CENEO'=>array('_bool','ceneo_export'),
        'ZA_SMS'=>array ('_bool','sms'),
        'ONLINE' => array('_bool','main_keys_online'),
        'ZAPYTAJ_O_CENE' => array('_bool','ask4price'),
        'UKRYJ_CENE' => array ('_bool','hidden_price'),
        'PRODUCENT' => array('_producer','producer'), // funkcja
        'KAT1' => array('_cat1','category1'), // to s funkcje
        'KAT2' => array('_cat2','category2'),
        'KAT3' => array('_cat3','category3'),
        'KAT4' => array('_cat4','category4'),
        'KAT5' => array('_cat5','category5'),
        'EKSTRA_KAT' => array('_multi_cat1','category_multi_1'),
        'EKSTRA_KAT2' => array('_multi_cat2','category_multi_2'),
        'CENA_BRUTTO' => array('_price_brutto','price_brutto'),
        'CENA_HURT' => array('_price','price_brutto_2'),
        'STARA_CENA'=>array ('_price','price_brutto_detal'),
        'MAX_RABAT' => array ('_int','max_discount'),
        'RABAT'=> array('_int','discount'),
//        'CENA_NETTO' => 'price_netto',
//        'WALUTA' => array('_curr','id_currency'), // id waluty - sprawd czy istnieje
        'DOSTEPNOSC' => array('_available','id_available'), // int - wybierz jeeli istnieje, jeeli str - dodaj tak
        'VAT' => array('_vat','vat'),
        'AKCESORIA' => 'accessories', // sprawd czy s takie produkty ?
        'ONET_KAT' => 'onet_category', // sprawd czy taka istnieje
        'ONET_USUN' => array ('_bool','onet_status'), // negatyw tego co podadz - tak jest w bazie
        'ONET_EXP' => array ('_neg_bool','onet_export'), // negatyw tego co podadz - tak jest w bazie
//        'URL' => 'url', // sprawd czy domena istnieje
        'ONET_OBRAZEK' => array('_bool','onet_image_export'),
        'ONET_OBRAZEK_TYTUL' => 'onet_image_title',
        'ONET_ATRYBUTY' => 'onet_attr',
//        'FLASH' => 'flash', // sprawd czy istnieje
        'PDF' => 'pdf', // sprawd czy istnieje
//        'FLASH_HTML' => 'flash_html', // czy jest razem z pdf
        'META_TITLE' => 'google_title',
        'META_DESC' => 'google_description',
        'META_KEYWORDS' => 'google_keywords',
        'VAT?' => array('_bool','status_vat'),
        'WAGA' => array('_int','weight'),
        'DOC' => 'doc', // czy istnieje
        'LINK' => 'link_url', // czy istnieje
        'LINK_NAZWA' => 'link_name',
        'DOD_POLE1' => 'additional_field_1',
        'DOD_POLE2' => 'additional_field_2',
        'DOD_POLE3' => 'additional_field_3',
        '!PHOTO_UID' => array('_photocount','photo_uid'),
        '!PHOTO_NORMAL' => 'photo',
        '!PHOTO_SMALL' => 'photo_small',
    );
}

?>