<?php 
require_once("include/ftp.inc.php");
require_once("include/image.inc");
require_once('lib/SProgress/SProgressBar.inc.php');
require_once('lib/SProgress/SProgressMessage.inc.php');
/**
 * Klasa odpowiadajaca za import zdjec 
 * 
 * @author marcin.butlak@sote.pl
 * @copyright  sote
 */
class photoImport extends SProgressMessage implements SProgressInterface {
	private $target="/../htdocs/photo/";
	private $source="/../htdocs/photo/upload";
	private $file_name="/tmp/photo_import.csv";
	private $status_file="/tmp/photo_import.html";
	private $last_pos_file="/tmp/last_pos.dat";
	private $file=null;
	private $sf=null;
	private $num_lines=1;
	private $countAll;

	public function saveToStatusFile($status)
	{
		global $DOCUMENT_ROOT, $theme;

		$_SESSION['photo']['errors']=true;

		fwrite($this->sf,$theme->photo_status_row($status));

	}

	public function init($offset=0)
	{
		global $DOCUMENT_ROOT, $lang, $theme, $ftp, $config;

		$this->sf=fopen($DOCUMENT_ROOT.$this->status_file,"a");

		if (!$this->sf)
		$this->throwError($lang->photo_errors["no_status_file"]);


		if (!$offset)
		{
			if (isset($_SESSION['photo']['offset']))
			{
				$offset=$_SESSION['photo']['offset'];
			}
			else
			{
				ftruncate($this->sf,0);
				$_SESSION['photo']['errors']=false;
			}

		}
		//$this->throwError("tutaj!");
		$this->file=@fopen($DOCUMENT_ROOT.$this->file_name,"r");

		if (!$this->file)
		$this->throwError($lang->photo_errors["no_import_file"]);



		if ($offset >= $this->progressCountAll())
		{

			unset($_SESSION["photo"]["file_size"]);
			unset($_SESSION['photo']['offset']);

			$ftp->connect();

			fclose($this->file);
			fclose($this->sf);

			if (is_file($DOCUMENT_ROOT.$this->last_pos_file))
			unlink($DOCUMENT_ROOT.$this->last_pos_file);
			if (is_file($DOCUMENT_ROOT.$this->file_name))
			unlink($DOCUMENT_ROOT.$this->file_name);



			if (isset($_SESSION['photo']['errors']) && $_SESSION['photo']['errors']==true)
			$this->endMessage($lang->photo_status['errors'].$theme->photo_status_head().file_get_contents($DOCUMENT_ROOT.$this->status_file).$theme->photo_status_foot());
			else
			$this->endMessage($lang->photo_status['success']);
		}


		fseek($this->file,$offset);

	}

	public function progressCountAll() {

		global $DOCUMENT_ROOT, $config;
		if (empty($this->countAll))
		$this->countAll=filesize($DOCUMENT_ROOT.$this->file_name);

		return $this->countAll;
	}

	public function progressCountPackage() {
		return ftell($this->file);
	}

	public function progressNext($offset=0) {
		global $lang;

		$this->init($offset);
		
		$this->import();
		return $this->progressCountPackage();
	}

	public function checkExtension($image)
	{
		if (exif_imagetype($image) > 3)
		return false;

		return true;
	}

	public function import()
	{
		global $db, $image, $photoconfig, $DOCUMENT_ROOT,$ftp, $lang, $config;


		$image=new Image();
		$image->photo_dir=$DOCUMENT_ROOT.$this->target;

		if (!$this->progressCountPackage())
		$is_firstline=true;
		else
		$is_firstline=false;

		for ($line=0; $line < $this->num_lines && ($data=fgetcsv($this->file,4096, ";",'"')) !== false;$line++)
		{

			if (empty($data[1])) continue;

			if (!$is_firstline || ($is_firstline && $line > 0))
			{

				$res=$db->Query("SELECT id, user_id, photo_uid, photo_count, photo, photo_small FROM main WHERE user_id LIKE '".trim($data[0], ' ')."'");
				if ($res!=0)
				{

					if ($db->NumberOfRows($res))
					{
						$id=$db->FetchResult($res, 0, "id");
						$user_id=$db->FetchResult($res, 0, "user_id");
						$photo_uid=$db->FetchResult($res, 0, "photo_uid");
						$photo_count=$db->FetchResult($res, 0, "photo_count");
						$photo=$db->FetchResult($res, 0, "photo");
						$photo_small=$db->FetchResult($res, 0, "photo_small");

						$source_image_list=explode(",",$data[1]);
						if (empty($photo_uid)) {
							$photo_uid=$image->gen_photo_uid($user_id);
						}
						foreach ($source_image_list as $source_image)
						{
							$current_image=trim($source_image);
							//$current_image=strtr($current_image,"/","");
							$source_image=$DOCUMENT_ROOT.$this->source.'/'.$current_image;

							if (is_file($source_image))
							{

								if ($this->checkExtension($source_image))
								{
									$target_image=$image->get_free_place($photo_uid, $photo_count)."_".$photo_uid.".jpg";
									// wygeneruj zdjecie orginalne
									$image->create_photo_from_conf($photoconfig->product_orig, $source_image, IMAGE_ORIG,$target_image);
									// wygeneruj zdjecie powiekszone dla info.html.phpp
									$image->create_photo_from_conf($photoconfig->product_big, $source_image, IMAGE_BIG,$target_image);
									// wygeneruj zdjecie dla info.html.php,
									$image->create_photo_from_conf($photoconfig->product_info,$source_image,IMAGE_INFO,$target_image);

									// wygeneruj zdjecie dla record_row.html.php, random_record.html.php
									$image->create_photo_from_conf($photoconfig->product_small,$source_image, IMAGE_SMALL,$target_image);

									// wygeneruj zdjecie ikonki
									$image->create_photo_from_conf($photoconfig->product_icon, $source_image,IMAGE_ICON,$target_image);

									// wygeneruj miniaturke zdjecia dla panelu administracyjnego
									$image->create_photo_from_conf($photoconfig->product_thumb, $source_image,IMAGE_THUMB,$target_image);

									// wygeneruj miniaturke zdjecia dla galerii
									$image->create_photo_from_conf($photoconfig->product_gallery, $source_image,IMAGE_GALLERY,$target_image);

									$photo_count++;

									// jesli duze zdjecie zostalo podane ustaw je jako duze zdjecie produktu
									if ((!empty($data[2]) && strpos($source_image, $data[2]) !== false) || empty($photo))
									$photo=$photo_count;

									// jesli male zdjecie zostalo podane ustaw je jako male zdjecie produktu
									if ((!empty($data[3]) && strpos($source_image, $data[3]) !== false) || empty($photo_small))
									$photo_small=$photo_count;

								}
								else
								$this->saveToStatusFile(array($data[0],$current_image,$lang->photo_status['extension']));
							}
							else
							if (!empty($current_image))
							$this->saveToStatusFile(array($data[0],$current_image,$lang->photo_status['no_image']));

						}

						reset($source_image_list);

						foreach ($source_image_list as $source_image)
						{
							$source_image=$DOCUMENT_ROOT.$this->source.'/'.trim($source_image);
							if (is_file($source_image))
							{
								$file_name=pathinfo($source_image);
								$dirname=substr($file_name['dirname'],strpos($file_name['dirname'],"/htdocs/photo/"));
								$ftp->delete($config->ftp['ftp_dir'].$dirname, $file_name['basename']);
							}
						}
						$rec->data['photo_count']=$photo_count;
						$rec->data['photo_uid']=$photo_uid;
						$size=$image->get_max_size($rec,IMAGE_INFO);
						$res=$db->Query("UPDATE main SET photo_uid='$photo_uid', photo_count=$photo_count, photo=$photo, photo_small=$photo_small, photo_info_width={$size['width']}, photo_info_height={$size['height']} WHERE id=$id");

						file_put_contents($DOCUMENT_ROOT.$this->last_pos_file,serialize($this->progressCountPackage()));

					}
					else
					$this->saveToStatusFile(array($data[0],'-',$lang->photo_status['no_userid']));
				}
			}
		}
		unset($image);
	}
};

?>