<?php
/**
 * Klasa importu do tabeli main
 *
 * @author lukasz.andrzejak@sote.pl
 * @package SImportCSV
 * @subpackage SExportCSVmain
 * @license SOTE
 * @version $Id: SExportCSV.inc.php,v 1.3 2007-08-17 15:05:41 michal Exp $
 */


require_once("lib/SProgress/SProgressBar.inc.php");

class SExportCSV implements SProgressInterface {
    
	private $_sep=';';
	
    public function progressCountPackage() {
        return 100;
    }
    
    public function progressCountAll() {
        global $mdbd;
        $count=$mdbd->select('count(1)','porownywarki_cen');
        return $count;
    }
    
    public function progressNext($last=0) {
        return $this->load($last);
    }
    
    private $_handle=NULL;
    
    private function _clearFile() {
        global $DOCUMENT_ROOT;
        fclose ($this->_handle);
        $this->_handle=fopen($DOCUMENT_ROOT.$this->file,'w+');
        $line='STATUS'.$this->_sep;
        foreach ($this->_config as $key=>$value) {
            $line.=''.$key.$this->_sep;
        }
        $line=preg_replace('@'.$this->_sep.'$@','',$line);
        $line.="\r\n";
        $this->_writetofile($line);
    }
    
    private function _writetofile($string='') {
        if (!empty($string)) {
            fwrite($this->_handle,$string,strlen($string));
        }
        return (0);
    }
    
    public $file='/tmp/export_porownywarki.csv';
    
    public function load($last=0) {
        global $db;
        global $DOCUMENT_ROOT;
        $this->_handle=fopen($DOCUMENT_ROOT.$this->file,'a+');
        if ($last==0) {
            $this->_clearFile();
        }
        $sql='SELECT * FROM porownywarki_cen ORDER BY user_id LIMIT '.$last.','.$this->progressCountPackage();
        $result=$db->Query($sql);
        if ($result!=0) {
            $num_rows=$db->NumberOfRows($result);
            if ($num_rows!=0) {
                for ($i=0;$i<$num_rows;$i++) {
                    $line='U'.$this->_sep;
                    foreach ($this->_config as $key=>$value) {
                        $val=$db->FetchResult($result,$i,$value);
                        $val=preg_replace('@"@',"''",$val);
                        $val=preg_replace("@\r@","",$val);
                        if (in_array($key,$this->_toReencode)) $val=$this->_reencode($val);
                        if (preg_match("@\"@",$val) || preg_match("@\r@",$val) || preg_match("@;@",$val) || preg_match("@\n@",$val)) {
                        	$line.='"'.$val.'"'.$this->_sep;
                        } else $line.=$val.$this->_sep;
                    }
                    $line=preg_replace('@'.$this->_sep.'$@','',$line);
                    $line.="\r\n";
                    $this->_writetofile($line);
                }
            }
            if ($num_rows<$this->progressCountPackage() || (($last+$this->progressCountPackage())>$this->progressCountAll())) $this->_finish();
            return $last+$this->progressCountPackage();
        }
    }
    
    private function _reencode($string) {
    	$string = strtr($string, 
	    				"\xA1\xA3\xA6\xAC\xAF\xB1\xB3\xB6\xBC\xBF\xC6\xCA\xD1\xD3\xE6\xEA\xF3",
    					"\xA5\xA3\x8C\x8F\xAF\xB9\xB3\x9C\x9F\xBF\xC6\xCA\xD1\xD3\xE6\xEA\xF3"
                        );
        return $string;
    }
    
    private function _finish() {
        global $lang,$theme;
//        $message=$lang->export_messages['get_file']." <a href='".$this->file."'>".$lang->export_messages['get_file2']."</a><br />";
        $message=$lang->export_messages['get_file']." <a href='export2.php?get_file=1'>".$theme->downloadIMG()."</a><br />";
        throw new SProgressException($message,1);
        return(0);
    }
    
    private $_toReencode=array();
    
    private $_config=array(
        'ID' => 'user_id', // sprawdzi spacje itd
        'CENEO' =>'ceneo_export', 
        'NOKAUT' =>'nokaut_export', 
        'SKAPIEC' =>'skapiec_export', 
        'INTERIA' =>'interia_export', 
        'KUPUJEMY' =>'kupujemy_export', 
        'ZAKUPOMAT' =>'zakupomat_export', 
        'OFERCIAK' =>'oferciak_export', 
        'RADAR' =>'radar_export', 
    );
}

?>