<?php
/**
 * Klasa importu do tabeli main
 *
 * @author lukasz.andrzejak@sote.pl
 * @package SImportCSV
 * @subpackage SImportCSVporownywarki_cen
 * @license SOTE
 * @version $Id: SImportCSVporownywarki_cen.inc.php,v 1.5 2007-09-12 17:03:16 michal Exp $
 */


require_once("include/SImportCSV.inc.php");
require_once("config/auto_config/csv_config.inc.php");
class SImportCSVporownywarki_cen extends SImportCSV  {
    
    
    /**
     * Nazwa tabeli na ktrej operujemy
     *
     * @var unknown_type
     */
    public $table='porownywarki_cen';
    
    /**
     * Nazwa pliku ktry jest parsowany
     *
     * @var unknown_type
     */
    public $filename='/tmp/compare.csv';
    
    /**
     * Wymagane - pola klucze
     * Po nich wyszukiwane s rekordy i po nich s aktualizowane.
     * Zawsze musz by w pliku
     *
     * @var array
     */
    protected $_required=array(
    "user_id"
    );
    
    /**
     * Kod autoryzacyjny
     *
     * @var string
     */
    protected $_code='1388';
    
    public function __construct() {
//        $this->_code=
          parent::__construct();
    }
    
    /**
     * Zwracamy identyfikator uzytkownika w akceptowalnym formacie
     *
     * @param string $uid
     * @return string
     */
    protected function _sane_uid($uid) {
    	global $mdbd;
        $uid=trim($uid);
        $n_uid=preg_replace('@[^a-zA-Z0-9 _]@','',(string) $uid);
        $n_uid=preg_replace('@ @','_',$n_uid);
        if ($n_uid!==$uid) $this->_logError(array(),'Niewaciwy identyfikator '.$uid.' zamieniony na '.$n_uid);
//        $data=$mdbd->select('id','main','user_id=\''.$n_uid.'\'','');
//        if (empty($data)) $this->_logError(array(),'Niewaciwy identyfikator '.$n_uid.' nie ma takiego produktu!');
        return $n_uid;
    }
    
    /**
     * Zwracamy 1 jezeli $bool zawiera 1,TAK,YES lub JA, w przeciwnym wypadku zwracamy 0
     *
     * @param string $bool
     * @return bool
     */
    protected function _bool($bool) {
        $bool=trim($bool);
        $yes=array('TAK','YES','JA','1');
        if (array_search(strtoupper($bool),$yes)!==false) return '1';
        return '0';
    }
    
    /**
     * Pola wymagane do wykonania inserta
     *
     * @var array
     */
    protected $_required_for_insert=array('user_id','ceneo_export');        
            
    /**
     * string - pole w tabeli main
     * array(funkcja,pole) - wywolujemy $this->funkcja, i zwrocona wartosc wstawiamy do tabeli
     *
     * @var array
     */
    protected $_config=array(
        'STATUS' => 'action',
        'ID' => array ('_sane_uid','user_id'), // sprawdzi spacje itd
        'CENEO' => array ('_bool','ceneo_export'), 
        'NOKAUT' => array ('_bool','nokaut_export'), 
        'SKAPIEC' => array ('_bool','skapiec_export'), 
        'INTERIA' => array ('_bool','interia_export'), 
        'KUPUJEMY' => array ('_bool','kupujemy_export'), 
        'ZAKUPOMAT' => array ('_bool','zakupomat_export'), 
        'OFERCIAK' => array ('_bool','oferciak_export'), 
        'RADAR' => array ('_bool','radar_export'), 
    );
}

?>