<?php
include_once("config/auto_config/invoice_config.inc.php");
class SInvoiceSQL {
    /**
     * Wybierz produkty z wskazanej faktury
     *
     * @param int $invoiceId
     * @return array array produktw
     */
    public function productsForInvoice($invoiceId) {
        global $db;
        $invoiceId=(int) $invoiceId;
        $sql="SELECT *,
        (num*price_netto)-(num*price_netto)*(discount/100) 
        AS price_sum,
        ((num*price_netto)*(vat/100)+(num*price_netto))-
        ((num*price_netto)*(vat/100)+(num*price_netto))*(discount/100)
        AS price_brutto,
        price_netto-price_netto*(discount/100) AS price_netto_discount,
        (price_netto-price_netto*(discount/100))*(vat/100) AS price_vat
        FROM invoice_products 
        WHERE invoice_id='$invoiceId' 
        ORDER BY pos";
        return $this->Query($sql);
    }
    /**
     * Wykonaj wskazane zapytanie i zwroc wynik w arrayu
     *
     * @param string $sql
     * @return array
     */
    public function Query($sql) {
//    	print "[$sql]<br>";
        global $db;
        $rows=array();
        $result=$db->Query($sql);
        if ($result!=0) {
            $num_rows=@$db->NumberOfRows($result);
            if ($num_rows!=0) {
                $columnNames='';
                $db->GetColumnNames($result,$columnNames);
                for ($i=0;$i<$num_rows;$i++) {
                    $row=array();
                    foreach ($columnNames as $key=>$value) {
                        $row[$key]=$db->FetchResult($result,$i,$key);
                    }
                    $this->decrypt_data($row);
                    $rows[]=$row;
                }
            };
        } else echo $db->Error();
       
       return $rows;
    }
    
    public static function nicePrice($price=0) {
    	$price = preg_replace("@,@",'',$price);
        return number_format(round($price,2),2,'.','');
    }
    
    /**
     * Wybierz podsumowanie produktow pogrupowanych wedlug vatu
     *
     * @param int $invoiceId
     * @return array
     */
    public function productSummary($invoiceId) {
        global $db;
        
        $invoiceId=(int) $invoiceId;
        $sql="SELECT 
        vat, 
        SUM((price_netto-price_netto*(discount/100))*(vat/100)*num) AS vat_sum, 
        SUM((price_netto-price_netto*(discount/100))*num) AS netto_sum, 
        SUM( 
        			(num*(price_netto-price_netto*(discount/100)))*(vat/100)+(num*(price_netto-price_netto*(discount/100)))
        	) AS brutto_sum 
        FROM invoice_products 
        WHERE invoice_id='$invoiceId'
        GROUP BY vat 
        ORDER BY vat DESC";
        return $this->Query($sql);
    }
    
    /**
     * Podsumuj fakture
     *
     * @param int $invoiceId
     * @return array
     */
    public function invoiceSum($invoiceId) {
        global $db;
        $invoiceId=(int) $invoiceId;
        $sql="SELECT 
        SUM(((num*price_netto)*(vat/100)+(num*price_netto))-
        ((num*price_netto)*(vat/100)+(num*price_netto))*
        (discount/100)) AS brutto_sum 
        FROM invoice_products 
        WHERE invoice_id='$invoiceId'";
        return $this->Query($sql);
    }
    
    /**
     * Przenies zamowienie do faktur
     *
     * @param int $orderId
     * @return int number faktury
     */
    public function invoiceFromOrder($orderId) {
        $orderId=(int) $orderId;
        global $db, $mdbd;
        $data=$mdbd->select('id','invoice_register','id_order='.$orderId.' AND type='.$this->_type.' ','','LIMIT 1');
        /**
         * Blokada zakladania duplikatow faktur
         */
        if (!empty($data)) return $data;
        if (empty($orderId)) return (0);
        $sql="SELECT id_users_data, date_add FROM order_register WHERE order_id='$orderId'";
        $order=$this->Query($sql);
        if (empty($order[0])) return (0);
        $id_user=$order[0]['id_users_data'];
        $sql="SELECT * FROM users WHERE id='$id_user' LIMIT 1";
        $user_data=$this->Query($sql);
        $user_data=$user_data[0];
        $this->decrypt_data($user_data);
        $client=$user_data['firm']."<br>\n".$user_data['name'].' '.$user_data['surname']."<br>\n".
        $user_data['street'].' '.$user_data['street_n1'];
        if (!empty($user_data['street_n2'])) $client.='/'.$user_data['street_n2'];
        $client.="<br>\n";
        $client.=$user_data['postcode'].' '.$user_data['city']."<br>\n".
        'NIP: '.$user_data['nip'];
        $invoice_data=array(
        'crypt_client'=>'',
        'client'=>$client,
        'crypt_sell_date'=>'',
        'sell_date'=>$order[0]['date_add'],
        'crypt_place'=>'',
        'place'=>'Pozna',
        'user_id'=>$this->getUserId(),
        'id_user'=>'',
        'id_order'=>$orderId,
        'draw_user'=>''
        );
        $this->encrypt_data($invoice_data);
        $this->insert_invoice($invoice_data);
        $sql="SELECT id FROM invoice_register ORDER BY id DESC LIMIT 1;";
        $invoice_id_arr=$this->Query($sql);
        $invoice_id=$invoice_id_arr[0]['id'];
        $sql="SELECT * FROM order_products WHERE order_id='$orderId' ORDER BY id;";
        $prod_data=$this->Query($sql);
        $prod_data[]=$this->_getDeliveryProd($orderId);
        $this->insert_products($prod_data,$invoice_id);
        return $invoice_id;
    }
    
    /**
     * Tworzymy produkt bedacy kosztami dostawy
     *
     * @param id zamowienia $orderId
     * @return array produkt
     */
    private function _getDeliveryProd($orderId) {
    	global $mdbd;
    	$sql="SELECT delivery_cost,id_delivery FROM order_register WHERE order_id=$orderId LIMIT 1";
    	$data=$this->Query($sql);
    	$delivery_id=$data[0]['id_delivery'];
    	$delivery=$mdbd->select('name,vat','delivery','id='.$delivery_id);
    	if (empty($delivery['vat'])) $delivery['vat']=0;
    	$prod_data=array(
    					'user_id_main'=>'0',
    					'price_brutto'=>$data[0]['delivery_cost'],
    					'vat'=>$delivery['vat'],
    					'name'=>'Dostawa: '.$delivery['name'],
    					'num'=>1,
    					'discount'=>0,
    					);
    	return $prod_data;
    }
    
    /**
     * Wstaw produkty z zamowienia do faktury
     *
     * @param array $prod_data lista produktow
     * @param int $invoice_id numer faktury
     */
    public function insert_products($prod_data,$invoice_id) {
        global $db;
        $invoice_id=(int) $invoice_id;
        $query="INSERT INTO invoice_products (
                pos,name,pkwiu,
                num,unit,discount,
                user_id_main,vat,invoice_id,
                price_netto)
                VALUES (
                ?,?,?,
                ?,?,?,
                ?,?,$invoice_id,
                ?);";
        $preparedQuery=$db->PrepareQuery($query);
        if ($preparedQuery!=0) {
            $index=0;
            foreach ($prod_data as $key=>$value) {
                $index++;
                $db->QuerySetInteger($preparedQuery,1,$index);
                $db->QuerySetText($preparedQuery,2,$value['name']);
                $db->QuerySetText($preparedQuery,3,'');
                $db->QuerySetInteger($preparedQuery,4,$value['num']);
                $db->QuerySetText($preparedQuery,5,'szt.');
                $db->QuerySetInteger($preparedQuery,6,$value['discount']);
                $db->QuerySetText($preparedQuery,7,$value['user_id_main']);
                $db->QuerySetInteger($preparedQuery,8,$value['vat']);
                $discount=$value['discount'];
                $brutto_with_disc=$value['price_brutto'];
                $brutto=$brutto_with_disc/((100-$discount)/100);
                $vat=$value['vat'];
                $netto=$brutto/((100+$vat)/100);
                $db->QuerySetText($preparedQuery,9,$netto);
                $result=$db->executeQuery($preparedQuery);
                if ($result==0) echo $db->Error();
            }
        }
    }
    /**
     * Wstaw dane faktury
     *
     * @param array $invoice_data dane faktury
     */
    public function insert_invoice($invoice_data) {
    	global $invoice_config;
        $sql="INSERT INTO invoice_register (
                user_id,crypt_sell_date,create_date,
                crypt_place,crypt_client,id_user,
                id_order,draw_user,seller,company,type)
              VALUES ('".$invoice_data['user_id'].'\',\''.$invoice_data['crypt_sell_date'].'\',NOW()'.
                ',\''.$invoice_data['crypt_place'].'\',\''.$invoice_data['crypt_client'].'\',\''.$invoice_data['id_user'].
                '\',\''.$invoice_data['id_order'].'\',\''.$invoice_data['draw_user'].'\',\''.addslashes($invoice_config->seller).'\',\''.addslashes($invoice_config->company).'\',\''.$this->_type.'\');';
        $this->Query($sql);
    }
    
    /**
     * Odkoduj dane z bazy<br>
     * Jezeli pole zaczyna sie od crypt_ to jest dekodowane i zapisywane jako niezakodowane w arrayu
     *
     * @param array $data wskaznik na arraya z danymi
     * @return void
     */
    public function decrypt_data(&$data) {
        require_once ("include/my_crypt.inc");
        $my_crypt=new MyCrypt();
        foreach ($data as $key=>$value) {
            if (preg_match("@^crypt_@",$key)) {
                $new_key=preg_replace('@^crypt_@','',$key);
                $data[$new_key]=$my_crypt->endecrypt('',$value,'de');
            }
        }
        return (0);
    }
    /**
     * Zakoduj dane<br>
     * Jezeli pole nazywa sie crypt_ to jest zapelniane zakodowanymi danymi z odpowiedniego pola<br>
     * Pole zrodlowe jest potem usuwane zeby ulatwic wstawianie do bazy
     *
     * @param array $data wskaznik na tablice z danymi
     * @return void
     */
    public function encrypt_data(&$data) {
        require_once ("include/my_crypt.inc");
        $my_crypt=new MyCrypt();
        foreach ($data as $key=>$value) {
            if (preg_match('@^crypt_@',$key)) {
                $old_key=preg_replace('@^crypt_@','',$key);
                $data[$key]=$my_crypt->endecrypt('',@$data[$old_key],'');
                unset($data[$old_key]);
            }
        }
        return (0);
    }
    
    
    /**
     * Zmieniamy id faktury na podstawie formatu z konfiguracji
     *
     * @return string
     */
    public function getUserId() {
    	global $invoice_config;
    	switch ($this->_type) {
    		case 1:
    			$format=$invoice_config->id_format;
    			break;
    		case 2:
    			$format=$invoice_config->id_format_prof;
    			break;
    		default:
    			throw new Exception('Bad invoice type');
    			break;
    	}
    	
    	$format=strtolower($format);
    	$format=preg_replace('@{id}@',$this->getCurrentSeq(),$format);
    	$format=preg_replace('@{yyyy}@',date('Y'),$format);
    	$format=preg_replace('@{yy}@',date('y'),$format);
    	$format=preg_replace('@{mm}@',date('m'),$format);
    	$format=preg_replace('@{dd}@',date('d'),$format);
    	return $format;
    }
    
    /**
     * Pobierz aktualny numer faktury
     *
     * @return int
     */
    public function getCurrentSeq() {
    	global $mdbd;
    	if (!empty($this->_curr_id)) return $this->_curr_id;
    	
    	switch ($this->_type) {
    		case 1:
    			$id=$mdbd->select('value','invoice_id','type=\'vat\'','','LIMIT 1');
		    	$id++;
		    	if ($id==1) $mdbd->insert('invoice_id','value,type',"'$id','vat'");
		    		else $mdbd->update('invoice_id','value=?','type=\'vat\'',array($id=>'int'));
		    	$this->_curr_id=$id;
    			break;
    		case 2:
    			$id=$mdbd->select('value','invoice_id','type=\'pro\'','','LIMIT 1');
		    	$id++;
		    	if ($id==1) $mdbd->insert('invoice_id','value,type',"'$id','pro'");
		    		else $mdbd->update('invoice_id','value=?','type=\'pro\'',array($id=>'int'));
		    	$this->_curr_id=$id;
    			break;
    		case 2:
    			$id=$mdbd->select('value','invoice_id','type=\'cor\'','','LIMIT 1');
		    	$id++;
		    	if ($id==1) $mdbd->insert('invoice_id','value,type',"'$id','cor'");
		    		else $mdbd->update('invoice_id','value=?','type=\'cor\'',array($id=>'int'));
		    	$this->_curr_id=$id;
    			break;
			default:
				throw new Exception("Invalid invoice type");
    			break;
    	}
    	// aktualizujemy dane w bazie tylko raz!
    	return $id;
    }
    
    /**
     * Pobieramy dane z invoice_register czyli dane o fakturze
     *
     * @param int $invoiceId
     * @return array dane z tabeli w tablicy asocjacyjnej
     */
    public function invoiceUserData($invoiceId) {
        $invoiceId=(int) $invoiceId;
        $sql="SELECT * FROM invoice_register WHERE id='$invoiceId'";
        $data=$this->Query($sql);
        return $data;
    }
    
    /**
     * Pobierz wszystkie dane dotyczace faktury o danym id
     *
     * @param int $invoiceId
     * @return array
     */
    public function getInvoiceData($invoiceId) {
        $invoiceId=(int) $invoiceId;
        $data=array();
        $user=$this->invoiceUserData($invoiceId);
        $data['user']=$user[0];
        $data['products']=$this->productsForInvoice($invoiceId);
        $data['summary']=$this->productSummary($invoiceId);
        $sum=$this->invoiceSum($invoiceId);
        $data['sum']=$sum[0]['brutto_sum'];
        $data['summary_options']=$this->summaryList();
        return $data;
    }
    
    /**
     * Generujemy liste statusow faktury
     *
     * @return array lista stringow i identyfikatorow
     */
    public function summaryList() {
    	$sql="SELECT * FROM invoice_status";
    	$data=$this->Query($sql);
    	return $data;
    }
    
    /**
     * Aktualizujemy tabele invoice_register danymi z posta
     *
     * @param int $invoiceId id faktury
     * @param array $data dane do wstawienia w tablicy asocjacyjnej
     */
    public function updateInvoiceRegister($invoiceId,$data) {
        $data['crypt_sell_date']='';
        $data['crypt_place']='';
        $data['crypt_client']='';
        $data['crypt_summary_amount']='';
        $this->encrypt_data($data);
        $data['id']=intval($data['id']);
        $sql="UPDATE invoice_register SET 
        `company`='".$data['company']."',
        `crypt_place`='".$data['crypt_place']."',
        `crypt_client`='".$data['crypt_client']."',
        `draw_user`='".$data['draw_user']."',
        `seller`='".$data['seller']."',
        `summary`='".$data['summary']."',
        `recip_user`='".$data['recip_user']."',
        `create_date`='".$data['create_date']."',
        `crypt_summary_amount`='".$data['crypt_summary_amount']."',
        `crypt_sell_date`='".$data['crypt_sell_date']."',
        `user_id`='".$data['user_id']."',
        `type`='".$this->_type."'
         WHERE `id`='".$data['id'].'\'';
        $this->Query($sql);
    }
    
    /**
     * Aktualizujemy produkty do danej faktury 
     * + dodajemy dodatkowy produkt jezeli zostal ustawiony
     * + usuwamy checkniete do wywalenia produkty
     *
     * @param int $invoiceId
     * @param array $data tablica danych do produktow
     */
    public function updateInvoiceProducts($invoiceId,$data) {
    	for ($i=1;$i<count($data);$i++) {
    		$value=$data[$i];
    		$value['discount']=intval($value['discount']);
    		$value['num']=intval($value['num']);
    		$value['vat']=intval($value['vat']);
    		$invoiceId=intval($invoiceId);
    		$value['price_netto']=(float) $value['price_netto'];
    		if (empty($value['name']) ||
		    empty($value['unit']) ||
		    empty($invoiceId) ||
		    !is_int($value['num']) ||
		    !is_int($value['vat']) ||
		    !is_int($value['discount']) ||
		    !is_float($value['price_netto'])
		    ) return;
    		$sql="UPDATE invoice_products SET
    		`name`='".$value['name']."',
    		`pkwiu`='".$value['pkwiu']."',
    		`num`='".$value['num']."',
    		`discount`='".$value['discount']."',
    		`vat`='".$value['vat']."',
    		`price_netto`='".$value['price_netto']."' 
    		WHERE `invoice_id`='".$invoiceId."' AND `pos`='".$value['pos']."'";
    		$this->Query($sql);
    		
    	}
    	$value=end($data);
    	$value['discount']=intval($value['discount']);
    	$value['num']=intval($value['num']);
    	$value['vat']=intval($value['vat']);
    	$value['price_netto']=floatval($value['price_netto']);
    	$no_insert=false;
    	if (empty($value['name']) ||
		    empty($value['unit']) ||
		    empty($invoiceId) ||
		    !is_int($value['num']) ||
		    !is_int($value['vat']) ||
		    !is_int($value['discount']) ||
		    (!is_float($value['price_netto']) && !is_int($value['price_netto']))
		    ) $no_insert=true;
		 $sql="INSERT INTO `invoice_products` 
		 ( 
		 `pos` , 
		 `name` , `pkwiu` , 
		 `num` , `unit` , 
		 `discount` , `user_id_main` , 
		 `vat` , `invoice_id` , 
		 `price_netto` )
		 VALUES (
		 '".$value['pos']."',
		 '".$value['name']."','".$value['pkwiu']."', 
		 '".$value['num']."','".$value['unit']."',
		 '".$value['discount']."','0',
		 '".$value['vat']."','$invoiceId',
		 '".$value['price_netto']."'
		 );";
		 if (!$no_insert)$this->Query($sql);
		 foreach ($data as $value) {
		 	if (!empty($value['del'])) $this->removeProdFromInvoice($value['pos'],$invoiceId);
		 }
    }
    
    /**
     * Usuwamy produkty z faktury
     *
     * @param int $prodId pozycja produktu na fakturze
     * @param int $invoiceId id faktury
     * @return void
     */
    function removeProdFromInvoice($prodId,$invoiceId) {
    	$invoiceId=(int) $invoiceId;
    	$prodId=(int) $prodId;
    	$sql="DELETE  FROM invoice_products WHERE `invoice_id`='$invoiceId' AND `pos`='$prodId' LIMIT 1";
    	$this->Query($sql);
    	$sql="SELECT id, pos FROM invoice_products WHERE `invoice_id`='$invoiceId' AND `pos`>'$prodId'";
    	$data=$this->Query($sql);
    	foreach ($data as $value) {
    		$sql="UPDATE invoice_products SET `pos`='".($value['pos']-1)."' WHERE `invoice_id`='$invoiceId' AND `pos`='".$value['pos']."'";
    		$this->Query($sql);
    	}
    	return (0);
    }
    
    /**
     * Typ faktur ktore obslugujemy
     * Domyslnie 1 - czyli std faktury vat
     * (inne opcje to 2 - proforma, 3 - korekta)
     *
     * @var int
     */
    private $_type=1;
    
    /**
     * Ustawiamy typ faktur ktore chcemy obslugiwac
     * 1 - std faktura vat
     * 2 - faktura proforma
     * 3 - korekta do faktury
     *
     * @param int $type
     */
    public function setType($type=1) {
    	$type=(int) $type;
    	$this->_type=$type;
    }
    
    /**
     * Usuwamy wiele faktur
     *
     * @param array $ids lista id taka jaka otrzymamy w poscie
     * @return void
     */
    public function deleteInvoices($ids=array()) {
		foreach ($ids as $key=>$value) {
			$this->_delInvoice($key);
		}
		return (0);
    }
    
    
    /**
     * Usuwamy pojedyncza fakture i jej produkty
     *
     * @param int $id wewnetrzne id faktury
     * @return void
     */
    private function _delInvoice($id=0) {
    	$id=(int) $id;
    	$sql="SELECT user_id FROM invoice_register WHERE id=$id";
    	$data=$this->Query($sql);
    	$user_id=$data[0]['user_id'];
    	$sql="DELETE FROM invoice_register WHERE id=$id";
    	$this->Query($sql);
    	$sql="DELETE FROM invoice_products WHERE invoice_id=$id";
    	$this->Query($sql);
    	echo "Faktura $user_id usunieta.<br />";
    	return (0);
    }
    
}

?>