<?php 
/**
 * Generator kodow anty spamowych
 *
 * @author  marcin.butlak@sote.pl
 * @version $Id: anti_spam_codes.inc,v 1.8 2007/05/23 14:07:56 marcin Exp $
 * @package    include
*/ 
require_once 'PEAR/CAPTCHA.php';

class anti_spam_codes {
	/**
	 * zmienna przechowujaca obiekt image_gd
	 *
	 * @var image_gd
	 */
	private $im;
	/**
	 * typ generowanego obrazka 
	 *
	 * @var string
	 */
	private $output='png';
	/**
	 * prefix obiektu wykorzystywany do generowania zmiennej sesyjnej
	 *
	 * @var string
	 */
	private $prefix='asc_';
	/**
	 * kod obrazka
	 *
	 * @var string
	 */
	private $code='';
	/**
	 * zmienna przechowujaca wygenerowany obrazek
	 *
	 * @var string
	 */
	private $image='';
	/**
	 * sciezka do skryptu php generujacego obrazek
	 * brzydkie obejscie ale jedyne poniewaz sklep nie ma wbudowanego buforowania wyjscia
	 *
	 * @var string
	 */
	private $php_image_path='/plugins/_check_code/show_image.php';
	/**
	 * inicjalizuje obiekt oraz wczytuje zmienne sesyjne
	 *
	 */
	public function __construct($font='arial.ttf',$font_size=18, $width=150, $height=60) {

		global $DOCUMENT_ROOT;
		if ($this->check_compatibility())
		{

			$imageOptions = array(
			'font_size' => $font_size,
			'font_path' => $DOCUMENT_ROOT.GD_FONT_PATH,
			'font_file' => $font
			);

			// Set CAPTCHA options
			$options = array(
			'width' => $width,
			'height' => $height,
			'output' => $this->output,
			'imageOptions' => $imageOptions
			);

			$this->im = Text_CAPTCHA::factory('Mod_Image');

			$retval = $this->im->init($options);
			if (PEAR::isError($retval)) {
				echo 'Error initializing CAPTCHA!';
				exit;
			}
		}
		$this->load_session();
	}
	/**
	 * wczytanie danych sesyjnych
	 *
	 */
	public function load_session()
	{
		if (isset($_SESSION[$this->prefix.session_id()]['image']))
		$this->image=$_SESSION[$this->prefix.session_id()]['image'];

		if (isset($_SESSION[$this->prefix.session_id()]['code']))
		$this->code=$_SESSION[$this->prefix.session_id()]['code'];
	}
	/**
	 * zapisanie zmiennych sesyjnych
	 *
	 */
	public function save_session() {
		$_SESSION[$this->prefix.session_id()]['code']=$this->code;
		$_SESSION[$this->prefix.session_id()]['image']=$this->image;
	}
	/**
	 * sprawdza obsluge GD
	 *
	 * @return bool zwraca true w przypadku powodzenia, false w innym przypadku
	 */
	public function check_compatibility()
	{
		if (function_exists('gd_info'))
		{
			$gdinfo=gd_info();

			if (isset($gdinfo['FreeType Support']))
			return $gdinfo['FreeType Support'];
		}

		return false;
	}
	/**
	 * zwraca kod obrazka
	 *
	 * @return string
	 */
	public function get_code()
	{
		return $this->code;
	}
	/**
	 * weryfikuje kod obrazka
	 *
	 * @param string $code kod obrazka podany do weryfikacji 
	 * @return bool zwraca true w przypadku poprawnego kodu , false w innym przypadku
	 */
	public function check_code($code)
	{
		if (!$this->check_compatibility())
		return true;

		if ($this->get_code() == $code)
		return true;

		return false;
	}
	/**
	 * generuje obrazek
	 *
	 * @param string $phrase dodatkowy ciag znakow brany podczas generowania kodu
	 * 
	 */
	public function gen_code_image($phrase='')
	{
		if ($this->check_compatibility())
		{
			$this->im->setPhrase($phrase);

			$this->code=$this->im->getPhrase();

			$this->image=$this->im->getCAPTCHA();
			$this->save_session();
		}

	}
	/**
	 * zwraca sciezke do skryptu generujacego obrazek
	 *
	 * @return string
	 */
	function get_img_path()
	{
		return $this->php_image_path;
	}
	/**
	 * pokazuje obrazek
	 *
	 */
	function show_image()
	{
		echo $this->image;
	}
}

?>