<?php 
/**
 *
 * Klasa odpowiadajaca ze generowanie drzewka kategorii w sklepie
 * 
 * @author marcin.butlak@sote.pl
 * @package categoryTree.inc.php
 * @version $Id: categoryTree.inc.php,v 1.4 2007/05/14 14:31:00 marcin Exp $
 * @copyright sote 
 */
require_once("include/lang_functions.inc");
class categoryTree {
	var $category;
	var $checkCat=false;
	function categoryTree($category)
	{
		$this->category=$category;
	}
	/**
	 * Pokaz drzewo kategorii
	 * @param string $catId
	 * @param int $toLevel do poziomu zagniezdzenia
	 */
	function showTree($idc='',$toLevel=5)
	{
		global $theme;
		if (!empty($idc))
		{
			$this->checkCat=true;
			$idc=explode("_",ltrim($idc,"id_"));
		}
		else 
		$idc=array();
		
		// wlacz buforowanie wyjscia
		ob_start();
		$theme->treeNodesOpen('none',false);
		// generuj drzewo kategorii
		$this->parseTree($this->category, 1, $toLevel,$idc);
		// zakoncz buforowanie wyjscia i wyslij jego zawartosc
		$theme->treeNodesClose();
		ob_end_flush();
	}
	/**
	 * Rekurencyjna funkcja generujaca drzewo kategorii
	 *
	 * @param array $cat kategorie
	 * @param int $nestLevel poziom zagniezdzenia
	 * @param int $toLevel maksymalny poziom zagniezdzenia
	 */
	function parseTree($cat, $nestLevel, $toLevel,$idc)
	{
		global $theme;



		if ($nestLevel > $toLevel)
		return;

		if ($this->checkCat)
		{
			$catm=$idc[0];
			for ($i=1; $i < $nestLevel; $i++)
			if (isset($idc[$i]))
			$catm.="_".$idc[$i];
		}
		
		$maxCats=count($cat);
		$countCats=0;
		foreach ($cat as $key=>$val)
		{
			$countCats++;
			
			if ($countCats >= $maxCats)
			$lastCat=true;
			else 
			$lastCat=false;
			
			$hide=true;
			
			// jesli klucz jest liczba sprawdz czy jest to podkategoria z kolejnym poziomem zaglebienia
			if (is_numeric($key))
			{

				if (is_array($val))
				{
					// w przypadku kolejnego poziomu zaglebienia przekaz dalej
					$this->parseTree($val, $nestLevel, $toLevel,$idc);
				}
				else
				{

					// w przypadku braku kolejnego poziomu wyswietl podkategorie
					$theme->treeElementOpen("child_node");
					$theme->treeElement(langF::translate($key), $val, $nestLevel,0,$lastCat);
					$theme->treeElementClose();
				}
			}
			else
			if (is_array($val))
			{
				if (array_key_exists("elements",$val))
				$count=count($val["elements"]);
				else
				$count = 0;
				if ($this->checkCat)
				{
					if ($catm==ltrim($key,"id_"))
					$hide=false;
				}
				if ($nestLevel==1)
				$theme->treeElementOpen("main_node");
				else
				if ($count)
				$theme->treeElementOpen("root_node");
				else
				$theme->treeElementOpen("child_node");

				$theme->treeElement(langF::translate($val["name"]), $key, $nestLevel, $count, $lastCat,$hide);
				if ($count)
				{
					$theme->treeNodesOpen($key, $hide);
					$this->parseTree($val["elements"], $nestLevel+1, $toLevel,$idc);
					$theme->treeNodesClose();
				}

				$theme->treeElementClose();
			}
			else
			{
				$theme->treeElementOpen("child_node");
				$theme->treeElement(langF::translate($key), $val, $nestLevel, 0, $lastCat);
				$theme->treeElementClose();
			}
		}
	}


};
?>