<?php
/**
* Wyswietlanie zdjec do produktu
*
* @author  m@sote.pl rp@sote.pl marcin.butlak@sote.pl
* @version $Id: image.inc,v 1.5 2007-09-24 15:31:20 marcin Exp $
* @package include
* @copyright sote
*/
require_once ("include/gdimage.inc");
require_once("config/auto_config/photo.inc.php");

/* PREFIX - zdjecie orginalne produktu */
if(!defined("IMAGE_ORIG"))
define ("IMAGE_ORIG", "product_orig");
/* PREFIX - zdjecie duze produktu */
if(!defined("IMAGE_BIG"))
define ("IMAGE_BIG", "product_big");
/* PREFIX - zdjecie dla opisu produktu produktu */
if(!defined("IMAGE_INFO"))
define ("IMAGE_INFO", "product_info");
/* PREFIX - zdjecie dla pasazow */
if(!defined("IMAGE_PASAZ"))
define ("IMAGE_PASAZ", "product_pasaz");
/* PREFIX - zdjecie male produktu */
if(!defined("IMAGE_SMALL"))
define ("IMAGE_SMALL", "product_small");
/* PREFIX - zdjecie male produktu */
if(!defined("IMAGE_ICON"))
define ("IMAGE_ICON", "product_icon");
/* PREFIX - zdjecie dla galerii produktu */
if(!defined("IMAGE_GALLERY"))
define ("IMAGE_GALLERY", "product_gallery");
/* PREFIX - zdjecie dla edycji produktu */
if(!defined("IMAGE_THUMB"))
define ("IMAGE_THUMB", "product_thumb");


// okreslenie czy dane zdjcie moe by powikszane (po klikniciu)
define ("IMAGE_ZOOM_UP_TRUE",true);
define ("IMAGE_ZOOM_UP_FALSE",false);

class Image {

	var $photo_dir;                            // katalog zawierajacy zdjecia produktow wzgledem $DOCUMENT_ROOT
	var $support_ext="jpg|gif|png";            // obslugiwane typy plikow (depricated)
	var $max_size=250;                         // maksymalna szerokosc lub wysokosc zdjecia (depricated)
	var $max_images=10;                        // maksymalna liczba zdjec (depricated)
	var $default_bmp_name="/themes/base/base_theme/_img/_mask.gif"; // nazwa zalczanego pliku w przypadku nie odnalezienia zadanego pliku
	var $free=-1;
	var $max_height=0;
	var $max_width=0;
	var $image_list=array();
	/**
    * @var string prefix wywoania zdjcia (np. http://www.sklep.pl, wykorzystywane w adminie, do odwolania sie do /photo/)
    */
	var $http_prefix='';

	/**
    * Konstruktor
    *
    * @access public
    * @return none
    */
	function Image() {
		global $DOCUMENT_ROOT,$_SERVER;
		global $config,$shop;

		if ($shop->admin) {
			$this->photo_dir=$config->admin_dir."/photo/";
			$this->http_prefix="http://".str_replace("http://","",$config->www);
		} else {
			$this->photo_dir=$config->htdocs_dir."/photo/";
		}

		return(0);
	} // end image()

	/**
	 * Wyswietla zdjcie produktu
	 *
	 * @param object $rec rekord produktu
	 * @param string $prefix okresla zdjecie produktu
	 * @param string $alt tytul zdjecia
	 * @param string $id id dla zdjecia
	 * @return unknown
	 */
	function show($rec,$prefix="",$alt="",$id="photo") {
		global $DOCUMENT_ROOT,$config,$shop;
		$dynamic_scale = 0;

		if ($prefix=="product_small")
		$photo=$rec->data['photo_small']."_".$rec->data['photo_uid'];
		else
		$photo=$rec->data['photo']."_".$rec->data['photo_uid'];

		// 1. wywolaj wyswietlenie zdjecia np. nazwa.jpg (dla $photo="nazwa.jpg")
		// 2. sprawdz czy istnieje plik nazwa-1.jpg
		// 3. a) jesli jest to wyswietl je i zwieksz numer o 1 i idz do 2.
		//    b) jesli nie to zakoncz wyswietlanie || sprawdz kolejny numer az do $this->max_images
		$this->max_width=$rec->data['photo_info_width'];
		$this->max_height=$rec->data['photo_info_height'];
		$this->_showPhoto($photo,$prefix,htmlspecialchars($alt,ENT_QUOTES),$id);

		return(0);
	} // end show()
	/**
	 * zwraca indeks z wolnym miejscem dla zdjecia
	 * @deprecated wyleci w patchu
	 * @param string $photo_uid id zdjecia
	 * @param int $photo_count ilosc zdjec
	 * @return int
	 */
	function get_free_place($photo_uid,$photo_count)
	{
		return $photo_count+1;
	}

	function gen_photo_uid($user_id)
	{
		return substr(md5($user_id.microtime()),0,12);
	}

	function get_max_size($rec, $prefix)
	{
		global $DOCUMENT_ROOT, $shop;
		$max_size=array("width"=>0,"height"=>0);
		$photo_part=@$rec->data['photo_uid'];
		for ($i=1;$i<=@$rec->data['photo_count'];$i++)
		{
			if ($shop->admin)
			$file_name=$this->get_file($i.'_'.$photo_part, $prefix);
			else
			if ($i != $rec->data['photo'])
			$file_name=$this->get_file($i.'_'.$photo_part, $prefix);

			if (!empty($file_name))
			{

				$ims=getimagesize($file_name);
				if ($max_size["width"] < $ims[0])
				$max_size["width"]=$ims[0];
				if ($max_size["height"] < $ims[1])
				$max_size["height"]=$ims[1];
				
			}

		}
		return $max_size;
	}

	function get_resize($name, $prefix, $width, $height)
	{
		$size=@getimagesize($this->get_file($name, $prefix));

		if (!$size)
		return false;

		if ($size[0] > $width && $size[0] > $size[1])
		{
			$height = $size[1]*($width/$size[0]);
		}
		else
		if ($size[1] > $height)
		$width = $size[0]*($height/$size[1]);


		if ($size[0] < $width && $size[1] < $height)
		{
			$width=$size[0];
			$height=$size[1];
		}

		return array("width"=>$width, "height"=>$height);
	}


	/**
	 * Zwraca nazwe zdjecia bez rozszezenia
	 *
	 * @param int $photo_number numer zdjecia 
	 * @param string $photo_uid unikalny numer id pobierany z $rec->data['photo_uid']
	 * @return string nazwa ("$photo_number_$photo_uid")
	 */
	function get_image_name($photo_number, $photo_uid)
	{
		if (empty($photo_uid)) return '';
		return $photo_number.'_'.$photo_uid;
	}

	/**
	 * Zwraca sciezke dla nazwy zdjecia
	 *
	 * @param string $name nazwa zdjecia 
	 * @return string sciezka 
	 */
	function path_name($name)
	{
		$pos=0;
		if (($tmp=strpos($name, "_")) !== false)
		{
			$pos=$tmp+1;
		}

		$dir1=$name[$pos];
		$dir2=$name[$pos+1];
		$dir3=$name[$pos+2];
		return "$dir1/$dir2/$dir3";
	}
	/**
	 * Zwracajaca pelna nazwa/sciezke/url zdjecia w sklepie
	 *
	 * przykladowe pobranie pelnego URL do zdjecia duzego:
	 * $image->get_file($image->get_image_name(1, $rec->data['photo_uid']), IMAGE_BIG, false, true)
	 * 
	 * 
	 * @param string $name nazwa zdjecia 
	 * @param string $prefix prefix okresla rodzaj zdjecia (IMAGE_BIG, IMAGE_INFO, IMAGE_SMALL, IMAGE_GALLERY) brak prefixu funkcja zwraca wszystkie zdjecia w tablicy 
	 * @param bool $name_only jesli prawda zwraca jest wylacznie pelna nazwa zdjecia, jesli falsz zwraca pelna sciezke do zdjecia lub url
	 * @param bool $get_url	jesli prawda zwracany jest URL do zdjecia ($name_only musi byc ustawione na false)
	 * @return string/array pelna nazwa/sciezka/url zdjecia (lub tablica w przypadku braku prefixu)
	 */
	function get_file($name, $prefix='', $name_only=false, $get_url=false)
	{
		global $config, $DOCUMENT_ROOT, $shop;

		
		if (empty($name)) {
			return false;
		}

		if (!is_array($prefix))
		{
			if (!empty($prefix))
			$prefix .= '/';

			if ($shop->admin) {
				$path=$DOCUMENT_ROOT."/../htdocs/photo/".$prefix;
			} else {
				$path=$DOCUMENT_ROOT."/photo/".$prefix;
			}


			$image_name=$name;
			$name=$this->path_name($name)."/$name";

			$file=$path.$name.".jpg";

			if (is_file($file))
			{
				if ($name_only)
				return $image_name.".jpg";

				if ($get_url)
				return $this->http_prefix."/photo/".$prefix.$name.".jpg";

				return $file;
			}


		}
		else
		{
			$files=array();
			$image_name=$name;
			$name=$this->path_name($name)."/$name";
			foreach($prefix as $v)
			{

				if ($shop->admin) {
					$path=$DOCUMENT_ROOT."/../htdocs/photo/".$v."/";
				} else {
					$path=$DOCUMENT_ROOT."/photo/".$v."/";
				}

				$file=$path.$name.".jpg";

				if (is_file($file))
				{
					if ($name_only)
					$files[$v]=$image_name.".jpg";
					else
					if ($get_url)
					$files[$v]=$this->http_prefix."/photo/".$prefix."/".$name.".jpg";
					else
					$files[$v]=$file;
				}
			}


			return $files;
		}

		return false;
	}

	function get_name_ext($filename) {
		$name=preg_match("/^(.+).(.{3})$/",$filename,$matches);

		$name=&$matches[1];
		$ext=&$matches[2];
		// print "<font color=red>$name</font>.<font color=green>$ext</font <BR>";

		return array($name,$ext);
	} // end get_name_ext()
	
	function count_files($photo_uid) {
		$count=0;
		for ($i=1; $this->get_file($this->get_image_name($i,$photo_uid),IMAGE_ORIG); $i++) {
			$count++;
		}
		
		return $count;
	}

	/**
    * Funkcja odpowiadajaca za weryfikacje obslugiwanych formatow bitmap
    *
    * @param  string $filename      nazwa pliku do weryfikacji
    * @param  array  $support_ext   obslugiwane typy plikow
    *
    * @access public
    * @static
    * @return int  status weryfikacji pliku (1 - rozpoznano rozszezenie i typ pliku, 0 - nie rozpoznano rozszezenia)
    *
    */
	function verifyInputData($file){
		$verify_status=0;
		if (preg_match("/$this->support_ext/i",$file)){
			$verify_status=1;
		}
		return $verify_status;
	} // end verifyInputData()

	/**
    * Wyswietl zdjecie produktu, jesli istnieje.
    *
    * @param string $photo    nazwa zdjecia pobrana z bazy
    * @param string $align    [left|right] parametr align przy zdjeciu
    * @param string $prefix   string poprzedzajacy nazwe zdjecia (nazwa pobrana z bazy)
    * @param int    $max_size maksymalna szeroko lub wysoko zdjcia
    * @param bool   $zoom_up  true - zdjcie moe by powikszane po klikniciu, false - w p.w.
    *
    * @access private
    * @return none
    */
	function _showPhoto($photo,$prefix="",$alt="",$id="photo") {
		global $DOCUMENT_ROOT;
		global $theme;
		global $my_xml_options;
		global $shop,$photoconfig;

		if (empty($photo)) return;

		$_allow_scale=true;


		$file_name=$this->get_file($photo, $prefix, true);

		if ($file_name) {
			$photo_big=$this->get_file($photo, IMAGE_BIG);
			$photo_big_url=$this->get_file($photo, IMAGE_BIG,false,true);
			$photo_url=$this->get_file($photo, $prefix,false,true);

			$size=getimagesize($photo_big);


			if ($prefix==IMAGE_INFO)
			{
				$base_name=basename($photo_big);
				$photo_dir=$this->path_name($base_name);
				$max_width=$this->max_width;
				$max_height=$this->max_height;
				$onclick="window.open('".$photo_big_url."','_blank','width=".$size[0].",height=".$size[1]."scrollbars=0,menubar=0,status=0,location=0,directories=0,toolbar=0,resizable=0')";
				print "<div id=\"photo_link\" style=\"margin: 0 auto;width:{$max_width}px;height:{$max_height}px\"><img class=\"pseudoLink\" id=\"$id\" src=\"".$photo_url."\" onclick=\"$onclick\" alt=\"$alt\" /></div>";
			}
			else
			{
				print "<img src=\"".$photo_url."\" alt=\"$alt\" />";
			}
		}

		return;
	} // end _showPhoto()


	function create_photo_from_conf($conf, $photo, $prefix, $photoout)
	{

		global $DOCUMENT_ROOT, $ftp, $config,$photoconfig;
		$gdim = new gdImage();
		if ($gdim->checkGDSupport(gdJPG))
		{
			$file=$this->get_file($photo,IMAGE_ORIG);
			if ($file) {
				$gdim->loadFromFile($file);
			}
			else
			if (is_file($photo))
			{
				$gdim->loadFromFile($photo);
			}
			else {
				return false;
			}

			if ($gdim->im)
			{
				$w=@$conf['width'];
				$h=@$conf['height'];
				$q=@$conf['quality'];

				if ($prefix=='product_thumb')
				$gdim->resize($w, $h,false);
				else
				$gdim->resize($w, $h);

				if (!empty($photoconfig->watermark[$prefix]) && $gdim->checkGDSupport(gdTTF))
				{
					$ts=$photoconfig->watermark['text_pos'];
					$tsize=$photoconfig->watermark['text_size'];
					$text_auto=$photoconfig->watermark['text_auto'];

					$gdim->font->setColor($photoconfig->watermark['text_cr'], $photoconfig->watermark['text_cg'],$photoconfig->watermark['text_cb'], $photoconfig->watermark['text_alpha']);
					$box=array();

					if (($ts=='bottom') || ($ts=='up') || ($ts=='center'))
					{
						do
						{
							$gdim->font->setFont('./file/arial.ttf', $tsize);
							$box=$gdim->getTextBoxSize($photoconfig->watermark['text_text'],0);
							$tsize--;
							$offset=$tsize/4;
						} while($gdim->w < $box['width'] && !empty($text_auto));
					}
					else
					{
						do
						{
							$gdim->font->setFont('./file/arial.ttf', $tsize);
							$box=$gdim->getTextBoxSize($photoconfig->watermark['text_text'],0);
							$tsize--;
							$offset=$tsize/4;
						} while($gdim->h < $box['width'] && !empty($text_auto));
					}
					switch($ts)
					{
						case 'up':
							$gdim->drawText($photoconfig->watermark['text_text'], 2, $tsize, 0);
							break;
						case 'bottom':
							$gdim->drawText($photoconfig->watermark['text_text'], 2, $gdim->h-$offset, 0);
							break;
						case 'left':
							$gdim->drawText($photoconfig->watermark['text_text'], $offset, 0, -90);
							break;
						case 'right':
							$gdim->drawText($photoconfig->watermark['text_text'], $gdim->w-$offset, $gdim->h, 90);
							break;
						case 'center':
							$x=($gdim->w/2)-($box['width']/2);
							$y=($gdim->h/2-$offset)+($box['height']/2);

							$gdim->drawText($photoconfig->watermark['text_text'], $x, $y, 0);
							break;
					}

				}


				$gdim->saveToFile($DOCUMENT_ROOT.'/tmp/'.$photoout,gdJPG, $q);
				$gdim->destroy();
				unset($gdim);
				$ftp->connect();

				$ftp->mkdir($config->ftp['ftp_dir']."/htdocs/photo/".$prefix."/".$this->path_name($photoout));
				$ftp->put($DOCUMENT_ROOT.'/tmp/'.$photoout,$config->ftp['ftp_dir']."/htdocs/photo/".$prefix."/".$this->path_name($photoout),$photoout);
				

				return true;
			}
		}

		return false;

	}

	/**
    * Wyswietl zdjecie produktu duze (max_photo) jesli istnieje.
    *
    * @param string $photo    nazwa zdjecia pobrana z bazy
	* @author krzys@sote.pl
    * @access private
    * @return none
    **/

	function _show_max_Photo($rec) {
		global $DOCUMENT_ROOT;



		return;
	}



	/**
    * Wyswietl jako atrybut onClick wywolanie otworzenie nowego okna przegladarki
    *
    * @param int   $x    szerokosc okna
    * @param int   $y    wysokosc okna
    * @param stirn $name nazwa okna
    *
    * @access public
    * @return none
    */
	function onClick($x,$y,$name) {
		print "onclick=\"window.open('','$name','width=$x,height=$y,scrollbars=0,menubar=0,status=0,location=0,directories=0,toolbar=0,resizable=0');\"";
	} // end onClick()

} // end class Image

$image =& new Image;

?>
