<?php 
/**
 * Klasa generujaca pasek nawigacyjny
 * @author marcin.butlak@sote.pl
 * @copyright sote
 * @version $Id: navigationPath.inc.php,v 1.4 2007-06-26 08:33:54 marcin Exp $ 
 */
require_once("include/lang_functions.inc");
class navigationPath {

	private $path=array();
	private $count=0;
	private $catId;
	private $categories=array();

	public function showPath()
	{
		echo $this->getPath();
	}

	public function getPath()
	{
		global $theme;
		$path='';
		$current=str_replace(array("index.php", "cidc="),array("","idc="),$_SERVER['REQUEST_URI']);

		$count=0;

		foreach ($this->path as $val)
		{
			$count++;
			if ($count==$this->count)
			$path.=" &raquo; <u>{$val['name']}</u>";
			else
			$path.=' &raquo; '.$theme->navigationLink($theme->google_url($val['url'],$val['name']),false, $val['name']);
		}
		return $path;
	}
	/**
	 * pobierz ostatnia nazwe linku ze sciezki
	 *
	 * @return unknown
	 */
	public function getLastLinkName()
	{
		if (!$this->count)
		return "";

		return $this->path[$this->count-1]['name'];
	}
	/**
	 * dodaj nowy link do sciezki 
	 *
	 * @param string $url link url
	 * @param string $name nazwa linku
	 */
	public function appendNewLink($url, $name)
	{
		array_push($this->path, array("url"=>$url, "name"=>LangF::translate(htmlspecialchars(trim($name)))));
		$this->count++;
	}
	/**
	 * Generuj sciezke dla produktu
	 *
	 * @param object $rec obiekt rekordu produktu
	 */
	public function genProductPath($rec)
	{
		global $theme, $config;
		
		$currId=$rec->data["id_category1"];
		
		$tree_url=$this->getCategoryUrlPart();

		$this->appendNewLink("/go/_category/?idc=id_$currId".$tree_url,$rec->data["category1"]);

		for ($i=2; $i <= 5; $i++)
		{
			$currId.="_".$rec->data["id_category$i"];
			if (isset($rec->data["id_category$i"]) && !empty($rec->data["id_category$i"]))
			{
				$this->appendNewLink("/go/_category/?idc=$currId".$tree_url,$rec->data["category$i"]);
			}
		}

		$this->appendNewLink("/go/_info/?user_id={$rec->data['user_id']}",$rec->data['name']);
	}

	private function genCategoryPathHelp($cat, $ckey,$nest, $max)
	{
		global $theme,$config;
		if ($nest <= $max)
		{
			$tree_url=$this->getCategoryUrlPart();

			$catm=$ckey[0];
			for ($i=1; $i < $nest; $i++)
			$catm.="_".$ckey[$i];

			foreach ($cat as $key=>$val) {
				if (is_numeric($key))
				{
					if (is_array($val))
					$this->genCategoryPathHelp($val, $ckey, $nest, $max);
					else
					{

						if ($catm==str_replace("id_","", $val))
						$this->appendNewLink("/go/_category/?idc=$val".$tree_url,$key);

					}
				}
				else
				if (is_array($val))
				{

					if ($catm==str_replace("id_","", $key))
					$this->appendNewLink("/go/_category/?idc=$key".$tree_url,$val["name"]);

					if (array_key_exists("elements",$val))
					$this->genCategoryPathHelp($val["elements"],$ckey, $nest+1, $max);

				}
				else
				{

					if ($catm==str_replace("id_","", $val))
					$this->appendNewLink("/go/_category/?idc=$val".$tree_url,$key);

				}
			}
		}
	}

	/**
	 * Generuj sciezke dla kategorii
	 *
	 */
	public function genCategoryPath()
	{
		global $theme;
		include ("config/tmp/category.php");

		if (isset($_REQUEST['cidc']))
		{
			$this->catId=$_REQUEST['cidc'];

		}
		else
		if (isset($_REQUEST['idc']))
		{
			$this->catId=$_REQUEST['idc'];

		}

		if (isset($category[$this->catId]))
		{
			$tree_url=$this->getCategoryUrlPart();

			$this->appendNewLink("/go/_category/?idc=$this->catId".$tree_url,$category[$this->catId]["name"]);
		}
		else
		{
			$catTab=explode("_",$this->catId);

			$this->genCategoryPathHelp($category,$catTab, 1, count($catTab));
		}


	}
	/**
	 * Generuj sciezke dla plikow (podstron)
	 *
	 */
	public function genFilesPath()
	{
		global $lang;
		$file=$_REQUEST['file'];
		$fileName=@$lang->bar_title[str_replace(".html","",$file)];
		if (! empty($fileName)) {
			$this->appendNewLink("/go/_files/?file=$file",$fileName);
		}
	}
	/**
	 * Generuj sciezke dla promocji, bestseller, nowosci
	 *
	 */
	public function genPromotionPath()
	{
		global $lang;
		$column=$_REQUEST['column'];
		$colName=@$lang->bar_title[$column];
		if (! empty($colName)) {
			$this->appendNewLink("/go/_promotion/?column=$column",$colName);
		}
	}

	public function genNewsPath($newsTitle)
	{
		$this->appendNewLink($_SERVER['PHP_SELF'],$newsTitle);
	}
	/**
	 * zwraca string zawierajacy wspolna czesc parametrow dla kategorii
	 *
	 * @return string
	 */
	private function getCategoryUrlPart() {
		global $config;
		
		$tree_url="";

		if (isset($_REQUEST['order']) && !empty($_REQUEST['order'])) {
			$tree_url.="&order=".$_REQUEST['order'];
		} elseif (isset($_SESSION['__order_main']) && !empty($_SESSION['__order_main'])) {
			$tree_url.="&order=".$_SESSION['__order_main'];
		} else {
			if ($config->main_order_default=='price') {
				$main_order_default='price_brutto';
			} elseif (strpos($config->main_order_default,"name") !== false) {
				$main_order_default="name";
			} else {
				$main_order_default=$config->main_order_default;
			}
			$order_id=array_search($main_order_default,$config->dbedit_order_names['main']);
			$tree_url.="&order=$order_id";
		}

		$tree_url.="&page=1";

		if (isset($_SESSION['__producer_filter']) && !empty($_SESSION['__producer_filter'])) {
			$tree_url.="&producer_id=".$_SESSION['__producer_filter'];
		} elseif (isset($_REQUEST['producer_filter']) && !empty($_REQUEST['producer_filter'])) {
			$tree_url.="&producer_id=".$_REQUEST['producer_filter'];
		} else {
			$tree_url.="&producer_id=0";
		}

		if (isset($_SESSION['__record_row_type']) && !empty($_SESSION['__record_row_type'])) {
			$tree_url.="&record_row=".$_SESSION['__record_row_type'];
		} else {
			$tree_url.="&record_row=".$config->record_row_type_default;
		}

		return $tree_url;
	}

};

global $navigationPath;

$navigationPath=new navigationPath();

?>