<?php
/**
* Generowanie maila i wysanie zamwienia do sprzedawcy i kleinta.
*
* @author  m@sote.pl
* @version $Id: send.inc,v 1.7 2007-10-09 19:19:11 marcin Exp $
* @package    include
*/

/**
* Klasa obsugujca wysanie zamwienia.
* @package order
* @subpackage htdocs
*/
class OrderSend {

	/**
    * Wylij zamwienie do sprzedawcy i potwierdzenie do klienta.
    *
    * @return bool true - zamwienie zostao poprawnie wysane, false w p.w.
    */
	function send($send_mail_only=false) {

		global $_SESSION,$sess;
		global $DOCUMENT_ROOT;
		global $lang,$config;
		global $__check,$theme;
		global $auto_transaction;
		global $theme;

		// dodaj obsluge wysylania wiadomosci e-mail
		require_once ("lib/Mail/MyMail.php");

		$mail =new MyMail(true);

		// ustalenie typu wysylanego maila do sprzedawcy
		if (!empty($config->email_HTML_merchant)) {
			$config->mail_type_path="html";
			$mail->allowHTML(true);
		} else {
			$config->mail_type_path="txt";
			$mail->allowHTML(false,false);
		}

		require_once ("lib/SPayment/SOrder.inc.php");
		$ord_reg =& new SOrder;

		if (! empty($_SESSION['global_basket_data'])) {
			require_once ("go/_basket/include/my_ext_basket.inc.php");
			$basket=& new My_Ext_Basket;
			$basket->init();
			$my_basket=&$basket;
			$my_basket->display="text";
		} else {
			//            if (!$auto_transaction) {
			//                die ("gpo2main 2<hr>");
			//                $theme->go2main();
			//                exit;
			//            } else return;
		}

		// generowanie tresci zamowienia do maila
		require_once("go/_register/include/message.inc.php");
		$message =& new Message; // odczytaj dane z sesji z wczesniej wypelnionych formularzy

		if (! empty($_SESSION['form'])) {
			$form=$_SESSION['form'];
		}
		if (! empty($_SESSION['form_cor'])) {
			$form_cor=$_SESSION['form_cor'];
		}

		// odczytaj rodzaj platnosci
		if (! empty($_SESSION['global_pay_name'])) {
			$pay_name=$_SESSION['global_pay_name'];
		}
		if (empty($pay_name)) $pay_name=$_SESSION['prev_session']['global_pay_name'];
		if ((empty($pay_name)) && (! empty($global_pay_name))) {
			$pay_name=$global_pay_name;
		}

		$body=$message->order2txt($ord_reg->getOrderID());

		$basket_txt=$my_basket->basket_txt($pay_name);

		// wyslij maila z zamowieniem
		$from=$config->from_email;
		$to=$config->order_email;
		$merchant_email=$to;
		$subject=$lang->order_subject;

		if (! empty($form['email'])) {
			$reply=$form['email']; $user_email=$reply;
		} else $reply="";

		$confirm=false;

		// wyslij maila z zamowieniem o ile mail nie zostal juz wyslany
		if (my(@$_SESSION['global_lock_send'])!=true) {

			// odczytaj numer transakcji
			$order_id=$ord_reg->getOrderID();
			$order_id_date=$ord_reg->getOrderIDDate();

			// pelna tresc zamowienia
			$order_body=$message->order_body($basket_txt,$body,$order_id,$pay_name);
			// sprawdz czy uzytkownik nie wybral wczesniej platnosci karta
			if ($__check==1) {
				$order_body.=$lang->send_add_info;
			}

			// generuj tytu
			$subject="$lang->order_id: $order_id, $pay_name, $subject";

			// wyslij maila z zamowieniem do sprzedawcy
			if ($mail->send($from,$to,$subject,$order_body,$reply)) {
				//ustalenie typu wysylanego maila do klienta
				if (!empty($config->email_HTML_client)) {
					$config->mail_type_path="html";
					$mail->allowHTML(true);
				} else {
					$config->mail_type_path="txt";
					$mail->allowHTML(false,false);
				}
				// wyslij maila z potwierdzeniem zamowienia do klienta
				$confirm_subject=$lang->order_confirm_subject." ".$_SERVER['HTTP_HOST']." ($lang->order_id_nr: $order_id)";
				$host=$_SERVER['HTTP_HOST'];
				$from=$merchant_email;
				$to=$user_email;
				$order_body='';
				$body=$message->order2txt($ord_reg->getOrderID(),true);
				$basket_txt=$my_basket->basket_txt($pay_name);
				$order_body.=$message->order_body($basket_txt,$body,$order_id,$pay_name,true);
				// nazwa hosta

				$reply=$config->from_email;




				$mail->send($from,$to,$confirm_subject,$order_body,$reply,"html");
				$confirm=true;

				// jesli jest wlaczona opcja sprzedazy on-line, to zapamietaj stan koszyka przed jeggo skasowaniem
				//                if (in_array("main_keys",$config->plugins)) {
				//                    $prev_session['my_basket']=$my_basket;
				//                    $prev_session['global_order_id']=$order_id;
				//                    $prev_session['global_basket_amount']=$_SESSION['global_basket_amount'];
				//                    $sess->register("prev_session",$prev_session);
				//                }
				// end

				// skasuj zawartosc koszyka
				if (!$send_mail_only) {
					$basket->emptyBasket();
					$this->save2db($order_id);
				}

			}
		} else {
			$confirm=true;
		}

		return $confirm;
	} // end send()

	function save2db($order_id) {
		global $global_basket_amount,$global_basket_count,$global_order_amount;
		global $mdbd, $sess;
		$global_order_amount=0;
		$global_basket_count=0;
		$global_order_amount=0;
		
		$sess->unregister('global_lock_register');
		$saved_session=serialize($_SESSION);
		$mdbd->update('order_session','data=?','order_id=?',array("$saved_session"=>"text","$order_id"=>"int"));
		$sess->unregister("global_basket_amount");
		$sess->unregister("global_order_amount");
		$sess->unregister("global_basket_count");
		$sess->unregister("global_order_id");
		$sess->unregister("global_order_id_date");
		$sess->unregister("global_basket_data");
	}

} // end class OrderSend

?>
