<?php
/**
* Funckje obslugi komunikacji z PayBack nadeslany przez kg@payback.pl
*
* @author  PayBack
* @version $Id: payback.inc.php,v 1.1.1.1 2006/09/02 13:56:04 marek Exp $
* @package    include
*/

// start SOTE: (drobne zmiany)
define("MY_PASSWORD", $payback_config->id);
define("MY_ID",       $payback_config->password);
include 'include/payback/xmlrpc.inc.php';
// end SOTE:

// funkcja do naliczania punktw
function pb_give_points($komu, $ile, $idt)
{
	$pb['login']   = $komu;		// komu dajemy punkty (string) - login klienta w PayBack
	$pb['points']  = $ile;		// ile
	$pb['idt']     = $idt;		// za co - powinien to by unikalny numer (id transakcji) typu integer
	$pb['partner'] = MY_ID;		// identyfikator sklepu w PayBacku
	$pb['time']    = time();	// wiadomo

	// teraz generujemy podpis, ktry zostanie sprawdzony w PayBacku
	// taki anty-spoofing ;-) 
	$pb['sig']     = md5($pb['login'] . $pb['points'] . $pb['partner'] . $pb['time'] . $pb['idt']  . MY_PASSWORD);	
	
	// generujemy paczk
	$paczka = xmlrpc_encode($pb);

	// i wysyamy...
	$server = new xmlrpc_client('/xmlrpc/server.php', 'kg.payback.pl', 80);
	$message = new xmlrpcmsg('GivePoints', array($paczka));
	$result = $server->send($message);

	if (!$result)	// brak poczenia
	{
/*
		Tutaj (lub ju po wyjciu z funkcji) wskazane by byo wrzucenie
		informacji o punktach do jakiej kolejki (np. tabeli w bazie danych),
		aby mona byo naliczy punkty nastpnym razem (gdy ju bdzie poczenie)
*/
		return "Brak poczenia";
	}
	elseif ($result->faultCode())	// poczono, ale nastpi jaki bd
	{
/*
		To te mona zmieni (jakie wasne komunikaty, itp.)
		Standardowo serwer zwraca nastpujce bedy:
		
		$result->faultCode()	$result->faultString()
		801			Brak parametrw
		802			Brak uytkownika
		803			Brak punktw
		804			Brak id
		805			Brak klucza
		806			Brak uytkownika $paczka[login]
		810			Niepoprawny podpis
		811			Zdublowana transakcja
		815			Bd podczas naliczania punktw
*/
		return "Bd XML-RPC #" . $result->faultCode() . ": " . utf8_decode($result->faultString());
	}
	else
	{
/*
		Jeli wszystko poszo OK 
		to serwer zwraca komunikat
		"Uytkownik $paczka[login] otrzyma $paczka[points] punktw"
		Oczywicie te mona to zmieni :)
*/
		$resval = $result->value();
		$val = utf8_decode($resval->scalarval());

		return $val;
	}
}

// funkcja do weryfikacji transakcji
function pb_verify_transaction($idt, $ver)
{
	$pb['idt']     = $idt;		// id transakcji
	$pb['partner'] = MY_ID;		// identyfikator sklepu w PayBacku
	$pb['ver']     = $ver;	    // jak weryfikujemy (0 - odrzucamy punkty, 1 - uznajemy)
	$pb['time']    = time();	// wiadomo

	// teraz generujemy podpis, ktry zostanie sprawdzony w PayBacku
    // podobnie jak w pb_give_points()
	$pb['sig']     = md5($pb['idt'] . $pb['partner']. $pb['ver']. $pb['time'] . MY_PASSWORD);

	// generujemy paczk
	$paczka = xmlrpc_encode($pb);

	// i wysyamy...
	$server = new xmlrpc_client('/xmlrpc/server.php', 'kg.payback.pl', 80);
	$message = new xmlrpcmsg('VerifyTransaction', array($paczka));
	$result = $server->send($message);

    // dalej podobnie jak w pb_give_points()
	if (!$result) 
	{
		return "Brak poczenia";
	}
	elseif ($result->faultCode())
	{
		return "Bd XML-RPC #" . $result->faultCode() . ": " . utf8_decode($result->faultString());
	}
	else
	{
/*
		Jeli wszystko poszo OK 
		to serwer zwraca komunikat
		"Zweryfikowano transakcj $paczka[idt]"
		Oczywicie te mona to zmieni :)
*/
		$resval = $result->value();
		$val = utf8_decode($resval->scalarval());

		return $val;
	}
}

function pb_user_exists($pb_login)
{
	$server = new xmlrpc_client('/xmlrpc/server.php', 'kg.payback.pl', 80);
	$message = new xmlrpcmsg('UserExists', array(xmlrpc_encode(utf8_encode($pb_login))));
	$result = $server->send($message);

    // dalej podobnie jak w pb_give_points()
	if (!$result) 
	{
		return "Brak poczenia";
	}
	elseif ($result->faultCode())
	{
		return "Bd XML-RPC #" . $result->faultCode() . ": " . utf8_decode($result->faultString());
	}
	else
	{
		$resval = $result->value();
		$val = $resval->scalarval();

		return $val;
	}
}

?>
