<?php
/**
 *
 * klasa obslugujaca poprawne wywolania statusow kodow protokolu HTTP
 * 
 * @author marcin.butlak@sote.pl
 * @package phpHeader
 * @version $Id: phpHeader.inc,v 1.2 2007-06-27 17:19:46 marcin Exp $
 * @copyright sote 
 */
class phpHeader {
	/**
	 * informuje przegladarke/robota o zmianie adresu strony i przekierowuje na wskazany relatywny adres url
	 *
	 * @param string $url relatywny adres url (np. "/go/_info/index.php?user_id=22")
	 */
	static public function redirect($url)
	{
		global $config,$theme;
		header ('HTTP/1.1 301 Moved Permanently');
		self::location($theme->google_url($url));
		exit;
	}
	/**
	 * informuje przegladarke/robota ze strona nie istnieje i wyswietla 
	 *
	 */
	static public function notFound()
	{
		global $theme;
		header("HTTP/1.1 404 Not Found");
		$theme->head();
		$theme->page_open("left","custom_404","right","","","","page_open");
		$theme->foot();
		exit;
	}
	/**
	 * przekierowuje na podany adres url (nie informuje przegladarke/robota)
	 *
	 * @param string $url adres url (np. "http://www.sote.pl") 
	 */
	static public function location($url)
	{
		if (strpos($url,"http://") === false) {
			$url = "http://".$url;
		}
		header ('Location: '.$url);
		exit;
	}
}

?>