<?php
/**
 * Klasa zawierajca metody zwizane z bezpieczestwem danych.
 * 
 * @author m@sote.pl
 * @version  $Id: security.inc,v 1.3 2007-09-03 13:22:15 bartek Exp $
 * @package security
 */
class SSecurity {
    
    /**
     * Preztwrz URL do bezpiecznej postaci
     * 
     * @param string $url
     * @return string url
     */
    function secureURL($url) {
        if (empty($url) || is_numeric($url)) return $url;
        
        if(is_array($url)) return false;
        
        $url=urldecode($url);        
        if (eregi("script",$url)) return '';        
        $url=eregi_replace("\"","",$url);
        $url=eregi_replace("\'","",$url);
        return $url;
    }
    
    function secureString($text) {
        return SSecurity::secureURL($text);
    }
    
    function systemPassword($name) {
        if (eregi("^[0-9a-zA-Z\!\@\#\$\%\^\&\*\(\)\+\"\:\;\>\<\.\,\_\-]+$",$name)) {
            return true;
        } else return false;

    }
    
    /**
     * Sprawd poprawno numeru sesji.
     * Funkcja przepuszcza tylko poprawne numery sesji. 
     *
     * @param string $sess_id
     * @return string
     */
    function secureSessionID($sess_id) {
        preg_match("^[0-9A-Z]{32}$",$sess_id,$matches);
        if (! empty($matches[0])) {
            return $matches[0];
        } else return 'Invalid session';
    }
    
}
?>