<?php
@include ("Validate/Validate.php");

/**
 * Klasa poszerzajkca Validate z PEAR. Metody wykorzystywane do validacji danych wejciowych.
 * Klasa ta jest wykorzytywana do wprowadzenia poprawek dot. bezpieczestwa.
 * 
 * @author m@sote.pl
 * @version $Id: security_validate.inc,v 1.2 2007-06-27 19:34:08 michal Exp $
 * @package securrity
 */
class SValidate extends Validate {

    /**
     * Nazwa systemowa z separatorami '-' '_'.
     * 
     * @param string $name
     * @return bool
     */
    function systemName($name) {
        if (eregi("^[0-9a-z_\.-]+$",$name)) {
            return true;
        } else return false;

    }


    /**
     * Nazwa systemowa bez separatorow.
     * 
     * @param string $name
     * @return bool
     */
    function systemNameNoSep($name) {
        if (eregi("^[0-9a-z]+$",$name)) {
            return true;
        } else return false;

    }
    /**
     * Integer.
     * 
     * @param int $num
     * @return bool
     */
    function integer($num) {
        if (ereg("^[0-9]+$",$num)) {
            return true;
        } else return false;
    }

    /**
     * Plik HTML filename.html
     *
     * @param string $file
     * @return bool
     */
    function fileHTML($file) {
        if (eregi("^[a-z0-9_-]+\.html$",$file)) return true;
        return false;
    }

    /**
     * Numer sesji
     *
     * @param string $sessionId
     * @return bool
     */
    function sessionId($sessionId) {
        if (eregi("^[a-z0-9]{32}$",$sessionId)) return true;
        return false;
    }

    /**
     * MD5
     *
     * @param string $md5
     * @return bool
     */
    function md5($md5) {
        if (eregi("^[a-z0-9]{32}$",$md5)) return true;
        return false;
    }

    /**
     * Cena w sklepie
     *
     * @param float $price
     * @return bool
     */
    function price($price)
    {
        if (eregi("^([0-9]+)((\.){0,1})([0-9]{0,2})$",$price)) {
            // dla przypadku 20.
            if (ereg("\.$",$price)) return false;
            return true;
        } else return false;
    }
}
?>