<?php
/**
* Obsluga glowna klasa do kominkacji z wp
*
* @author  rdiak@sote.pl
* @author michal@sote.pl
* @version $Id: wp_transaction_ajax.inc.php,v 1.1 2007/03/08 09:57:45 michal Exp $
* 
* @package pasaz.wp.pl
*/

require_once("include/wp/wp.inc.php");
include_once("include/metabase.inc");
require_once("../../../include/head.inc");
require_once('lib/SProgress/SProgressBar.inc.php');

class WpTransaction extends WP implements SProgressInterface {

	var $data_CommitTrans = array();
	var $data_RollbackTrans = array();
	var $per_one = 2;
	
	/**
     * Funkcja liczaca wszystkie jednostki ktore sa do przetworzenia
     * 
     * @return int
     */
	function progressCountAll(){
		global $mdbd;
		$count_db = $mdbd->select("count(id)","order_register","confirm = 1 AND ( confirm_partner = 1 OR confirm_partner = 2 )");
		return ceil(($count_db/$this->per_one));
	}
    
    /**
     * Funkcja liczaca ile jest jednostek w pojedynczym pakiecie
     * 
     * @return int
     */
    function progressCountPackage(){
    	return $this->per_one;
    }
    
    /**
     * Ostatni element, ktory byl przetworzony w poprzednim wywolaniu
     *      
     * @param int $last
     * @return int
     */
    function progressNext($last=0){
    	global $db,$database;
    	global $lang;
    	$progressCountAll = $this->progressCountAll();
		if ($last < $progressCountAll AND $progressCountAll != 0 ) {
			return $this->_send_transaction($last);
		} elseif ($last == $progressCountAll OR $progressCountAll == 0)
		{
			$message = $this->_get_export_message();
			throw new SProgressException($message,1);
		} else {
			throw new SProgressException($lang->wp_import['error'],99);
		}
    }

    /**
    * Konstruktor obiektu WpTransaction
    *
    * @return boolean true/false
    */
    function WpTransaction() {
        // wywolaj konstruktor obiektu rodzica.
        $this->WP();
        return true;
    } // end WpTransaction

//    /**
//    * Funkcja wysya trnasakcje do pasazu wp w momencie sfianalizowania zakupow w sklepie
//    * i wyslania zamowienia. Ta transakcja musi jeszcze zostac potwierdzona lub wycofana z
//    * poziomu panelu administracyjnego.
//    *
//    * @return boolean true/false
//    */
//    function SendTrans($order_id,$commit) {
//        global $mdbd;
//        global $lang;
//        global $database;
//
//        $record=array();
//        $ids=array();
//        // wyciagnij z sesji user_id produktw
//        foreach($_SESSION['global_basket_data']['items'] as $key=>$value) {
//            array_push($ids,$value['user_id']);
//        }
//        if(empty($ids)) {
//            // jesli z sesji nie udalo sie wyciagnac user_id produktow
//            // to sprobuj z bazy
//            $ids=$mdbd->select("user_id_main","order_products","order_id=?",array($order_id=>"int"));
//        }
//        $record['order_id']=$order_id;
//        if(!empty($_SESSION['global_basket_amount'])) {
//            $record['price']=$_SESSION['global_basket_amount'];
//        } else {
//            $amount=$mdbd->select("amount","order_register","order_id=?",array($order_id=>"int"));
//            $record['price']=$amount;
//        }
//        $record['price']=eregi_replace('\.',',',$record['price']);
//        $record['commit']=$commit;
//        // naglowek komunikatu soap
//        $str=$this->_wp_get_head();
//        // komunikat glowny
//        $str.=$this->_wp_store_transaction($record, $ids);
//        // stopka komunikatu soap
//        $str.=$this->_wp_get_foot();
//        //wyslij oferte na serwer
//        $content=$this->soap->send_soap_category($str);
//        // sparsuj odpowiedz serwera wp
//        $this->_wp_send_request($content,'trans');
//
//        // zapisz zwrotna informacje do bazy danych
//        $this->_insert_info_db("StoreTransaction",'TRANS_ID');
//
//        return true;
//    } // end SendTransFromShop


    /**
    * Funkcja jest wywolywana z poziomu panelu administracyjnego
    * i wysya transakcje potwierdzone i anulowane do pasazu wp
    *
    * @return boolean true/false
    */
    function ConfirmTrans() {
    	
    	foreach ($this->data as $key => $value)
    	{
    		if ( $value['confirm_partner'] == 1 )
    		{
    			array_push($this->data_CommitTrans,$this->data[$key]);
    		} elseif ( $value['confirm_partner'] == 2 ) 
    		{
    			array_push($this->data_RollbackTrans,$this->data[$key]);
    		} else {
    			
    		}
    	}
    	
    	if(!empty($this->data_CommitTrans))
    	{
    		// wyslij tranasakcje do potwiedzenia
        	$this->CommitTrans();
    	}
        if(!empty($this->data_RollbackTrans)) 
        {
        	// wyslij tanskacje do anulowania
        	$this->RollbackTrans();
        }
        return true;
    } // end ConfirmTrans

    /**
    * Funkcja tworzy i wysla komunikat SOAP z transakcjami
    * do potwiedzenia
    *
    * @return boolean true/false
    */
    function CommitTrans() {
        global $mdbd;
        global $database;
        global $lang;
        global $DOCUMENT_ROOT;

        $limit = "";
        // wyciagnij w bazy danych wszystkie transakcje do przelania do wp
//        $data=$mdbd->select("order_id","order_register","confirm=1 AND confirm_partner=1 AND partner_name='wp'","",$limit,"array");
		$data = $this->data_CommitTrans;
        // jesli sa jakies dane do wyslania
        if(!empty($data)) {
            // naglowek komunikatu soap
            $str=$this->_wp_get_head();
            // komunikat glowny
            $str.=$this->_wp_commit_roll_trans("CommitTransactions", $data);
            // stopka komunikatu soap
            $str.=$this->_wp_get_foot();

            /**
             * Zapis xml'a do pliku
             * 
             * if( $str ) 
             * {
             *   $file = $DOCUMENT_ROOT."/tmp/commit.xml";
             *   if ( $fd = @fopen( $file, "w+" ) )
             *   {
             *   	fwrite( $fd, $str, strlen( $str ) );
             * 		fclose( $fd );
             * 	 }
             * }
             */
            //wyslij oferte na serwer
			$content = $this->_send_soap($str);
//			$content = "";
            // sparsuj odpowiedz serwera wp
            $this->_wp_send_request($content,'trans');
            
            $this->_insert_info_session($content);
			
            // zapisz zwrotna informacje do bazy danych
            $this->_insert_info_db("CommitTransaction",'TRANS_ID');
            // analizuj komunikat zwrotny i dodaj odpowiednie wpisy do bazy danych
            foreach($this->_tags['TRANS_ID'] as $key=>$value) {
                $order_id=$this->_values[$this->_tags['TRANS_ID'][$key]]['value'];
                // zapisz informacje o tym ze transakcja zostala wyslana i potwiedzona w tablicy order_register
                if($this->_values[$this->_tags['RES'][$key]]['value'] == 0 ) {
                    // transakcja zostala poprawnie zalogowana
                    $mdbd->update("order_register","confirm_partner=?","order_id=?",array("3"=>"int",$order_id=>"int"));
//                    print "<br>Transkacja <b>$order_id</b> zalogowana poprawnie";
                } else {
                    // transakcja nie zostala zalogowana poprawnie
                    $mdbd->update("order_register","confirm_partner=?","order_id=?",array("-1"=>"int",$order_id=>"int"));
//                    print "<br>Transkacja <b>$order_id</b> zalogowana niepoprawnie.<font color=red><b> Bd !!! </b></font>";
                }
            }
        }
        return true;
    } // end CommitTrans

    function RollbackTrans() {
        global $mdbd;
        global $database;
        global $lang;
        global $DOCUMENT_ROOT;

        $limit = "LIMIT ";
        // wyciagnij w bazy danych wszystkie transakcje do przelania do wp
//        $data=$mdbd->select("order_id","order_register","confirm=1 AND confirm_partner=2 AND partner_name='wp'","",$limit,"array");
		$data = $this->data_RollbackTrans;
        // jesli sa jakies dane do wyslania
        if(!empty($data)) {
            // naglowek komunikatu soap
            $str=$this->_wp_get_head();
            // komunikat glowny
            $str.=$this->_wp_commit_roll_trans("RollbackTransactions", $data);
            // stopka komunikatu soap
            $str.=$this->_wp_get_foot();
            
            /**
             * Zapis xml'a do pliku
             * 
             * if( $str ) 
             * {
             *   $file = $DOCUMENT_ROOT."/tmp/rollback.xml";
             *   if ( $fd = @fopen( $file, "w+" ) )
             *   {
             *   	fwrite( $fd, $str, strlen( $str ) );
             * 		fclose( $fd );
             * 	 }
             * }
             */
            
            //wyslij oferte na serwer
            $content = $this->_send_soap($str);
            // sparsuj odpowiedz serwera wp
            $this->_wp_send_request($content,'trans');

            $this->_insert_info_session($content);
            
            // zapisz zwrotna informacje do bazy danych
            $this->_insert_info_db("RollbackTransaction",'TRANS_ID');

            // analizuj komunikat zwrotny i dodaj odpowiednie wpisy do bazy danych
            foreach($this->_tags['TRANS_ID'] as $key=>$value) {
                $order_id=$this->_values[$this->_tags['TRANS_ID'][$key]]['value'];
                // zapisz informacje o tym ze transakcja zostala wyslana i potwiedzona w tablicy order_register
                if($this->_values[$this->_tags['RES'][$key]]['value'] == 0 ) {
                    // transakcja zostala poprawnie zalogowana
                    $mdbd->update("order_register","confirm_partner=?","order_id=?",array("3"=>"int",$order_id=>"int"));
//                    print "Transkacja <b>$order_id</b> zalogowana poprawnie<br>";
                } else {
                    // transakcja nie zostala zalogowana poprawnie
                    $mdbd->update("order_register","confirm_partner=?","order_id=?",array("-1"=>"int",$order_id=>"int"));
//                    print "Transkacja <b>$order_id</b> zalogowana niepoprawnie.<font color=red><b> Bd !!! </b></font><br>";
                }
            }
        }
    } // end RollbackTrans
    
    /**
	 * Funkcja do czenia z soapem WP.pl
	 *
	 * @param string $xml
	 * @return string
	 */
	function _send_soap($xml)
	{
		$server = "wymianadanych.wp.pl";
		$router = "/SOAPInterface/Zakupy/index.php";
		
		$req_headers="POST $router HTTP/1.0\r\n";
        $req_headers.="Host: $server\r\n";
        $req_headers.="Content-type: text/xml; charset=iso-8859-2\r\n";
        $req_headers.="Content-Length: ".strlen($xml)."\r\n\r\n";
        
		$connection=@fsockopen($server,80);
		
            if ($connection) {
                stream_set_timeout($connection,40);
                $connection_info=stream_get_meta_data($connection);
                fputs($connection,$req_headers.$xml);
                $data='';
                // barany sa niezgodni z http\1.0 i przed naglowkiem wysylaja newline
                // wiec sprawdzam czy wyslali conn:close i jezeli tak - to zaczynam na nastepnej lini body
                $header=true;
                while (!feof($connection)) {
                    $connection_info=stream_get_meta_data($connection);
                    $line=fgets($connection,1024);
                    if (trim($line)=='Connection: close') {
                        $line=fgets($connection,1024);
                        $line=fgets($connection,1024);
                        $header=false;
                    } 
                    //if (!$header) $data.=$line;
                    if (!$header) $data.=htmlspecialchars($line);
                }
              return trim($data)."\n";
            }
	}
	
	/**
	 * Wrapper do wysyania zamwie do wp.pl
	 *
	 * @param integer $offset
	 * @return integer
	 */
	function _send_transaction( $offset )
	{
		$this->_get_database( $offset );
		$this->ConfirmTrans();
		return $offset+1;
	}
	
	/**
	 * Funkcja do wycigania danych o transakcjach z bazy danych
	 *
	 * @return true
	 */
	function _get_database( $offset )
	{
		global $db,$mdbd;
		global $image;
		global $config;
		global $theme;
		
		$query = "SELECT order_id, confirm_partner FROM order_register WHERE confirm = 1 AND ( confirm_partner = 1 OR confirm_partner = 2 )
				  ORDER BY confirm_partner, id ASC LIMIT ".($offset*$this->per_one).", ".$this->per_one;
		$this->data = array();
		$data = array();
		$prepared_query=$db->PrepareQuery($query);
		if ($prepared_query) {
			$result=$db->ExecuteQuery($prepared_query);
			if ($result!=0) {
				$num_rows=$db->NumberOfRows($result);
				if ($num_rows>0) {
					for ($i=0;$i<$num_rows;$i++) {
						$data[$i]['order_id']=$db->FetchResult($result,$i,"order_id");
						$data[$i]['confirm_partner']=$db->FetchResult($result,$i,"confirm_partner");
					} // end for
				}
			} else die ($db->Error());
		} else die ($db->Error());
		
		$this->data = $data;
		return true;
	}
	
	function _get_export_message()
	{
		global $lang;
		
		$status_tab = $_SESSION['wp_transaction_status'];
		$error_tab = $_SESSION['wp_transaction_messages'];
		
		$str = "";
//		$str .= "<script type=\"javascript\">self.resizeTo(800,500);</script>";
		
		$str .= "<b>Status:</b> ".$status_tab['message']."<br><br>\n";
		
		$str .= "<div style=\"overflow: auto; width: 600px; height: 200px;\">\n";
		$str .= "<br><table border cellspacing=\"0\" cellpadding=\"3\" style=\"border: 1px solid; border-collapse: collapse;\">";
		$str .= "<tr><td>".$lang->wp_load_trans['id_transaction']."</td><td>".$lang->wp_load_offer['message']."</td></tr>";
		
		foreach ($error_tab as $key => $value)
		{
			$str.= "<tr><td>".$value['order_id']."</td><td>".$value['message']."</td></tr>\n";
		}
		
		$str .= "</table>";
		$str .= "</div>";
		
		return $str;
	}
	
	function _insert_info_session( $xml )
	{
		global $lang;
		
		$tab = explode("\n",$xml);
		
		$i = 0;
		if (isset($_SESSION['wp_transaction_messages']))
		{
			$i = count($_SESSION['wp_transaction_messages']);
		}
		
		foreach ($tab as $key => $value)
		{
			if (eregi("<Result>",$value))
			{
				$result = trim($tab[$key]);
				$result = preg_replace("@<result>(.*)</result>@i",'\1',$result);
				
				switch ($result) {
					case -1:
						$message = $lang->wp_load_offer['msg_-1'];
						break;
					case 0:
						$message = $lang->wp_load_offer['msg_0'];
						break;
					case 1:
						$message = $lang->wp_load_offer['msg_1'];
						break;
					case 2:
						$message = $lang->wp_load_offer['msg_2'];
						break;
					case 3:
						$message = $lang->wp_load_offer['msg_3'];
						break;
					default:
						break;
				}
				$status_tab['code'] = $result;
				$status_tab['message'] = $message;
			}
			
			if (eregi("<row>",$value))
			{
				$order_id = trim($tab[$key+1]);
				$order_id = preg_replace("@<Trans_id>(.*)</Trans_id>@i",'\1',$order_id);
								
				if (preg_replace("@<res>(.*)</res>@i",'\1',$tab[$key+3]) == 0)
				{
					$message = $lang->wp_load_trans['transaction_add2wp'];
				} else {
					$message = trim($tab[$key+5]);
					$message = preg_replace("@<msg>(.*)</msg>@i",'\1',$message);
					$message = $this->_wp_utf8_to_8859_2($message);
				}
				
				$error_tab[$i]["order_id"] = $order_id;
				$error_tab[$i]["message"] = $message;
				$i++;
			}
		}
		session_register("wp_transaction_status");
		$_SESSION['wp_transaction_status'] = $status_tab;
		
		if (!isset($_SESSION['wp_transaction_messages'])) 
		{
			session_register("wp_transaction_messages");
			$_SESSION['wp_transaction_messages'] = $error_tab;
		} else {
			foreach ($error_tab as $key => $value)
			{
				array_push($_SESSION['wp_transaction_messages'],array("order_id" => $value['order_id'],"message" => $value['message']));
			}
		}
	}
	
} // end class WpTransaction
