<?php
/**
 * Obsluga wysylania poczty.
 *
 * @author  marcin.butlak@sote.pl
 * @version $Id: MyMail.php,v 1.9 2007-10-08 16:31:19 marcin Exp $
 * @package soteesklep
 */ 

class MyMail {

	private $to;
	private $body;
	private $subject;
	private $from;
	private $reply;
	private $encoding="iso-8859-2";
	private $eol="\n";
	private $headers="";
	private $css_file;
	private $html;
	private $html2txt;

	/**
	 * Konstruktora klasy MyMail
	 *
	 * @param bool $html zezwol na HTML
	 * @param string $css_file nazwa pliku CSS dla maila HTML
	 */
	public function __construct($html=false,$css_file="mail_order.css") {
		$this->html=$html;
		$this->css_file=$css_file;

	}
	/**
	 * Zezwol na HTML
	 *
	 * @param bool $html
	 */
	public function allowHTML($html=true, $html2txt=true) {
		$this->html=$html;
		$this->html2txt=$html2txt;
	}

	function send_mail()
	{
		global $theme,$DOCUMENT_ROOT;
		if (strpos($this->body,"<body") === false && strpos($this->body,"<html") === false && strpos($this->body,"</body>") === false && strpos($this->body,"</html>") === false) {
			$head="<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n<html xmlns=\"http://www.w3.org/1999/xhtml\">\n<head>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=$this->encoding\" />\n";
			// zalacz plik CSS
			$file=$DOCUMENT_ROOT.$theme->filepath("_style/$this->css_file");
			if (is_file($file)) {
				$head.="<style type=\"text/css\">\n".file_get_contents($file)."\n</style>\n";
			}
			$head.="</head>\n<body>\n";
			$foot="</body>\n</html>";
		} else {
			$head=$foot="";
		}

		$this->body=$head.$this->body.$foot;

		$this->headers = "From: ".$this->fromaddress.$this->eol;
		$this->headers .= "Reply-To: ".$this->replyaddress.$this->eol;
		$this->headers .= "Return-Path: ".$this->replyaddress.$this->eol;    // these two to set reply address
		$this->headers .= "Message-ID: <".time()."-".$this->fromaddress.">".$this->eol;
		$this->headers .= "X-Mailer: PHP v".phpversion().$this->eol;          // These two to help avoid spam-filters

		$this->headers .= 'MIME-Version: 1.0'.$this->eol;

		if (!$this->html) {
			# Text Version
			$this->headers .= "Content-Type: text/plain; charset=$this->encoding".$this->eol;
			$this->headers .= "Content-Transfer-Encoding: 8bit".$this->eol;
			$offset=strpos($this->body, "<body>")+6;
			$length=strpos($this->body, "</body>")-$offset;
			$msg = substr($this->body,$offset,$length);
			if ($this->html2txt) {
				$msg=$theme->html2txt($msg);
			} 
			$msg.=$this->eol.$this->eol;		
		} else {
			# HTML Version
			$this->headers .= "Content-Type: text/html; charset=$this->encoding".$this->eol;
			$this->headers .= "Content-Transfer-Encoding: 8bit".$this->eol;
			$msg = $this->body.$this->eol.$this->eol;

		}

		# SEND THE EMAIL
		//ini_set(sendmail_from,$this->fromaddress);  // the INI lines are to force the From Address to be used !
		$mail_sent = mail($this->to, $this->subject, $msg, $this->headers);

		//ini_restore(sendmail_from);

		return $mail_sent;
	}

	/**
     * Wysli wiadomosc e-mail
     *
     * @param string $to      adresat
     * @param string $from    nadawca
     * @param string $subject temat
     * @param string $body    tresc maila
     * @param string $reply   odpowiedz na adres
     * @param string $type    typ wiadomosci np. [html]
     * @access public
     * @return bool true  mail wyslany, false - problem z wyslaniem maila
     */
	function send($from,$to,$subject,$body,$reply="",$type="") {
		global $lang,$theme,$DOCUMENT_ROOT;

		if (isset($lang->encoding)) {
			$this->encoding=$lang->encoding;
		}

		$subject = "=?".$this->encoding."?B?".base64_encode($subject) ."?=";

		if (empty($reply)) $reply=$from;

		if (empty($to) || empty($from)) {
			return false;
		}
		
		$this->to=$to;

		$this->subject=$subject;
		$this->fromaddress=$from;
		$this->replyaddress=$reply;

		$this->body=$body;

		if ($this->send_mail()) {
			return true;
		} else {
			return false;
		}
	} // end send()
} // end class MyMail

?>
