<?php
/**
 * Klasa SAllpay - gwna klasa do obsugi Allpay.pl
 * 
 * @author michal.prochowski@sote.pl
 * @package SPayment
 * @subpackage SAllpay
 * @version $Id: SAllpay.inc.php,v 1.4 2007-08-01 18:29:50 michal Exp $
 * @copyright sote 
 */

// adowanie lib'w 
require_once ("lib/SPayment/SOrder.inc.php");
require_once ("lib/SPayment/SPayment/SPayment.interface.inc.php");
require_once ("include/security_validate.inc");
global $allpay_config;
require_once ("config/auto_config/allpay_config.inc.php");

// Zdefiniowany adres do wysyania zapyta o status transakcji
define("ALLPAY_IP","217.17.41.5");

class SAllpay implements SPayment {

	/**
	 * Obiekt z configiem $allpay_config
	 *
	 * @var object
	 */
	private $_config;
	
	/**
	 * Obiekt klasy SOrder
	 *
	 * @var object
	 */
	private $SOrder;
	
	/**
	 * Czy $_REQUEST by sprawdzony
	 *
	 * @var bool
	 */
	private $requestChecked = false;
	
	/**
	 * Konstruktor
	 *
	 */
	function __construct()
	{
		global $allpay_config;
		$this->_config = $allpay_config;
		
		$this->SOrder = new SOrder;
	}
	
	/**
	 * Wywietlanie forumlarza z przejciem do patnoci
	 * 
	 * Dane o wycigamy z sesji, z funkcji $SOrder i z config'w np.
	 * - $_SESSION['form']['name'] - imie klienta
	 * - $_SESSION['form']['surname'] - nazwisko klienta
	 * - $_SESSION['global_order_id'] - numer zamwienia
	 * - $SOrder->getAmount() - kwota zamwienia
	 * 
	 * Wynikiem jest print "<form>...</form>";
	 * 
	 * @return true
	 */
	function showForm()
	{
		global $lang;
		global $config;
		
       	$amount = $this->SOrder->getAmount();
       	$amount = number_format($amount, 2, ".","");
       	
       	if ($config->lang == "pl") { $language = "pl"; }
        elseif($config->lang == "de") { $language = "de"; }
        elseif($config->lang == "it") { $language = "it"; }
        elseif($config->lang == "fr") {	$language = "fr"; }
        elseif($config->lang == "es") { $language = "es"; }
        elseif($config->lang == "cz") { $language = "cz"; }
        elseif($config->lang == "ru") { $language = "ru"; }
        elseif($config->lang == "bg") { $language = "bg"; }
		else { $language = "pl"; }
        
//		if ($config->currency == "PLN") { $currency = "PLN"; }
//		elseif ($config->currency == "EUR") { $currency = "EUR"; }
//		elseif ($config->currency == "RUB") { $currency = "USD"; }
//		elseif ($config->currency == "CZK") { $currency = "EUR"; }
//		elseif ($config->currency == "USD") { $currency = "USD"; }
//		else { $currency = "PLN"; }
		
		$currency = "PLN";
		
		
        $o="";
        $o="<br /><table width=\"70%\" border=\"0\"><tr><td width=\"50%\" valign=\"top\" align=\"center\"><img src=\"/themes/base/base_theme/_img/allpay_logo.gif\"><br /></td><td width=\"50%\" valign=\"top\" align=\"center\">$lang->allpay_info<br /></td></tr></table>";
        $o.="<form action=\"https://ssl.allpay.pl\" method=\"POST\" name=\"payform\">\n";
        $o.="<input type=\"hidden\" name=\"id\" value=\"".$this->_config->allpay_id."\">\n";
        $o.="<input type=\"hidden\" name=\"amount\" value=\"".$amount."\">\n";
        $o.="<input type=\"hidden\" name=\"currency\" value=\"$currency\">\n";
        $o.="<input type=\"hidden\" name=\"description\" value=\"".$_SESSION['global_order_id']."\">\n";
        $o.="<input type=\"hidden\" name=\"lang\" value=\"".$language."\">\n";
        $o.="<input type=\"hidden\" name=\"channel\" value=\"".$this->_config->allpay_channel."\">\n";
        $o.="<input type=\"hidden\" name=\"ch_lock\" value=\"".$this->_config->allpay_ch_lock."\">\n";
        $o.="<input type=\"hidden\" name=\"onlinetransfer\" value=\"".$this->_config->allpay_onlinetransfer."\">\n";
        $o.="<input type=\"hidden\" name=\"URL\" value=\"http://".$config->www."/".$this->_config->allpay_url."/?allpay_session_id=".$_SESSION['order_session']."\">\n";
        $o.="<input type=\"hidden\" name=\"type\" value=\"".$this->_config->allpay_type."\">\n";
        $o.="<input type=\"hidden\" name=\"txtguzik\" value=\"".$this->_config->allpay_txtguzik."\">\n";
        $o.="<input type=\"hidden\" name=\"buttontext\" value=\"".$this->_config->allpay_buttontext."\">\n";
        $o.="<input type=\"hidden\" name=\"URLC\" value=\"http://".$config->www."/".$this->_config->allpay_urlc."\">\n";
        $o.="<input type=\"hidden\" name=\"control\" value=\"".$_SESSION['order_session']."\">\n";
        $o.="<input type=\"hidden\" name=\"firstname\" value=\"".$_SESSION['form']['name']."\">\n";
        $o.="<input type=\"hidden\" name=\"surname\" value=\"".$_SESSION['form']['surname']."\">\n";
        $o.="<input type=\"hidden\" name=\"email\" value=\"".$_SESSION['form']['email']."\">\n";
        $o.="<input type=\"hidden\" name=\"street\" value=\"".$_SESSION['form']['street']."\">\n";
        $o.="<input type=\"hidden\" name=\"street_n1\" value=\"".$_SESSION['form']['street_n1']."\">\n";
        $o.="<input type=\"hidden\" name=\"street_n2\" value=\"".$_SESSION['form']['street_n2']."\">\n";
        $o.="<input type=\"hidden\" name=\"city\" value=\"".$_SESSION['form']['city']."\">\n";
        $o.="<input type=\"hidden\" name=\"postcode\" value=\"".$_SESSION['form']['postcode']."\">\n";
        $o.="<input type=\"hidden\" name=\"phone\" value=\"".$_SESSION['form']['phone']."\">\n";
        $o.="<input type=\"hidden\" name=\"country\" value=\"".$config->country_select[$_SESSION['form']['country']]."\">\n";
        $o.="<input type=\"hidden\" name=\"p_info\" value=\"".$config->merchant['name']."\">\n";
        $o.="<input type=\"hidden\" name=\"p_email\" value=\"".$config->order_email."\">\n";
        $o.="<br /><input type=\"submit\" value=\"$lang->register_allpay_order\">\n";
        $o.="</form>\n";
        print $o;
        
        return true;
	}

	/**
	 * Sprawdzanie czy $_REQUEST jest dobry i zawiera wszystkie dane
	 * 
	 *  !!! SPRAWDZAMY WSZYSKO CO MOLIWE, (TNZ. DUGOCI I TYPY DANYCH) UYWAJC KLASY Svalidate.
	 * 
	 *  !!! Przykad uzycia 
	 *	!!! require_once ("include/security_validate.inc");
	 *	!!! SValidate::Integet("1000"); // zwrci true
	 * 
	 * @global array $_REQUEST
	 * @return bool true/false 
	 */
	function checkRequest()
	{
		// $_REQUEST['id'] - id sprzedawcy - int
		// $_REQUEST['control'] - sessja - string (md5)
		// $_REQUEST['t_id'] - id trans zaksiegowany w allpay - string
		// $_REQUEST['amount'] - kwota (np. 42.82) - string
		// $_REQUEST['email'] - email osoby dokonujcej patnoci - string
		// $_REQUEST['service'] - niedotyczy (patrz dokumentacja Allpay s.10)
		// $_REQUEST['code'] - niedotyczy (patrz dokumentacja Allpay s.10)
		// $_REQUEST['username'] - niedotyczy (patrz dokumentacja Allpay s.10)
		// $_REQUEST['password'] - niedotyczy (patrz dokumentacja Allpay s.10)
		// $_REQUEST['t_status'] - status transakcji - int
		// $_REQUEST['description'] - opis transakcji, w to pole wpada numer transakcji sklepu - int
		// $_REQUEST['md5'] - md5 (patrz dokumentacja Allpay s.11,12) - string (md5)
		// $_REQUEST['p_info'] - nazwa sklepu - string
		// $_REQUEST['p_email'] - email do zamwie - string
		// $_REQUEST['date'] - data realizacji transakcji - ??
		
		if (! empty($_REQUEST))
		{
			// sprawdzenie czy $_REQUEST['id'] nie jest pusty i czy id z $_REQUEST'a jest watroscia liczbowa
			if (empty($_REQUEST['id']) or !SValidate::integer($_REQUEST['id']))
			{
				return false;
			}
			
			// sprawdzenie czy $_REQUEST['control'] nie jest pusty i czy control z $_REQUEST'a jest numerem sesji
			if (empty($_REQUEST['control']) or !SValidate::sessionId($_REQUEST['control']))			
			{
				return false;
			}
			
			// sprawdzenie czy $_REQUEST['t_id'] nie jest pusty i czy t_id z $_REQUEST'a jest string'iem
			if (empty($_REQUEST['t_id']) or !SValidate::string($_REQUEST['t_id'],array("min_length"=>5, "max_length"=>50)))
			{				
				return false;
			}
			
			// sprawdzenie czy $_REQUEST['amount'] nie jest pusty i czy amount z $_REQUEST'a jest floatem
			if (empty($_REQUEST['amount']) or !SValidate::price($_REQUEST['amount']))
			{				
				return false;
			}
			
			// sprawdzenie czy $_REQUEST['email'] nie jest pusty i czy email z $_REQUEST'a jest email'em
			if (empty($_REQUEST['email']) or !SValidate::email($_REQUEST['email']))
			{				
				return false;
			}
			
			// $_REQUEST['service'], $_REQUEST['code'], $_REQUEST['username'], $_REQUEST['password']
			// te parametry nie s sprawdzanie poniewa nie s nigdzie uywane.
			
			// sprawdzenie czy $_REQUEST['t_status'] nie jest pusty i czy t_status z $_REQUEST'a jest wartoscia liczbowa
			if (empty($_REQUEST['t_status']) or !SValidate::integer($_REQUEST['t_status']))
			{				
				return false;
			}

			// sprawdzenie czy $_REQUEST['description'] nie jest pusty i czy description z $_REQUEST'a jest wartoscia liczbowa
			if (empty($_REQUEST['description']) or !SValidate::integer($_REQUEST['description']))
			{				
				return false;
			}
			
			$shop_md5 = md5($this->_config->allpay_pin.":".$this->_config->allpay_id.":".$_REQUEST['control'].":".$_REQUEST['t_id'].":".$_REQUEST['amount'].":".$_REQUEST['email'].":"."".":"."".":"."".":"."".":".$_REQUEST['t_status']);
			
			// sprawdzenie czy $_REQUEST['md5'] nie jest pusty, czy md5 z $_REQUEST'a jest md5
			// i czy md5 z $_REQUEST'a jest zgody z tym wygenerowanym w sklepie
			if (empty($_REQUEST['md5']) or !SValidate::md5($_REQUEST['md5']) or $_REQUEST['md5'] != $shop_md5)
			{				
				return false;
			}
			
			// $_REQUEST['p_info'], $_REQUEST['p_email'], $_REQUEST['date']
			// te parametry nie s sprawdzanie poniewa nie s nigdzie uywane.

		} else {
			return false;
		}

		$this->requestChecked = true;
		return true;
	}
	
	/**
	 * Przetwarzanie $_REQUEST'a otrzymanego od patnoci
	 *
	 *  !!! UWAGA: WYMAGANE SPRAWDZANIE CZY ZOSTA WYWOANA METODA $this->checkRequest();
	 * 
	 * Statusy transakcji:
	 * - 000 - nowa (niebieski)
	 * - 001 - zatwierdzona (zielony)
	 * - 002 - anluowana (pomaranczowy)
	 * - 003 - odrzucona (czerwony)
	 * - 099 - nieznany bd (czarny)
	 * 
	 * @global array $_REQUEST
	 * @return array przetworzone dane $_REQUEST'a
	 * 
	 * array( 'order_id' => "numer zamwienia - int", 
	 * 		  'pay_status' => "status transakcji - int",
	 * 		  'checksum_online' => "suma kontrolna - text",
	 * 		 );
	 * 
	 * $checksum = $SOrder->checksum("numer id zamwienia", "transakcja zatwierdzona - 1/nie zatwierdzona - 0, "kwota zamwienia"); 
	 */
	function processingRequest()
	{
		global $mdbd;
		
		if( $this->requestChecked === false)
		{
			if(!$this->checkRequest()) return false;
		}
		
		$status = array( 'order_id' => 0, 'pay_status' => "000", 'checksum_online' => "checksum_online_false" );
		
		// $_REQUESTy byy ju sprawdzone i nie trzeba ich sprawdzac
		$order_id = $_REQUEST['description'];
		$amount = number_format($_REQUEST['amount'],2,",","");
		
		if (!$this->SOrder->checkOrderId($_REQUEST['description'], $_REQUEST['control']))
		{
			return false;
		}
		
		switch ($_REQUEST['t_status']) {
			// koniec wysyania powiadomie
			case "0":
				break;
			// nowa transakcja
			case "1": 
				$checksum = $this->SOrder->checksum($order_id, 0, $amount);
				$status = array( 'order_id' => $order_id,
							 	 'pay_status' => "000",
							 	 'checksum_online' => $checksum,
								);
				break;
			// transakcja zatwierdzona
			case "2":
				$checksum = $this->SOrder->checksum($order_id, 1, $amount);
				$status = array( 'order_id' => $order_id,
							 	 'pay_status' => "001",
							 	 'checksum_online' => $checksum,
								);
				break;
			// transakcja odrzucona
			case "3":
				$checksum = $this->SOrder->checksum($order_id, 0, $amount);
				$status = array( 'order_id' => $order_id,
							 	 'pay_status' => "003",
							 	 'checksum_online' => $checksum,
								);
				break;
			// transakcja anulowana
			case "4":
				$checksum = $this->SOrder->checksum($order_id, 0, $amount);
				$status = array( 'order_id' => $order_id,
							 	 'pay_status' => "002",
							 	 'checksum_online' => $checksum,
								);
				break;
			default:
				$status = array( 'order_id' => 0,
							 	 'pay_status' => "000", 
							 	 'checksum_online' => "checksum_online_false",
							 	);
				break;
		}
		return $status;
	}
	
	 /**
	 * Zapisywanie $_REQUEST'a do bazy danych
	 *
	 *  !!! UWAGA: NALEY SPRAWDZIC $_REQUEST'Y OTRZYMANE OD PATNOCI ZANIM TRAFI DO BAZY DANYCH
	 * 	!!! Przykad uycia soteesklep3/lib/SPayment/SPlatnosciPL/SPlatnosciPL.inc.php
	 * 
	 * @global array $_REQUEST
	 * @return true
	 */
	function saveRequest()
	{
		global $db;

		// sprawdzenie czy $_REQUEST['id'] jest watroscia liczbowa
		if (SValidate::integer(@$_REQUEST['id']))
		{
			$request['id'] = $_REQUEST['id'];
		} else {
			$request['id'] = "";
		}
		
		// sprawdzenie czy $_REQUEST['status'] ma watro OK/FAIL
		if ($_REQUEST['status'] == "OK" or $_REQUEST['status'] == "FAIL")
		{
			$request['status'] = $_REQUEST['status'];
		} else {
			$request['status'] = "";
		}
		
		// sprawdzenie czy $_REQUEST['control'] jest numerem sesji
		if (SValidate::sessionId(@$_REQUEST['control']))
		{
			$request['control'] = $_REQUEST['control'];
		} else {
			$request['control'] = "";
		}
		
		// sprawdzanie czy $_REQUEST['t_id'] jest string'iem
		if(SValidate::string($_REQUEST['t_id'],array("min_length"=>5, "max_length"=>50)))
		{
			$request['t_id'] = $_REQUEST['t_id'];
		} else {
			$request['t_id'] = "";
		}
		
		// sprawdzanie czy $_REQUEST['amount'] jest cen
		if (SValidate::price($_REQUEST['amount']))
		{
			$request['amount'] = $_REQUEST['amount'];
		} else {
			$request['amount'] = "";
		}
		
		// sprawdzanie czy $_REQUEST['email'] jest email'em
		if (SValidate::email($_REQUEST['email']))
		{
			$request['email'] = $_REQUEST['email'];
		} else {
			$request['email'] = "";
		}
		
		// sprawdzenie czy $_REQUEST['t_status'] jest watroscia liczbowa
		if (SValidate::integer(@$_REQUEST['t_status']))
		{
			$request['t_status'] = $_REQUEST['t_status'];
		} else {
			$request['t_status'] = "";
		}
		
		// sprawdzenie czy $_REQUEST['description'] jest watroscia liczbowa
		if (SValidate::integer(@$_REQUEST['description']))
		{
			$request['description'] = $_REQUEST['description'];
		} else {
			$request['description'] = "";
		}
		
		// sprawdzenie czy $_REQUEST['md5'] jest md5
		if (SValidate::md5(@$_REQUEST['md5']))
		{
			$request['md5'] = $_REQUEST['md5'];
		} else {
			$request['md5'] = "";
		}
		
		// generowanie md5 z REQUEST'a
		$shop_md5 = md5($this->_config->allpay_pin.":".$this->_config->allpay_id.":".$_REQUEST['control'].":".$_REQUEST['t_id'].":".$_REQUEST['amount'].":".$_REQUEST['email'].":"."".":"."".":"."".":"."".":".$_REQUEST['t_status']);
		
		$query = "INSERT INTO allpay_trans (`id`,`status`,`control`,`t_id`,`amount`,`email`,`t_status`,`description`,`md5`,`md5_req`,`remote_addres`) ";
		$query.= "VALUES (?,?,?,?,?,?,?,?,?,?,?)";
			
		$prepared_query=$db->PrepareQuery($query);
		if ($prepared_query) 
		{
			$db->QuerySetText($prepared_query,1,$request['id']);
			$db->QuerySetText($prepared_query,2,$request['status']);
			$db->QuerySetText($prepared_query,3,$request['control']);
			$db->QuerySetText($prepared_query,4,$request['t_id']);
			$db->QuerySetText($prepared_query,5,$request['amount']);
			$db->QuerySetText($prepared_query,6,$request['email']);
			$db->QuerySetText($prepared_query,7,$request['t_status']);
			$db->QuerySetText($prepared_query,8,$request['description']);
			$db->QuerySetText($prepared_query,9,$shop_md5);
			$db->QuerySetText($prepared_query,10,$request['md5']);
			$db->QuerySetText($prepared_query,11,$_SERVER['REMOTE_ADDR']);
			$result=$db->ExecuteQuery($prepared_query);
		}
		return true;
	}
	
	/**
	 * Wywietlenie niejawnego komunikatu odbioru poprawnego $_REQUEST'a
	 * np. print "OK"; lub print "TRUE";
	 */
	function confirmRequest()
	{
		print "OK";
	}
	
	/**
	 * Jeli moliwe to sprawdzamy ip serwera z ktrego przyszed $_REQUEST
	 *
	 * @param string $ip adres ip systemu patnoci
	 * @return bool
	 */
	function checkServer()
	{
		if ($_SERVER['REMOTE_ADDR'] == ALLPAY_IP)
		{
			return true;
		} else {
			return false;
		}
	}
	
	
	
}

?>