<?php
/**
 * Klasa SEcard - gwna klasa do obsugi Ecard.pl
 * 
 * @author michal.prochowski@sote.pl
 * @package SPayment
 * @subpackage SEcard
 * @version $Id: SEcard.inc.php,v 1.3 2007-08-01 18:28:29 michal Exp $
 * @copyright sote 
 */

// adowanie lib'w 
require_once ("lib/SPayment/SOrder.inc.php");
require_once ("lib/SPayment/SPayment/SPayment.interface.inc.php");
require_once ("include/security_validate.inc");
require_once ("HTTP/Client.php");
global $ecard_config;
require_once ("config/auto_config/ecard_config.inc.php");

define("ECARD_HASH_URL","https://pay.ecard.pl/servlet/HS");
define("ECARD_POST_URL","https://pay.ecard.pl/payment/PS");
define("ECARD_POST_URL_TEST","https://pay.ecard.pl/servlet/PSTEST");

class SEcard implements SPayment {

	/**
	 * Obiekt z configiem $ecard_config
	 *
	 * @var object
	 */
	private $_config;
	
	/**
	 * Obiekt klasy SOrder
	 *
	 * @var object
	 */
	private $SOrder;
	
	/**
	 * Czy $_REQUEST by sprawdzony
	 *
	 * @var bool
	 */
	private $requestChecked = false;
	
	/**
	 * Konstruktor
	 *
	 */
	function __construct()
	{
		global $ecard_config;
		$this->_config = $ecard_config;
		
		$this->SOrder = new SOrder;
	}
	
	/**
	 * Wywietlanie forumlarza z przejciem do patnoci
	 * 
	 * Dane o wycigamy z sesji, z funkcji $SOrder i z config'w np.
	 * - $_SESSION['form']['name'] - imie klienta
	 * - $_SESSION['form']['surname'] - nazwisko klienta
	 * - $_SESSION['global_order_id'] - numer zamwienia
	 * - $SOrder->getAmount() - kwota zamwienia
	 * 
	 * Wynikiem jest print "<form>...</form>";
	 * 
	 * @return true
	 */
	function showForm()
	{
		global $lang, $config;
		
		$amount = $this->SOrder->getAmount();
       	$amount = intval($amount*100);
		
		$http =& new HTTP_Client;
		
		$http_data = array( 'orderNumber' => $_SESSION['global_order_id'],
							'orderDescription' => "",
							'amount' => $amount,
							'currency' => "985",
							'merchantId' => $this->_config->ecardAccount,
							'password' => $this->_config->ecardPassword
							);
		
        $http->post(ECARD_HASH_URL,$http_data);
        
        $result = $http->_responses[0]['body'];
        $result = trim($result);

        if (@$this->_config->autodeposit)
        {
        	$autodeposit = 1;
        } else {
        	$autodeposit = 0;
        }
        
        $o="";
        $o="<br /><table width=\"70%\" border=\"0\"><tr><td width=\"50%\" valign=\"top\" align=\"center\"><img src=\"/themes/base/base_theme/_img/ecard_logo.jpg\"><br /></td><td width=\"50%\" valign=\"top\" align=\"center\">$lang->ecard_info<br /></td></tr></table>";
        
        if ($result and $result != "zlyHash" and $result != "wrongPassword")
        {
        	if ($this->_config->ecardActive == 1)
        	{
        		$o.="\n<form action=\"".ECARD_POST_URL."\" method=\"POST\">\n";
        	} else {
        		$o.="\n<form action=\"".ECARD_POST_URL_TEST."\" method=\"POST\">\n";
        	}
        	$o.="<input type=\"hidden\" name=\"ORDERNUMBER\" value=\"".$_SESSION['global_order_id']."\">\n";
        	$o.="<input type=\"hidden\" name=\"MERCHANTID\" value=\"".$this->_config->ecardAccount."\">\n";
        	$o.="<input type=\"hidden\" name=\"ORDERDESCRIPTION\" value=\"".$_SESSION['global_order_id']."\">\n";
        	$o.="<input type=\"hidden\" name=\"AMOUNT\" value=\"".$amount."\">\n";
        	$o.="<input type=\"hidden\" name=\"CURRENCY\" value=\"985\">\n";
        	$o.="<input type=\"hidden\" name=\"SESSIONID\" value=\"".$_SESSION['order_session']."\">\n";
        	$o.="<input type=\"hidden\" name=\"NAME\" value=\"".$_SESSION['form']['name']."\">\n";
        	$o.="<input type=\"hidden\" name=\"SURNAME\" value=\"".$_SESSION['form']['surname']."\">\n";
        	$o.="<input type=\"hidden\" name=\"AUTODEPOSIT\" value=\"".$autodeposit."\">\n";
        	$o.="<input type=\"hidden\" name=\"BIN\" value=\"\">\n"; // nie wykorzystywane
        	$o.="<input type=\"hidden\" name=\"LANGUAGE\" value=\"PL\">\n";
        	$o.="<input type=\"hidden\" name=\"CHARSET\" value=\"iso-8859-2\">\n";
        	$o.="<input type=\"hidden\" name=\"COUNTRY\" value=\"616\">\n"; // warto pusta z powodu dziwnych wymaga Ecardu
        	$o.="<input type=\"hidden\" name=\"JS\" value=\"0\">\n";
        	$o.="<input type=\"hidden\" name=\"HASH\" value=\"".$result."\">\n";
        	$o.="<input type=\"hidden\" name=\"PAYMENTTYPE\" value=\"".$this->_config->ecardPayType."\">\n";
        	$o.="<input type=\"hidden\" name=\"LINKFAIL\" value=\"".$config->www."/".$this->_config->ecardCancelReturnUrl."\">\n";
        	$o.="<input type=\"hidden\" name=\"LINKOK\" value=\"".$config->www."/".$this->_config->ecardReturnUrl."\">\n";
        	$o.="<input type=\"hidden\" name=\"TRANSPARENTPAGES\" value=\"0\">\n";
        	$o.="<input type=\"submit\" value=\"$lang->register_ecard_order\">\n";
        	$o.="</form>\n";
        } else {
        	// Zy hash
        	$o.= "Bd poczenia z systemem Ecard";
        }
        
        print $o;
        
        return true;
	}

	/**
	 * Sprawdzanie czy $_REQUEST jest dobry i zawiera wszystkie dane
	 * 
	 *  !!! SPRAWDZAMY WSZYSKO CO MOLIWE, (TNZ. DUGOCI I TYPY DANYCH) UYWAJC KLASY Svalidate.
	 * 
	 *  !!! Przykad uzycia 
	 *	!!! require_once ("include/security_validate.inc");
	 *	!!! SValidate::Integet("1000"); // zwrci true
	 * 
	 * @global array $_REQUEST
	 * @return bool true/false 
	 */
	function checkRequest()
	{
		if (! empty($_REQUEST))
		{
			// sprawdzenie czy $_REQUEST['MERCHANTNUMBER'] nie jest pusty i czy MERCHANTNUMBER z $_REQUEST'a jest watroscia liczbowa
			if (empty($_REQUEST['MERCHANTNUMBER']) or !SValidate::integer($_REQUEST['MERCHANTNUMBER']))
			{
				return false;
			}
			
			// sprawdzenie czy $_REQUEST['ORDERNUMBER'] nie jest pusty i czy ORDERNUMBER z $_REQUEST'a jest watroscia liczbowa
			if (empty($_REQUEST['ORDERNUMBER']) or !SValidate::integer($_REQUEST['ORDERNUMBER']))
			{
				return false;
			}
			
			// sprawdzenie czy $_REQUEST['COMMTYPE'] nie jest pusty i czy COMMTYPE z $_REQUEST'a jest string'iem
			if (empty($_REQUEST['COMMTYPE']) or !SValidate::string($_REQUEST['COMMTYPE'], array("min_length"=>5, "max_length"=>50)))
			{
				return false;
			}
			
			// sprawdzenie czy $_REQUEST['PREVIOUSSTATE'] nie jest pusty i czy PREVIOUSSTATE z $_REQUEST'a jest string'iem
			if (empty($_REQUEST['PREVIOUSSTATE']) or !SValidate::string($_REQUEST['PREVIOUSSTATE'], array("min_length"=>5, "max_length"=>50)))
			{
				return false;
			}
			
			// sprawdzenie czy $_REQUEST['CURRENTSTATE'] nie jest pusty i czy CURRENTSTATE z $_REQUEST'a jest string'iem
			if (empty($_REQUEST['CURRENTSTATE']) or !SValidate::string($_REQUEST['CURRENTSTATE'], array("min_length"=>5, "max_length"=>50)))
			{
				return false;
			}
			
			// sprawdzenie czy $_REQUEST['PAYMENTTYPE'] nie jest pusty i czy PAYMENTTYPE z $_REQUEST'a jest rwne 1
			if (empty($_REQUEST['PAYMENTTYPE']) or $_REQUEST['PAYMENTTYPE'] != 1)
			{
				return false;
			}
			
			// sprawdzenie czy $_REQUEST['EVENTTYPE'] nie jest pusty i czy EVENTTYPE z $_REQUEST'a jest rwne 1
			if (empty($_REQUEST['EVENTTYPE']) or $_REQUEST['EVENTTYPE'] != 1)
			{
				return false;
			}
			
			// sprawdzenie czy $_REQUEST['PAYMENTNUMBER'] nie jest pusty i czy PAYMENTNUMBER z $_REQUEST'a jest rwne 1
			if (empty($_REQUEST['PAYMENTNUMBER']) or $_REQUEST['PAYMENTNUMBER'] != 1)
			{
				return false;
			}
			
			// sprawdzenie czy $_REQUEST['TYPE'] nie jest pusty i czy TYPE z $_REQUEST'a jest watroscia liczbowa
			if (empty($_REQUEST['TYPE']) or !SValidate::integer($_REQUEST['TYPE']))
			{
				return false;
			}
			
			// Reszty parametrw z $_REQUEST'a nie sprawdzam bo nie s one potrzebne w sklepie i w niektrych przypadkach puste.
			
		} else {
			return false;
		}

		$this->requestChecked = true;
		return true;
	}
	
	/**
	 * Przetwarzanie $_REQUEST'a otrzymanego od patnoci
	 *
	 *  !!! UWAGA: WYMAGANE SPRAWDZANIE CZY ZOSTA WYWOANA METODA $this->checkRequest();
	 * 
	 * Statusy transakcji:
	 * - 000 - nowa (niebieski)
	 * - 001 - zatwierdzona (zielony)
	 * - 002 - anluowana (pomaranczowy)
	 * - 003 - odrzucona (czerwony)
	 * - 099 - nieznany bd (czarny)
	 * 
	 * @global array $_REQUEST
	 * @return array przetworzone dane $_REQUEST'a
	 * 
	 * array( 'order_id' => "numer zamwienia - int", 
	 * 		  'pay_status' => "status transakcji - int",
	 * 		  'checksum_online' => "suma kontrolna - text",
	 * 		 );
	 * 
	 * $checksum = $SOrder->checksum("numer id zamwienia", "transakcja zatwierdzona - 1/nie zatwierdzona - 0, "kwota zamwienia"); 
	 */
	function processingRequest()
	{
		global $mdbd;
		
		if( $this->requestChecked === false)
		{
			if(!$this->checkRequest()) return false;
		}
		
		$amount = $mdbd->select("amount","order_register","order_id=?",array($_REQUEST['ORDERNUMBER']=>"int"));
		
		$status = array( 'order_id' => 0, 'pay_status' => "000", 'checksum_online' => "checksum_online_false" );
		
		// transakcja nowa
		if ( $_REQUEST['CURRENTSTATE'] == "payment_pending" or $_REQUEST['CURRENTSTATE'] == "transfer_pending" )
		{
			$checksum = $this->SOrder->checksum($_REQUEST['ORDERNUMBER'], 0, $amount);
			$status = array( 'order_id' => $_REQUEST['ORDERNUMBER'],
						 	 'pay_status' => "000",
						 	 'checksum_online' => $checksum,
							);
		}
		
		// transakcja zapacona
		if ( ( $_REQUEST['PREVIOUSSTATE'] == "transfer_accepted" and $_REQUEST['CURRENTSTATE'] == "transfer_closed" ) or
		  	 ( $_REQUEST['PREVIOUSSTATE'] == "payment_pending" and $_REQUEST['CURRENTSTATE'] == "payment_approved" ))
		{
			$checksum = $this->SOrder->checksum($_REQUEST['ORDERNUMBER'], 1, $amount);
			$status = array( 'order_id' => $_REQUEST['ORDERNUMBER'],
						 	 'pay_status' => "001",
						 	 'checksum_online' => $checksum,
							);
		}
		
		// transakcja anulowana
		if ( $_REQUEST['CURRENTSTATE'] == "transfer_canceled" )
		{
			$checksum = $this->SOrder->checksum($_REQUEST['ORDERNUMBER'], 0, $amount);
			$status = array( 'order_id' => $_REQUEST['ORDERNUMBER'],
						 	 'pay_status' => "002",
						 	 'checksum_online' => $checksum,							 	 
							);
		}
		
		// transakcja odrzucona
		if ( $_REQUEST['CURRENTSTATE'] == "payment_declined" or $_REQUEST['CURRENTSTATE'] == "transfer_declined" )
		{
			$checksum = $this->SOrder->checksum($_REQUEST['ORDERNUMBER'], 0, $amount);
			$status = array( 'order_id' => $_REQUEST['ORDERNUMBER'],
						 	 'pay_status' => "003",
						 	 'checksum_online' => $checksum,
							);
		}

		return $status;
	}
	
	 /**
	 * Zapisywanie $_REQUEST'a do bazy danych
	 *
	 *  !!! UWAGA: NALEY SPRAWDZIC $_REQUEST'Y OTRZYMANE OD PATNOCI ZANIM TRAFI DO BAZY DANYCH
	 * 	!!! Przykad uycia soteesklep3/lib/SPayment/SPlatnosciPL/SPlatnosciPL.inc.php
	 * 
	 * @global array $_REQUEST
	 * @return true
	 */
	function saveRequest()
	{
		// sprawdzenie czy $_REQUEST['MERCHANTNUMBER'] jest watroscia liczbowa
		if (SValidate::integer(@$_REQUEST['MERCHANTNUMBER']))
		{
			$request['MERCHANTNUMBER'] = $_REQUEST['MERCHANTNUMBER'];
		} else {
			$request['MERCHANTNUMBER'] = "";
		}
		
		// sprawdzenie czy $_REQUEST['ORDERNUMBER'] jest watroscia liczbowa
		if (SValidate::integer(@$_REQUEST['ORDERNUMBER']))
		{
			$request['ORDERNUMBER'] = $_REQUEST['ORDERNUMBER'];
		} else {
			$request['ORDERNUMBER'] = "";
		}
		
		// sprawdzanie czy $_REQUEST['COMMTYPE'] jest string'iem
		if(SValidate::string(@$_REQUEST['COMMTYPE'],array("min_length"=>5, "max_length"=>50)))
		{
			$request['COMMTYPE'] = $_REQUEST['COMMTYPE'];
		} else {
			$request['COMMTYPE'] = "";
		}
		
		// sprawdzanie czy $_REQUEST['PREVIOUSSTATE'] jest string'iem
		if(SValidate::string(@$_REQUEST['PREVIOUSSTATE'],array("min_length"=>5, "max_length"=>50)))
		{
			$request['PREVIOUSSTATE'] = $_REQUEST['PREVIOUSSTATE'];
		} else {
			$request['PREVIOUSSTATE'] = "";
		}
		
		// sprawdzanie czy $_REQUEST['CURRENTSTATE'] jest string'iem
		if(SValidate::string(@$_REQUEST['CURRENTSTATE'],array("min_length"=>5, "max_length"=>50)))
		{
			$request['CURRENTSTATE'] = $_REQUEST['CURRENTSTATE'];
		} else {
			$request['CURRENTSTATE'] = "";
		}
		
		// sprawdzenie czy $_REQUEST['APPROVALCODE'] jest watroscia liczbowa
		if (SValidate::integer(@$_REQUEST['APPROVALCODE']))
		{
			$request['APPROVALCODE'] = $_REQUEST['APPROVALCODE'];
		} else {
			$request['APPROVALCODE'] = "";
		}
		
		// sprawdzenie czy $_REQUEST['APPROVALCODE'] jest watroscia liczbowa
		if (SValidate::integer(@$_REQUEST['VALIDATIONCODE']))
		{
			$request['VALIDATIONCODE'] = $_REQUEST['VALIDATIONCODE'];
		} else {
			$request['VALIDATIONCODE'] = "";
		}
		
		// sprawdzanie czy $_REQUEST['AUTHTIME'] jest string'iem
		if(SValidate::string(@$_REQUEST['AUTHTIME'],array("min_length"=>5, "max_length"=>50)))
		{
			$request['AUTHTIME'] = $_REQUEST['AUTHTIME'];
		} else {
			$request['AUTHTIME'] = "";
		}
		
		// sprawdzenie czy $_REQUEST['TYPE'] jest watroscia liczbowa
		if (SValidate::integer(@$_REQUEST['TYPE']))
		{
			$request['TYPE'] = $_REQUEST['TYPE'];
		} else {
			$request['TYPE'] = "";
		}
		
		// sprawdzenie czy $_REQUEST['control'] jest numerem sesji
		if (SValidate::sessionId(@$_REQUEST['sess_id']))
		{
			$request['sess_id'] = $_REQUEST['sess_id'];
		} else {
			$request['sess_id'] = "";
		}
		
		$query = "INSERT INTO ecard_status (MERCHANTNUMBER,ORDERNUMBER,COMMTYPE,PREVIOUSSTATE,CURRENTSTATE,APPROVALCODE,VALIDATIONCODE,AUTHTIME,TYPE,sess_id) ";
		$query.= "VALUES (?,?,?,?,?,?,?,?,?,?)";
			
		$prepared_query=$db->PrepareQuery($query);
		if ($prepared_query) 
		{
			$db->QuerySetInteger($prepared_query,1,$request['MERCHANTNUMBER']);
			$db->QuerySetInteger($prepared_query,2,$request['ORDERNUMBER']);
			$db->QuerySetText($prepared_query,3,$request['COMMTYPE']);
			$db->QuerySetText($prepared_query,4,$request['PREVIOUSSTATE']);
			$db->QuerySetText($prepared_query,5,$request['CURRENTSTATE']);
			$db->QuerySetText($prepared_query,6,$request['APPROVALCODE']);
			$db->QuerySetText($prepared_query,7,$request['VALIDATIONCODE']);
			$db->QuerySetText($prepared_query,8,$request['AUTHTIME']);
			$db->QuerySetInteger($prepared_query,9,$request['TYPE']);
			$db->QuerySetText($prepared_query,10,$request['sess_id']);
			$result=$db->ExecuteQuery($prepared_query);
		}
		return true;
	}
	
	/**
	 * Wywietlenie niejawnego komunikatu odbioru poprawnego $_REQUEST'a
	 * np. print "OK"; lub print "TRUE";
	 */
	function confirmRequest()
	{
		print "OK";
	}
	
	/**
	 * Jeli moliwe to sprawdzamy ip serwera z ktrego przyszed $_REQUEST
	 *
	 * @param string $ip adres ip systemu patnoci
	 * @return bool
	 */
	function checkServer()
	{
		return true;
	}
}
?>