<?php
/**
 * Klasa SPlatnosciPL - gwna klasa do obsugi Patnoci.pl
 * 
 * @author marcin.butlak@sote.pl
 * @package SPayment
 * @subpackage SPaypal
 * @version $Id: SPaypal.inc.php,v 1.6 2007-08-02 19:23:58 marcin Exp $
 * @copyright sote 
 */
define("CURRENCY","USD");
// adowanie lib'w
require_once ("lib/SPayment/SOrder.inc.php");
require_once ("lib/SPayment/SPayment/SPayment.interface.inc.php");
require_once ("include/security_validate.inc");
require_once ("HTTP/Client.php");
global $paypal_config;
require_once ("config/auto_config/paypal_config.inc.php");
require_once('lib/SPayment/SPaypal/lib/paypal_base.php');

class SPaypal implements SPayment {

	/**
	 * Obiekt z configiem $paypal_config
	 *
	 * @var object
	 */
	private $_config;

	/**
	 * Obiekt klasy SOrder
	 *
	 * @var object
	 */
	private $SOrder;

	/**
	 * Czy $_REQUEST by sprawdzony
	 *
	 * @var bool
	 */
	private $requestChecked = false;


	private $api;

	private $paypal_server;
	/**
	 * Konstruktor
	 *
	 */
	function __construct()
	{
		global $paypal_config;
		$this->_config = $paypal_config;

		if ($paypal_config->test_mode!=1) {
			$this->paypal_server=$paypal_config->server_url;
		} else {
			$this->paypal_server=$paypal_config->server_test_url;
		}

		$this->SOrder = new SOrder;

		$this->api = new WebsitePaymentsPro();

		$this->api->prepare($this->_config->username, $this->_config->password, $this->_config->signature);
	}

	/**
	 * Wywietlanie forumlarza z przejciem do patnoci
	 * 
	 * Dane o wycigamy z sesji, z funkcji $SOrder i z config'w np.
	 * - $_SESSION['form']['name'] - imie klienta
	 * - $_SESSION['form']['surname'] - nazwisko klienta
	 * - $_SESSION['global_order_id'] - numer zamwienia
	 * - $SOrder->getAmount() - kwota zamwienia
	 * 
	 * Wynikiem jest print "<form>...</form>";
	 * 
	 * @return true
	 */
	function showForm()
	{
		global $lang, $config,$shop,$db, $theme;

		// Setting up the Authentication information
		// Such as Username, Password, Signature and Subject

		$amount = $shop->currency->price($this->SOrder->getAmount());

		$Paypal = $this->api->selectOperation('SetExpressCheckout');

		// kwota zamowienia
		$OrderTotal = $amount;

		// adres powrotny do sklepu w przypadku kontynuacji
		$ReturnURL = $config->http.$_SERVER['HTTP_HOST']."/plugins/_SPayment/confirm.php?paypal_session_id={$_SESSION['order_session']}";

		// adres powrotny do sklepu w przypadku anulowania
		$CancelURL = $config->http.$_SERVER['HTTP_HOST']."/plugins/_SPayment/confirm_false.php";

		// typ akcji
		$PaymentAction = 'Sale';

		$Paypal->setParams($OrderTotal, $ReturnURL, $CancelURL, $PaymentAction,$shop->currency->currency);

		$Paypal->execute();

		if ($Paypal->success()) {

			$response=$Paypal->getAPIResponse();
			if ($response->Ack=='Success') {
				// dodajemy token do bazy
				$db->Query("INSERT INTO paypal (session_id,token_id) VALUES('{$_SESSION['order_session']}','$response->Token')");
				// generujemy formularz
				$theme->theme_file("_paypal/info.html.php");
				$form = "<form action=\"{$this->paypal_server}\" method=\"post\">\n";
				$form .= "<input type=\"hidden\" name=\"cmd\" value=\"_express-checkout\" />\n";
				$form .= "<input type=\"hidden\" name=\"token\" value=\"$response->Token\" />\n";
				$form .= "<input type=\"submit\" value=\"$lang->register_paypal_order\" />";
				$form .= "</form>\n";
				echo $form;
			} else {

				echo "<p style=\"color: red; font-weight: bold\">Patno PayPal nie jest poprawnie skonfigurowana, skontaktuj si z sprzedawc</p>";
				$this->saveRequest($_REQUEST['paypal_session_id'],'','','',var_export($response,true));

				return false;

			}
		} else {
			$response=$Paypal->getAPIResponse();
			$this->saveRequest($_REQUEST['paypal_session_id'],'','','',var_export($response,true));
			return false;
		}

		return true;
	}

	/**
	 * Sprawdzanie czy $_REQUEST jest dobry i zawiera wszystkie dane
	 * 
	 *  !!! SPRAWDZAMY WSZYSKO CO MOLIWE, (TNZ. DUGOCI I TYPY DANYCH) UYWAJC KLASY Svalidate.
	 * 
	 *  !!! Przykad uzycia 
	 *	!!! require_once ("include/security_validate.inc");
	 *	!!! SValidate::Integet("1000"); // zwrci true
	 * 
	 * @global array $_REQUEST
	 * @return bool true/false 
	 */
	function checkRequest($paypal_ipn=true)
	{
		global $db;
		if (!isset($_REQUEST['paypal_session_id']) || !SValidate::sessionId($_REQUEST['paypal_session_id'])) {
			return false;
		}

		$res=$db->Query("SELECT payer_id,token_id FROM paypal WHERE session_id='{$_REQUEST['paypal_session_id']}'");
		if ($res!=0) {
			$payer_id=$db->FetchResult($res,0,"payer_id");
			$token_id=$db->FetchResult($res,0,"token_id");
		}

		/**
		 * 
		 * payer_id przekazywane jest ponownie wylacznie przez IPN
		 * token przekazywany wylacznie do momentu zatwierdzenia platnosci
		 * 
		 */ 
		if ($paypal_ipn) {
			if (isset($_REQUEST['payer_id'])) {
				$payer_id_from_paypal=$_REQUEST['payer_id'];
			} else {
				$payer_id_from_paypal='';
			}

			if ($payer_id != $payer_id_from_paypal) {
				return false;
			}

		} else {
			if (isset($_REQUEST['token'])) {
				$token_id_from_paypal=$_REQUEST['token'];
			} else {
				$token_id_from_paypal='';
			}

			if ($token_id != $token_id_from_paypal) {
				return false;
			}

		}

		return true;
	}

	/**
	 * Przetwarzanie $_REQUEST'a otrzymanego od patnoci
	 *
	 *  !!! UWAGA: WYMAGANE SPRAWDZANIE CZY ZOSTA WYWOANA METODA $this->checkRequest();
	 * 
	 * Statusy transakcji:
	 * - 000 - nowa (niebieski)
	 * - 001 - zatwierdzona (zielony)
	 * - 002 - anluowana (pomaranczowy)
	 * - 003 - odrzucona (czerwony)
	 * - 099 - nieznany bd (czarny)
	 * 
	 * @global array $_REQUEST
	 * @return array przetworzone dane $_REQUEST'a
	 * 
	 * array( 'order_id' => "numer zamwienia - int", 
	 * 		  'pay_status' => "status transakcji - int",
	 * 		  'checksum_online' => "suma kontrolna - text",
	 * 		 );
	 * 
	 * $checksum = $SOrder->checksum("numer id zamwienia", "transakcja zatwierdzona - 1/nie zatwierdzona - 0, "kwota zamwienia"); 
	 */
	function processingRequest()
	{
		global $mdbd, $paypal_config,$config, $shop,$db;

		$status = array( 'order_id' => 0, 'pay_status' => "000", 'checksum_online' => "checksum_online_false" );

		$http = new HTTP_Client;

		$validate_data=$_REQUEST;
		file_put_contents($_SERVER['DOCUMENT_ROOT']."/tmp/paypal_ipn.txt",var_export($validate_data,true));
		// flaga okreslajaca zweryfikowanie odebranych danych
		$validate_data['cmd']="_notify-validate";

		// wyslanie odebranych danych w celach weryfikacji
		$http->post($this->paypal_server,$validate_data);

		$result = trim($http->_responses[0]['body']);

		/**
		 * 
		 * Weryfikacja danych
		 * 
		 * VERIFIED - dane poprawne
		 * 
		 * INVALID - dane bledne
		 * 
		 */
		if ($result=="VERIFIED"){

			$order_id = $mdbd->select("order_id","order_register","session_id=?",array($_REQUEST['paypal_session_id'] => "text"),"LIMIT 1");

			// przeliczenie waluty zwroconej z paypal na walute przechowywana w bazie
			$price=$shop->currency->change($validate_data['mc_gross'],$config->currency_name[$validate_data['mc_currency']],1);

			switch ($validate_data['payment_status']) {
				case 'Pending':
					$checksum = $this->SOrder->checksum($order_id, 0, $price);
					$status = array( 'order_id' => $order_id,
					'pay_status' => "000",
					'checksum_online' => $checksum,
					);
					break;

				case 'Completed':
					$checksum = $this->SOrder->checksum($order_id, 1, $price);
					$status = array( 'order_id' => $order_id,
					'pay_status' => "001",
					'checksum_online' => $checksum,
					);
					break;

				case 'Reversed':
				case 'Refunded':
				case 'Voided':
					$checksum = $this->SOrder->checksum($order_id, 0, $price);
					$status = array( 'order_id' => $order_id,
					'pay_status' => "002",
					'checksum_online' => $checksum,
					);
					break;

				case 'Denied':
				case 'Failed':
				case 'Expired':
					$checksum = $this->SOrder->checksum($trans_order_id, 0, $price);
					$status = array( 'order_id' => $trans_order_id,
					'pay_status' => "003",
					'checksum_online' => $checksum,
					);
					break;
			}

			$this->saveRequest($validate_data['paypal_session_id'],$validate_data['payment_status'],$validate_data['pending_reason'],$validate_data['reason_code']);

		}
		return $status;

	}

	/**
	 * Zapisywanie $_REQUEST'a do bazy danych
	 *
	 *  !!! UWAGA: NALEY SPRAWDZIC $_REQUEST'Y OTRZYMANE OD PATNOCI ZANIM TRAFI DO BAZY DANYCH
	 * 	!!! Przykad uycia soteesklep3/lib/SPayment/SPlatnosciPL/SPlatnosciPL.inc.php
	 * 
	 * @global array $_REQUEST
	 * @return true
	 */
	function saveRequest($paypal_session_id='',$payment_status='',$pending_reason='',$reason_code='',$exception='')
	{
		global $db;

		if ($res=$db->Query("SELECT session_id FROM paypal_ipn WHERE session_id LIKE '$paypal_session_id'"))
		{
			if (!$db->NumberOfRows($res)) {
				$db->Query("INSERT INTO paypal_ipn (session_id,payment_status,pending_reason,reason_code,exception) VALUES ('$paypal_session_id','$payment_status','$pending_reason','$reason_code','$exception')");
			} else {
				$db->Query("UPDATE paypal_ipn SET payment_status='$payment_status',pending_reason='$pending_reason',reason_code='$reason_code' WHERE session_id LIKE '$paypal_session_id'");

			}
		}
	}

	/**
	 * Wywietlenie niejawnego komunikatu odbioru poprawnego $_REQUEST'a
	 * np. print "OK"; lub print "TRUE";
	 */
	function confirmRequest()
	{
		//print "OK";
	}

	/**
	 * Jeli moliwe to sprawdzamy ip serwera z ktrego przyszed $_REQUEST
	 *
	 * @param string $ip adres ip systemu patnoci
	 * @return bool
	 */
	function checkServer()
	{
		global $paypal_config;

		file_put_contents($_SERVER['DOCUMENT_ROOT']."/tmp/paypal_server.txt","remote_addr='{$_SERVER['REMOTE_ADDR']}'\n".var_export(
		$paypal_config->ipn_server,true));
		if (array_search($_SERVER['REMOTE_ADDR'],$paypal_config->ipn_server)===null) {
			return false;
		}

		return true;
	}

	/**
	 * Metoda pomocnicza 
	 *
	 */
	function ExpressCheckout() {

		global $config, $shop, $db;

		if (!$this->checkRequest(false)) {
			return false;
		}

		$fname      = @iconv("ISO_8859-2","UTF-8",$_SESSION['form']['name']);
		$lname      = @iconv("ISO_8859-2","UTF-8",$_SESSION['form']['surname']);
		$address1   = @iconv("ISO_8859-2","UTF-8",$_SESSION['form']['street']);
		$city       = @iconv("ISO_8859-2","UTF-8",$_SESSION['form']['city']);
		$zip        = $_SESSION['form']['postcode'];
		$cc_country = $_SESSION['form']['country'];

		$Paypal = $this->api->selectOperation('GetExpressCheckoutDetails');

		$Token = $_REQUEST['token'];

		$Paypal->setParams($Token);

		$Paypal->execute();

		if ($Paypal->success())
		{
			$response=$Paypal->getAPIResponse();

			$this->saveRequest($_REQUEST['paypal_session_id'],'','','',var_export($response,true));
			if ($response->Ack!='Success') {
				return false;
			}
		}
		else
		{
			$response=$Paypal->getAPIException();

			$this->saveRequest($_REQUEST['paypal_session_id'],'','','',var_export($response,true));

			return false;
		}

		$Paypal = $this->api->selectOperation('DoExpressCheckoutPayment');

		$PaymentAction = 'Sale';

		$Token = $_REQUEST['token'];

		$PayerID = $_REQUEST['PayerID'];

		$Address = PayPalTypes::AddressType($fname .' '. $lname, $address1, '', $city, '', $zip, $cc_country, '');

		$invoice  = date('U');

		$ip  = $_SERVER['REMOTE_ADDR'];

		$order_total=$shop->currency->price($this->SOrder->getAmount());

		$item_total='0.00';

		$shipping='0.00';

		$handling='0.00';

		$tax='0.00';

		$PaymentDetails = PayPalTypes::PaymentDetailsType(	$order_total,
		$item_total,
		$shipping,
		$handling,
		$tax,
		'',
		'',
		$invoice,
		'',
		$config->http.$_SERVER['HTTP_HOST']."/plugins/_SPayment/check.php?paypal_session_id={$_REQUEST['paypal_session_id']}",
		$Address,
		array(),
		$shop->currency->currency);

		$Paypal->setParams($PaymentAction, $Token, $PayerID, $PaymentDetails);

		$Paypal->execute();

		if ($Paypal->success())
		{
			$response=$Paypal->getAPIResponse();
			if ($response->Ack=='Success') {
				// zapisujemy payer_id do bazy
				$db->Query("UPDATE paypal SET payer_id='$PayerID' WHERE session_id='{$_SESSION['order_session']}'");
			} else {
				$this->saveRequest($_REQUEST['paypal_session_id'],'','','',var_export($response,true));
				return false;
			}

		}
		else
		{
			$response=$Paypal->getAPIException();
			$this->saveRequest($_REQUEST['paypal_session_id'],'','','',var_export($response,true));
			return false;
		}


		return true;
	}
}
?>