<?php
/**
 * Klasa SPlatnosciPL - gwna klasa do obsugi Patnoci.pl
 * 
 * @author michal.prochowski@sote.pl
 * @package SPayment
 * @subpackage SPlatnosciPL
 * @version $Id: SPlatnosciPL.inc.php,v 1.3 2007-08-01 18:30:36 michal Exp $
 * @copyright sote 
 */

// adowanie lib'w 
require_once ("lib/SPayment/SOrder.inc.php");
require_once ("lib/SPayment/SPayment/SPayment.interface.inc.php");
require_once ("include/security_validate.inc");
require_once ("HTTP/Client.php");
global $platnoscipl_config;
require_once ("config/auto_config/platnoscipl_config.inc.php");

// Zdefiniowany adres do wysyania zapyta o status transakcji
define("PLATNOSCIPL_HTTP_URL","https://www.platnosci.pl/paygw/ISO/Payment/get/txt");

class SPlatnosciPL implements SPayment {

	/**
	 * Obiekt z configiem $platnoscipl_config
	 *
	 * @var object
	 */
	private $_config;
	
	/**
	 * Obiekt klasy SOrder
	 *
	 * @var object
	 */
	private $SOrder;
	
	/**
	 * Czy $_REQUEST by sprawdzony
	 *
	 * @var bool
	 */
	private $requestChecked = false;
	
	/**
	 * Konstruktor
	 *
	 */
	function __construct()
	{
		global $platnoscipl_config;
		$this->_config = $platnoscipl_config;
		
		$this->SOrder = new SOrder;
	}
	
	/**
	 * Wywietlanie forumlarza z przejciem do patnoci
	 * 
	 * Dane o wycigamy z sesji, z funkcji $SOrder i z config'w np.
	 * - $_SESSION['form']['name'] - imie klienta
	 * - $_SESSION['form']['surname'] - nazwisko klienta
	 * - $_SESSION['global_order_id'] - numer zamwienia
	 * - $SOrder->getAmount() - kwota zamwienia
	 * 
	 * Wynikiem jest print "<form>...</form>";
	 * 
	 * @return true
	 */
	function showForm()
	{
		global $lang, $config;
		
        $pos_id = $this->_config->pl_pos_id;
        $pos_auth_key = $this->_config->pl_pos_auth_key;
        $key_one = substr($this->_config->pl_md5_one,0,2);
        
       	$amount = $this->SOrder->getAmount();
       	$amount = intval($amount*100);
       	
       	$js_function = "PlnDrawRadioImg(4);";

       	if (!empty($this->_config->draw_type)) 
       	{
       		if ($this->_config->draw_type == "radioimg") 
       		{
        		$js_param = @$this->_config->js_param;
        		if (empty($js_param)) 
        		{
        			$js_param = 4;
        		}
        		$js_function = "PlnDrawRadioImg($js_param);";
        	} elseif ($this->_config->draw_type == "radio") 
        	{
        		$js_function = "PlnDrawRadio();";
        	} elseif ($this->_config->draw_type == "select") 
        	{
        		$js_function = "PlnDrawSelect();";
	        }
        }
        
        if ($config->lang == "pl")
        {
        	$language = "pl";
        } else {
        	$language = "en";
        }

        $o="";
        $o="<table width=\"70%\" border=\"0\"><tr><td width=\"50%\" valign=\"top\" align=\"center\"><img src=\"/themes/base/base_theme/_img/platnosci.gif\"><br /></td><td width=\"50%\" valign=\"top\" align=\"center\">$lang->platnosci_info<br /></td></tr></table>";
        
        $o.="<form action=\"https://www.platnosci.pl/paygw/ISO/NewPayment\" method=\"POST\" name=\"payform\">\n";
        $o.="<input type=\"hidden\" name=\"pos_id\" value=\"".$pos_id."\">\n";
        $o.="<input type=\"hidden\" name=\"pos_auth_key\" value=\"".$pos_auth_key."\">\n";
        $o.="<script language=\"JavaScript\" type=\"text/javascript\" src=\"https://www.platnosci.pl/paygw/ISO/js/".$pos_id."/".$key_one."/paytype.js\">";
        $o.="</script>";
		$o.="<script language=\"JavaScript\" type=\"text/javascript\">";
		$o.=$js_function;
		$o.="</script>\n";
		
        $o.="<input type=\"hidden\" name=\"session_id\" value=\"".$_SESSION['order_session']."\">\n";
        $o.="<input type=\"hidden\" name=\"amount\" value=\"".$amount."\">\n";
        $o.="<input type=\"hidden\" name=\"desc\" value=\"Sklep - zamwienie nr ".$_SESSION['global_order_id']."\">\n";
        $o.="<input type=\"hidden\" name=\"order_id\" value=\"".$_SESSION['global_order_id']."\">\n";
        $o.="<input type=\"hidden\" name=\"first_name\" value=\"".$_SESSION['form']['name']."\">\n";
        $o.="<input type=\"hidden\" name=\"last_name\" value=\"".$_SESSION['form']['surname']."\">\n";
        $o.="<input type=\"hidden\" name=\"street\" value=\"".$_SESSION['form']['street']."\">\n";
        $o.="<input type=\"hidden\" name=\"street_hn\" value=\"".$_SESSION['form']['street_n1']."\">\n";
        $o.="<input type=\"hidden\" name=\"street_an\" value=\"".$_SESSION['form']['street_n2']."\">\n";
        $o.="<input type=\"hidden\" name=\"city\" value=\"".$_SESSION['form']['city']."\">\n";
        $o.="<input type=\"hidden\" name=\"post_code\" value=\"".$_SESSION['form']['postcode']."\">\n";
        $o.="<input type=\"hidden\" name=\"email\" value=\"".$_SESSION['form']['email']."\">\n";
        $o.="<input type=\"hidden\" name=\"client_ip\" value=\"".$_SERVER['SERVER_ADDR'] ."\">\n";
        $o.="<input type=\"hidden\" name=\"js\" value=\"0\">\n";
        $o.="<input type=\"hidden\" name=\"language\" value=\"".$language."\">\n";
        if ($this->_config->payback == 1)
        {
        	$o.="<br />$lang->payback_login <input type=\"text\" size=\"15\" name=\"payback_login\">\n";
        }
        $o.="<br /><br /><input type=\"submit\" value=\"".$lang->register_platnoscipl_order."\">\n";
        $o.="</form>\n";
        print $o;
        
        return true;
	}

	/**
	 * Sprawdzanie czy $_REQUEST jest dobry i zawiera wszystkie dane
	 * 
	 *  !!! SPRAWDZAMY WSZYSKO CO MOLIWE, (TNZ. DUGOCI I TYPY DANYCH) UYWAJC KLASY Svalidate.
	 * 
	 *  !!! Przykad uzycia 
	 *	!!! require_once ("include/security_validate.inc");
	 *	!!! SValidate::Integet("1000"); // zwrci true
	 * 
	 * @global array $_REQUEST
	 * @return bool true/false 
	 */
	function checkRequest()
	{
		if (! empty($_REQUEST))
		{
			// sprawdzenie czy $_REQUEST['pos_id'] nie jest pusty i czy pos_id z $_REQUEST'a jest watroscia liczbowa
			if (empty($_REQUEST['pos_id']) or !SValidate::integer($_REQUEST['pos_id']))
			{
				return false;
			}
			
			// sprawdzenie czy $_REQUEST['session_id'] nie jest pusty i czy session_id z $_REQUEST'a jest numerem sesji
			if (empty($_REQUEST['session_id']) or !SValidate::sessionId($_REQUEST['session_id']))			
			{
				return false;
			}
			
			// sprawdzenie czy $_REQUEST['ts'] nie jest pusty i czy ts z $_REQUEST'a jest wartoscia liczbowa
			if (empty($_REQUEST['ts']) or !SValidate::integer($_REQUEST['ts']))
			{				
				return false;
			}
			
			// generowanie md5 z $_REQUEST'a
			$shop_sig = md5($_REQUEST['pos_id'].$_REQUEST['session_id'].$_REQUEST['ts'].$this->_config->pl_md5_two);
			
			// sprawdzenie czy $_REQUEST['sig'] nie jest pusty, czy sig z $_REQUEST'a jest kluczem md5 (takie same sprawdzanie jak w przypadku sesji)
			// i czy jest zgodny z wygenerowanym w sklepie
			if (empty($_REQUEST['sig']) or !SValidate::md5($_REQUEST['sig']) or $_REQUEST['sig'] != $shop_sig)
			{
				return false;
			}
		} else {
			return false;
		}

		$this->requestChecked = true;
		return true;
	}
	
	/**
	 * Przetwarzanie $_REQUEST'a otrzymanego od patnoci
	 *
	 *  !!! UWAGA: WYMAGANE SPRAWDZANIE CZY ZOSTA WYWOANA METODA $this->checkRequest();
	 * 
	 * Statusy transakcji:
	 * - 000 - nowa (niebieski)
	 * - 001 - zatwierdzona (zielony)
	 * - 002 - anluowana (pomaranczowy)
	 * - 003 - odrzucona (czerwony)
	 * - 099 - nieznany bd (czarny)
	 * 
	 * @global array $_REQUEST
	 * @return array przetworzone dane $_REQUEST'a
	 * 
	 * array( 'order_id' => "numer zamwienia - int", 
	 * 		  'pay_status' => "status transakcji - int",
	 * 		  'checksum_online' => "suma kontrolna - text",
	 * 		 );
	 * 
	 * $checksum = $SOrder->checksum("numer id zamwienia", "transakcja zatwierdzona - 1/nie zatwierdzona - 0, "kwota zamwienia"); 
	 */
	function processingRequest()
	{
		global $mdbd;
		
		if( $this->requestChecked === false)
		{
			if (!$this->checkRequest()) return false;
		}
		
		$status = array( 'order_id' => 0, 'pay_status' => "000", 'checksum_online' => "checksum_online_false" );
		
		$shop_sig = md5($_REQUEST['pos_id'].$_REQUEST['session_id'].$_REQUEST['ts'].$this->_config->pl_md5_one);
		
		$http = new HTTP_Client;
		
		$http_data = array( 'pos_id' => $_REQUEST['pos_id'],
							'session_id' => $_REQUEST['session_id'],
							'ts' => $_REQUEST['ts'],
							'sig' => $shop_sig
							);
							
		$http->post(PLATNOSCIPL_HTTP_URL,$http_data);
		
		$result = $http->_responses[0]['body'];
		
		$tab = explode("\n",$result);
		
		foreach ($tab as $value)
		{
			if (preg_match('@^trans_session_id:@',$value)) 
			{
				$trans_session_id = trim(preg_replace('@.*: (.*)@','\1',$value));
			}
			if (preg_match('@^trans_order_id:@',$value)) 
			{
				$trans_order_id = intval(preg_replace('@.*: (.*)@','\1',$value));
			}
			if (preg_match('@^trans_status:@',$value)) 
			{
				$trans_status_id = intval(preg_replace('@.*: (.*)@','\1',$value));
			}
			if (preg_match('@^trans_amount:@',$value)) 
			{
				$trans_amount = intval(preg_replace('@.*: (.*)@','\1',$value));
			}
		}
		
		if (!SValidate::sessionId($trans_session_id))
		{
			return false;
		}
		
		if (!$this->SOrder->checkOrderId($trans_order_id, $trans_session_id))
		{
			return false;
		}
			
		switch ($trans_status_id) {
			// nowa transakcja
			case "1": 
				$checksum = $this->SOrder->checksum($trans_order_id, 0, ($trans_amount/100));
				$status = array( 'order_id' => $trans_order_id,
							 	 'pay_status' => "000",
							 	 'checksum_online' => $checksum,
								);
				break;
			// transakcja anulowana
			case "2":
				$checksum = $this->SOrder->checksum($trans_order_id, 0, ($trans_amount/100));
				$status = array( 'order_id' => $trans_order_id,
							 	 'pay_status' => "002",
							 	 'checksum_online' => $checksum,							 	 
								);
				break;
			// transakcja odrzucona
			case "3":
				$checksum = $this->SOrder->checksum($trans_order_id, 0, ($trans_amount/100));
				$status = array( 'order_id' => $trans_order_id,
							 	 'pay_status' => "003",
							 	 'checksum_online' => $checksum,
								);
				break;
			// transakcja zatwierdzona
			case "99":
				$checksum = $this->SOrder->checksum($trans_order_id, 1, ($trans_amount/100));
				$status = array( 'order_id' => $trans_order_id,
							 	 'pay_status' => "001",
							 	 'checksum_online' => $checksum,
								);
				break;
			// bdny status - kontakt z PatnociamiPL
			case "888":
				$checksum = $this->SOrder->checksum($trans_order_id, 0, ($trans_amount/100));
				$status = array( 'order_id' => $trans_order_id,
							 	 'pay_status' => "099",
							 	 'checksum_online' => $checksum,
								);
				break;
			default:
				$status = array( 'order_id' => 0,
							 	 'pay_status' => "000", 
							 	 'checksum_online' => "checksum_online_false",
							 	);
				break;
		}
		return $status;
	}
	
	 /**
	 * Zapisywanie $_REQUEST'a do bazy danych
	 *
	 *  !!! UWAGA: NALEY SPRAWDZIC $_REQUEST'Y OTRZYMANE OD PATNOCI ZANIM TRAFI DO BAZY DANYCH
	 * 	!!! Przykad uycia soteesklep3/lib/SPayment/SPlatnosciPL/SPlatnosciPL.inc.php
	 * 
	 * @global array $_REQUEST
	 * @return true
	 */
	function saveRequest()
	{
		global $db;

		// sprawdzenie czy $_REQUEST['pos_id'] jest watroscia liczbowa
		if (SValidate::integer(@$_REQUEST['pos_id']))
		{
			$request['pos_id'] = $_REQUEST['pos_id'];
		} else {
			$request['pos_id'] = "";
		}
		
		// sprawdzenie czy $_REQUEST['session_id'] jest numerem sesji
		if (SValidate::sessionId(@$_REQUEST['session_id']))
		{
			$request['session_id'] = $_REQUEST['session_id'];
		} else {
			$request['session_id'] = "";
		}
		
		// sprawdzenie czy $_REQUEST['ts'] jest watroscia liczbowa
		if (SValidate::integer(@$_REQUEST['ts']))
		{
			$request['ts'] = $_REQUEST['ts'];
		} else {
			$request['ts'] = "";
		}
		
		// sprawdzenie czy $_REQUEST['sig'] jest kluczem md5
		if (SValidate::md5(@$_REQUEST['sig']))
		{
			$request['sig'] = $_REQUEST['sig'];
		} else {
			$request['sig'] = "";
		}
		
		// generowanie md5 z REQUEST'a
		$shop_sig = md5(@$_REQUEST['pos_id'].@$_REQUEST['session_id'].@$_REQUEST['ts'].$this->_config->pl_md5_two);
		
		$query="INSERT INTO platnoscipl_error (pos_id,session_id,ts,sig,sig_compute) VALUES (?,?,?,?,?)";
			
		$prepared_query=$db->PrepareQuery($query);
		if ($prepared_query) 
		{
			$db->QuerySetText($prepared_query,1,$request['pos_id']);
			$db->QuerySetText($prepared_query,2,$request['session_id']);
			$db->QuerySetText($prepared_query,3,$request['ts']);
			$db->QuerySetText($prepared_query,4,$request['sig']);
			$db->QuerySetText($prepared_query,5,$shop_sig);
			$result=$db->ExecuteQuery($prepared_query);
		}
		return true;
	}
	
	/**
	 * Wywietlenie niejawnego komunikatu odbioru poprawnego $_REQUEST'a
	 * np. print "OK"; lub print "TRUE";
	 */
	function confirmRequest()
	{
		print "OK";
	}
	
	/**
	 * Jeli moliwe to sprawdzamy ip serwera z ktrego przyszed $_REQUEST
	 *
	 * @param string $ip adres ip systemu patnoci
	 * @return bool
	 */
	function checkServer()
	{
		return true;
	}
}
?>