<?php
/**
 * Klasa SPolcard - gwna klasa do obsugi Polcard.pl
 * 
 * @author michal.prochowski@sote.pl
 * @package SPayment
 * @subpackage SPolcard
 * @version $Id: SPolcard.inc.php,v 1.2 2007/05/10 07:49:21 krzys Exp $
 * @copyright sote 
 */

// adowanie lib'w 
require_once ("lib/SPayment/SOrder.inc.php");
require_once ("lib/SPayment/SPayment/SPayment.interface.inc.php");
require_once ("include/security_validate.inc");
global $polcard_config;
require_once ("config/auto_config/polcard_config.inc.php");


class SPolcard implements SPayment {

	/**
	 * Obiekt z configiem $polcard_config
	 *
	 * @var object
	 */
	private $_config;
	
	/**
	 * Obiekt klasy SOrder
	 *
	 * @var object
	 */
	private $SOrder;
	
	/**
	 * Konstruktor
	 *
	 */
	function __construct()
	{
		global $polcard_config;
		$this->_config = $polcard_config;
		
		$this->SOrder = new SOrder;
	}
	
	/**
	 * Wywietlanie forumlarza z przejciem do patnoci
	 * 
	 * Dane o wycigamy z sesji, z funkcji $SOrder i z config'w np.
	 * - $_SESSION['form']['name'] - imie klienta
	 * - $_SESSION['form']['surname'] - nazwisko klienta
	 * - $_SESSION['global_order_id'] - numer zamwienia
	 * - $SOrder->getAmount() - kwota zamwienia
	 * 
	 * Wynikiem jest print "<form>...</form>";
	 * 
	 * @return true
	 */
	function showForm()
	{
		global $lang;
		global $config;
		
       	$amount = $this->SOrder->getAmount();
       	$amount = number_format($amount, 2, ".","");
       	
       	if ($this->_config->status)
       	{
       		$test = "N";
       	} else {
       		$test = "Y";
       	}
        
        $o="";
        $o="<table width=\"70%\" border=\"0\"><tr><td width=\"50%\" valign=\"top\" align=\"center\"><img src=\"/themes/base/base_theme/_img/polcard_logo.gif\"><br /><br /></td><td width=\"50%\" valign=\"top\" align=\"center\">{$lang->bar_title['polcard']}<br /><br />$lang->register_polcard_cards</td></tr></table>";
        $o.="<form action=\"https://post.polcard.com.pl/cgi-bin/autoryzacja.cgi\" method=\"POST\" name=\"payform\">\n";
        $o.="<input type=\"hidden\" name=\"order_id\" value=\"".$_SESSION['global_order_id']."\">\n";
        $o.="<input type=\"hidden\" name=\"id\" value=\"".$this->_config->posid."\">\n";
        $o.="<input type=\"hidden\" name=\"amount\" value=\"".$amount."\">\n";
        $o.="<input type=\"hidden\" name=\"language\" value=\"".$config->lang."\">\n";
        $o.="<input type=\"hidden\" name=\"email\" value=\"".$_SESSION['form']['email']."\">\n";
        $o.="<input type=\"hidden\" name=\"test\" value=\"".$test."\">\n";
        $o.="<input type=\"hidden\" name=\"client_ip\" value=\"".$_SERVER['SERVER_ADDR'] ."\">\n";
		$o.="<input type=\"hidden\" name=\"street\" value=\"".$_SESSION['form']['street']."\">\n";
        $o.="<input type=\"hidden\" name=\"street_n1\" value=\"".$_SESSION['form']['street_n1']."\">\n";
        $o.="<input type=\"hidden\" name=\"street_n2\" value=\"".$_SESSION['form']['street_n2']."\">\n";
        $o.="<input type=\"hidden\" name=\"phone\" value=\"".$_SESSION['form']['phone']."\">\n";
        $o.="<input type=\"hidden\" name=\"postcode\" value=\"".$_SESSION['form']['postcode']."\">\n";
        $o.="<input type=\"hidden\" name=\"phone\" value=\"".$_SESSION['form']['phone']."\">\n";
        $o.="<input type=\"hidden\" name=\"country\" value=\"".$config->country_select[$_SESSION['form']['country']]."\">\n";
        $o.="<br /><input type=\"submit\" value=\"$lang->register_polcard_order\">\n";
        $o.="</form>\n";
        print $o;
        
        return true;
	}

	/**
	 * Sprawdzanie czy $_REQUEST jest dobry i zawiera wszystkie dane
	 * 
	 *  !!! SPRAWDZAMY WSZYSKO CO MOLIWE, (TNZ. DUGOCI I TYPY DANYCH) UYWAJC KLASY Svalidate.
	 * 
	 *  !!! Przykad uzycia 
	 *	!!! require_once ("include/security_validate.inc");
	 *	!!! SValidate::Integet("1000"); // zwrci true
	 * 
	 * @global array $_REQUEST
	 * @return bool true/false 
	 */
	function checkRequest()
	{
		return true;
	}
	
	/**
	 * Przetwarzanie $_REQUEST'a otrzymanego od patnoci
	 *
	 *  !!! UWAGA: WYMAGANE SPRAWDZANIE CZY ZOSTA WYWOANA METODA $this->checkRequest();
	 * 
	 * Statusy transakcji:
	 * - 000 - nowa (niebieski)
	 * - 001 - zatwierdzona (zielony)
	 * - 002 - anluowana (pomaranczowy)
	 * - 003 - odrzucona (czerwony)
	 * - 099 - nieznany bd (czarny)
	 * 
	 * @global array $_REQUEST
	 * @return array przetworzone dane $_REQUEST'a
	 * 
	 * array( 'order_id' => "numer zamwienia - int", 
	 * 		  'pay_status' => "status transakcji - int",
	 * 		  'checksum_online' => "suma kontrolna - text",
	 * 		 );
	 * 
	 * $checksum = $SOrder->checksum("numer id zamwienia", "transakcja zatwierdzona - 1/nie zatwierdzona - 0, "kwota zamwienia"); 
	 */
	function processingRequest()
	{
		$status = array( 'order_id' => 0, 'pay_status' => "000", 'checksum_online' => "checksum_online_false" );
		
		return $status;
	}
	
	 /**
	 * Zapisywanie $_REQUEST'a do bazy danych
	 *
	 *  !!! UWAGA: NALEY SPRAWDZIC $_REQUEST'Y OTRZYMANE OD PATNOCI ZANIM TRAFI DO BAZY DANYCH
	 * 	!!! Przykad uycia soteesklep3/lib/SPayment/SPlatnosciPL/SPlatnosciPL.inc.php
	 * 
	 * @global array $_REQUEST
	 * @return true
	 */
	function saveRequest()
	{
		return true;
	}
	
	/**
	 * Wywietlenie niejawnego komunikatu odbioru poprawnego $_REQUEST'a
	 * np. print "OK"; lub print "TRUE";
	 */
	function confirmRequest()
	{
		print "OK";
	}
	
	/**
	 * Jeli moliwe to sprawdzamy ip serwera z ktrego przyszed $_REQUEST
	 *
	 * @param string $ip adres ip systemu patnoci
	 * @return bool
	 */
	function checkServer()
	{
			return true;
	}
}
?>