<?php
/**
 * Klasa SPost - gwna klasa do obsugi sklepowych przeleww i zamwie za zaliczeniem
 * 
 * @author michal.prochowski@sote.pl
 * @package SPayment
 * @subpackage SPost
 * @version $Id: SPost.inc.php,v 1.1 2007/04/27 14:20:30 michal Exp $
 * @copyright sote 
 */

// adowanie lib'w
require_once ("go/_basket/include/my_basket.inc.php");
require_once ("lib/SPayment/SOrder.inc.php");
require_once ("lib/SPayment/SPayment/SPayment.interface.inc.php");

class SPost implements SPayment {

    /**
	 * Wywietlanie forumlarza z przejciem do patnoci
	 * 
	 * Dane o wycigamy z sesji, z funkcji $SOrder i z config'w np.
	 * - $_SESSION['form']['name'] - imie klienta
	 * - $_SESSION['form']['surname'] - nazwisko klienta
	 * - $_SESSION['global_order_id'] - numer zamwienia
	 * - $SOrder->getAmount() - kwota zamwienia
	 * 
	 * Wynikiem jest print "<form>...</form>";
	 * 
	 * @return true
	 */
    function showForm()
    {
        global $theme;
        global $lang;
        global $sess;
        global $DOCUMENT_ROOT;

        $SOrder = new SOrder;

        $theme->bar($lang->register_send_title);

        if ($SOrder->sendOrder()) {
            // zapamietaj, ze zostalo wywolane wyslanie zamowienia, pozwoli to na zabronienie
            // ponownego wyslanie tego samego zamowienia
            $global_lock_send=true;
            $global_lock_basket=false;
            $global_lock_register=false;
            $sess->register("global_lock_send",$global_lock_send);
            $sess->register("global_lock_basket",$global_lock_basket);
            $sess->register("global_lock_register",$global_lock_register);

            // wyswietl informacje o wyslaniu zamowienia
            $SOrder->backFromPayment(1);            
        } else {
            $SOrder->backFromPayment(0);
        }
    }

    /**
	 * Sprawdzanie czy $_REQUEST jest dobry i zawiera wszystkie dane
	 * 
	 *  !!! SPRAWDZAMY WSZYSKO CO MOLIWE, (TNZ. DUGOCI I TYPY DANYCH) UYWAJC KLASY Svalidate.
	 * 
	 *  !!! Przykad uzycia 
	 *	!!! require_once ("include/security_validate.inc");
	 *	!!! SValidate::Integet("1000"); // zwrci true
	 *
	 * @global array $_REQUEST
	 * @return bool true/false 
	 */
    function checkRequest()
    {
        return true;
    }

    /**
	 * Przetwarzanie $_REQUEST'a otrzymanego od patnoci
	 *
	 *  !!! UWAGA: WYMAGANE SPRAWDZANIE CZY ZOSTA WYWOANA METODA $this->checkRequest();
	 * 
	 * Statusy transakcji:
	 * - 000 - nowa (niebieski)
	 * - 001 - zatwierdzona (zielony)
	 * - 002 - anluowana (pomaranczowy)
	 * - 003 - odrzucona (czerwony)
	 * - 099 - nieznany bd (czarny)
	 * 
	 * @global array $_REQUEST
	 * @return array przetworzone dane $_REQUEST'a
	 * 
	 * array( 'order_id' => "numer zamwienia - int", 
	 * 		  'pay_status' => "status transakcji - int",
	 * 		  'checksum_online' => "suma kontrolna - text",
	 * 		 );
	 * 
	 * $checksum = $SOrder->checksum("numer id zamwienia", "transakcja zatwierdzona - 1/nie zatwierdzona - 0, "kwota zamwienia"); 
	 */
    function processingRequest()
    {
        return true;
    }

    /**
	 * Zapisywanie $_REQUEST'a do bazy danych
	 *
	 *  !!! UWAGA: NALEY SPRAWDZIC $_REQUEST'Y OTRZYMANE OD PATNOCI ZANIM TRAFI DO BAZY DANYCH
	 * 	!!! Przykad uycia soteesklep3/lib/SPayment/SPlatnosciPL/SPlatnosciPL.inc.php
	 * 
	 * @global array $_REQUEST
	 * @return true
	 */
    function saveRequest()
    {
        return true;
    }

    /**
	 * Wywietlenie niejawnego komunikatu odbioru poprawnego $_REQUEST'a
	 * np. print "OK"; lub print "TRUE";
	 */
    function confirmRequest()
    {
        return true;
    }

    /**
	 * Jeli moliwe to sprawdzamy ip serwera z ktrego przyszed $_REQUEST
	 *
	 * @param string $ip adres ip systemu patnoci
	 * @return bool
	 */
    function checkServer()
    {
        return true;
    }
}

?>