<?php
/**
 * Klasa SPrzelewy24 - gwna klasa do obsugi Przelewy24.pl
 * 
 * @author michal.prochowski@sote.pl
 * @package SPayment
 * @subpackage SPrzelewy24.pl
 * @version $Id: SPrzelewy24.inc.php,v 1.2 2007-08-01 18:30:42 michal Exp $
 * @copyright sote 
 */

// adowanie lib'w 
require_once ("lib/SPayment/SOrder.inc.php");
require_once ("lib/SPayment/SPayment/SPayment.interface.inc.php");
require_once ("include/security_validate.inc");
require_once ("HTTP/Client.php");
global $przelewy24_config;
require_once ("config/auto_config/przelewy24_config.inc.php");

// Zdefiniowany adres do wysyania zapyta o status transakcji
define("PRZELEWY24_HTTP_URL","https://secure.przelewy24.pl/transakcja.php");

class SPrzelewy24 implements SPayment {

	/**
	 * Obiekt z configiem $przelewy24_config
	 *
	 * @var object
	 */
	private $_config;
	
	/**
	 * Obiekt klasy SOrder
	 *
	 * @var object
	 */
	private $SOrder;
	
	/**
	 * Czy $_REQUEST by sprawdzony
	 *
	 * @var bool
	 */
	private $requestChecked = false;
	
	/**
	 * Konstruktor
	 *
	 */
	function __construct()
	{
		global $przelewy24_config;
		$this->_config = $przelewy24_config;
		
		$this->SOrder = new SOrder;
	}
	
	/**
	 * Wywietlanie forumlarza z przejciem do patnoci
	 * 
	 * Dane o wycigamy z sesji, z funkcji $SOrder i z config'w np.
	 * - $_SESSION['form']['name'] - imie klienta
	 * - $_SESSION['form']['surname'] - nazwisko klienta
	 * - $_SESSION['global_order_id'] - numer zamwienia
	 * - $SOrder->getAmount() - kwota zamwienia
	 * 
	 * Wynikiem jest print "<form>...</form>";
	 * 
	 * @return true
	 */
	function showForm()
	{
		global $lang;
		global $config;	

		$pos_id = $this->_config->posid;

		$amount = $this->SOrder->getAmount();
       	$amount = intval($amount*100);
       	 	
        if ($this->_config->status == 0)
        {
			$p24_opis = "TEST_OK";
        } else {
        	$p24_opis = "Sklep - zamwienie nr ".$_SESSION['global_order_id'];
        }

        if (!empty($_SESSION['form']['street_n2']))
        {
        	$adress = $_SESSION['form']['street']." ".$_SESSION['form']['street_n1']."/".$_SESSION['form']['street_n2'];
        } else {
        	$adress = $_SESSION['form']['street']." ".$_SESSION['form']['street_n1'];
        }
        
        if ($config->lang == "pl")
        {
        	$language = "pl";
        } else {
        	$language = "en";
        }
        
        $o="";
        $o="<table width=\"70%\" border=\"0\"><tr><td width=\"50%\" valign=\"top\" align=\"center\"><img src=\"/themes/base/base_theme/_img/przelewy24.gif\"><br /></td><td width=\"50%\" valign=\"top\" align=\"center\">$lang->przelewy24_info<br /></td></tr></table>";
        $o.="<form action=\"https://secure.przelewy24.pl/index.php\" method=\"POST\" name=\"payform\">\n";
		
        if ($this->_config->status == 1)
        {        
        	$o.="<script language=\"JavaScript\" type=\"text/javascript\" src=\"https://secure.przelewy24.pl/external/formy.php?id=$pos_id&style=1&lang=$language&sort=2&cols=3\">";
	        $o.="</script>";
			$o.="<script language=\"JavaScript\" type=\"text/javascript\">";
			$o.="m_formy();";
			$o.="</script>\n";
        }

        $o.="<input type=\"hidden\" name=\"p24_session_id\" value=\"".$_SESSION['order_session']."\">\n";
        $o.="<input type=\"hidden\" name=\"p24_id_sprzedawcy\" value=\"".$pos_id."\">\n";
        $o.="<input type=\"hidden\" name=\"p24_kwota\" value=\"".$amount."\">\n";
        $o.="<input type=\"hidden\" name=\"p24_opis\" value=\"".$p24_opis."\">\n";
        $o.="<input type=\"hidden\" name=\"p24_klient\" value=\"".$_SESSION['form']['name']." ".$_SESSION['form']['surname']."\">\n";
        $o.="<input type=\"hidden\" name=\"p24_adres\" value=\"".$adress."\">\n";
        $o.="<input type=\"hidden\" name=\"p24_kod\" value=\"".$_SESSION['form']['postcode']."\">\n";
        $o.="<input type=\"hidden\" name=\"p24_miasto\" value=\"".$_SESSION['form']['city']."\">\n";
        $o.="<input type=\"hidden\" name=\"p24_kraj\" value=\"".$_SESSION['form']['country']."\">\n";
        $o.="<input type=\"hidden\" name=\"p24_email\" value=\"".$_SESSION['form']['email']."\">\n";
        $o.="<input type=\"hidden\" name=\"p24_language\" value=\"$language\">\n";
        $o.="<input type=\"hidden\" name=\"p24_return_url_ok\" value=\"http://".$_SERVER['HTTP_HOST']."/".$this->_config->confirm_url."\">\n";
        $o.="<input type=\"hidden\" name=\"p24_return_url_error\" value=\"http://".$_SERVER['HTTP_HOST']."/".$this->_config->confirm_false_url."\">\n";
        $o.="<br /><br /><input type=\"submit\" value=\"".$lang->przelewy24_next."\">\n";
        $o.="</form>\n";
        print $o;
        
        return true;
	}

	/**
	 * Sprawdzanie czy $_REQUEST jest dobry i zawiera wszystkie dane
	 * 
	 *  !!! SPRAWDZAMY WSZYSKO CO MOLIWE, (TNZ. DUGOCI I TYPY DANYCH) UYWAJC KLASY Svalidate.
	 * 
	 *  !!! Przykad uzycia 
	 *	!!! require_once ("include/security_validate.inc");
	 *	!!! SValidate::Integet("1000"); // zwrci true
	 * 
	 * @global array $_REQUEST
	 * @return bool true/false 
	 */
	function checkRequest()
	{
		
		if (! empty($_REQUEST))
		{
			// sprawdzenie czy $_REQUEST['p24_session_id'] nie jest pusty i czy p24_session_id z $_REQUEST'a jest sesja
			if (empty($_REQUEST['p24_session_id']) or !SValidate::sessionId($_REQUEST['p24_session_id']))
			{
				return false;
			}
			
			// sprawdzenie czy $_REQUEST['p24_order_id'] nie jest pusty i czy p24_order_id z $_REQUEST'a jest string'iem
			if (empty($_REQUEST['p24_order_id']) or !SValidate::string($_REQUEST['p24_order_id'],array('min_length'=>2,'max_length'=>10)))
			{
				return false;
			}
			
			// sprawdzenie czy $_REQUEST['p24_kwota'] nie jest pusty i czy p24_kwota z $_REQUEST'a jest wartoscia liczbowa
			if (empty($_REQUEST['p24_kwota']) or !SValidate::integer($_REQUEST['p24_kwota']))
			{				
				return false;
			}
		} else {
			return false;
		}

		$this->requestChecked = true;
		return true;
	}
	
	/**
	 * Przetwarzanie $_REQUEST'a otrzymanego od patnoci
	 *
	 *  !!! UWAGA: WYMAGANE SPRAWDZANIE CZY ZOSTA WYWOANA METODA $this->checkRequest();
	 * 
	 * Statusy transakcji:
	 * - 000 - nowa (niebieski)
	 * - 001 - zatwierdzona (zielony)
	 * - 002 - anluowana (pomaranczowy)
	 * - 003 - odrzucona (czerwony)
	 * - 099 - nieznany bd (czarny)
	 * 
	 * @global array $_REQUEST
	 * @return array przetworzone dane $_REQUEST'a
	 * 
	 * array( 'order_id' => "numer zamwienia - int", 
	 * 		  'pay_status' => "status transakcji - int",
	 * 		  'checksum_online' => "suma kontrolna - text",
	 * 		 );
	 * 
	 * $checksum = $SOrder->checksum("numer id zamwienia", "transakcja zatwierdzona - 1/nie zatwierdzona - 0, "kwota zamwienia"); 
	 */
	function processingRequest()
	{
		global $mdbd;
		
		if( $this->requestChecked === false)
		{
			if (!$this->checkRequest()) return false;
		}
		
		$status = array( 'order_id' => 0, 'pay_status' => "000", 'checksum_online' => "checksum_online_false" );
		
		$http = new HTTP_Client;
		
		$http_data = array( 'p24_session_id' => $_REQUEST['p24_session_id'],
							'p24_order_id' => $_REQUEST['p24_order_id'],
							'p24_id_sprzedawcy' => $this->_config->posid,
							'p24_kwota' => $_REQUEST['p24_kwota'],
							);
							
		$http->post(PRZELEWY24_HTTP_URL,$http_data);
		
		$result = $http->_responses[0]['body'];			
		
		if (preg_match('@TRUE@',$result)) 
		{
			$status_id = 1;
		} else {
			$status_id = 0;
		}
		
		$order_id = $mdbd->select("order_id","order_register","session_id=?",array($_REQUEST['p24_session_id'] => "text"),"LIMIT 1");
		
			
		switch ($status_id) {
			// nowa transakcja
			case "0": 
				$checksum = $this->SOrder->checksum($order_id, 0, ($_REQUEST['p24_kwota']/100));
				$status = array( 'order_id' => $order_id,
							 	 'pay_status' => "000",
							 	 'checksum_online' => $checksum,
								);
				break;
			// transakcja zatwierdzona
			case "1":
				$checksum = $this->SOrder->checksum($order_id, 1, ($_REQUEST['p24_kwota']/100));
								
				$status = array( 'order_id' => $order_id,
							 	 'pay_status' => "001",
							 	 'checksum_online' => $checksum,
								);
				break;
			default:
				$status = array( 'order_id' => 0,
							 	 'pay_status' => "000", 
							 	 'checksum_online' => "checksum_online_false",
							 	);
				break;
		}
		return $status;
	}
	
	 /**
	 * Zapisywanie $_REQUEST'a do bazy danych
	 *
	 *  !!! UWAGA: NALEY SPRAWDZIC $_REQUEST'Y OTRZYMANE OD PATNOCI ZANIM TRAFI DO BAZY DANYCH
	 * 	!!! Przykad uycia soteesklep3/lib/SPayment/SPlatnosciPL/SPlatnosciPL.inc.php
	 * 
	 * @global array $_REQUEST
	 * @return true
	 */
	function saveRequest()
	{
		global $db;

		// sprawdzenie czy $_REQUEST['p24_session_id'] jest sesja
		if (SValidate::sessionId($_REQUEST['p24_session_id']))
		{
			$request['p24_session_id'] = $_REQUEST['p24_session_id'];
		} else {
			$request['p24_session_id'] = "";
		}
		
		// sprawdzenie czy $_REQUEST['p24_order_id'] jest string'iem
		if (SValidate::string($_REQUEST['p24_order_id'],array('min_length'=>3,'max_length'=>10)))
		{
			$request['p24_order_id'] = $_REQUEST['p24_order_id'];
		} else {
			$request['p24_order_id'] = "";
		}
		
		// sprawdzenie czy $_REQUEST['p24_kwota'] jest wartoscia liczbowa
		if (SValidate::integer($_REQUEST['p24_kwota']))
		{				
			$request['p24_kwota'] = $_REQUEST['p24_kwota'];
		} else {
			$request['p24_kwota'] = "";
		}
		
		$query="INSERT INTO przelewy24_auth (p24_session_id,p24_order_id,p24_kwota) VALUES (?,?,?)";
			
		$prepared_query=$db->PrepareQuery($query);
		if ($prepared_query) 
		{
			$db->QuerySetText($prepared_query,1,$request['p24_session_id']);
			$db->QuerySetText($prepared_query,2,$request['p24_order_id']);
			$db->QuerySetText($prepared_query,3,$request['p24_kwota']);
			$result=$db->ExecuteQuery($prepared_query);
		}
		return true;
	}
	
	/**
	 * Wywietlenie niejawnego komunikatu odbioru poprawnego $_REQUEST'a
	 * np. print "OK"; lub print "TRUE";
	 */
	function confirmRequest()
	{
		print "OK";
	}
	
	/**
	 * Jeli moliwe to sprawdzamy ip serwera z ktrego przyszed $_REQUEST
	 *
	 * @param string $ip adres ip systemu patnoci
	 * @return bool
	 */
	function checkServer()
	{
		return true;
	}
	
	/**
	 * Funkcja sprawdzajca $_REQUEST'a, powinna wykonywa to samo co /htdocs/plugins/_SPayment/check.php
	 *
	 * @return unknown
	 */
	function confirmCheck()	
	{
	    
	    // print "P24 check <br>";
		// Zapisywanie $_REQUEST'a do bazy danych
		// domyslnie zahashowane, eby nie robi mietnika z bazy danych
		// $this->saveRequest();

		// Sprawdzanie poprawnoci $_REQUEST'a i serwera z ktrego przyszed
		if ( $this->checkRequest() and $this->checkServer() )
		{
		    // print "Request OK <br>";
			// Przetwarzanie $_REQUEST'a
			$this->SOrder->request = $this->processingRequest();
	
			// Sprawdzanie czy $SOrder->request jest array'em
			if ( !is_array( $this->SOrder->request ))
			{
				return false;
			}
	
			// Zapisywanie statusu zamwienia
			$this->SOrder->savePaymentStatus();
		} else {
		    // print "Request FALSE <br>";
			return false;
		}
	}
}
?>