<?php 
/**
* Klasa Basket_Container.
* @package basket
*/

/**
 * Klasa jest kontenerem - pozwala na przerzucanie $this w php w wersjach 5 i wyszych.
 * Konieczna jest taka kombinacja poniewa starsze elementy koszyka pozostaj niezmodyfikowane
 * a odwouj si one do globalnego (z ich punktu widzenia) obiektu $basket, 
 * ktry w tej chwili jest zaleny od kontekstu.
 *
 * Wykorzystanie - przy zalozeniu ze $x ma byc bierzacym obiektem:
 * $x = $this; // taka skladnia jest dozwolona
 * { //kod }
 * require_once ("./include/container.inc.php");
 * $containter =& new Basket_Container;
 * $container->me=& $this;
 * $container->me=$x;
 *
 * @author lukasz@sote.pl
 * @package basket
 * @since 03.11.05-cvs
 * @version $Id: container.inc.php,v 1.1.1.1 2006/09/02 13:47:39 marek Exp $
 */
class Basket_Container {
	/**
	 * Obiekt docelowy
	 *
	 * @var object
	 */
	var $me;
}
?>