<?php
/**
* Obsluga koszyka, obliczanie sumy zakupow, prezentacja koszyka itp.
*
* @author  m@sote.pl
* @version $Id: my_basket.inc.php,v 1.6 2007-09-27 13:07:25 marcin Exp $
*
* @package    basket
* \@lang
*/

/**
* Podstawowa klasa obsugi koszyka.
*/
require_once ("lib/Basket/basket.php");

/**
* Klasa obsugi tumacze
*/
require_once ("include/lang_functions.inc");

/**
* Gwna klasa zwizana obsug koszyka. Do tej klasy odwouj si funkcje, korzystajce z danych zawartoci
* koszyka. W odrnieniu od klasy Basket, klasa ta spenia gwnie funkcje zwizane z prezentacj i
* dostpem do informacjio zawartoci koszyka.
*
* @package basket
* @subpackage basket
*/
class MyBasket extends Basket {

	/**
    * Wartosc calego zamowienia
    * @var float
    */
	var $amount=0;

	/**
    * Zawartosc calego koszyka, w stosunku do zmiennej z klasy Basket, tablica
    * ta zaweira dodatkowe informacje o produkcie m.in. cen netto, sum - warto danego produktu * ilo
    * @var array
    */
	var $items=array();

	/**
    * Zawartosc koszyka w formacie TXT
    * @var string
    */
	var $basket_data_txt="";

	/**
    * Rodzaj prezentacji koszyka;
    * @var string "form"  - wstaw pola formularza, "text"  - tylko informacja
    */
	var $display="form";


	var $related_photo=array();
	/**
    * Konstruktor
    */
	function MyBasket() {
		global $_SESSION;

		if (! empty($_SESSION['global_basket_data'])) {
			$basket_data=$_SESSION['global_basket_data'];
			$this->items=$basket_data['items'];
			$this->_count=$basket_data['count'];
		}

		return;
	} // end MyBasket()

	// {{{ empty_basket()

	/**
    * Oproznij koszyk
    *
    * @access public
    * @return none
    */
	function empty_basket() {
		$this->amount=0;
		$this->_item=array();
		$this->items=array();
		$this->basket_data_txt="";
		return(0);
	} // end empty_basket()


	// }}}

	// {{{ amount()

	/**
    * Wartosc calego zamowienia, bez kosztow dostawy
    *
    * @access public
    * @return float  wartosc zamowienia
    */
	function amount() {
		global $_SESSION;
		if (@$_SESSION['global_basket_amount']>0) {
			return $_SESSION['global_basket_amount'];
		} else return 0;
	} // end amount()

	// }}}

	// {{{ totalAmount()

	/**
    * Warto zamwienia wraz z kosztami dostawy
    */
	function totalAmount() {
		global $_SESSION;
		if ($_SESSION['global_delivery']['cost']>0) {
			return $this->amount()+$_SESSION['global_delivery']['cost'];
		} else return $this->amount();
	} // end totalAmount()

	// }}}

	/**
    * Uaktualnij dane w koszyku, uporzadkuj kolejnosc elementow
    * oblicz wartosc zakupow, uaktuanij ilosc elementow w koszyku.
    *
    * @access public
    * @return float warto zakupw
    */
	function calc() {
		global $theme;
		global $delivery_obj;

		$this->amount=0;$this->num=0;$this->weight=0;
		if ($this->count()==0) return;

		foreach ($this->items as $id=>$item) {
			$this->amount+=($item['price']*$item['num']);
			$this->num+=intval($item['num']);
			$this->items[$id]['price_netto']=$theme->price($item['price']/((100+$item['data']['vat'])/100));
			$this->items[$id]['sum_brutto']=$theme->price($item['price']*$item['num']);
			$this->items[$id]['price']=$theme->price($this->items[$id]['price']);

			// opcje dot. zgodnoci z poprzedni werj koszyka
			$this->items[$id]['user_id']=$this->items[$id]['data']['user_id'];
			$this->items[$id]['vat']=$this->items[$id]['data']['vat'];
			$this->items[$id]['price_brutto']=$this->items[$id]['price'];
			$this->items[$id]['options']=@$this->items[$id]['data']['options'];
			$this->weight+=(@$this->items[$id]['data']['weight']*$item['num']);
			// end
		}
		//print "weight".$this->weight;
		$delivery_obj->weight=$this->weight;
		return $this->amount;
	} // end calc()

	/**
    * Pokaz linki do kategorii w ktorej dodano produkt
    *
    * \@global array  $__add_basket_category tablica z danymi kategorii i producenta dodawanego
    *                                       do koszyka produktu
    */
	function add_category_links() {
		global $__add_basket_category;
		global $lang;
		global $category_lang;

		$idc1="id_";$idc="";$url="";

		if (! empty($__add_basket_category['category1'])) {
			$url="idc=id_".$__add_basket_category['id_category1'];
			$category_lang=$__add_basket_category['category1'];
			LangF::translate($category_lang);
			print "<b>$lang->basket_continue_in_category:</b> <a href=/go/_category/?$url>".$category_lang."</a>";
		}

		if (! empty($__add_basket_category['category2'])) {
			for ($i=1;$i<=5;$i++) {
				if ($i>1) {
					$url.=$__add_basket_category["id_category$i"]."_";
					$url2=substr($url,0,strlen($url)-1);
					if (! empty($__add_basket_category["category$i"])) {
						$category_lang=$__add_basket_category['category'.$i];
						LangF::f_translate($category_lang);
						print "> <a href=/go/_category/?$url2>".$category_lang."</a> ";
					}
				} else {
					$url="idc=".$__add_basket_category["id_category$i"]."_";
				}
			} // end for
		} // end if


		return(0);
	} // end add_category_links()

	/**
    * Sprawd czy koszyk jest pusty.
    *
    * @return bool   true - koszyk jest pusty, false w p.w.
    */
	function isEmpty() {
		if (empty($this->items)) {
			if ($this->amount()>0) {
				return false;
			}
			return true;
		}
		return false;
	} // end isEmpty()

	/**
    * Formularz z zawartoscia koszyka.
    * Wyswoanie funckji powoduje wywietlenie na stronie koszyka + elementw formularza (zmiana iloci).
    * Funkcja wywouje tabelke z opisem oraz peny formularz <form> ... </form>. WYwietlane te s
    * informacje o dostawie i promocjach, ktre mona wybra w koszyku.
    *
    * @return wartosc zamowienia, bez kosztow dostawy
    * \@global object $basket        obiekt klasy Basket
    * \@global object $delivery_obj  obiekt z klasy Delivery
    */
	function showBasketForm() {
		global $theme;
		global $lang;
		global $delivery_obj;
		global $global_basket_calc_button;

		// jeli koszyk jest pusty to poka odpowiedni komunikat
		if (empty($this->items)) {
			$theme->basket_empty();
			return;
		}
		// Jeli koszyk jest w formie do wydruku, to nie wyswietlaj paska i przycisku
		global $config;
		if ($config->theme!='print'){
			// pasek "bar" koszyka
			$theme->bar($lang->basket_bar_title);

			print "<p>\n";
			print "<div align=\"left\">\n";
			print "<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\">\n";
			print "  <tr>\n";
			print "    <td valign=\"top\" align=\"left\">";
			// button kontynuuj zakupy
			$theme->button($lang->basket_order_continue,"/",220);
			print "</td>\n";
			print "  </tr>\n";
			print "</table>\n";
			print "<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\">\n";
			print "  <tr>\n";
			print "    <td>\n";
			// pokaz kategorie dodawanego produktu - linki do ketegorii
			$this->add_category_links();
			print "<td>\n";
			print "  </tr>\n";
			print "</table>\n";
			print "</div>\n";
		}

		$theme->theme_file("basket_up.html.php");
		if ($this->display=="form") {
			print "<form action=\"index.php\" method=\"post\" name=\"basketForm\">\n";
		} // end niewydruk

		// start koszyk lista produktw
		// Jesli
		// jesli koszyk jest do wydruku to nie rb odstpw pomidzy wierszami
		if ($config->theme!='print'){
			print  "<table border=\"0\" cellspacing=\"2\" cellpadding=\"2\" align=\"center\" width=\"100%\">\n";
		}else{
			print  "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\" width=\"100%\">\n";
		}
		/*
		print "<pre>";
		print_r (debug_backtrace());
		print "</pre>";*/
		$theme->basket_th($this->display);

		/* uaktualnij wartoc zakupw i dodatkowe dane prodyuktw */
		$this->calc();

		// wywietl pozycje z koszyka w wierszach
		reset($this->items);
		foreach ($this->items as $id=>$item) {
			// print "<pre>";print_r($item);print "</pre><hr>\n";
			$this->_row($id,$item);
		}

		print "</table>\n";
		// end koszyk lista produktw

		if (! empty($global_basket_calc_button)) {
			// przycisk podsumuj
			print "<div align=\"right\">";
			$theme->calc_button();
			print "</div>";

		}

		if ($this->display=="form") {
			// pokaz: suma zamowienia, podsumuj wprowadzone zmiany, zaplac, powrot
			$delivery_obj->show_country();
			$delivery_obj->show();
			$this->order_amount=$this->amount+$delivery_obj->delivery_cost;
			$theme->basket_submit($theme->price($this->amount),$theme->price($this->order_amount),
			$delivery_obj->delivery_name,$delivery_obj->delivery_cost);
			print "</form>\n";

			// pokaz dostepne promocje
			global $config;
			if (in_array("promotion",$config->plugins)) {
				$theme->showPromotions();
			}
		} else {
			print "<p>";
		}

		return $this->amount;
	} // end showBasketForm()

	/* @see showBasketForm()  */
	function show_form() {
		return $this->showBasketForm();
	} // end show_form()


	/**
    * Przedstaw pozycje/wiersz z koszyka w formacie html
    *
    * @param int   $id   id systemowe koszyka, pozycja w koszyku
    * @param array $item dane dot. produktu
    *
    * @access private
    * @return none
    */
	function _row($id,$item) {
		global $theme, $config;

		// przetumacz nazw
		$name=$item['data']['lang_names'][$config->lang_id];

		// jesli koszyk jest do wydruku to nie wyswietlaj kolorw i usu
		if ($config->theme!='print'){

			print "<tr bgcolor=" . @$config->theme_config['colors']['basket_td'] . ">\n";
			print "<td>".$name;
			$id_pos='';
			if (! empty($item['data']['options'])) {
				$options=$item['data']['options'];
				$this->_showOptions($options,"html");
			}
			print "</td>\n";

			// start waluty:
			global $shop;
			$shop->currency();
			$item2=$item;
			if ($shop->currency->changed()) {
				$item2['price']=$shop->currency->price($item2['price']);
				$item2['price_netto']=$shop->currency->price($item2['price_netto']);
				$item2['sum_brutto']=$shop->currency->price($item2['sum_brutto']);

			}
			// end waluty:

			print "<td align=\"center\">".$item2['price_netto']."</td>\n";
			print "<td align=\"center\">".$item['data']['vat']."%</td>\n";
			print "<td align=\"center\">".$item2['price']."</td>\n";
			if ($this->display=="form") {
				print "<td align=\"center\">
            <input type=\"text\" size=\"2\" maxsize=\"6\" name=\"num[$id]\" value=\"".$item['num']."\"></td>\n";
			} else {
				print "<td align=\"center\">".$item['num']."</td>\n";
			}
			print "<td align=\"center\">".$item2['sum_brutto']."</td>\n";
			if ($this->display=="form") {
				print "<td align=\"center\">
            <input class=\"border0\" type=\"checkbox\" name=\"del[$id]\" onClick=\"this.form.submit();\"></td>\n";
			}
			print "</tr>\n";
		}else{
			// jesli koszyk do wydruku to wywietlaj
			print "<tr><td><hr width=100%</td><td><hr width=100%</td><td><hr width=100%</td>
        <td><hr width=100%</td><td><hr width=100%</td><td><hr width=100%</td></tr>";	
			print "<tr bgcolor=>";
			print "<td>".$name;
			$id_pos='';
			if (! empty($item['data']['options'])) {
				$options=$item['data']['options'];
				$this->_showOptions($options,"html");
			}
			print "</td>\n";

			// start waluty:
			global $shop;
			$shop->currency();
			$item2=$item;
			if ($shop->currency->changed()) {
				$item2['price']=$shop->currency->price($item2['price']);
				$item2['price_netto']=$shop->currency->price($item2['price_netto']);
				$item2['sum_brutto']=$shop->currency->price($item2['sum_brutto']);

			}
			// end waluty:

			print "<td align=\"center\">".$item2['price_netto']."</td>\n";
			print "<td align=\"center\">".$item['data']['vat']."%</td>\n";
			print "<td align=\"center\">".$item2['price']."</td>\n";
			print "<td align=\"center\">".$item['num']."</td>\n";
			print "<td align=\"center\">".$item2['sum_brutto']."</td>\n";

			print "</tr>\n";

		}
		return;
	} // end _row()

	/**
    * Przedstaw wybrane opcje produktu.
    *
    * @param array $data opcje produktu
    * @param array $type tryb prezentacji opcji produktu (txt,html)
    *
    * @access private
    * @return string|none
    */
	function _showOptions($data,$type) {
		$o="";
		if (is_array($data)) {
			reset($data);
			foreach ($data as $option) {
				$o.="$option ";
			}
		} else {
			$o.="$data";
		}

		if ($type=="txt") {
			return $o;
		} else {
			print "<br>".$o;
		}
		return(0);
	} // end _showOptions()

	/**
    * Przedstaw zawartosc koszyka w postaci TXT. Informacja ta zostanie dodana do
    * maila z zamowieniem
    *
    * @access public
    * @return string zwraca zawartosc calego goszyka w formacie TXT
    */
	function basket_txt() {
		global $lang;
		global $_SESSION;
		global $config;

		$this->calc();

		$global_delivery=$_SESSION['global_delivery'];
		$global_order_amount=$_SESSION['global_order_amount'];

		$this->basket_data_txt.=$lang->basket_txt_title.":\n";
		reset($this->items);$this->_pos=1;
		foreach ($this->items as $id=>$item) {
			$this->basket_data_txt.=$this->_rowTXT($item);
			$this->_pos++;
		}


		// start waluty:
		global $shop;
		$shop->currency();

		$curr_delivery_cost=$shop->currency->price($global_delivery['cost']);
		$curr_amount=$shop->currency->price($this->amount);
		$curr_order_amount=$shop->currency->price($global_order_amount);

		// end waluty:

		$o=$this->basket_data_txt;
		$o.="\n".$lang->basket_delivery_name.": ".$global_delivery['name'].", ";
		$o.=$lang->basket_delivery_cost.": ".$curr_delivery_cost." ".$shop->currency->currency."\n";
		$o.=$lang->basket_amount_name.": ".$curr_amount." ".$shop->currency->currency."\n";
		$o.=$lang->basket_order_amount_name.": ".$curr_order_amount." ".$shop->currency->currency."\n";

		global $shop;
		$shop->promotions();
		$o.=$shop->promotions->txtInfo();

		return $o;
	} // end basket_txt()


	/**
	 * Pobiera tablice zawierajaca aktualne zdjecia do produktow
	 *
	 * @return array
	 */
	function getRelatedPhoto() {
		return $this->related_photo;
	}
	/**
    * Dane rekordu z koszyka w postaci TXT
    *
    * @param array $item dane produktu
    *
    * @access private
    * @return string dane produktu w TXT
    */
	function _rowTXT($item) {
		global $lang;
		global $config;
		global $theme;
		global $shop;

		$shop->currency();
		if ($shop->currency->changed()) {
			$item['price']=$shop->currency->price($item['price']);
			$item['price_brutto']=$shop->currency->price($item['price_brutto']);
			$item['price_netto']=$shop->currency->price($item['price_netto']);
			$item['sum_brutto']=$shop->currency->price($item['sum_brutto']);
		}
		$theme->basket_item=$item;
		
		$theme->basket_item["photo_url"]=$this->getItemPhotoUrl($item['data']['user_id']);

		$theme->basket_item["item_nr"]=$this->_pos;
		if (! empty($item['data']['options'])) {
			$data=$item['data']['options'];
			$theme->basket_item['options']=trim($this->show_options($data,"txt"),",");
		} else {
			$theme->basket_item['options']="";
		}

		// end waluty:
		ob_start();
		$theme->theme_file("_mail/$config->mail_type_path/basket_send_row.html.php");

		return ob_get_clean();
	} // end _row_txt()

	function getItemPhotoUrl($user_id, $image_type=IMAGE_SMALL) {
		global $db;
		global $config;
		global $image;
		
		$res=$db->Query("SELECT photo_uid,photo_count,photo_small FROM main WHERE user_id LIKE '$user_id' and photo_count > 0 and photo_small <> 0");
		if ($res!=0) {
			$photo_count=$db->FetchResult($res,0,"photo_count");
			$photo_uid=$db->FetchResult($res,0,"photo_uid");
			$photo_small=$db->FetchResult($res,0,"photo_small");

			if ($db->NumberOfRows($res) > 0) {
				return $config->http.$_SERVER['HTTP_HOST'].$image->get_file($image->get_image_name($photo_small, $photo_uid), $image_type,false,true);
			}
		}
		
		return false;
	}
	/**
    * Generuj opis skrcony zamwienia.
    *
    * @return string opis skrocony zmowienia
    */
	function orderDescription() {
		$o="ID: ".$_SESSION['global_order_id'].", ";
		foreach ($this->items as $item) {
			$o.=$item['name']."; ";
		}
		$o=substr($o,0,strlen($o)-2);

		return $o;
	} // end orderDescription()

	/**
    * @ignore
    */
	function order_description() {
		return $this->orderDescription();
	} // end order_description()


	/**
    * Zarejestruj dane zwizane z koszykiem w sesji
    *
    * \@global float $global_basket_amount wartoc produktw w koszyku
    * \@global float $global_order_amount  warto zamwienia z koszyami dostawy
    * \@global int   $global_basket_count  iloc produktw w koszyku
    * \@global array $global_basket_data   pena zawarto koszyka, ktra jest zapamitywana w sesji
    *
    * @return none
    */
	function register() {
		global $sess,$_SESSION;
		global $global_basket_amount,$global_basket_count,$global_order_amount,$global_basket_data;

		// mozliwe, ze wprowadzono zmiany, uaktualnij wartosc zakupow i ilo wszystkich produktw
		$this->calc();

		// zapisz wartosc zakupow i iloc produktw
		$global_basket_amount=$this->amount;
		$global_basket_count=$this->num;

		$sess->register("global_basket_amount",$global_basket_amount);
		$sess->register("global_basket_count",$global_basket_count);

		// zapamitaj stan koszyka w sesji
		$global_basket_data=array("items"=>$this->items,"count"=>$this->getCount());
		$sess->register("global_basket_data",$global_basket_data);

		if (! empty($_SESSION['global_delivery'])) {
			$global_delivery=$_SESSION['global_delivery'];
		}

		// kwota do zaplazy z kosztami dostawy
		$global_order_amount=$global_delivery['cost']+$global_basket_amount;
		$sess->register("global_order_amount",$global_order_amount);

		return;
	} // end register()


	/**
    * Przedstaw wybrane opcje produktu
    *
    * @param array $data opcje produktu
    * @param array tryb prezentacji opcji produktu (txt,html)
    *
    * @access public
    * @return string|none
    */
	function show_options($data,$type) {
		$o="";
		if (is_array($data)) {
			reset($data);
			foreach ($data as $option) {
				$o.=", $option ";
			}
		} else {
			$o.="$data";
		}

		if ($type=="txt") {
			return $o;
		} else {
			print "<br>".$o;
		}
		return(0);
	} // end show_options()

} // end class MyBasket
?>
