<?php
/**
 * Klasa obsugujca zakupy za punkty
 * - sprawdzenie dostpnoci produktu dla danego uytkownika
 *
 * @author lukasz@sote.pl
 * @since 3.5alfa19 07.11.2005
 * @version $Id: points_buy.inc.php,v 1.2 2007/04/30 07:25:10 marek Exp $
 *
 */
class Points_Buy {

    /**
	 * Sprawdzenie czy produkt jest punktowy (zaznaczone pole prezent)
	 *
	 * @param unknown_type $id
	 * @return bool
	 */
    function is_points ($id) {
        global $mdbd;
        /**
	     * Security 5
	     */
        $id=intval($id);
        if (! $id>0) return false;
        // end Security 5
        $is_points=$mdbd->select('points','main','id=?',array($id=>"int"));
        if ($is_points=='1') return true;
        return false;
    }

    /**
	 * Metoda sprawdza czy produkt moze zostac dodany do obecnego koszyka.
	 *
	 * @param int $id - id produtku
	 * @param string $mode - tryb obiektu ktory wywoluje ta metode
	 * @return int $error - blad ktory wystapil podczas weryfikacji (1-ok, pozostae wg langw basket_errors)
	 */
    function check_avail ($id,&$mode) {
        // sprawdzamy ju czy uytkownik moe kupi ten produkt - bdziemy to potem wykorzystywa przy komunikatach bdw
        // standard - warto 1 oznacza sukces eby mona byo porwnywa wynik jako boola
        $is_good_for_points=$this->is_good_for_points($id);
        // z jakim obiektem mamy do czynienia ?
        // obiekt ktry zawiera produkty punktowe
        if ($mode=='points') {
            if ($this->is_points($id)) {
                if ($is_good_for_points=="1") {
                    return 1;
                    // za malo punktow na koncie
                } else return $is_good_for_points;
                // produkt punktowy dodawany do normalnego koszyka
            } else return 4;

            // obiekt ktry zawiera standardowe produkty
        } else if ($mode=='standard') {
            if (!$this->is_points($id)) {
                return 1;
            } else {
                // do koszyka zawierajacego normalne produkty dodano produkt punktowy
                return 2;
            }
            // obiekt ktry nie zawiera produktw, i trzeba ustawi tryb
        } else {
            // jezeli produkt jest punktowy i dostpny - ustawiamy tryb i pozwalamy na dodanie
            if ($this->is_points($id)) {
                if ($is_good_for_points=="1") {
                    $mode="points";
                    return 1;
                    // produkt jest za punkty, ale jest niedostpny. zwracamy zonka.
                } else {
                    // za malo punktow na koncie
                    return $is_good_for_points;
                }
                // jeeli produkt jest normaly - ustawiamy tryb i dodajemy
            } else {
                $mode="standard";
                return 1;
            }
        }
    }

    /**
	 * Sprawdzanie dostpnoci produktu dla danego uytkownika
	 * @access $_SESSION['global_id_user']
	 *
	 * @param int $id - id produktu ktry jest sprawdzany
	 * @return bool - czy produkt jest dostpny dla danego uytkownika
	 */
    function is_good_for_points ($id) {
        global $mdbd;
        // sprawdzamy czy uytkownik jest zalogowany - jeeli nie to nie puszczamy
        if (!empty($_SESSION['global_id_user'])) {
            $__global_id_user=$_SESSION['global_id_user'];
        }
        // uytkownik jest niezalogowany
        else return "12";
        // wycigamy do $data dane dot produktu - czy jest on za punkty i za ile punktw
        $points_value=$mdbd->select('points_value','main','id=?',array($id=>"int"));
        // wycigamy ile punktw ma na koncie uytkownik
        //		$user_points=$mdbd->select('points','users_points','id_user=?',array($__global_id_user=>"int"));
        $user_points=@$_SESSION['form']['points'];
        // czy uytkownik ma do punktw na koncie ?
        // NIE:
        if ($user_points<$points_value) return "13";
        return "1";
    }
}
?>