<?php
/**
* Generowanie tresci zamowienia.
*
* @author m@sote.pl
* @version $Id: message.inc.php,v 1.5 2007-09-19 17:16:53 marcin Exp $
* @package    register
*/

class Message {
 	/**
 	 * dane bilingowe
 	 *
 	 * @param int $order_id id zamowienia
 	 * @param bool	$send_client wyslij dane do klienta
 	 * @return string pliku basket_send_billing.htmp.php
 	 */
	function order2txt($order_id,$send_client=false) {
		global $form,$form_cor;
		global $lang;
		global $config;
		global $theme;

		$theme->basket_form=array();

		if ((empty($form)) && (! empty($_SESSION['form']))) {
			$theme->basket_form['address']=$_SESSION['form'];
		} else {
			$theme->basket_form['address']=$form;
		}
		if ((empty($form_cor)) && (! empty($_SESSION['form_cor']))) {
			$theme->basket_form['address_cor']=$_SESSION['form_cor'];
		} else {
			$theme->basket_form['address_cor']=$form_cor;
		}

		$this->order_id=$order_id;
		$theme->basket_form['send_client']=$send_client;

		ob_start();
		$theme->theme_file("_mail/$config->mail_type_path/basket_send_billing.html.php");

		return ob_get_clean();
	} // end order2txt()


	/**
    * Dodaj linki do zalaczonych do zamowienia zdjec
    *
    * @param int $order_id
    * @return string (txt) linki do zdjec produktow
    */
	function basket_photo() {
		global $db,$sess;
		global $lang;
		global $_SERVER;
		global $_SESSION;
		global $config;

		// nazwa hosta
		$host=$_SERVER['HTTP_HOST'];

		if (empty($this->order_id)) die ("Error: Zamwienie nie zostao wysane/Error: Order wasn't sent.");
		$order_id=$this->order_id;

		$o=$lang->message_basket_photo_title;
		$query="SELECT user_id,name FROM basket_photo WHERE session_id=?";
		$prepared_query=$db->PrepareQuery($query);
		if ($prepared_query) {
			$db->QuerySetText($prepared_query,1,$sess->id);
			$result=$db->ExecuteQuery($prepared_query);
			if ($result!=0) {
				$num_rows=$db->NumberOfRows($result);
				for ($i=0;$i<$num_rows;$i++) {
					$user_id=$db->FetchResult($result,$i,"user_id");
					$name=$db->FetchResult($result,$i,"name");
					$o.=$user_id." http://$host".$config->url_prefix."/go/_basket/_photo/tmp_photos/$name<br />\n";
				} // end for
			} else die ($db->Error());
		} else die ($db->Error());

		return $o;
	} // end basket_photo


	/**
    * Zloz tresc calego zamowienia
    *
    * @param string $basket_add zawartosc koszyka w formacie txt
    * @param string $body dane zamaiwajacego, adres korepsondencyjny
    * @param int    $order_id numer zamowienia
    * @param bool	$send_client wyslij dane do klienta
    * @return string pliku basket_send_body.html.php
    */
	function order_body(&$basket_txt,&$body,$order_id,&$pay_name, $send_client=false) {
		global $lang,$config;
		global $_SESSION;
		global $global_id_pay_method;
		global $theme;
		global $DOCUMENT_ROOT;

		$this->order_id=$order_id;

		$theme->basket_body=array();
		$theme->basket_body['body_content']=$body;
		$theme->basket_body['basket_send_order']=$basket_txt;
		$theme->basket_body['order_id']=$order_id;
		$theme->basket_body['send_client']=$send_client;



		if ($send_client) {
			$user_text_file = $DOCUMENT_ROOT . "/themes/_" . $config->langs_symbols[$config->lang_id] . "/_html_files/order_mail_hello.html";
			if ($user_text=@file_get_contents($user_text_file)) {
				$theme->basket_body['order_mail_hello']=$user_text;
			} else {
				$theme->basket_body['order_mail_hello']="";
			}

			$user_text_file = $DOCUMENT_ROOT . "/themes/_" . $config->langs_symbols[$config->lang_id] . "/_html_files/order_mail.html";
			if ($user_text=@file_get_contents($user_text_file)) {
				$theme->basket_body['order_mail'] = str_replace("{bank}", $config->merchant['bank'],$user_text);
			} else {
				$theme->basket_body['order_mail']="";
			}
		}
		ob_start();
		$theme->theme_file("_mail/$config->mail_type_path/basket_send_body.html.php");

		return ob_get_clean();
	} // end order_body()

} // end class Message
?>
