<?php
/**
*  Funkcje pomocnicze, zwizane z prezentacj danych o transakcji
*
* @author  m@sote.pl
* @version $Id: order_func.inc.php,v 1.3 2007/05/18 12:54:46 krzys Exp $
* @package    users
*/


/**
* Element formularza, status platnosci
*
* @param string $user_id user_id statusu
*/
function show_status($user_id) {
    global $db,$lang;
    
    $query="SELECT name FROM order_status WHERE user_id=?";
    $prepared_query=$db->PrepareQuery($query);
    if ($prepared_query) {
        $db->QuerySetInteger($prepared_query,1,$user_id);
        $result=$db->ExecuteQuery($prepared_query);
        if ($result!=0) {
            $num_rows=$db->NumberOfRows($result);
            if ($num_rows>0) {
                $name=$db->FetchResult($result,0,"name");
            } else {
                $name=$lang->users_order_status_undefined;
            }
        } else die ($db->Error());
    } else die ($db->Error());
    return $name;
}

function show_select_order($label,$id=-1) {
    global $db;
    global $lang;
    
    $str="<SELECT name=$label>";
    if ($id==-1) {
        $str.="<OPTION selected value=''>$lang->all\n";
    }
    $query="SELECT user_id,name FROM order_status ORDER BY user_id";
    $prepared_query=$db->PrepareQuery($query);
    if ($prepared_query) {
        $result=$db->ExecuteQuery($prepared_query);
        if ($result!=0) {
            $num_rows=$db->NumberOfRows($result);
            if ($num_rows>0) {
                for($i=0;$i<$num_rows;$i++) {
                    $name=$db->FetchResult($result,$i,"name");
                    $user_id=$db->FetchResult($result,$i,"user_id");
                    if($user_id == $id ) {
                        $sel="selected";
                    } else {
                        $sel="";
                    }
                    $str.="<OPTION $sel value=$user_id> $name\n";
                }
            } else {
                $str="";
            }
        } else die ($db->Error());
    } else die ($db->Error());
    $str.="</SELECT>";
    
    return $str;
}

/**
* Odczytan nazwy statusow z tabeli order_status
*
* @author m@sote.pl
* @return array user_id=>name nazwa przyporzadkowana id statusu
*/
function read_status_names() {
    global $db;
    
    $status_names=array();
    
    $query="SELECT user_id,name FROM order_status ORDER BY user_id";
    $prepared_query=$db->PrepareQuery($query);
    if ($prepared_query) {
        $result=$db->ExecuteQuery($prepared_query);
        if ($result!=0) {
            $num_rows=$db->NumberOfRows($result);
            if ($num_rows>0) {
                for($i=0;$i<$num_rows;$i++) {
                    $name=$db->FetchResult($result,$i,"name");
                    $user_id=$db->FetchResult($result,$i,"user_id");
                    $status_names[$user_id]=$name;
                }
            }
        } else die ($db->Error());
    } else die ($db->Error());
    
    return $status_names;
} // end get_status_names

/**
* Wycignij nazw produktw odpowiednia dla danego jzyka
*
* @param string $user_id user_id statusu
*/
function show_name($user_id) {
    global $db,$lang, $config;
    
    $query="SELECT name_L0, name_L1, name_L2, name_L3, name_L4 FROM main WHERE user_id=?";
    $prepared_query=$db->PrepareQuery($query);
    if ($prepared_query) {
        $db->QuerySetText($prepared_query,1,$user_id);
        $result=$db->ExecuteQuery($prepared_query);
        if ($result!=0) {
            $num_rows=$db->NumberOfRows($result);
            if ($num_rows>0) {
            	
                $name_L0=$db->FetchResult($result,0,"name_L0");
                $name_L1=$db->FetchResult($result,0,"name_L1");
                $name_L2=$db->FetchResult($result,0,"name_L2");
                $name_L3=$db->FetchResult($result,0,"name_L3");
                $name_L4=$db->FetchResult($result,0,"name_L4");
                
                $lang_table=$config->langs_symbols;
                $lang_table=array_flip($lang_table);
                $lang_number=$lang_table[$config->lang];
				
                if ($lang_number==0){
                	$name=$name_L0;
                }elseif ($lang_number==1){
                	$name=$name_L1;
                }elseif ($lang_number==2){
                	$name=$name_L2;
                }elseif ($lang_number==3){
                	$name=$name_L3;
                }else{
                	$name=$name_L4;
                }
                
            } else {
                $name=$lang->users_order_status_undefined;
            }
        } else die ($db->Error());
    } else die ($db->Error());
    return $name;
}
/**
* Poka produkty do transakcji
*
* @param int $order_id id transakcji
* @return none
*/
function show_products($order_id) {
    global $db,$lang,$config;
    
    $query="SELECT * FROM order_products WHERE order_id=?";
    $prepared_query=$db->PrepareQuery($query);
    if ($prepared_query) {
        $db->QuerySetText($prepared_query,1,$order_id);
        $result=$db->ExecuteQuery($prepared_query);
        if ($result!=0) {
            $num_rows=$db->NumberOfRows($result);
            print "<table cellspacing=\"2\" cellpadding=\"2\" border=\"0\" >\n";
            print "<tr bgcolor=\"".$config->theme_config['colors']['body_background']."\">\n";
            print "<th>".$lang->order_basket['user_id']."</th>\n";
            print "<th>".$lang->order_basket['name']."</th>\n";
            print "<th>".$lang->order_basket['price_brutto']."</th>\n";
            print "<th>".$lang->order_basket['num']."</th>\n";
            print "<th>".$lang->order_basket['sum']."</th>\n";
            print "</tr>\n";
            if ($num_rows>0) {
                for ($i=0;$i<$num_rows;$i++) {
                    product_row($result,$i);
                }
            }
            print "</table>\n";
        } else die ($db->Error());
    } else die ($db->Error());
} // end show_products()

/**
* Wyswietl rekord transakcji
*
* @param mixed $result wynik zapytania z bazy danych
* @param int   $i      numer wiersza wyniku zapytania z bazy danych
* @return none
*/
function product_row($result,$i) {
    global $db,$config;
    global $shop;
    global $lang;
	$shop->currency();
	global $rec;
    $num=$db->FetchResult($result,$i,"num");
    $price_brutto=$db->FetchResult($result,$i,"price_brutto");
    $points_value=$db->FetchResult($result,$i,"points_value");
    $sum_points=$num*$points_value;
    $sum=$num*$shop->currency->price($price_brutto);
    print "<tr>";
    print "<td>"; print $db->FetchResult($result,$i,"user_id_main"); print "</td>";
    print "<td>"; print show_name($db->FetchResult($result,$i,"user_id_main")); print "</td>";
    if ($price_brutto!=0) {
	    print "<td>"; print $shop->currency->price($price_brutto)." ".$shop->currency->currency; print "</td>";
    } else if ($rec->data['points']==1) {
    	print "<td>$points_value $lang->points_unit</td>";
    } else print "<td></td>";
    print "<td>"; print $num; print "</td>";
    if ($price_brutto!=0) {
	    print "<td>"; print $sum." ".$shop->currency->currency; print "</td>";
    } else if ($rec->data['points']==1) {
    	print "<td>$sum_points $lang->points_unit</td>";
    } else print "<td></td>";
    print "</tr>";
} // end product_row()


?>
