<?php
/**
 * Elementy PHP związane z head.html.php
 *
 * @author m@sote.pl
 * @version $Id: head.inc.php,v 1.4 2007-09-04 15:36:11 krzys Exp $
 * @package themes
 */
class T_Head {

	function __construct() {
		$this->T_HEad();
	}

	function T_Head() {
		global $theme,$config,$lang,$prefix;
		$this->theme=&$theme;
		$this->config=&$config;
		$this->lang=&$lang;
		$this->prefix=&$prefix;
	}

	/**
     * Opis title
     */
	function googleTitle() {
		print @$this->config->google['title'];
	}

	/**
     * Meta keywords
     */
	function googleKeywords() {
		print @$this->config->google['keywords'];
	}

	/**
     * Meta description
     */
	function googleDescription() {
		print @$this->config->google['description'];
	}


	/**
    * Kolor tła strony
    */
	function bgColor() {
		print $this->config->theme_config['colors']['body_background'];
	}

	/**
     * Obrazek tła
     */
	function imgBgImage() {
		$this->theme->path($this->prefix . $this->config->theme_config['head']['background-image']);
	}

	/**
     * Logo
     */
	function imgLogo() {
		$this->theme->path($this->prefix . $this->config->theme_config['head']['logo']);
	}

	function imgSmallMenu() {
		$this->theme->path($this->prefix . $this->config->theme_config['head']['small_menu']['img']['left']);
	}

	function imgSmallMenuBg() {
		$this->theme->path($this->prefix . $this->config->theme_config['head']['small_menu']['img']['center']);
	}

	function imgSmallMenuRight() {
		$this->theme->path($this->prefix . $this->config->theme_config['head']['small_menu']['img']['right']);
	}

	function imgMainMenuLeft() {
		$this->theme->path($this->prefix . $this->config->theme_config['head']['main_menu']['img']['left']);
	}

	function imgMainMenuBg() {
		$this->theme->path($this->prefix . $this->config->theme_config['head']['main_menu']['img']['center']);
	}

	function imgMainMenuRight() {
		$this->theme->path($this->prefix . $this->config->theme_config['head']['main_menu']['img']['right']);
	}

	function color1(){
		print $this->config->theme_config['colors']['color_1'];
	}

	/**
     * Link do koszyka.
     */
	function basket() {
		if (@$this->config->catalog_mode==0) {
			print "&nbsp;&#183;&nbsp;<a href=\"/go/_basket/\">".$this->lang->head_your_basket."</a>";
		}
	}

	/**
     * Ilo uytkownikw on-line
     */
	function usersOnline() {
		if ($this->config->users_online) {
			include_once ("include/online.inc");
			print $this->lang->head_users_online.": ".$online->check_users_online();
		}
	}


	/**
     * Jeśli uźytkownik jest zalogowany, pokaż jego login*
     */
	function userLogin() {
		// jesli user jest zalogowany, to pokaz login zalogowanego uzytkownika
		global $_SESSION, $config;
		if ((! empty($_SESSION['global_id_user'])) && (! empty($_SESSION['global_login']))) {
			print "<a href=\"{$this->config->url_prefix}/go/_users/index.php\">".$this->lang->users_login.": <b>".$_SESSION['global_login']."</b></a> ";

		}
	}

	/**
     * Pokaż flagi do wersji językowych
     */    
	function flags() {
		if (in_array("multi_lang",$this->config->plugins)) {
			$this->theme->showFlags();
		}
	}

	/**
     * Wyświetl linki do rejestracji użytkownika i logowania
     */
	function userregisterLogin() {
		if (((@$this->config->cd!=1)&&(@$this->config->catalog_mode==0))||((@$this->config->catalog_mode==1) && (@$this->config->catalog_mode_options['users']==1))){
			if ((! empty($_SESSION['global_id_user'])) && (! empty($_SESSION['global_login']))) {
				print "<a href=\"{$this->config->url_prefix}/go/_users/logout.php\">".$this->lang->users_logout."</a> | ";
			}
			else
			print "<a href=\"/go/_users/new.php\">".$this->lang->head_register."</a> | ";
			print "<a href=\"/go/_users/index.php\">".$this->lang->head_my_account."</a>";
		}
	}

	/**
     * Lista walut
     */
	function currencyList() {
		global $shop, $base_theme_config, $config;
		
		if (in_array("currency",$this->config->plugins) && ($base_theme_config->show_currency==1)) {
			// poka wybr waluty, jeli konfiguracja tematu bazowego na to pozwala
			$shop->currency();
			$shop->currency->currencyList();
		}elseif ($config->catalog_mode==0){
			print "&nbsp;".$shop->currency->currency;
		}
	}

	/**
     * Informacja z przechowalni, link do przechowalni.
     */
	function wishList() {
		if (@$this->config->catalog_mode==0) {
			//print "<td align=\"centere\" style=\"padding: 4px;\">\n";
			$this->theme->wishlistHead();
			//print "</td>\n";
		}
	}

	/**
     * Informacja o koszyku, link do okszyka
     *
     */
	function basketList(){
		global $theme;
		global $global_basket_count,$prefix;
		global $shop;
		if (@$this->config->catalog_mode==0){


			//$this->theme->ask4price();
			print "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\">\n";
			print "<tr>\n";
			print "<td style=\"text-align: left; padding-right: 5px\" rowspan=\"2\" width=\"35\">";
            ?>
            <a href="/go/_basket/"><?php $theme->desktopBoxImage('box_basket'); ?></a>
			<?
			print "</td>\n";			
			print "<td align=\"right\">\n";
			print "<div><table cellpadding=\"0\" cellspacing=\"0\" border=\"0\"><tr><td>";
			print "<a href=\"/go/_basket/\">";
			print $this->lang->head_in_basket;
			print "</a>: <div id=\"basketAmount\">";
			print $this->theme->basketAmount();
			print "</div></td><td>";
			 
			$this->currencyList();
		
			print "</td></tr></table></div></td>\n";
			print "</tr>\n";
			print "<tr>\n";
			print "<td align=\"left\"><a href=\"/go/_basket/\">\n";
			print $this->lang->head_products_count.":&nbsp;<span id=\"basket_count\"> $global_basket_count</span>";
			print "</a></td>\n";

			print "</tr>\n";
			print "</table>\n";


		}
	} // end basketList()


	/**
     * Formularz wyszukiwania
     */
	function search() {
		$this->theme->search_form("horizontal");
	}
	function link2MainPage(){
		print "<a href=\"/\">";
		print $this->lang->foot_main_page;
		print "</a>";
	}

	/**
     * Funkcja wstawia link do promocji
     *
     */
	function link2Promotions(){
		print "<a href=\"".$this->theme->google_url("/go/_promotion/?column=promotion")."\">";
		print $this->lang->foot_promotions;
		print "</a>";
	}

	/**
     * Funkcja wstawia link do news
     *
     */
	function link2News(){
		print "<a href=\"".$this->theme->google_url("/go/_promotion/?column=newcol")."\">";
		print $this->lang->foot_news;
		print "</a>";
	}
	
	/**
     * Funkcja wstawia link do bestseller
     *
     */
	function link2Bestseller(){
		print "<a href=\"".$this->theme->google_url("/go/_promotion/?column=bestseller")."\">";
		print $this->lang->bar_title['bestseller'];
		print "</a>";
	}

	/**
     * Funkcja wstawia link do strony o firmie
     *
     */
	function link2About(){
		print "<a href=\"".$this->theme->google_url("/go/_files/?file=about_company.html")."\">";
		print $this->lang->foot_about;
		print "</a>";
	}

	/**
     * Funkcja wstawia link do strony regulaminu
     *
     */
	function link2Terms(){
		print "<a href=\"".$this->theme->google_url("/go/_files/?file=terms.html")."\">";
		print $this->lang->foot_terms;
		print "</a>";
	}

	/**
     * Funkcja wstawia link do stanu koszyka
     *
     */
	function link2BasketState(){
		if ($this->config->catalog_mode==0){
			print "<a href=\"/go/_basket/\">";
			print $this->lang->foot_basket_state;
			print "</a>";
		}
	}

	/**
     * Funkcja wstawia link do helpa
     *
     */
	function link2Help(){
		print "<a href=\"".$this->theme->google_url("/go/_files/?file=help.html")."\">";
		print $this->lang->foot_help;
		print "</a>";
	}

} // end class
global $t_head;
$t_head = new T_Head();
global $config,$prefix,$lang;
?>