<?php
/**
 * Elementy PHP związane z head.html.php
 *
 * @author m@sote.pl
 * @version $Id: head.inc.php,v 1.3 2007/01/31 10:07:22 lukasz Exp $
 * @package themes
 */
class T_Head {

    function __construct() {
        $this->T_HEad();
    }

    function T_Head() {
        global $theme,$config,$lang,$prefix;
        $this->theme=&$theme;
        $this->config=&$config;
        $this->lang=&$lang;
        $this->prefix=&$prefix;
    }

    /**
     * Opis title
     */
    function googleTitle() {
        print @$this->config->google['title'];
    }

    /**
     * Meta keywords
     */
    function googleKeywords() {
        print @$this->config->google['keywords'];
    }

    /**
     * Meta description
     */
    function googleDescription() {
        print @$this->config->google['description'];
    }


    /**
    * Kolor tła strony
    */
    function bgColor() {
        print $this->config->theme_config['colors']['body_background'];
    }

    /**
     * Obrazek tła
     */
    function imgBgImage() {
        $this->theme->path($this->prefix . $this->config->theme_config['head']['background-image']);
    }

    /**
     * Logo
     */
    function imgLogo() {
        $this->theme->path($this->prefix . $this->config->theme_config['head']['logo']);
    }

    function imgSmallMenu() {
        $this->theme->path($this->prefix . $this->config->theme_config['head']['small_menu']['img']['left']);
    }

    function imgSmallMenuBg() {
        $this->theme->path($this->prefix . $this->config->theme_config['head']['small_menu']['img']['center']);
    }

    function imgSmallMenuRight() {
        $this->theme->path($this->prefix . $this->config->theme_config['head']['small_menu']['img']['right']);
    }

    function imgMainMenuLeft() {
        $this->theme->path($this->prefix . $this->config->theme_config['head']['main_menu']['img']['left']);
    }

    function imgMainMenuBg() {
        $this->theme->path($this->prefix . $this->config->theme_config['head']['main_menu']['img']['center']);
    }

    function imgMainMenuRight() {
        $this->theme->path($this->prefix . $this->config->theme_config['head']['main_menu']['img']['right']);
    }

    function color1(){
        print $this->config->theme_config['colors']['color_1'];
    }

    /**
     * Link do koszyka.
     */
    function basket() {
        if (@$this->config->catalog_mode==0) {
            print "&nbsp;&#183;&nbsp;<a href=\"/go/_basket/\">".$this->lang->head_your_basket."</a>";
        }
    }

    /**
     * Ilo uytkownikw on-line
     */
    function usersOnline() {
        if ($this->config->users_online) {
            include_once ("include/online.inc");
            print $this->lang->head_users_online.": ".$online->check_users_online();
        }
    }


    /**
     * Jeśli uźytkownik jest zalogowany, pokaż jego login*
     */
    function userLogin() {
        // jesli user jest zalogowany, to pokaz login zalogowanego uzytkownika
        global $_SESSION;
        if ((! empty($_SESSION['global_id_user'])) && (! empty($_SESSION['global_login']))) {
            print "<a href=\"$this->config->url_prefix/go/_users/index.php\">".$this->lang->users_login.": <b>".$_SESSION['global_login']."</b></a> ";
        }
    }

    /**
     * Pokaż flagi do wersji językowych
     */    
    function flags() {
        if (in_array("multi_lang",$this->config->plugins)) {
            $this->theme->showFlags();
        }
    }

    /**
     * Wyświetl linki do rejestracji użytkownika i logowania
     */
    function userregisterLogin() {
        if (((@$this->config->cd!=1)&&(@$this->config->catalog_mode==0))||((@$this->config->catalog_mode==1) && (@$this->config->catalog_mode_options['users']==1))){
            print "<a href=\"/go/_users/new.php\">".$this->lang->head_register."</a> | ";
            print "<a href=\"/go/_users/index.php\">".$this->lang->head_my_account."</a>";
        }
    }

    /**
     * Lista walut
     */
    function currencyList() {
        global $shop;
        if (in_array("currency",$this->config->plugins)) {
            $shop->currency();
            $shop->currency->currencyList();
        }
    }

    /**
     * Informacja z przechowalni, link do przechowalni.
     */
    function wishList() {
        if (@$this->config->catalog_mode==0) {
            print "<td align=\"right\" style=\"padding: 4px;\">\n";
            $this->theme->wishlistHead();
            print "</td>\n";
        }
    }

    /**
     * Informacja o koszyku, link do okszyka
     *
     */
    function basketList(){
        global $global_basket_count,$prefix;
        if (@$this->config->catalog_mode==0){

            print "<td align=\"right\" nowrap><nobr>\n";
            $this->theme->ask4price();
            print "</nobr></td>\n";
            print "<td align=\"right\" style=\"padding: 4px\">\n";
            print "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"right\">\n";
            print "<tr>\n";
            print "<td align=\"right\"><a href=\"/go/_basket/\">\n";
            print $this->lang->head_in_basket.":&nbsp;";
            print "</a> </td>\n";
            print "<td align=\"left\">\n";
            print "<div id='basketAmount'>";
            print $this->theme->basketAmount();
            print "</div>";
            print "</td>\n";
            print "<td rowspan=\"2\">&nbsp;</td>\n";
            print "<td rowspan=\"2\"><a href=\"/go/_basket/\"><img alt=\"\" title=\"".$this->lang->tooltip['basket_head']."\" src=\"";
            $this->theme->path($prefix . $this->config->theme_config['icons']['basket']);
            print "\" border=\"0\"></a></td>\n";
            print "</tr>\n";
            print "<tr>\n";
            print "<td align=\"right\"><nobr><a href=\"/go/_basket/\">\n";
            print $this->lang->head_products_count.":&nbsp;";
            print "</a></nobr></td>\n";
            print "<td align=\"left\">\n";
            print "<nobr><div id='basket_count'>$global_basket_count</div></nobr>\n";
            print "</td>\n";
            print "</tr>\n";
            print "</table>\n";
            print "</td>\n";
        }
    } // end basketList()


    /**
     * Formularz wyszukiwania
     */
    function search() {
        $this->theme->search_form("horizontal");
    }
    
} // end class

$t_head = new T_Head();
global $config,$prefix,$lang;
?>