<?php
/**
* @version    $Id: theme.inc.php,v 1.16 2007-10-08 16:30:50 marcin Exp $
* @package    themes
* @subpackage bluelight
*/
require_once("themes/include/buttons.inc.php");
require_once("include/image.inc");

class Theme {

	var $dir;                            // katalog tematu
	var $bg_bar_color="#6699cc";         // kolor tla paskow typu bar
	var $bg_form_color="#ffffff";        // kolr tla formularzy zamowienia
	var $bg_basket_top_color="#abcdef";  // kolor tla w formularzu koszyka - naglowek
	var $bg_basket_row_color="#fedcba";  // kolor tla w formularzu ksozyka - wiersze
	var $bg_bar_color_light="#d5e6ed";
	var $before_main_obj="";             // obiekt zawierajacy funkcje wywolywana przed dbedit
	var $before_main_func="";            // nazwa funkcji jw.
	var $form=array();                   // tablica z danymi z formularza(y)
	var $form_error=false;               // oznacznie poprawnosci wypelnienia formularza
	var $onclick="onclick=\"window.open('','window','width=760,height=580,scrollbars=0,menubar=0,status=0,location=0,directories=0,toolbar=0,resizable=0');\"";
	var $record_row_fun="record_row";    // domyslna funkcja prezentacji rekordu
	var $img_border=0;                   // obramowanie wokol zdjec produktow
	var $dbedit_bar_size="100%";         // domyslna szerokosc paska bar nad listami produktow
	var $producer_filter_name;           // nazwa producenta (filtru kategorii)
	var $max_producer_chars=20;          // maksymalna liczba znakow wyswietlanej na liscie nazwy producenta
	var $record_odd_color="#ffffff";           // kolor komorki nieparzystej w liscie skroconej (domyslna "#ffffff")
	var $record_even_color="#ffffff";          // kolor komorki parzystej w liscie skroconej (domyslna "#ffffff")

	function __construct()
	{
		$this->desktop();
	}
	/**
     * Wywietlanie krokw w koszyku
     *
     * @param integer $step numer kroku w koszyku
     */

	function basket_steps( $step = 0 )
	{
		global $lang;

		print "<div align=\"left\"><table border=\"0\" cellpadding=\"3\" cellspacing=\"3\" height=25px><tr>";
		if ($step == 1)
		{
			print "<td align=\"center\" title=\"".$lang->basket_steps['step']." 1\"><a href=\"/go/_basket/\"><b>1. ".$lang->basket_steps['step1']."</b></a></td>";
			print "<td align=\"center\" title=\"".$lang->basket_steps['step']." 2\">2. ".$lang->basket_steps['step2']."</td>";
			print "<td align=\"center\" title=\"".$lang->basket_steps['step']." 3\">3. ".$lang->basket_steps['step3']."</td>";
			print "<td align=\"center\" title=\"".$lang->basket_steps['step']." 4\">4. ".$lang->basket_steps['step4']."</td>";
		} elseif ($step == 2)
		{
			print "<td align=\"center\" title=\"".$lang->basket_steps['step']." 1\"><a href=\"/go/_basket/\">1. ".$lang->basket_steps['step1']."</a></td>";
			print "<td align=\"center\" title=\"".$lang->basket_steps['step']." 2\"><a href=\"/go/_register/index.php\"><b>2. ".$lang->basket_steps['step2']."</b></a></td>";
			print "<td align=\"center\" title=\"".$lang->basket_steps['step']." 3\">3. ".$lang->basket_steps['step3']."</td>";
			print "<td align=\"center\" title=\"".$lang->basket_steps['step']." 4\">4. ".$lang->basket_steps['step4']."</td>";
		} elseif ($step == 3)
		{
			print "<td align=\"center\" title=\"".$lang->basket_steps['step']." 1\"><a href=\"/go/_basket/\">1. ".$lang->basket_steps['step1']."</a></td>";
			print "<td align=\"center\" title=\"".$lang->basket_steps['step']." 2\"><a href=\"/go/_register/index.php\">2. ".$lang->basket_steps['step2']."</a></td>";
			print "<td align=\"center\" title=\"".$lang->basket_steps['step']." 3\"><a href=\"/go/_register/register2.php\"><b>3. ".$lang->basket_steps['step3']."</b></a></td>";
			print "<td align=\"center\" title=\"".$lang->basket_steps['step']." 4\">4. ".$lang->basket_steps['step4']."</td>";
		} elseif ($step == 4)
		{
			print "<td align=\"center\" title=\"".$lang->basket_steps['step']." 1\">1. ".$lang->basket_steps['step1']."</td>";
			print "<td align=\"center\" title=\"".$lang->basket_steps['step']." 2\">2. ".$lang->basket_steps['step2']."</td>";
			print "<td align=\"center\" title=\"".$lang->basket_steps['step']." 3\">3. ".$lang->basket_steps['step3']."</td>";
			print "<td align=\"center\" title=\"".$lang->basket_steps['step']." 4\"><b>4. ".$lang->basket_steps['step4']."</b></td>";
		}
		print "</tr></table></div>";
	}
	/**
    * Wywietl buttony w menu gwnym wg konfiguracji z tenmatow TEMAT/config/config.inc.php
    *
    * @author m@sote.pl lech@sote.pl
    * @return none
    */
	function autoButtons() {
		global $config, $prefix;

		reset($config->theme_config['head']['main_menu']['buttons']);
		print "<table>\n";
		print "<tr>\n";
		foreach ($config->theme_config['head']['main_menu']['buttons'] as $name=>$tab) {
			$img_over=$prefix . $tab['over'];
			$img_out=$prefix . $tab['out'];
			$url=$tab['url'];
			$desc=@$tab['desc'];
			print "<td>";
			print "<a href=\"$url\"><img src=\"";
			$this->img($img_out);
			print "\" alt=\"$desc\" border=\"0\" onmouseover=\"this.src='";
			$this->img($img_over);
			print "'\" onmouseout=\"this.src='";
			$this->img($img_out);
			print "'\"></a>";
		}
		print "</tr>";
		print "</table>\n";
		return;
	} // end autoButtons()

	/**
    * Otworz obszar ramki
    *
    * @author       rdiak@sote.pl
    * \@modified_by  m@sote.pl
    *               20030317 zmiana kolejnosci atrybutow, atrybuty domyslne zostaly przeniesione na koniec wywolania,
    *                        dzieki czemu mozna wywolac prosciej funkcje np.
    *                        wystarczy wywolac $theme->frame_open("nazwa")
    *
    * @param string $width szerokosc elementu frame (ramki)
    * @param string $align wyrownanie
    */
	function frame_open($title="frame",$width="100%",$align="center") {
		$file="frame_open.html.php"; $include_once=false;
		include ("themes/include/theme_file.inc.php");
		return(0);
	} // end frame_open()

	/**
    * Zamknij obszar ramki
    *
    * \@depend $this->frame_open()
    */
	function frame_close() {
		$file="frame_close.html.php"; $include_once=false;
		include ("themes/include/theme_file.inc.php");
		return(0);
	} // end frame_close()


	/**
    * Wyswietl formularz newslettera
    */
	function newsletter() {
		global $DOCUMENT_ROOT, $image;
		$file="newsletter.html.php"; $include_once=true;
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");
		return(0);
	} // end foot()

	function newsletter_send() {
		global $newsletter,$lang;
		$this->bar($lang->newsletter_title);
		$newsletter->action();
	}

	function newsletter_show() {
		global $request_vars,$lang;

		$this->bar($lang->newsletter_title);
		$this->show_check_code($request_vars);
	}

	function newsletter_email() {
		global $request_vars,$lang;
		$this->bar($lang->newsletter_title);
		echo "<p style=\"text-align: center\">".$lang->newsletter_error_address."</p>";
		$this->theme_file("newsletter_error.html.php");
	}

	function show_check_code_msg()
	{
		global $check_code, $lang;

		if (!$check_code && isset($_REQUEST['CHECK_CODE']))
		echo '<div style="color:red">'.$lang->check_code['auth'].'</div>';

	}


	function show_check_code($request_vars=array()) {
		global $asc, $check_code, $lang;

		if (!$check_code)
		echo '<p><img src="'.$asc->get_img_path().'" alt=\"\" /></p>';

		echo '<form action="'.$_SERVER['PHP_SELF'].'" id="show_check_code" name="show_check_code" method="post"><p>';
		echo $lang->check_code['code'].'<br /><input type="text" name="code" /> ';
		if (isset($_REQUEST['CHECK_CODE']))
		echo '<p style="color:red; margin: 10px 0">'.$lang->check_code['auth'].'</p>';
		echo '<input type="hidden" name="CHECK_CODE" />';
		foreach ($request_vars as $k => $v)
		{
			if ($k != 'sess_id' && $k != 'clickedFolder' && $k != 'CHECK_CODE' && $k != 'code')
			echo '<input type="hidden" name="'.$k.'" value="'.$v.'" />';
		}
		$this->DesktopOpen3Horizontal($this->config['boxh3_button_newsletter'],"","","middle","center");
		echo "<span style=\"cursor: pointer; cursor: hand;color: #000\" onclick=\"document.getElementById('show_check_code').submit();\">$lang->send</span>";
		$this->DesktopClose3Horizontal($this->config['boxh3_button_newsletter'],"","","middle","center");
		echo '</p></form>';

		return(0);
	} // end foot()

	/**
    * Funckja dodaje link "Drukuj" pozwalajacy wydrukowac bierzaca strone.
    *
    * @desc do poprawnego dzialania potrzebny jest JavaScript printPage.js
    * @author rp@sote.pl
    *
    * @param string $format sposob generoania linku (submit - formularz | * - <a href>Drukuj<a>
    *
    * @return void
    */
	function printPage($format="submit"){
		global $lang;
		if($format=="submit"){
			print "<form action=\"\">\n";
			print "    <input type=\"button\" value=\"".$lang->printPage["button"]."\" onclick=\"javascript:printPage('".$lang->printPage["info"]."');\">\n";
			print "</form>";
		} else {
			print "<a href=\"javascript:printPage('".$lang->printPage["info"]."');\">".$lang->printPage["button"]."</a>";
		}
		return;
	}

	/**
    * Funckja sprawdza czy istnieje tablica z bitmapami dla aktualnego tematu.
    * Jesli istnieje przeszukuje w celu odszukania lokalizacji bitmapy na dysku
    * oraz wyswietla pelna sciezke
    *
    * @param string $file_name  nazwa bitmapy jesli jest z rozszerzeniem
    *                           to nastepna funkcja z obiektu Image pomija sprawdzanie
    *                           tablicy z bitmapami w celu zmnieszenia czasu wykonania zadania
    * @param string $location   polozenie bitmapy w temacie lub katalogu, jesli nie ma wskazania
    *                           lokalicacje przybierana jest domyslna wartosc default
    *                           i wtedy sciezka przeszukiwania zaczyna sie od _bmp/default/...
    * @param string $theme_name nazwa szablonu strony z ktorego bitmapa ma byc pobrana
    *
    * @return none
    */
	function bmp($file_name="",$location="",$theme_name=""){
		return $this->img($file_name);
	} // end bmp()

	/**
    * Funkcja zwracajaca odpowiedni kod Javascript do otwierania nowego okna w zaleznosci od podanych parametrow
    *
    * @author piotrek@sote.pl
    *
    * @param  $width  szerokosc okna
    * @param  $height wysokosc okna
    *
    * @access public
    *
    * @return string $click
    */
	function onclick($width,$height) {
		$click="onclick=\"window.open('','window','width=$width,height=$height,scrollbars=0,menubar=0,status=0,location=0,directories=0,toolbar=0,resizable=0');\"";
		return $click;
	}

	/**
    * Wyswietl naglowek programu
    *
    * \@global float $global_basket_amount kwota zakupow
    * \@global int   $global_backet_count  ilosc produktow w koszyku
    * \@global array $_SESSION
    */
	function head() {
		global $_SESSION;
		global $global_basket_amount,$global_basket_count;
		global $config,$lang;
		global $global_wishlist_count;

		if ($config->lang!=$config->base_lang) @$config->google=@$lang->google;

		if (! empty($_SESSION['global_basket_amount'])) {
			$global_basket_amount=$_SESSION['global_basket_amount'];
		}
		if (! empty($_SESSION['global_basket_count'])) {
			$global_basket_count=$_SESSION['global_basket_count'];
		}
		if (! empty($_SESSION['global_wishlist_count'])) {
			$global_wishlist_count=$_SESSION['global_wishlist_count'];
		}

		if (empty($global_basket_amount)) $global_basket_amount=0;
		if (empty($global_basket_count)) $global_basket_count=0;
		if (empty($global_wishlist_count)) $global_wishlist_count=0;

		global $DOCUMENT_ROOT;
		$file="head.html.php"; $include_once=true;
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");

		return(0);
	} // end head()

	/**
    * Wyswietl stopke programu
    */
	function foot() {
		global $DOCUMENT_ROOT, $image;
		$file="foot.html.php"; $include_once=true;
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");
		return(0);
	} // end foot()

	/**
    * Wyswietl naglowek programu
    *
    * \@global float $global_basket_amount kwota zakupow
    * \@global int   $global_backet_count  ilosc produktow w koszyku
    * \@global array $_SESSION
    */
	function head_simple() {
		global $DOCUMENT_ROOT;
		$file="head_simple.html.php"; $include_once=true;
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");

		return(0);
	} // end head()

	/**
    * Wyswietl prosta stopke programu
    */
	function foot_simple() {
		global $DOCUMENT_ROOT;
		$file="foot_simple.html.php"; $include_once=true;
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");
		return(0);
	} // end foot()

	/**
    * Wyswietl plik z katalogu _tematu html_files
    */
	function file($file,$lang_name='') {
		global $config;
		global $DOCUMENT_ROOT;

		if($lang_name=="") {
			$lang_name=$config->lang;
		}

		global $_SERVER;
		@include_once("$DOCUMENT_ROOT/themes/_$lang_name/_html_files/$file");

		return(0);
	}

	/**
    * Wyswietl plik z biezacego katalogu theme, jesli pliku nie ma, to wez plik z $base_theme lub z base_theme
    * @param array $vars zmienne przekazywane do funkcji
    */
	function theme_file($file,$vars=array()) {
		global $lang,$config;

		while (list($key,$val) = each($vars)) {
			$$key=$val;
		}
		global $DOCUMENT_ROOT;
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");
		return(0);
	} // end file()

	/**
    * Wyswietl sciezke (+nazwa) do obrazeka z katalogu tematu, lub z base_theme
    *
    * @param string $image nazwa pliku
    */
	function img($image) {
		global $config;
		global $DOCUMENT_ROOT;

		$base_theme=$config->base_theme;

		// sprawdz czy jest plik w zdefiniowanym temacie (katalog jezykowy)
		$inode=@fileinode($config->theme_dir."/$image");

		if ($inode>0) {
			print $config->htdocs_dir."/themes/_$config->lang/$config->theme/$image";
		} else {
			//sprawdzam czy plik jest w katlogu base tematu zdefiniowanego
			$inode2=@fileinode("$DOCUMENT_ROOT/themes/base/$config->theme/$image");
			if ($inode2>0) {
				print $config->htdocs_dir."/themes/base/$config->theme/$image";
			} else {

				// sprawdzam czy istnieje plik w $base_theme (katalog jezykowy)
				$inode3=@fileinode("$DOCUMENT_ROOT/themes/_$config->lang/$base_theme/$image");
				if ($inode3>0) {
					print $config->htdocs_dir."/themes/_$config->lang/$base_theme/$image";
				} else {

					//sprawdzam czy plik istnieje w $base_theme (katalog base)
					$inode4=@fileinode("$DOCUMENT_ROOT/themes/base/$base_theme/$image");
					if ($inode4>0) {
						print $config->htdocs_dir."/themes/base/$base_theme/$image";
					} else {

						//sprawdzam czy plik istnieje w glownym temacie - base_theme (katalog jezykowy)
						$inode5=@fileinode("$DOCUMENT_ROOT/themes/_$config->lang/base_theme/$image");
						if ($inode5>0) {
							print $config->htdocs_dir."/themes/_$config->lang/base_theme/$image";
						} else {

							//sprawdzam czy plik istnieje w glownym temacie - base_theme (katalog base)
							$inode6=@fileinode("$DOCUMENT_ROOT/themes/base/base_theme/$image");
							if ($inode6>0) {
								print $config->htdocs_dir."/themes/base/base_theme/$image";
							} else {
								print $config->htdocs_dir."/themes/base/base_theme/_img/_mask.gif";
							}
						} //end if
					} //end if
				} //end if
			} // end if
		}// end if
		return(0);
	} // end img()

	/**
    * Zwr sciezke (+nazwa) do pliku z katalogu tematu, lub z base_theme
    *
    * @param string $image nazwa pliku
    */
	function filepath($image) {
		global $config;
		global $DOCUMENT_ROOT;

		$base_theme=$config->base_theme;

		// sprawdz czy jest plik w zdefiniowanym temacie (katalog jezykowy)
		$inode=@fileinode($config->theme_dir."/$image");

		if ($inode>0) {
			return $config->htdocs_dir."/themes/_$config->lang/$config->theme/$image";
		} else {
			//sprawdzam czy plik jest w katlogu base tematu zdefiniowanego
			$inode2=@fileinode("$DOCUMENT_ROOT/themes/base/$config->theme/$image");
			if ($inode2>0) {
				return $config->htdocs_dir."/themes/base/$config->theme/$image";
			} else {

				// sprawdzam czy istnieje plik w $base_theme (katalog jezykowy)
				$inode3=@fileinode("$DOCUMENT_ROOT/themes/_$config->lang/$base_theme/$image");
				if ($inode3>0) {
					return $config->htdocs_dir."/themes/_$config->lang/$base_theme/$image";
				} else {

					//sprawdzam czy plik istnieje w $base_theme (katalog base)
					$inode4=@fileinode("$DOCUMENT_ROOT/themes/base/$base_theme/$image");
					if ($inode4>0) {
						return $config->htdocs_dir."/themes/base/$base_theme/$image";
					} else {

						//sprawdzam czy plik istnieje w glownym temacie - base_theme (katalog jezykowy)
						$inode5=@fileinode("$DOCUMENT_ROOT/themes/_$config->lang/base_theme/$image");
						if ($inode5>0) {
							return $config->htdocs_dir."/themes/_$config->lang/base_theme/$image";
						} else {

							//sprawdzam czy plik istnieje w glownym temacie - base_theme (katalog base)
							$inode6=@fileinode("$DOCUMENT_ROOT/themes/base/base_theme/$image");
							if ($inode6>0) {
								return $config->htdocs_dir."/themes/base/base_theme/$image";
							} else {
								return $config->htdocs_dir."/themes/base/base_theme/_img/_mask.gif";
							}
						} //end if
					} //end if
				} //end if
			} // end if
		}// end if
	} // end filepath()

	/**
    * Wywietl pelna sciezke do pliku lub domyslna bitmape systemowa
    * Funkcja ma m.in. na celu wyeliminowanie pojawiania sie okienek z bledami, jeli nie ma zdjcia
    *
    * @author rp@sote.pl m@sote.pl
    * @param string $file_name nazwa pliku
    *
    * @deprecated since 3.0 alfa
    * @return none
    */
	function path($file_name="_img/_mask.gif"){
		return $this->img($file_name);
	} // end path()

	/**
    * Przejdz na glowna strone. Strona wywolywana w przypadku, kiedy klient dokonal
    * jakiejs nieprawidlowej operacji (np. bledne wywolania back,forward) i trzeba go
    * odeslac na glowna strone, bo za bardzo zamieszal;)
    */
	function go2main($rtime=0) {
		//    	print "<pre>";
		//    	print_r (debug_backtrace());
		//    	print "</pre>";
		$this->refresh_time=$rtime;
		$this->theme_file("go2main.html.php");
	} // end go2main()

	/**
    * Tekst (HTML) na glownej stronie
    */
	function main_html(){
		$this->theme_file("main.html.php");
		return(0);
	} // end main_html()

	/**
    * Formatowanie formatu pienieznego
    *
    * @author  m@sote.pl
    * @param  string|real $price np. 2000.3423
    * @return $price w odpowiednim formacie np. 2000.34 (wartosc numeryczna!)
    */
	function price($price) {
		return number_format($price,2,".","");
	} // end price()

	/**
    * Funkcja wyswietla glowna czesc strony (poza naglowkiem i stopka).
    * Sa to domyslnie: kolumna lewa, srodek i prawa. Oczywiscie uklad ten moze zostac zmieniony.
    *
    * @param string $left  funkcja okreslajaca lewa kolumne
    * @param string $main  funkcja okreslajaca srodkowa kolumne
    * @param string $right funkcja okreslajaca prawa kolumne
    * @param class  $cl_left  klasa zawierajaca funkcje $left (jesli jest inna niz $this)
    * @param class  $cl_main  klasa zawierajaca funkcje $main jw.
    * @param class  $cl_right klasa zawierajaca funkcje $right jw.
    * @param string $page_file plik zawierajacy glowny podzial strony np. na 3 kolumny
    */
	function page_open($left="left",$main="main",$right="right",$cl_left="",$cl_main="",$cl_right="",$page_file="page_open") {
		global $config;

		if (empty($cl_left))  $o_left=$this;  else $o_left = new $cl_left;
		if (empty($cl_main))  $o_main=$this;  else $o_main = new $cl_main;
		if (empty($cl_right)) $o_right=$this; else $o_right = new $cl_right;

		global $DOCUMENT_ROOT;
		$file=$page_file.".html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");

		return(0);
	} // end page_open()

	/**
    * Jak page_open(), z ta roznica, ze podawany jest tu adres obiektu
    * zawierajacego element czesci tzw. "main"
    *
    * @param string $main nazwa funkcji
    * @param object &$o_main adres obiektu
    * @param string $page_file jak w page_open()
    */
	function page_open_object($main,&$o_main,$page_file) {
		$left="left";$right="right";
		$o_left=$this;
		$o_right=$this;

		global $DOCUMENT_ROOT;
		$file=$page_file.".html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");

		return(0);
	} // end page_open_object()

	/**
    * Otworz glowna tabele strony
    *
    * @param strong $file nazwa pliku zawierajacago naglowek
    */
	function page_open_head($file) {
		$this->theme_file("$file.html.php");
	} // end page_open_head()

	/**
    * Zamknij glowna tabele strony
    *
    * @param strong $file nazwa pliku zawierajacago stopke
    */
	function page_open_foot($file) {
		$this->theme_file("$file.html.php");
	} // end page_open_foot()

	/**
    * Lewa strona
    */
	function left() {
		global $rand_prod;
		if (! is_object($rand_prod)) {
			include_once ("include/random_products.inc");
			$rand_prod =  new RandProduct;
		}

		global $DOCUMENT_ROOT;
		$file="left.html.php";$include_once=true;
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");

		return(0);
	} // end left()

	/**
    * Prawa strona
    */
	function right() {
		global $rand_prod;
		if (! is_object($rand_prod)) {
			include_once ("include/random_products.inc");
			$rand_prod =  new RandProduct;
		}

		global $DOCUMENT_ROOT;
		$file="right.html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");

		return(0);
	} // end right()

	/**
    * Glowna czesc strony, srodek
    */
	function main() {
		$this->theme_file("main.html.php");
		return(0);
	} // end main()

	/**
    * Dolna czesc strony, ladowana po produktach na stronie glownej
    * uzyta w htdocs/index.php
    *
    * @access public
    *
    * @retyrn void
    */
	function mainBottom() {

		$this->theme_file("main_bottom.html.php");

		return;
	} // end mainBottom()


	/**
    * @desc wyswietla rekordy plugin'u NewsEdit
    *
    * @author rp@sote.pl
    * @return void
    */
	function mainNews() {
		global $lang;
		global $_REQUEST;
		global $mdbd;

		$news_title=$lang->main_news;
		if (@ereg("^[0-9]+$",$_REQUEST['group'])) {
			$group=$_REQUEST['group'];
			if ($group>0) {
				$title=$mdbd->select("name","newsedit_groups","id=?",array($group=>"int"),"LIMIT 1");
				if ($title!="0") $news_title=$title;
				else {
					$this->go2main();
					exit;
				}
			}
		}

		$this->win_top($news_title,380,1,1);
		@include_once ("plugins/_newsedit/include/newsedit.inc.php");
		if (is_object(@$newsedit)) {
			$newsedit->show_list();
		}
		$this->win_bottom(380);

		return;
	} // end mainNews()

	/**
    * Tytul
    */
	function title($title) {
		print "<table border=1><tr><td>$title</td></tr></table>";
		return(0);
	} // end title()

	/**
    * Pasek z napisem "bar"
    */
	function bar($text,$width="100%") {
		global $DOCUMENT_ROOT;
		$file="bar.html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");
		return(0);
	} // end bar()

	/**
    * Przycisk z napisem
    */
	function button($text,$url="/",$width=100) {
		global $config;
		$url=@$config->url_prefix.$url;
		print "<form action=\"$url\"><input type=\"button\" value=\"$text\" onclick=\"this.form.submit();\"></form>\n";
		return(0);
	} // end bar()

	/**
    * Przycisk podsumuj w koszyku
    */
	function calc_button() {
		global $lang;

		$order_update=$lang->basket_order_update;

		print "<input type=submit name=submit_update value='$order_update'>";
		return(0);
	} // end calc_button()


	/**
    * Aktualna data
    */
	function date() {
		global $lang;
		print "$lang->date:".(date("d-m-Y"));
		return(0);
	} // end date()

	/**
    * Elementy pojawiajace sie nad lista produktow. Np. wybor listy skroconej rozszezonej itp.
    */
	function top_dbedit() {
		require_once("include/record_row_links.inc");

		global $DOCUMENT_ROOT;
		$file="list/list_top.html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");

		return(0);
	} // end top_dbedit()

	/**
    * Wyglad wiersza w prezentacji rekordu w liscie
    */
	function record_row(&$rec) {
		global $image;
		global $description;
		global $config;

		// dodaj obsluge automatycznego generowania skrotu opisu
		if (! is_object($description)) {
			include_once ("include/description.inc");
		}

		global $DOCUMENT_ROOT;
		$file="record_row.html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");

		return(0);
	} // end record_row()

	/**
    * Wyglad wiersza prezentacji rekordu
    */
	function record_row_short(&$rec) {
		global $config;
		global $DOCUMENT_ROOT;

		// wartosc ktora pozwoli naprzemiennei wyswietlac komorki jako parzyste i nieparzyste
		static $odd=0;
		$file="record_row_short.html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");
		if($odd==0){
			$odd=1;
		} else {
			$odd=0;
		}
		return(0);
	} // end record_row_short()

	/**
    * Wyglad wiersza w prezentacji rekordu w liscie
    */
	function record_row_search(&$rec) {
		global $image;
		global $description;
		global $config;

		// dodaj obsluge automatycznego generowania skrotu opisu
		if (! is_object($description)) {
			include_once ("include/description.inc");
		}

		global $DOCUMENT_ROOT;
		$file="record_row_search.html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");

		return(0);
	} // end record_row()

	/**
    * Sprawd ustawienia parametrw produktu i w zalenoci od opcji wyiwetl cen, info, koszyk itp.
    * Funkcja jest wykorzystywana w info record_row itp. do obslugi pl m.in. hidden_price, ask4price, discount
    * Przykad wtwoania np. jeli chcemy wywietli cen wywoujemy funkcj:<br />
    * $theme->recPrice($price);<br />
    * W funckje recPrice() jest wywoane sparawdzanie odpowiednich parametrw i poprzez wywoanie:<br />
    * $this->_checkView($rec,"price") itp.
    *
    * @author  m@sote.pl
    *
    * @param string $type typ zapytania: basket,info,discount,price
    * @param object &$rec adres obiektu z danymi produktu $rec->data
    *
    * @access private
    * @return bool true mona pokaza dan opcj, false w p.w.
    */
	function checkView($type,&$rec) {
		global $config;

		// jesli sklep jest w trybie CD, to nie pokazuj koszyka
		if (($config->cd==1) && ($type=="basket"))   return false;

		switch ($type) {
			case "info": return true;
			break;
			case "ask4price": if ($rec->data['ask4price']==1) return true;
			break;
			case "points": if ($rec->data['points']==1) return true;
			break;
			default:
				// basket, discout, price
				if ((@$rec->data['hidden_price']==0) && (@$rec->data['ask4price']==0)) return true;
				break;
		}
		return false;
	} // end checkView()

	/**
    * Wywietl informacje o cenie (netto, brutto, netto/brutto ).
    *
    * @author rdiak@sote.pl
    * @param  int $id id produktu (z tabeli main)
    * @access private
    * @return string rodzaj ceny
    */
	function info_price() {
		global $config;
		global $lang;

		if($config->price_type == 'netto') {
			return $lang->cols['price_netto'];
		} elseif($config->price_type == 'netto/brutto') {
			return $lang->cols['price_nettobrutto'];
		} else {
			return $lang->cols['price_brutto'];
		}
	}

	function info_points() {
		global $lang;
		return $lang->cols['points'];
	}

	/**
    * Wywietl cene (netto, brutto).
    *
    * @author rdiak@sote.pl
    * @param  int $id id produktu (z tabeli main)
    * @access private
    * @return string rodzaj ceny
    */
	function print_price(&$rec) {
		global $config;

		if ($config->price_type == 'netto') {
			return $this->price($rec->data['price_netto']);
		} elseif($config->price_type == 'netto/brutto') {
			return $this->price($rec->data['price_netto'])."/".$this->price($rec->data['price_brutto']);
		} else {
			return $this->price($rec->data['price_brutto']);
		}
	} // end print_price

	/**
    * Wywietl ikonk info odsyajc do informacji szczegowych o produkcie.
    * Od wersji 3.0 funckja ta zmienia swoje znaczenie. Patrz recInfo().
    *
    * @author m@sote.pl
    * @param  int $id id produktu (z tabeli main)
    * @access private
    * @return none
    * @todo   opisa lub jawnie zdefiniowa zmienn $prefix (m@sote.pl->lech@sote.pl)
    */
	function _info($id,$name) {
		global $config, $prefix, $lang, $rec;
		print "<a href=\"".$this->google_url("/go/_info/?user_id=$id",$name)."\">";
		print "<img title=\"".$lang->tooltip['info']."\" src=\"";
		$this->desktopPathImage('box_info_simple');
		print "\" border=\"0\" alt=\"\" />";
		print "</a>";
		return;
	} // end _info()

	/**
    * Sprawd czy mona wywietli ikonk info i jeli tak, to wywietl j
    * Funckja ta zastpuje wczeniejsze wywoania postaci $theme->info().
    *
    * @author m@sote.pl
    * @param  int     $id  id produktu (z tabeli main)
    * @param  object &$rec adres obiektu z danymi produktu $rec->data
    * @return none
    */
	function recInfo($id,$name,&$rec) {
		if ($this->checkView("info",$rec)) {
			return $this->_info($id,$name);
		} else return;
	} // end recInfo()

	// start Basket:

	/**
    * Wyswietl link do koszyka
    */
	function basketLink() {
		global $DOCUMENT_ROOT, $image;
		$file="basketlink.html.php"; $include_once=true;
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");
		return(0);
	} // end foot()


	/**
    * Wywietl formularz zamwienia wraz z opcjami.
    * Funkcja generuje peen formularz <form> ... </form> + przycisk submit->zamw
    *
    * @param int    $id id  produktu
    * @param string $xml_options opcje
    */
	function _basketOptions($id,$xml_options) {
		// atrybuty
		if (! empty($xml_options)) {
			// dodaj obsluge pola xml_options
			global $result,$my_xml_options;
			include_once ("include/xml_options.inc");
			$my_xml_options->show($result);
		} else {
			$this->_basket();
		}
	} // end _basketOptions()

	/**
    * Wywietl formularz dodania produktu do koszyka.
    * Jeli nie przekazujemy do funkcji adnych opcji (np. L, XL itp), to zostanie wywietlony
    * standardowy koszyk. Jeli dla danego produktu s zdefiniowane jakie opcje, pokae si formularz
    * wybrania opcji + przycisk submit->zamw.
    *
    * @param  int    $id           identyfikator produktu (id z tabeli main)
    * @param  string $xml_options  opcje   
    * @access private
    * @return none
    */
	function _basket($id,$xml_options) {
		if (! empty($xml_options)) return $this->_basketOptions($id,$xml_options);
		$this->_basketSimple($id);
		return;
	} // end _basket()

	/**
    * Wywietl ikonk (formularz) koszyka.
    * Funkcja powoduje wywietlenie zwykego koszyka. Rni sie od basket() tym, e nie powoduje
    * wywietlania formularza z opcjami.
    *
    * @param  int    $id identyfikator produktu (id z tabeli main)
    * @access private
    * @return none
    */
	function _basketSimple($id) {
		global $config;
		global $lang;
		if (@$config->catalog_mode==1){
			return;
		}
		global $config, $prefix;
		if (@$config->ajax_basket) {
			print "<a onclick=\"xajax_add2basket($id,0);\" style=\"cursor: pointer; cursor: hand;\"><img src=\"";
			$this->desktopPathImage('box_basket_simple');
			print "\" title=\"".$lang->tooltip['basket']."\"  alt=\"\" /></a>";
		} else {
			print "<form action=\"/go/_basket/index.php\">\n";
			print "<input type=\"hidden\" name=\"id\" value=\"".$id."\" />";
			print "<input class=\"border0\" type=\"image\" src=\"";
			$this->desktopPathImage('box_basket_simple');
			print "\" title=\"".$lang->tooltip['basket']."\" />";
			print "</form>\n";
		}
		return;
	} // end _basketSimple()
	/**
    * Sprawd czy mona wywietli ikonk koszyk i jeli tak, to wywietl j.
    * Funckja ta zastpuje wczeniejsze wywoania postaci $theme->basket().
    *
    * @author m@sote.pl
    * @param  int     $id  id produktu (z tabeli main)
    * @param  object &$rec adres obiektu z danymi produktu $rec->data
    * @return none
    */
	function recBasket($id,&$rec) {
		if ($this->checkView("basket",$rec)) {
			return $this->_basket($id,@$rec->data['xml_options']);
		} elseif ($this->checkView("ask4price",$rec)) {
			$this->ask4price($rec);
		} elseif (ereg("^music",@$rec->data['xml_options'])) {
			// nawet jeli jest zaczona opcja "nie pokazuj ceny", ale
			// produkt zawiera utwory do zakupu, to poka list atrybutw
			//return $this->_basket($id,@$rec->data['xml_options']);
		}
		return;
	} // end recInfo()
	// end Basket:

	/**
    *Wywietl drukuj i poka strone prezentacji produktu do wydruku
    *
    * @author krzys@sote.pl
    */
	function print_page($url) {
		global $config, $prefix, $theme;
		print "<a href=\"$url\" onclick=\"window.open('', 'window_popup', 'width=590, height=450, rezisable=1, scrollbars=1, toolbar=0, status=0');\" target='window_popup'>";
		global $lang;
		//print "<img src=\"";

		$this->desktopBoxImage('box_printer');
		//print "\" style=\"border-width: 0px;\" alt=\"\" />";
		print "</a>";
		return;
	} // end _print(


	/**
    * Przyciski podsumuj wprowadzone zmiany, dalej, wartosc zamowienia
    *
    * @param float  $amount        wartosc zakupow (bez kosztow dostawy)
    * @param float  $order_amount  kwota do zaplaty
    * @param string $delivery_name nazwa dostawcy
    * @param float  $delivery_cost koszt dostawy
    */
	function basket_submit($amount,$order_amount,$delivery_name,$delivery_cost) {
		global $config;

		global $DOCUMENT_ROOT;
		$file="basket_delivery_submit.html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");

		return(0);
	} // end basket_submit()

	/**
    * Przyciski podsumuj wprowadzone zmiany, dalej, wartosc zamowienia - w przypadku zamwienia produktw za punkty
    *
    * @param float  $amount        wartosc zakupow (bez kosztow dostawy)
    * @param float  $order_amount  kwota do zaplaty
    * @param string $delivery_name nazwa dostawcy
    * @param float  $delivery_cost koszt dostawy
    */
	function basket_points_submit($amount,$order_amount,$delivery_name,$delivery_cost) {
		global $config;

		global $DOCUMENT_ROOT;
		$file="basket_delivery_points_submit.html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");

		return(0);
	} // end basket_submit()


	/**
    *
    * Wyswietl podsumowanie kosztow dot. zakupow
    *
    * @param float  $amount        wartosc zakupow (bez kosztow dostawy)
    * @param float  $order_amount  kwota do zaplaty
    * @param string $delivery_name nazwa dostawcy
    * @param float  $delivery_cost koszt dostawy
    */
	function basket_points_amount($amount,$order_amount,$delivery_name,$delivery_cost) {
		global $config;
		global $DOCUMENT_ROOT;

		$file="basket_points_amount.html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");

		return(0);
	} // end basket_amount()

	/**
    *
    * Wyswietl podsumowanie kosztow dot. zakupow
    *
    * @param float  $amount        wartosc zakupow (bez kosztow dostawy)
    * @param float  $order_amount  kwota do zaplaty
    * @param string $delivery_name nazwa dostawcy
    * @param float  $delivery_cost koszt dostawy
    */
	function basket_amount($amount,$order_amount,$delivery_name,$delivery_cost) {
		global $config;
		global $DOCUMENT_ROOT;

		$file="basket_amount.html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");

		return(0);
	} // end basket_amount()

	/**
    * Koszyk jest pusty
    */
	function basket_empty() {
		global $lang;

		$this->bar($lang->basket_title);
		print "<p><center>$lang->basket_empty</center>";
		return(0);
	} // end basket_empty()

	/**
    * Przycisk powrotu do poprzedniej strony
    */
	function back() {
		global $lang;
		global $buttons;

		print "<form action=\"\"><input type=\"button\" value=\"$lang->back\" onclick=\"history.back();\" /></form>";
	} // end back()

	/**
    * Przycisk powrotu do glownej strony
    */
	function back2main() {
		global $lang;
		print "<form action=/><input type=\"submit\" value=\"$lang->back\" /></form>";
	} // end back()


	/**
    * Formularz rejestracji - billing
    *
    * @param array  $form       dane z formularza
    * @param object $form_check obiekt klasy FormCheck - sprawdzanie formularza
    */
	function register_billing_form(&$form,&$form_check){
		global $lang;
		$this->form=&$form;
		$this->form_check=&$form_check;
		global $DOCUMENT_ROOT;

		if (! empty($_SESSION['global_login'])) {
			include_once("$DOCUMENT_ROOT/go/_users/include/menu.inc.php");
		}

		$this->bar($lang->bar_title['register_billing']);

		$file="register_billing.html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");

		return(0);
	} // end register_billing_form()

	/**
    * Formularz rejestracji - billing w panelu zalogowanego uzytkownika
    *
    * @param array  $form       dane z formularza
    * @param object $form_check obiekt klasy FormCheck - sprawdzanie formularza
    */
	function register_billing_form_users(&$form,&$form_check){
		global $lang;
		$this->form=&$form;
		$this->form_check=&$form_check;
		global $DOCUMENT_ROOT;

		if (! empty($_SESSION['global_login'])) {
			include_once("$DOCUMENT_ROOT/go/_users/include/menu.inc.php");
		}

		$this->bar(@$lang->bar_title['register_billing']);

		$file="register_billing_users.html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");

		return(0);
	} // end register_billing_form()

	/**
    * Formularz rejestracji - adres korespondencyjny
    *
    * @param array $form        dane z formularza
    * @param object $form_check obiekt klas FormCheck
    */
	function register_cor_form(&$form,&$form_check){
		global $lang;
		global $DOCUMENT_ROOT;
		$this->form=&$form;
		$this->form_check=&$form_check;

		if (! empty($_SESSION['global_login'])) {
			include_once("$DOCUMENT_ROOT/go/_users/include/menu.inc.php");
		}

		$this->bar($lang->bar_title['register_cor']);

		$file="register_cor.html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");

		return(0);
	} // end register_cor_form()

	/**
    * Podsumowanie wprowadzonych danych
    *
    * @param array $form dane z formularza - dane bilingowe
    * @param object $form_cor dane z formularza - adres korespondencyjny
    */
	function register_confirm(&$form,&$form_cor) {
		global $lang;
		global $DOCUMENT_ROOT;
		$this->form=&$form;
		$this->form_cor=&$form_cor;

		if (! empty($_SESSION['global_login'])) {
			include_once("$DOCUMENT_ROOT/go/_users/include/menu.inc.php");
		}

		$this->bar($lang->bar_title['register_confirm']);

		$file="register_confirm.html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");

	} // end register_confirm()

	/**
    * Formularz rejestracji uzytkownikow, logowanie - nowy user
    *
    * @param array $form dane z formularza
    * @param object $form_check obiekt klas FormCheck
    */
	function users_form(&$form,&$form_check,$file="users.html.php"){
		global $lang;
		$this->form=&$form;
		$this->form_check=&$form_check;

		//if (empty($_SESSION['global_id_user'])) {
		$this->bar(@$lang->bar_title['users']);
		//}

		global $DOCUMENT_ROOT;
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");

		return(0);
	} // end users_form()

	/**
    * Wybor sposobu platnosci
    */
	function register_pay_method(){
		$this->theme_file("register_pay_method.html.php");
		return(0);
	} // end register_pay_method()

	/**
    * Wartosc elementu formularza value=$this->form_val('nazwa_pola')
    *
    * @param string $name nazwa pola formularza
    */
	function form_val($name) {
		global $form;

		if (empty($form))
		$form=$this->form;

		if (! empty($form[$name])) {
			print $form[$name];
		}
		return(0);
	} // end form_val()

	/**
    * Blednie wypelnione pole formularza
    *
    * @param string $name nazwa pola formularza
    * @return wyswietla komunikat o bledzie, jesli takowy zostal wykrypty przez $this->form_check->test()
    */
	function form_error($name) {
		if (! @empty($this->form_check->errors_found[$name])) {
			print "<font color=red>";
			print $this->form_check->errors_found[$name];
			print "</font>\n";
		}
		return(0);
	} // end form_error()

	/**
    * Formularz wyszukiwania
    *
    * @param string $view rodzaj prezentacji fromularza wyszukiwania "vertical" - pionowo, "horizontal" - poziomo
    */
	function search_form(){
		global $lang;
		global $config;
		global $base_theme_config;

		// start plugin cd:
		if ($config->cd==1) return;
		// end plugin cd:ss


		print "<div align=\"left\">\n";
		print "<form action=\"/go/_search/full_search.php\" method=\"get\">";
		print "<table border=\"0\">";
		print "<tr>";
		print "<td>";
		print "<input type=\"hidden\" name=\"SEARCH_FORM\" />";
		print "    <input id=\"search_query_words\" type=\"text\" name=\"search_query_words\" onkeyup=\"hintMe();\" size=\"23\" onmouseover=\"showHints();\" onmouseout=\"hideHints();\" />\n";
		//		print "    <input id='search_query_words' type=\"text\" name=\"search_query_words\" onkeyup=\"hintMe();\" size=\"23\" onmouseover=\"showHints();\" onmouseout=\"hideHints();\" />\n";
		print "<div id='magicDiv'><div id='searchHint' class='searchDivHidden' onmouseout=\"hideHints();\" onmouseover=\"showHints();\"></div></div>";
		print "</td>";
		print "<td>";
		print "    <input style=\"border-style: none;\" type=\"image\" src=\"";
		//	$this->img('_img/magnifying.gif');
		$this->desktopPathImage('box_magnifying');
		print "\" />\n";

		print "</td>";
		print "</tr>";
		if (@$base_theme_config->show_adv_seach==1){
			// poka wyszukiwanie zaawansowane, jeli konfiguracja tematu bazowego na to pozwala
			print "<tr>";
			print "<td colspan=\"2\">";

			print "<a href='/go/_search/advanced_search.php'>".@$lang->search_advanced."</a>";
			print "</td>";
			print "</tr>";
		}
		print "</table>";
		print "</form>";
		print "</div>\n";
	} // end search_form()

	/**
    * Informacja o tym ,z e zamowienie zostalo wyslane
    */
	function send_confirm() {
		$this->theme_file("send_confirm.html.php");
		return(0);
	} // end send_confirm()

	/**
    * Nie udalo sie wysalc zamowienia do sklepu
    */
	function send_error() {
		$this->theme_file("send_error.html.php");
		return(0);
	} // end send_error()

	/**
    * Bledy ciag wyszukiwania
    */
	function search_empty() {
		global $lang;
		$this->bar($lang->search_empty_title);
		print "<center>".$lang->search_empty_query."</center>";
	} // end search_empty()

	/**
    * Okno prezentacji rekordu (losowanie)
    */
	function random_row(&$rec) {
		global $image,$config;

		global $DOCUMENT_ROOT;
		$file="random_record.html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");

		return(0);
	} // end random_row()

	/**
    * Uzytkwonik zostal zarejestrowny
    */
	function users_registered() {
		$this->theme_file("users_registered.html.php");
		return(0);
	} // end users_registered()

	/**
    * Uzytkwonik zostal zarejestrowny, realizuj zamowienie (koszyk nie jest pusty)
    */
	function users_go2register() {
		$this->theme_file("users_go2register.html.php");
		return(0);
	} // end users_registered()

	/**
    * Formularz logowania uzytkownikow; wylogowanie.
    */
	function login_form(){
		require_once("include/login.inc");
		$sys_login->login_form();
		return(0);
	} // end login_form()

	/**
    * Formularz logowanie odbiorcy hurtowego; wylogowanie.
    */
	function firm_login_form() {
		require_once("include/firm_login.inc");
		$f_login->login_form();
		return(0);
	} // end firm_login_form()

	/**
    * Wyswietl liste tematow do wyboru. Jeeli lista aktywnych (dostpnych) tematw
    * skada si tylko z jednego tematu, to nie jest wywietlona wogle
    */
	function show_themes() {
		global $config, $lang;

		// start plugin cd:
		if ($config->cd==1) return '';
		// end plugin cd:

		print "<table width=\"100%\" style=\"border-bottom: 1px solid black; background-color: #cccccc;\">";
		print "<tr>";
		print "<td><table border=\"0\"><tr><td>";
		print "$lang->right_choose_layout</td><td>";
		print "<form action=\"$config->url_prefix/go/_themes/index.php\" method=\"get\">";
		print "<select name=\"theme\" onchange=\"this.form.submit();\">";
		foreach ($config->themes as $key => $value)
		{
			if ($value == $config->theme) $select_theme = " selected=\"selected\""; else $select_theme = "";
			print "<option value=\"$value\"$select_theme>$value</option>";
		}
		print "</select>";
		print "</form>";
		print "</td></tr></table>";
		print "</td>";
		print "</tr>";
		print "</table>";

		return(0);
	} // end show_theme()

	// --- start Plugins ----

	// --- start InCategory --
	/**
    * Wiersz prezentacji produktu z tej samej kategorii na liscie w info
    *
    * @param object $rec obiekt z danymi produktu $rec->data
    */
	function category_row(&$rec) {
		// nie wstawiac include_once, bo plik ma byc ladowany wiele razy!
		global $DOCUMENT_ROOT;
		$file="in_category_row.html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");
		return(0);
	} // end category_row()
	// --- end InCategory ---

	// --- start Reviews ----
	/**
    * Wiersz prezentacji recenzji na liscie w info
    *
    * @param object $rec obiekt z danymi produktu $rec->data
    * @author piotrek@sote.pl
    */
	function reviews_row(&$rec) {
		// nie wstawiac include_once, bo plik ma byc ladowany wiele razy!
		global $DOCUMENT_ROOT;
		$file="plugins/_reviews/reviews_row.html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");
		return(0);
	} // end reviews_row()

	// end Reviews ---

	// --- start HiddenPrice ---
	/**
    * Wstaw link zapytaj o cene
    *
    * @param string $name nazwa produktu
    * @public
    */
	function ask4price($rec = '') {
		global $lang,$config, $_SESSION;
		if((!empty($_SESSION['ask4price_list'])) || (!empty($rec))) {
			//        if(1) {
			if(!empty($rec)) {
				$name_url=urlencode($rec->data['name']);
				$producer_url=urlencode($rec->data['producer']);
				$id_url=urlencode($rec->data['user_id']);
				print "<a href='/plugins/_ask4price/?action=add&id=$id_url&name=$name_url&producer=$producer_url' onclick=\"window.open('','window','width=600,height=450,scrollbars=1,menubar=0,status=0,location=0,directories=0,toolbar=0,resizable=1');\" target='window'>".$lang->ask4price."</a>";
			}
			else {
				print "<a href='/plugins/_ask4price/?action=show' onclick=\"window.open('','window','width=600,height=450,scrollbars=1,menubar=0,status=0,location=0,directories=0,toolbar=0,resizable=1');\" target='window'>".$lang->ask4price_list."</a>";
			}
		}
		return(0);
	} // end ask4price
	// --- end HiddenPrice ---

	//-- start UserTrans
	/**
    * Nazwy elementow nad lista transakcji
    */
	function trans_list_th() {
		global $lang, $_SESSION;
		$o="<br /><center>$lang->trans_desc</center>";
		$o.="<br /><table align=center>";
		$o.="<tr bgcolor=$this->bg_bar_color_light><th>$lang->trans_id</th><th>$lang->trans_date</th><th>$lang->trans_amount</th><th>$lang->trans_stat</th><th>$lang->trans_pay_conf</th><th>$lang->trans_payment</th>";
		if(empty($_SESSION['id_partner'])) {
			$o .= "<th>$lang->trans_ask4trans</th></tr>\n";
		}
		else {
			$o .= "\n";
		}
		return $o;
	}

	//-- start UserPoints
	/**
    * Nazwy elementow nad liscie historii punktow 
    */

	function points_list_th() {
		global $lang;
		global $lang;
		$o="<br /><center></center>";
		$o.="<br /><table align=center>";
		$o.="<tr bgcolor=$this->bg_bar_color_light><th>$lang->points_action</th><th>$lang->users_points</th><th>$lang->points_time</th><th>$lang->trans_stat</th><th>$lang->trans_id</th><th>$lang->points_id_product</th></tr>\n";
		return $o;

	}

	/**
    * Wiersz prezentacji historii punktow
    *
    * @param object $rec obiekt z danymi produktu $rec->data
    */
	function points_record_row(&$rec) {
		// nie wstawiac include_once, bo plik ma byc ladowany wiele razy!
		global $DOCUMENT_ROOT;
		$file="points_record_row.html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");
		return(0);
	} // end order_record_row()

	/**
    * Wiersz prezentacji transakcji
    *
    * @param object $rec obiekt z danymi produktu $rec->data
    */
	function trans_record_row(&$rec) {
		// nie wstawiac include_once, bo plik ma byc ladowany wiele razy!
		global $DOCUMENT_ROOT;
		$file="trans_record_row.html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");
		return(0);
	} // end order_record_row()

	/**
    * Edycja transakcji
    *
    * @param object $rec obiekt z danymi produktu $rec->data
    */
	function trans_product(&$rec) {
		global $lang;
		global $config;
		global $DOCUMENT_ROOT;
		$file="trans_products.html.php";
		include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");
		return(0);
	} // end order_edit()

	/**
    * Wstaw link, icone z opisem
    *
    * @param string $image nazwa fotki z katalogu _img/_icons (wzgledem katalogu tematu)
    * @param string $link  URL wzgledem domeny
    * @text  string $text  podpis pod ikonka
    */
	function icon($image,$link,$text) {
		print "
          <table cellpadding=\"0\" cellspacing=\"0\" border=\"0\">
          <tr>
           <td valign=\"top\" align=\"center\"><a href=\"$link\">";
		print "<img src=\"";$this->img("_img/_icons/$image");print "\" border=\"0\" alt=\"\" /></a></td>
          </tr>
          <tr><td align=\"center\" valign=\"top\">$text</td></tr>
         </table>";

		return(0);
	} // end icon()
	// -- end UserTrans

	// -- start producers_category
	/**
    * Wyswietl liste producentow, zapamietaj wybranego przez usera producenta
    *
    * \@global string $this->producer_filter_name nazwa producenta (filtru kategorii)
    */
	function producers_category() {
		global $lang;
		global $_REQUEST;
		global $__all_producers;
		global $config;
		include_once("include/lang_functions.inc");

		// start plugin cd:
		if ($config->cd==1) return '';
		// end plugins cd:

		if (empty($__all_producers)) {
			include_once("config/tmp/producer.php");
		}

		global $_SESSION;

		// odczytaj kategorie dla danego producenta
		if (ereg("^[0-9]+$",@$_REQUEST['producer_filter'])) {
			$__producer_filter=$_REQUEST['producer_filter'];
		} elseif (ereg("^[0-9]+$",@$_SESSION['__producer_filter'])) {
			$__producer_filter=$_SESSION['__producer_filter'];
		} else {
			$__producer_filter='';
		}

		if (! empty($__all_producers)) {
			print "<form action=\"$config->url_prefix/index.php\" method=\"get\" name=\"producers\">\n";
			print "<select name=\"producer_filter\" onchange=\"this.form.submit();\" style=\"width: 98%;\">\n";
			print "<option value=\"0\">$lang->producer_select</option>\n";
			while (list($producer,$id_producer) = each($__all_producers)) {
				$producer=stripslashes($producer);
				if ($__producer_filter==$id_producer) {
					$selected=" selected=\"selected\"";
					$this->producer_filter_name=$producer;
				} else $selected="";
				if (strlen($producer)>$this->max_producer_chars) $producer=substr($producer,0,$this->max_producer_chars)."...";
				print "<option value=\"$id_producer\"$selected>" . LangF::translate($producer) . "</option>\n";
			}
			print "</select>";
			//            print "<input type=image src="; $this->bmp("next.gif","layout_buttons"); print " class=\"border0\"></nobr>\n";
			print "</form>\n";
		}
		return;
	} // end producers_category()
	// -- end  producers_category

	// --- end Plugins ---

	/**
    * Funkcja generujca otwarcie okienka z lewej lub prawej strony sklepu
    *
    * @param  int    $width     szerokosc tabeli w px
    * @param  string $data      tekst do wyswietlenia jako nazwa naglowka
    * @param  int    $width     szerokosc tabeli
    * @param  int    $bar       generowac naglowek czy okno 1 - naglowek / 0 - tabela
    * @param  int    $open_body generowac otwarcie okienka czy sam bar 1 - okno / 0 - bar
    *
    * @access public
    *
    * @return void
    */
	function win_top($data='',$width=180,$bar=0,$open_body=1){
		global $config, $prefix;
		if($bar==1){
			$img_file="bar";
		} else {
			$img_file="top";
		}
		if($data == '&nbsp;')
		$data = '';
		$left      = $prefix . $config->theme_config['box']['img'][$img_file]['left'];
		$center    = $prefix . $config->theme_config['box']['img'][$img_file]['center'];
		$right     = $prefix . $config->theme_config['box']['img'][$img_file]['right'];

		/**
    	* pomniejsz szerokosc kolumny
    	* o szerokosc naroznikow tabeli
    	* o ile nie wpisano wartosci w %
    	*/
		if (preg_match ("/(\%)$/", $width)) {
			$cell_width="";
			$open_body=0; // dla wartosc procentowych szerokosci mozna generowac tylko bar'y z tekstem
		} else {
			$cell_width=$width-30;
		}
		print "<table width=\"$width\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\" bgcolor=\"" . $config->theme_config['colors']['box_background'] . "\">\n";
		print "  <tr>\n";
		print "    <td  align=\"left\" background=\"";
		$this->img($center);
		print "\"><img alt=\"\" src=\"";
		$this->img($left);
		print "\" /></td>\n";
		print "    <td width=\"$cell_width\" background=\"";
		$this->img($center);
		print "\" align=\"center\" style=\"color: ";
		if ($bar==1){
			print  $config->theme_config['colors']['header_font'];
		} else {
			print $config->theme_config['colors']['base_font'];
		}
		print "; font-weight: bold;\">";
		print $data;
		print "</td>\n";
		print "    <td  align=\"right\" background=\"";
		$this->img($center);
		print "\"><img alt=\"\" src=\"";
		$this->img($right);
		print "\" /></td>\n";
		print "  </tr>\n";
		print "</table>\n";

		/**
    	* jesli nie jest to bar to zalacz cialo tabelki
    	*/
		if ($open_body==1){
			$this->win_body_open($width);
		}

		return;
	} // end win_top()

	/**
    * Funkcja generujca zamkniecie okienka z lewej lub prawej strony sklepu
    *
    * @param int $width szerokosc tabeli w px
    *
    * @return void
    */
	function win_bottom($width=180){

		global $config, $prefix;
		$this->win_body_close();
		$cell_width=$width-30;

		$left      = $prefix . $config->theme_config['box']['img']['bottom']['left'];
		$center    = $prefix . $config->theme_config['box']['img']['bottom']['center'];
		$right     = $prefix . $config->theme_config['box']['img']['bottom']['right'];

		print "<table width=\"$width\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\" bgcolor=\"" . $config->theme_config['colors']['box_background'] . "\">\n";
		print "  <tr>\n";
		print "    <td ><img alt=\"\" src=\"";
		$this->img($left);
		print "\" /></td>\n";
		print "    <td width=\"100%\" background=\"";
		$this->img($center);
		print "\" align=\"center\" style=\"color: #FFFFFF; font-weight: bold;\"></td>\n";
		print "    <td ><img alt=\"\" src=\"";
		$this->img($right);
		print "\" /></td>\n";
		print "  </tr>\n";
		print "</table>\n";

		return;
	} // end win_bottom()


	/**
    * Funkcja generujca otwarcie ciala okienka z lewej lub prawej strony sklepu
    *    
    * @param  int        $width szerokosc tabeli w px
    *
    * @access private
    *
    * @return void
    */
	function win_body_open($width=180){
		/**
    	* pomniejszona szerokosc kolumny o szerokosc ramki
    	* @var int
    	*/
		$cell_width=$width-2;

		global $config, $prefix;

		print "<table width=\"".$width."\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\" bgcolor=\"" . $config->theme_config['colors']['box_background'] . "\">\n";
		print "  <tr>\n";
		print "    <td width=\"1\" background=\"";
		$this->path($prefix . $config->theme_config['box']['img']['middle']['left']);
		print "\"><img alt=\"\" src=\"";
		//    	$this->img("_img/_mask.gif");
		$this->path($prefix . $config->theme_config['box']['img']['middle']['left']);
		print "\" /></td>\n";
		print "    <td width=\"100%\" align=\"left\">";

		return;
	} // win_body_open();

	/**
    * Funkcja generujca otwarcie ciala okienka z lewej lub prawej strony sklepu
    *    
    * @param  int        $width szerokosc tabeli w px
    *
    * @private
    * @return none
    */
	function win_body_close(){
		global $config, $prefix;
		print "</td>\n";
		print "    <td width=\"1\" background=\"";
		$this->path($prefix . $config->theme_config['box']['img']['middle']['right']);
		print "\"><img alt=\"\" src=\"";
		//    	$this->img("_img/_mask.gif");
		$this->path($prefix . $config->theme_config['box']['img']['middle']['right']);
		print "\" /></td>\n";
		print "  </tr>";
		print "  </table>";

		return;
	} // end win_body_close()

	/**
    * Link odsyajcy do penej informacji o artykule itp.
    *
    * @param string $link link do strony
    * @param int    $img  format wyswietlanego odsylacza (0 - text/1 - image)
    *
    * @return void
    */
	function infoOnPageURI($uri="", $img=0) {
		global $lang;

		if(empty($uri)) return;

		print "<a href=\"".$uri."\">";
		if($img==1){
			print "<img src=\"";
			$this->img("_img/info.gif");
			print "\" border=\"0\" alt=\"info\" align=\"middle\" />";
		} else print $lang->infoOnPageURI['name'];

		print "</a>&nbsp;";

		return;
	} // end info()

	/**
    * wyswietla logo firmy sote oraz link do strony producenta oprogramowania
    * xHTML 4.01
    *
    * @access public
    *
    * @return void
    */
	function copyrightSOTE2(){
		global $lang;

		print "<table cellspacing=\"0\" cellpadding=\"3\" border=\"0\">\n";
		print "  <tr>\n";
		print "    <td>";
		print "<a href=\"http://www.sote.pl\" target=\"_blank\" title=\"{$lang->foot_soft}\">";
		print $lang->foot_soft;
		print "</a><br />";
		print "<a href=\"http://www.sote.pl\" target=\"_blank\" title=\"{$lang->foot_soft2}\">";
		print $lang->foot_soft2;
		print "</a>";
		print "</td>\n";
		print "    <td>";
		print "<a href=\"http://www.sote.pl\" target=\"_blank\">";
		print "<img src=\"";
		$this->path("_img/_bmp/foot/logo_foot.gif");
		print "\" border=\"0\" alt=\"Sklepy internetowe\" />";
		print "</a>";
		print "</td>\n";
		print "  </tr>\n";
		print "</table>\n";

		return;
	} // end copyrightSOTE()


	/**
    * Generuje link do okienka popup
    * aby funkcja dzialala poprawnie nalezy w head.html.php
    * zalaczyc skrypt JavaScript (popupWindow.js) lub napisac funkcje
    * wywolujaca okno popup i przekazac do niej odpowiednie parametry
    *
    * @param string $file   nazwa pliku wyswietlanego w okienku lub adres URI
    * @param string $alt    informacja wyswietlana jako info po najechaniu myszka na bitmape
    *                       lub nazwa linku tekstowego
    * @param int    $img    link w postaci tekstowej lub graficznej (0 - text/1 - bitmapa)
    * @param int    $width  szerokosc okienka popUp
    * @param int    $height wysokosc okienka popUp
    *
    * @access public
    *
    * @return void
    */
	function helpPopup($file="",$alt="Info",$img=0,$width=400,$height=300){
		global $DOCUMENT_ROOT, $config;

		if(empty($file)) return;

		$data=ereg_replace("\.\.","",$file);
		if(preg_match("([.html]$)",$file)){
			$_prefix="/themes/_".$config->lang."/_html_files/";
			if(file_exists($DOCUMENT_ROOT.$_prefix.$data)) $data=$_prefix.$file;
			else return;
		}
		else if(preg_match("([.php]$)",$file)){
			if(!preg_match("(^[/])",$file)) $file="/".$file;
			if(!file_exists($DOCUMENT_ROOT.$file)) return;
		}

		print "<a href=\"javascript:popup('".$file."','".$width."','".$height."','20','20','0')\" onmouseover=\"window.status=' '; return true;\">";

		if($img==1){
			print "<img src=\"";
			$this->bmp("help","layout_buttons");
			print "\" border=\"0\" alt=\"".$alt."\" />";
		} else print $alt;

		print "</a>\n";

		return;
	} // end helpPopup()

	/**
    * pokaz dostepne promocje
    */
	function showPromotions(){
		global $shop;

		print "<div align=\"left\" style=\"padding-top: 20px;\">\n";
		$shop->promotions();
		$shop->promotions->basketForm();
		print "</div>\n";

		return;
	} // end showPromotions()

	/**
    * Poka kwot zamwienia, warto koszyka w odpowiedniej walucie.
    * Funckja wykorzystywana do podgldu wartoci zmwienia.
    *
    * @author m@sote.pl
    * @return string wartoc zamwienia  + waluta
    */
	function basketAmount() {
		global $shop,$_SESSION;
		$shop->currency();
		if (! empty($_SESSION['global_basket_amount'])) {
			$price=$_SESSION['global_basket_amount'];
			return $shop->currency->price($price);
		} else return "0";
	} // end basketAmount()


	/**
    * Wywietl obiekt SELECT
    *
    * @author lech@sote.pl
    * @param string $name Nazwa i identyfikator obiektu, nazwa zmiennej przekazanej przy zatwierdzeniu formularza
    * @param array $options Tablica wartoci opcji do wyboru, klucz tablicy stanowi warto pola, warto tablicy - tekst wywietlany opcji
    * @param string $selected_value Warto domylnie wybrana w obiekcie (jeden z kluczy w tablicy opcji)
    * @param string $javascript dodatkowe parametry znacznika SELECT - w tym kod javascriptu
    */
	function inputSelect($name, $options, $selected_value, $javascript = '') {
		global $lang;
		echo "<select name='$name' id='$name' $javascript>";
		print "<option value=0>".$lang->country_user_def."</option>";
		while(list($key, $val) = each($options)) {
			$sel = '';
			if($key == $selected_value)
			$sel = 'selected';
			echo "
            <option value='$key' $sel>$val</option>
            ";
		}
		echo "</select>";
	}

	/**
    * Wstaw ukryte pole formularza
    *
    * @author lech@sote.pl
    * @param string $name Nazwa i identyfikator pola, nazwa zmiennej przekazanej przy zatwierdzeniu formularza
    * @param string $value Warto domylna pola
    * @param string $show_value Opcjonany tekst, ktry mona wywietli
    */
	function inputHidden($name, $value, $show_value='') {
		echo "<input type=hidden name='$name' id='$name' value='$value' />$show_value";
	}

	/**
    * Wstaw pole z krajami
    *
    * @author lech@sote.pl
    * @param string $name Nazwa i identyfikator pola, nazwa zmiennej przekazanej przy zatwierdzeniu formularza
    * @param string $value Warto domylna pola
    * @param string $locked Blokada pola: jeli 0: pojawi si lista rozwijana z moliwoci wyboru kraju; 1: pojawi si tylko nazwa kraju bez moliwoci wyboru
    * @param string $javascript dodatkowe parametry znacznika - w tym kod javascriptu
    */
	function inputCountries($name, $value, $locked = 0, $javascript = '') {
		global $lang;
		if($locked == 0) {
			$this->inputSelect($name, $lang->country, $value, $javascript);
		}
		else {
			$this->inputHidden($name, $value, $lang->country[$value]);
		}
	}

	/**
    * Wywietl flagi jzykowe
    *
    * @author lech@sote.pl
    */
	function showFlags() {
		global $config, $config_flags, $DOCUMENT_ROOT;

		include_once ("$DOCUMENT_ROOT/themes/base/base_theme/_flags/config_flags.inc.php");
		$lang_count = 0;
		for($i = 0; $i < count($config->langs_symbols); $i++) {
			if($config->langs_active[$i])
			$lang_count++;
		}

		if($lang_count > 1) {
			for($i = 0; $i < count($config->langs_symbols); $i++) {
				if($config->langs_active[$i]) {
					$lang_name = $config->langs_names[$i];
					echo "<a href=\"".$this->google_url("/go/_lang/?lang={$config->langs_symbols[$i]}","")."\"><img src=\""; $this->img("_flags/" . $config_flags->files[$config->langs_symbols[$i]]); echo "\" border=\"0\" alt=\"$lang_name\" /></a>&nbsp;";
				}
			}
		}
	}


	/**
    * Wywietl ikonki GG uwzgldniajc odpowiednie statusy wg pliku syatusw.
    *
    * @author maciej.s@sote.pl
    * @param int $gg_id numer GG
    * @return void
    */
	function gg($gg_id, $name='Kontakt'){

		$plik = fopen ("http://status.gadu-gadu.pl/users/status.asp?id=$gg_id&amp;styl=2", "r");

		$status = trim(fgets($plik));
		echo "status='$status'<br />";
		if (! empty($gg_id)){
			echo '<img src="';
			$this->img("_img/_bmp/gg/gg_$status.gif");
			echo '" alt="" />';
			echo "<a href=\"gg:'.$gg_id.'\"> $name</a>";
		}

		fclose($plik);


	}// end gg()


	/**
    * Wywietl wszystkie kategorie przegldajc je w gb rekurencyjnie
    *
    * Funkcja wywouje sam siebie dla kadej podkategorii, ktra nie jest liciem
    *
    * @author lech@sote.pl
    * @param array $sub_arr Tablica kategorii (kopia $__category) lub przekazana podtablica
    * @param int $level Poziom zagniedenia rekurencji
    * @param string $type google -> linki do stron statycznych, "other" -> linki do stron dynamicznych
    *
    * @see config/tmp/category.php
    */
	function categoriesRecursive($sub_arr, $level = 0, $type="other") {
		global $ocnfig;
		reset($sub_arr);
		while (list($key, $val) = each($sub_arr)) {
			$id_cat = $key;
			$subtree = array();
			unset($subtree);
			$subtree = $val;
			if($level > 0) {
				if ((is_array($val)) && (empty($val['name']))) {
					$arr = array_keys($val);
					$subtree = $val[$arr[0]];
					$id_cat = $arr[0];
				}
			}

			if((!empty($subtree['name'])) && (is_array($subtree))) {
				if($level == 0) {
					if ($type=="google") {
						echo "<li><a href='/html/cat_$id_cat".".html'>" . $subtree['name'] . "</a></li>\n";
					} else {
						echo "<li><a href='/go/_category/?idc=$id_cat'>" . $subtree['name'] . "</a></li>\n";
					}
				}
				else {
					if ($type=="google") {
						echo "<li><a href='/html/cat_$id_cat".".html'>" . $subtree['name'] . "</a</li>\n";
					} else {
						echo "<li><a href='/go/_category/?idc=$id_cat'>" . $subtree['name'] . "</a</li>\n";
					}
				}
				if (!empty($subtree['elements'])) {
					$subsubtree = array();
					$subsubtree = $subtree['elements'];
					// print "<ul>\n";
					$this->CategoriesRecursive($subsubtree, $level + 1);
					// print "</ul>\n";
				}
			}
			else {
				if ($type=="google") {
					echo "<li><a href='/html/cat_$val".".html'>" . $key . "</a></li>\n";
				} else {
					echo "<li><a href='/go/_category/?idc=$val'>" . $key . "</a></li>\n";
				}
			}

			//        if (is_array())
		}
		return;
	}


	/**
    * Wstaw link do wersji Google dla Google;)
    *
    * @author  m@sote.pl
    * @return void    
    */
	function google() {
		global $config,$lang;
		if (@$config->google_active) {
			print "<a href=\"/google.php\">$lang->google_up_link</a>\n";
		}
	} // end google()

	function _wishlist($id,$xml_options) {
		if (! empty($xml_options)) return 0;
		$this->_wishlistSimple($id);
		return;
	} // end _basket()

	/**
    * Wywietl ikonk (formularz) koszyka.
    * Funkcja powoduje wywietlenie zwykego koszyka. Rni sie od basket() tym, e nie powoduje
    * wywietlania formularza z opcjami.
    *
    * @param  int    $id identyfikator produktu (id z tabeli main)
    * @access private
    * @return none
    */
	function _wishlistSimple($id) {
		global $config;
		global $lang;
		if ((@$config->catalog_mode==1) || @$config->wishlist['disabled']){
			return;
		}
		global $config, $prefix;
		if (@$config->ajax_basket && $id!=0) {
			print "<a onclick=\"xajax_add2wishlist($id,0)\" style=\"cursor: pointer; cursor: hand;\"><img src=\"";
			print $this->desktopPathImage('box_wishlist_simple');
			print "\" title=\"".$lang->tooltip['wishlist']."\" alt=\"\" /></a>";
		} else {
			print "<form action=\"/go/_basket/index3.php\" method=\"post\">\n";
			print "<input type=\"hidden\" name=\"id\" value=\"".$id."\" />";
			print "<input type=\"hidden\" name=\"formName\" value=\"wishlistForm\" />";
			print "<input class=\"border0\" type=\"image\" src=\"";
			print $this->desktopPathImage('box_wishlist_simple');
			print "\" title=\"".$lang->tooltip['wishlist']."\" />";
			print "</form>\n";
		}
		return;
	} // end _basketSimple()


	/**
    * Sprawd czy mona wywietli ikonk koszyk i jeli tak, to wywietl j.
    * Funckja ta zastpuje wczeniejsze wywoania postaci $theme->basket().
    *
    * @author m@sote.pl
    * @param  int     $id  id produktu (z tabeli main)
    * @param  object &$rec adres obiektu z danymi produktu $rec->data
    * @return none
    */
	function recWishlist($id,&$rec) {
		if (@$rec->data['points']!=1 && $this->checkView('Basket',$rec)) {
			return $this->_wishlist($id,@$rec->data['xml_options']);
		}
	} // end recInfo()
	// end Basket:

	/**
    * Przechowalnia jest pusta
    */
	function wishlist_empty() {
		global $lang;

		$this->bar($lang->wishlistForm);
		print "<p><center>$lang->wishlist_empty</center>";
		return(0);
	} // end basket_empty()


	/**
    * Wyswietl link do przechowalni
    */
	function wishlistLink() {
		global $DOCUMENT_ROOT, $image, $config;
		if (!@$config->wishlist['disabled'])
		{
			$file="wishlistlink.html.php"; $include_once=true;
			include ("$DOCUMENT_ROOT/themes/include/theme_file.inc.php");
		}
		return(0);
	} // end foot()

	function wishlistHead()
	{
		global $config;
		if (!@$config->wishlist['disabled'])
		{
			$this->theme_file('basket_head.html.php');
		}
	}


	/**
    * Formularz do filtrowania zamwie dla partnerw od daty do daty
    * uzyta w htdocs/index.php
    *
    * @access public
    *
    * @return void
    */
	function ordersFilter() {

		$this->theme_file("orders_filter.html.php");

		return;
	} // end ordersFilter()

	/**
	 * pseudo konstruktor pobiera dane konfiguracyjne boxw z danego tematu 
	 * konfiguracja ta znajduje si w  _cfg/desktop.cfg.php po wywoaniu tej funkcji 
	 * mona korzysta z innych funkcji boxw.
	 *
	 */

	function desktop(){
		global $border;
		$this->theme_file('_cfg/desktop.cfg.php');

		$this->config=$border;
	}

	function desktopBoxImage($name)
	{
		print "<img border=\"0\" src=\"";
		$this->img('_img/'.$this->config[$name][1].'');
		print "\" alt=\"\" />";
	}

	function desktopPathImage($name)
	{
		global $config;

		$this->img('_img/'.$this->config[$name][1].'');
	}

	function desktopPathImageReturn($name)
	{
		global $config;


		if(ereg("user_",$config->theme)=='1'){

			$filename=$_SERVER['DOCUMENT_ROOT'].'/themes/base/'.$config->theme.'/_img/';
			if (!file_exists($filename)) {
				$config->theme="base_theme";
			}
		}


		$bufor="/themes/base/".$config->theme."/_img/".$this->config[$name][1];
		return $bufor;
	}

	function getFileSizeW($file){
		global $DOCUMENT_ROOT;

		$blah = getimagesize($DOCUMENT_ROOT.$this->getCurrPath().'_img/'.$file);
		$type = $blah['mime'];
		$width = $blah[0];
		return $width;
	}

	function getFileSizeH($file){
		global $DOCUMENT_ROOT;
		//
		$blah = getimagesize($DOCUMENT_ROOT.$this->getCurrPath().'_img/'.$file);
		$type = $blah['mime'];
		$height = $blah[1];
		return $height;
	}


	function getCurrPath() {
		global $config;


		if(ereg("user_",$config->theme)=='1'){

			$filename=$_SERVER['DOCUMENT_ROOT'].'/themes/base/'.$config->theme.'/_img/';
			if (!file_exists($filename)) {
				$config->theme="base_theme";
			}
		}


		return '/themes/base/'.$config->theme.'/';
	}

	/**
	 * funkcja odpowiedzialna za otwarcie boxa skadajcego si z 8 elementw
	 *
	 * @param unknown_type $desctopData tablica zawierajca cieki do plikw obrazkw lub kolorw w hex.
	 *  Tablica wszystkich tych elementw znajduje si w pliku konfiguracyjnym tematu _cfg/desktop.cfg.php.
	 *  Obrazki domylnie przechowywane s w katalogu tematu _img/
	 * 
	 * @param unknown_type $width
	 * szeroko boxa
	 * 
	 * @param unknown_type $height
	 * wysoko boxa
	 * 
	 * @param unknown_type $valign
	 * rozmieszczenie elementw w rodku boxa
	 * 
	 * @param unknown_type $align
	 * rozmieszczenie elementw w rodku boxa
	 * 
	 * @param unknown_type $style
	 * nazwa classy stylu przypisanego do boxa moe by ona umieszczona jako ostatni element
	 *  tablicy w pliku konfiguracyjnym okrelenie stylu moe by 
	 * zarwno lokalne i jak i globalne zdefiniowane w gwnym pliku styli css.
	 * 
	 * @param unknown_type $left
	 * pozycja boxa od lewej strony
	 * 
	 * @param unknown_type $top
	 * pozycja boxa od gry
	 * 
	 * @param unknown_type $position
	 * okrelanie pozycji relative absolute itd..
	 */

	function makeStyle($style='', $attr=array())
	{
		foreach ($attr as $name=>$value) {


			$check=trim($value, "pxturl()'%");

			if (!empty($check))
			{

				if (is_numeric($value)) $value=$value.'px';

				$style.=$name.':'.$value.';';
			}
		}

		if (!empty($style))
		{
			$style='style="'.$style.'"';
		}

		return $style;
	}

	function DesktopOpen8($desctopData, $width='',$height='',$valign='',$align='', $style='', $left='', $top='', $position='relative'){

		if($desctopData[1]{0}=="#" || @$desctopData[1]=="empty"){
			$width1="";
			$height1="";
		}else{
			$width1= $this->getFileSizeW($desctopData[1]);
			$height1= $this->getFileSizeH($desctopData[1]);
		}

		if($desctopData[2]{0}=="#" || @$desctopData[2]=="empty"){
			$height2="";
		}else{
			$height2= $this->getFileSizeH($desctopData[2]);
		}

		if($desctopData[3]{0}=="#" || @$desctopData[3]=="empty"){
			$width3="";
			$height3="";
		}else{
			$width3= $this->getFileSizeW($desctopData[3]);
			$height3= $this->getFileSizeH($desctopData[3]);
		}

		if($desctopData[4]{0}=="#" || @$desctopData[4]=="empty"){
			$width4="";
		}else{
			$width4= $this->getFileSizeW($desctopData[4]);
		}


		if($style==''){
			$style_test=$desctopData[count($desctopData)];
			if(ereg('style:',$style_test)){
				$style_arr=explode (':',$style_test);
				$style=$style_arr[1];

			}
		}

		if($left!='' || $top!=''){

			$div_style=$this->makeStyle('', array(	'position'=>$position,
			'left'=>$left,
			'top'=>$top));

			print "<div $div_style>";
			$this->close_div_8='1';
		}

		if (!empty($style))
		print "<div class=\"$style\">";
		else
		print "<div>";

		$style=$this->makeStyle('', array('width'=>$width, 'height'=>$height));
		print "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" $style><tr>";

		$style=$this->makeStyle('', array('width'=>$width1, 'height'=>$height1, 'background'=>$this->checkBackground($desctopData[1])));
		print "<td $style></td>";

		$style=$this->makeStyle('', array('height'=>$height2, 'background'=>$this->checkBackground($desctopData[2])));
		print "<td $style></td>";

		$style=$this->makeStyle('', array('width'=>$width3, 'height'=>$height3, 'background'=>$this->checkBackground($desctopData[3])));

		print "<td $style></td>";
		print "</tr><tr>";

		$style=$this->makeStyle('', array('width'=>$width4,'background'=>$this->checkBackground($desctopData[4])));



		print "<td $style>";
		if (!empty($valign))
		$valign='valign="'.$valign.'"';

		if (!empty($align))
		$align='align="'.$align.'"';

		print"</td><td $valign $align ".$this->makeStyle('',array('background'=>$this->checkBackground($desctopData[5]))).">";

	}

	/**
	 * funkcja odpowiedzialna za zamknicie boxa skadajcego si z 8 elementw
	 *
	 * @param unknown_type $desctopData tablica zawierajca cieki do plikw obrazkw lub kolorw w hex.
	 *  Tablica wszystkich tych elementw znajduje si w pliku konfiguracyjnym tematu _cfg/desktop.cfg.php.
	 *  Obrazki domylnie przechowywane s w katalogu tematu _img/
	 */

	function DesktopClose8($desctopData){

		if($desctopData[6]{0}=="#" || @$desctopData[6]=="empty"){
			$width6="";
		}else{
			$width6= $this->getFileSizeW($desctopData[6]);
		}


		if($desctopData[7]{0}=="#" || @$desctopData[7]=="empty"){
			$width7="";
			$height7="";
		}else{
			$width7= $this->getFileSizeW($desctopData[7]);
			$height7= $this->getFileSizeH($desctopData[7]);
		}


		if($desctopData[8]{0}=="#" || @$desctopData[8]=="empty"){
			$height8="";
		}else{
			$height8= $this->getFileSizeH($desctopData[8]);
		}



		if($desctopData[9]{0}=="#" || @$desctopData[9]=="empty"){
			$width9="";
			$height9="";
		}else{
			$width9= $this->getFileSizeW($desctopData[9]);
			$height9= $this->getFileSizeH($desctopData[9]);
		}



		$style=$this->makeStyle('', array('width'=>$width6, 'background'=>$this->checkBackground($desctopData[6])));

		print "</td><td $style></td></tr><tr>";

		$style=$this->makeStyle('', array('width'=>$width7, 'height'=>$height7, 'background'=>$this->checkBackground($desctopData[7])));

		print "<td $style></td>";

		$style=$this->makeStyle('', array('height'=>$height8, 'background'=>$this->checkBackground($desctopData[8])));
		print "<td $style></td>";

		$style=$this->makeStyle('', array('width'=>$width9, 'height'=>$height9, 'background'=>$this->checkBackground($desctopData[9])));

		print "<td $style></td></tr></table></div>";

		if(@$this->close_div_8=='1'){
			print "</div>";
			$this->close_div_8='0';
		}

	}

	/**
	 * funkcja odpowiedzialna za otwarcie boxa skadajcego si z 3 elementw w ukadzie poziomym
	 *
	 * @param unknown_type $desctopData tablica zawierajca cieki do plikw obrazkw lub kolorw w hex.
	 *  Tablica wszystkich tych elementw znajduje si w pliku konfiguracyjnym tematu _cfg/desktop.cfg.php.
	 *  Obrazki domylnie przechowywane s w katalogu tematu _img/
	 * 
	 * @param unknown_type $width
	 * szeroko boxa
	 * 
	 * @param unknown_type $height
	 * wysoko boxa
	 * 
	 * @param unknown_type $valign
	 * rozmieszczenie elementw w rodku boxa
	 * 
	 * @param unknown_type $align
	 * rozmieszczenie elementw w rodku boxa
	 * 
	 * @param unknown_type $style
	 * nazwa classy stylu przypisanego do boxa moe by ona umieszczona jako ostatni element
	 *  tablicy w pliku konfiguracyjnym okrelenie stylu moe by 
	 * zarwno lokalne i jak i globalne zdefiniowane w gwnym pliku styli css.
	 * 
	 * @param unknown_type $left
	 * pozycja boxa od lewej strony
	 * 
	 * @param unknown_type $top
	 * pozycja boxa od gry
	 * 
	 * @param unknown_type $position
	 * okrelanie pozycji relative absolute itd..
	 */

	function DesktopOpen3Horizontal($desctopData, $width='',$height='',$valign='',$align='', $style='', $left='', $top='', $position='relative'){

		if($desctopData[1]{0}=="#" || @$desctopData[1]=="empty"){
			$width1="";
			$height1="";
		}else{
			$width1= $this->getFileSizeW($desctopData[1]);
			$height1= $this->getFileSizeH($desctopData[1]);
		}

		if($desctopData[3]{0}=="#" || @$desctopData[3]=="empty"){
			$width3="";
			$height3="";
		}else{
			$width3= $this->getFileSizeW($desctopData[3]);
			$height3= $this->getFileSizeH($desctopData[3]);
		}

		if($desctopData[2]{0}=="#" || @$desctopData[2]=="empty"){
			$height2="";
		}else{
			$height2= $this->getFileSizeH($desctopData[2]);
		}

		if($width!='0'){
			$width2= $width - $width1 - $width3;
		}

		if($style==''){
			$style_test=$desctopData[count($desctopData)];
			if(ereg('style:',$style_test)){
				$style_arr=explode (':',$style_test);
				$style=$style_arr[1];

			}
		}

		if($left!='' || $top!=''){
			$div_style=$this->makeStyle('', array(	'position'=>$position,
			'left'=>$left,
			'top'=>$top));

			print "<div $div_style>";
			$this->close_div_3Horizontal='1';
		}

		if (!empty($style))
		print "<div class=\"$style\">";
		else
		print "<div>";

		$style=$this->makeStyle('', array('width'=>$width));


		print "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" $style>";
		print "<tr>";

		$style=$this->makeStyle('', array('width'=>$width1, 'height'=>$height1, 'background'=>$this->checkBackground($desctopData[1])));

		print "<td $style></td>";

		if (!empty($height))
		$height2=$height;

		$style=$this->makeStyle('', array('width'=>$width2, 'height'=>$height2, 'background'=>$this->checkBackground($desctopData[2])));

		if (!empty($valign))
		$valign='valign="'.$valign.'"';

		if (!empty($align))
		$align='align="'.$align.'"';

		print "<td $style $valign $align>";
	}

	/**
	 * funkcja odpowiedzialna za zamknicie boxa skadajcego si z 3 elementw w ukadzie poziomym
	 *
	 * @param unknown_type $desctopData tablica zawierajca cieki do plikw obrazkw lub kolorw w hex.
	 *  Tablica wszystkich tych elementw znajduje si w pliku konfiguracyjnym tematu _cfg/desktop.cfg.php.
	 *  Obrazki domylnie przechowywane s w katalogu tematu _img/
	 */

	function DesktopClose3Horizontal($desctopData){

		if($desctopData[3]{0}=="#" || @$desctopData[3]=="empty"){
			$width3="";
			$height3="";
		}else{
			$width3= $this->getFileSizeW($desctopData[3]);
			$height3= $this->getFileSizeH($desctopData[3]);
		}

		print "</td>";

		$style=$this->makeStyle('', array('width'=>$width3, 'height'=>$height3, 'background'=>$this->checkBackground($desctopData[3])));

		print "<td $style>";
		print"</td>";
		print "</tr>";
		print "</table>";
		print "</div>";
		if(@$this->close_div_3Horizontal=='1'){
			print "</div>";
			$this->close_div_3Horizontal='0';
		}

	}

	/**
	 * funkcja odpowiedzialna za otwarcie boxa skadajcego si z 3 elementw w ukadzie pionowym
	 *
	 * @param unknown_type $desctopData tablica zawierajca cieki do plikw obrazkw lub kolorw w hex.
	 *  Tablica wszystkich tych elementw znajduje si w pliku konfiguracyjnym tematu _cfg/desktop.cfg.php.
	 *  Obrazki domylnie przechowywane s w katalogu tematu _img/
	 * 
	 * @param unknown_type $width
	 * szeroko boxa
	 * 
	 * @param unknown_type $height
	 * wysoko boxa
	 * 
	 * @param unknown_type $valign
	 * rozmieszczenie elementw w rodku boxa
	 * 
	 * @param unknown_type $align
	 * rozmieszczenie elementw w rodku boxa
	 * 
	 * @param unknown_type $style
	 * nazwa classy stylu przypisanego do boxa moe by ona umieszczona jako ostatni element
	 *  tablicy w pliku konfiguracyjnym okrelenie stylu moe by 
	 * zarwno lokalne i jak i globalne zdefiniowane w gwnym pliku styli css.
	 * 
	 * @param unknown_type $left
	 * pozycja boxa od lewej strony
	 * 
	 * @param unknown_type $top
	 * pozycja boxa od gry
	 * 
	 * @param unknown_type $position
	 * okrelanie pozycji relative absolute itd..
	 */

	function DesktopOpen3Vertical($desctopData, $width='',$height='',$valign='',$align='', $style='', $left='', $top='', $position='relative'){

		if($desctopData[1]{0}=="#" || @$desctopData[1]=="empty"){
			$width1="";
			$height1="";
		}else{
			$width1= $this->getFileSizeW($desctopData[1]);
			$height1= $this->getFileSizeH($desctopData[1]);
		}

		if($desctopData[2]{0}=="#" || @$desctopData[2]=="empty"){
			$height2="";
		}else{
			$height2= $this->getFileSizeH($desctopData[2]);
		}

		if($desctopData[3]{0}=="#" || @$desctopData[3]=="empty"){
			$width3="";
			$height3="";
		}else{
			$width3= $this->getFileSizeW($desctopData[3]);
			$height3= $this->getFileSizeH($desctopData[3]);
		}

		if($height!='0'){
			$height2= $height - $height1 - $height3;
		}

		//$width1= $this->getFileSizeW($desctopData[1]);
		//$height1= $this->getFileSizeH($desctopData[1]);

		//$height2= $this->getFileSizeH($desctopData[2]);

		if($style==''){
			$style_test=$desctopData[count($desctopData)];
			if(ereg('style:',$style_test)){
				$style_arr=explode (':',$style_test);
				$style=$style_arr[1];

			}
		}

		if($left!='' || $top!=''){
			$div_style=$this->makeStyle('', array(	'position'=>$position,
			'left'=>$left,
			'top'=>$top));

			print "<div $div_style>";
			$this->close_div_3Vertical='1';
		}
		print "<div class=\"$style\">";

		$style=$this->makeStyle('', array('width'=>$width));

		print "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" $style>";
		print "<tr>";
		$style=$this->makeStyle('', array('width'=>$width1, 'height'=>$height1, 'background'=>$this->checkBackground($desctopData[1])));
		print "<td $style>";
		print"</td>";
		print "</tr>";
		print "<tr>";
		if (!empty($height))
		$height2=$height;

		$style=$this->makeStyle('', array('width'=>$width2, 'height'=>$height2, 'background'=>$this->checkBackground($desctopData[2])));

		if (!empty($valign))
		$valign='valign="'.$valign.'"';

		if (!empty($align))
		$align='align="'.$align.'"';

		print "<td $style $valign $align>";

	}

	/**
	 * funkcja odpowiedzialna za zamknicie boxa skadajcego si z 3 elementw w ukadzie pionowym
	 *
	 * @param unknown_type $desctopData tablica zawierajca cieki do plikw obrazkw lub kolorw w hex.
	 *  Tablica wszystkich tych elementw znajduje si w pliku konfiguracyjnym tematu _cfg/desktop.cfg.php.
	 *  Obrazki domylnie przechowywane s w katalogu tematu _img/
	 */

	function DesktopClose3Vertical($desctopData){

		if($desctopData[3]{0}=="#" || @$desctopData[3]=="empty"){
			$width3="";
			$height3="";
		}else{
			$width3= $this->getFileSizeW($desctopData[3]);
			$height3= $this->getFileSizeH($desctopData[3]);
		}

		//$width3= $this->getFileSizeW($desctopData[3]);
		//$height3= $this->getFileSizeH($desctopData[3]);

		print "</td>";
		print "</tr>";
		print "<tr>";

		$style=$this->makeStyle('', array('width'=>$width3, 'height'=>$height3, 'background'=>$this->checkBackground($desctopData[3])));
		print "<td width=\"$width3\" height=\"$height3\">";
		print "</td>";
		print "</tr>";
		print "</table>";
		print "</div>";
		if(@$this->close_div_3Vertical=='1'){
			print "</div>";
			$this->close_div_3Vertical='0';
		}


	}


	/**
	 * funkcja odpowiedzialna za otwarcie pojedynczego boxa skadajcego si z jednego elementu
	 *
	 * @param unknown_type $desctopData tablica zawierajca cieki do plikw obrazkw lub kolorw w hex.
	 *  Tablica wszystkich tych elementw znajduje si w pliku konfiguracyjnym tematu _cfg/desktop.cfg.php.
	 *  Obrazki domylnie przechowywane s w katalogu tematu _img/
	 * 
	 * @param unknown_type $width
	 * szeroko boxa
	 * 
	 * @param unknown_type $height
	 * wysoko boxa
	 * 
	 * @param unknown_type $valign
	 * rozmieszczenie elementw w rodku boxa
	 * 
	 * @param unknown_type $align
	 * rozmieszczenie elementw w rodku boxa
	 * 
	 * @param unknown_type $style
	 * nazwa classy stylu przypisanego do boxa moe by ona umieszczona jako ostatni element
	 *  tablicy w pliku konfiguracyjnym okrelenie stylu moe by 
	 * zarwno lokalne i jak i globalne zdefiniowane w gwnym pliku styli css.
	 * 
	 * @param unknown_type $left
	 * pozycja boxa od lewej strony
	 * 
	 * @param unknown_type $top
	 * pozycja boxa od gry
	 * 
	 * @param unknown_type $position
	 * okrelanie pozycji relative absolute itd..
	 */

	function DesktopOpenBox($desctopData, $width='',$height='',$valign='top',$align='left', $style='', $left='', $top='', $position='relative'){



		if($desctopData[1]{0}=="#" || @$desctopData[1]=="empty"){
			$width1="";
			$height1="";
		}else{
			$width1= $this->getFileSizeW($desctopData[1]);
			$height1= $this->getFileSizeH($desctopData[1]);
		}


		if($style==''){
			$style_test=$desctopData[count($desctopData)];
			if(ereg('style:',$style_test)){
				$style_arr=explode (':',$style_test);
				$style=$style_arr[1];

			}
		}
		if($left!='' || $top!=''){
			$div_style=$this->makeStyle('', array('position'=>$position,
			'left'=>$left,
			'top'=>$top));

			print "<div $div_style>";
			$this->close_div_box='1';
		}

		if (!empty($style))
		print "<div class=\"$style\">";
		else
		print "<div>";


		$style=$this->makeStyle('', array('width'=>$width));

		print "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" $style>";
		print "<tr>";

		if (!empty($height))
		$height1=$height;

		$style=$this->makeStyle('', array('width'=>$width1, 'height'=>$height1, 'background'=>$this->checkBackground($desctopData[1])));

		if (!empty($valign))
		$valign='valign="'.$valign.'"';

		if (!empty($align))
		$align='align="'.$align.'"';

		print "<td $style $valign $align>";
	}
	/**
	 * funkcja odpowiedzialna za zamknicie pojedynczego boxa skadajcego si z jednego elementu
	 *
	 */

	function DesktopCloseBox(){
		print "</td>";
		print "</tr>";
		print "</table>";
		print "</div>";

		if(@$this->close_div_box=='1'){
			print "</div>";
			$this->close_div_box='0';
		}
	}

	/**
	 * funkcja odpowiedzialna za rozmieszczenie zamknitego wewntrz obiektu na ekranie (otwiera blok)
	 *
	 * @param unknown_type $left
	 * @param unknown_type $top
	 * @param unknown_type $position
	 */

	function SetOpenPosition($left='', $top='', $position='relative'){
		print "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">";
		print "<tr>";
		print "<td>";

		$div_style=$this->makeStyle('', array(	'position'=>$position,
		'left'=>$left,
		'top'=>$top));

		print "<div $div_style>";
	}

	/**
	 * funkcja odpowiedzialna za rozmieszczenie zamknitego wewntrz obiektu na ekranie (zamyka blok)
	 *
	 */

	function SetClosePosition(){

		print "</div>";
		print "</td>";
		print "</tr>";
		print "</table>";
	}

	function checkBackground($data){
		if($data=="empty")
		return "";

		if ($data[0]=='#')
		return $data;

		return "url('".$this->getCurrPath()."_img/$data')";

	}

	function goToPrevPage()
	{
		global $lang, $config;
		$link='';

		if (isset($_SESSION['prev_page']) && !empty($_SESSION['prev_page']))
		{
			if (isset($_SESSION['global_lang']))
			$global_lang=$_SESSION['global_lang'];
			else
			$global_lang=$config->lang;

			if (empty($config->rewrite) || ($_SESSION['prev_page'][strlen($_SESSION['prev_page'])-1]=="/") || (strpos($_SESSION['prev_page'],".php") !== false) || (strpos($_SESSION['prev_page'],"/?") !== false))
			{
				if (strpos($_SESSION['prev_page'],"&") !== false)
				{
					$tmp=explode("&",$_SESSION['prev_page']);

					foreach ($tmp as $val)
					{
						if (strpos($val, "lang=") !== false)
						$link.="&lang=".$global_lang;
						else
						if (strpos($val,"?") !== false)
						$link.="$val";
						else
						$link.="&$val";
					}
					//die ($link);

				}
				else
				if (strpos($_SESSION['prev_page'],"?") !== false)
				{
					if (($pos=strpos($_SESSION['prev_page'],"?lang")) !== false)
					{
						$link=substr_replace($_SESSION['prev_page'],"?lang=".$global_lang,$pos);
					}
					else
					{
						$link=$_SESSION['prev_page']."&lang=".$global_lang;
					}
					//die ("cos2");
				}
				else
				{
					$link=$_SESSION['prev_page'];
					//die ("cos3");
				}
			}
			else
			{

				if (substr_count($_SESSION['prev_page'],"/") > 1)
				{

					$urlArr=explode("/",trim($_SESSION['prev_page'],"/"));

					$urlArr[1]=$global_lang;

					$link=implode("/",$urlArr);

				}

			}

			return $config->http.trim($config->www,'/')."/".ltrim($link,"/");
		}

		return $config->http.trim($config->www,'/');
	}
	/**
	 * Zamienia wszystkie znaki na zgodne ze znakami dozwolonymi w URL
	 *
	 * @param string $text tekst do zmiany
	 * @return string zmieniony tekst
	 */
	function replace_titles($text)
	{
		$search=array('.',' ','/','\'','&','%','','','','','','','','','','','','','','','','','','','"');
		$replace=array('_','_','-','-','and','procent','c','s','a','z','o','l','z','n','e','e','s','c','o','a','l','z','z','n','_');

		$text=strtolower($text);


		$text=html_entity_decode($text);

		$text=str_replace($search,$replace,$text);

		return $text;
	}
	/**
	 * Generuje URL dla mod rewrite
	 *
	 * @param string $url link z parametrami PHP
	 * @param string $name dodatkowa nazwa umieszczana na koncu wygenerowanego linku
	 * @param string $sep separator odzielajacy poszczegolne parametry w wygenerowanym linku 
	 * @return string wygenerowany link
	 */
	function google_url($url, $name='', $sep="/")
	{
		global $config;

		if (isset($_SESSION['global_lang']))
		$global_lang=$_SESSION['global_lang'];
		else
		$global_lang=$config->lang;

		$type='';

		if (!empty($config->rewrite) && $global_lang!="ru")
		{
			$purl=parse_url($url);

			if (array_key_exists("query", $purl))
			$query=explode("&", $purl['query']);
			else
			$query=array();

			if (strpos($purl['path'],'_info') !== false)
			{
				$google_url='p';
				$type='p';
			}
			else
			if (strpos($purl['path'],'_category') !== false)
			{
				$google_url="c";
				$type='c';
			}
			else
			if (strpos($purl['path'],'_files') !== false)
			{

				$google_url="f";
				$type='f';
			}
			else
			if (strpos($purl['path'],'_promotion') !== false)
			{
				$google_url="pr";
				$type='pr';
			}
			else
			if (strpos($purl['path'],'_lang') !== false)
			{
				$google_url="l";
				$type='l';
			}
			else
			if (strpos($purl['path'],'_newsedit'))
			{

				$purl['path']=str_replace("/plugins/_newsedit/news","",$purl['path']);
				$purl['path']=str_replace("index.php","",$purl['path']);
				return $config->http.trim($_SERVER['HTTP_HOST'],'/').$sep."news".$sep.$global_lang.$purl['path'].$this->replace_titles(trim($name)).".html";
			}
			else
			if (strpos($purl['path'],'_search/full_search.php'))
			{
				$google_url="s";
				$type='s';
			}
			else
			if (strpos($purl['path'],'_map_site'))
			{
				$google_url="sm";
				$type='sm';
			}
			else
			$google_url='';

			if (!empty($type))
			{
				if ($type != "l")
				{
					if (isset($_SESSION['global_lang']))
					$google_url.=$sep.$_SESSION['global_lang'];
					else
					$google_url.=$sep.$config->lang;
				}

				foreach ($query as $val)
				{
					$val=explode("=",$val);
					if ($val[0] != 'scat_name')
					{
						if ($val[0]=='idc' || $val[0]=='cidc') {
							$val[1]=str_replace("id_","",$val[1]);
						}
						elseif ($val[0]=='file') $val[1]=str_replace(".html",'',$val[1]);

						if ($type=='s')
						$google_url.=$sep.urlencode($val[1]);
						else
						$google_url.=$sep.$this->replace_titles($val[1]);
					}
				}



				if (!empty($name))
				$google_url.=$sep.$this->replace_titles(trim($name));




				return $config->http.trim($_SERVER['HTTP_HOST'],'/')."/".$google_url.".html";
			}
		}

		if (strpos($url, "?") !== false)
		{
			if (strpos($url, "lang=") === false)
			$url.="&lang=".$global_lang;
		}
		else
		{
			if (strpos($url, "lang=") === false)
			{
				if (isset($_SESSION['global_lang']))
				$url.="?lang=".$_SESSION['global_lang'];
				else
				$url.="?lang=".$config->lang;
			}
		}

		if (strpos($url,"&amp;") === false)
		return htmlspecialchars($url);

		return $url;
	}
	/**
	 * Zwraca link uzywany przez obiekt navigationPath
	 *
	 * @param string $url url linku
	 * @param string $name nazwa linku
	 * @param string $attr dodatkowe atrybuty dla linku jak style, title itp...
	 */
	function navigationLink($url, $current=false,$name='', $attr='')
	{
		if (empty($name)) $name=$url;
		if ($current)
		return "<a class=\"currentNavLink\" href=\"$url\" $attr>$name</a>";

		return "<a class=\"NavLink\" href=\"$url\" $attr>$name</a>";


	}
	/**
	 * znacznik otwierajacy drzewo
	 *
	 * @param string $idc id kategorii
	 * @param bool $hide
	 */
	function treeNodesOpen($idc='', $hide)
	{
		if ($hide)
		echo "<div id=\"$idc\" style=\"display: none\">\n";
		else
		echo "<div id=\"$idc\">\n";
	}
	/**
	 * znacznik zamykajacy drzewo
	 *
	 */
	function treeNodesClose()
	{
		echo "</div>\n";
	}
	/**
	 * Znacznik otwierajacy element
	 *
	 * @param unknown_type $class
	 */
	function treeElementOpen($class)
	{
		//echo "<li class=\"$class\">\n";
	}
	/**
	 * znacznik zamykajacy element
	 *
	 */
	function treeElementClose()
	{

		//echo "</li>\n";
	}
	/**
	 * Element drzewa
	 *
	 * @param string $name nazwa elementu
	 * @param string $idc id kategorii
	 * @param int $level poziom zagniezdzenia kategorii
	 * @param int $count ilosc podkategorii (count=0 jesli brak podkategorii)
	 * @param bool $hide true - ukryj podkategoriee, false - pokaz podkategorie
	 */
	function treeElement($name, $idc, $level, $count, $lastCat,$hide=true)
	{
		global $config;

		if (isset($_REQUEST['idc']))
		$current_idc=$_REQUEST['idc'];
		else
		$current_idc='';
		$padding=10*($level-1);

		$this->DesktopOpen3Horizontal($this->config['boxh3_category'.$level],"100%","","middle","left");
		echo "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\">";
		if ($count > 0)
		echo "<tr><td style=\"padding-left: {$padding}px\"><div class=\"pseudoLink\" onclick=\"var list=_$('$idc'); if (visible(list)) { hide_list(list); this.innerHTML='".htmlspecialchars($this->desktopBoxImageReturn('box_cat_icon_closed'))."' } else { show_list(list); this.innerHTML='".htmlspecialchars($this->desktopBoxImageReturn('box_cat_icon_open'))."' }\">";
		else
		echo "<tr><td style=\"padding-left: {$padding}px\">";
		if ($hide)
		{
			if ($current_idc == $idc)
			$this->desktopBoxImage('box_cat_icon_open');
			else
			$this->desktopBoxImage('box_cat_icon_closed');
		}
		else
		$this->desktopBoxImage('box_cat_icon_open');

		$tree_url="/go/_category/?idc=$idc";
		if (isset($_SESSION['__order_main']) && !empty($_SESSION['__order_main'])) {
			$tree_url.="&order=".$_SESSION['__order_main'];
		} elseif (isset($_REQUEST['order']) && !empty($_REQUEST['order'])) {
			$tree_url.="&order=".$_REQUEST['order'];
		} else {
			if ($config->main_order_default=='price') {
				$main_order_default='price_brutto';
			} elseif (strpos($config->main_order_default,"name") !== false) {
				$main_order_default="name";
			} else {
				$main_order_default=$config->main_order_default;
			}
			$order_id=array_search($main_order_default,$config->dbedit_order_names['main']);
			$tree_url.="&order=$order_id";
		}

		$tree_url.="&page=1";

		if (isset($_SESSION['__producer_filter']) && !empty($_SESSION['__producer_filter'])) {
			$tree_url.="&producer_id=".$_SESSION['__producer_filter'];
		} elseif (isset($_REQUEST['producer_filter']) && !empty($_REQUEST['producer_filter'])) {
			$tree_url.="&producer_id=".$_REQUEST['producer_filter'];
		} else {
			$tree_url.="&producer_id=0";
		}

		if (isset($_SESSION['__record_row_type']) && !empty($_SESSION['__record_row_type'])) {
			$tree_url.="&record_row=".$_SESSION['__record_row_type'];
		} else {
			$tree_url.="&record_row=".$config->record_row_type_default;
		}

		if ($count > 0){
			echo "</div>";
		}
		echo "</td><td><a href=\"".$this->google_url($tree_url,$name)."\">$name</a>";
		echo "</td></tr>";
		echo "</table>";
		$this->DesktopClose3Horizontal($this->config['boxh3_category'.$level]);

	}

	function desktopBoxImageReturn($name)
	{
		$bufor= "<img border=\"0\" src=\"".$this->filepath('_img/'.$this->config[$name][1].'')."\" alt=\"\" />";
		return $bufor;
	}

	function custom_404()
	{
		$this->file("custom_404.html");
	}
	/**
	 * Funkcja zmieniajaca HTML na odpowiadajacy mu format tekstowy 
	 *
	 * @param string $html string zawierajacy format html
	 * @return string zawierajacy format tekstowy
	 */
	function html2txt($html) {
		$html=str_replace(array("\r","\n","\t"),array("","",""),$html);
		$html=str_replace(array("</p>","<br />"),array("</p>\n","\n"),$html);
		$html=str_replace(array("&Oacute;","&oacute;"),array("",""),$html);
		$html=strip_tags($html);
		$html=html_entity_decode($html,ENT_QUOTES);
		$tmp=explode("\n",$html);
		$html="";
		foreach ($tmp as $val) {
			$html.=trim($val)."\n";
		}
		
		return $html;
	}

} // end class Theme

// sprawdz czy sa rozszezenia klas Theme z ktoryms ze zdefinicowanych tematow
$inode=@fileinode("$DOCUMENT_ROOT/themes/base/$config->theme/theme.inc.php");
if ($inode>0) {
	// temat koncowy
	include_once("$DOCUMENT_ROOT/themes/base/$config->theme/theme.inc.php");
} else {
	// sprawdz temat glowny
	$inode2=@fileinode("$DOCUMENT_ROOT/themes/base/$config->base_theme/theme.inc.php");
	if ($inode2>0) {
		include_once("$DOCUMENT_ROOT/themes/base/$config->base_theme/theme.inc.php");
	}
} // end if

// sprawdz czy s pliki konfiguracyjne w zdefiniowanej hierarchii tematw, odczytaj wszystkie
// definicje konfiguracji w kolejnoci od gwnego tematu do kocowego

@include_once ("themes/base/base_theme/config/config.inc.php");          // temat gwny
@include_once ("themes/base/$config->base_theme/config/config.inc.php"); // temat bazowy
@include_once ("themes/base/$config->theme/config/config.inc.php");      // temat kocowy
@include_once ("themes/base/$config->theme/config/user_config.inc.php");      // temat kocowy uytkownika


// sprawdz czy sa lokalne rozszerzenia klasy Theme
@include_once ("./themes/theme.inc.php");

// jesli nie znaleziono zadnej klasy ExtTheme, wedlug ktorej jest utowrzony obiekt $theme
// to utworz standardowy obiekt $theme
if (empty($theme)) {
	$theme =& new Theme;
}
?>