<?php 
/**
 * Klasa do obslugi dynamicznych kontrolek Formularzy
 * 
 * @author marcin.butlak@sote.pl
 * @version $Id: jsFormControls.inc.php,v 1.2 2007-09-03 12:44:32 marcin Exp $
 * @copyright sote
 *
 */
class jsFormControls
{
	private $index=500;
	public function __construct()
	{
		echo "<script type=\"text/javascript\">var menuActive=null;</script>";
	}
	/**
	 * Wyswietl dynamiczna kontrolke Select
	 *
	 * @param string $name nazwa kontrolki formularza
	 * @param string $title tytul kontrolki
	 * @param array $options elementy kontrolki array("klucz1"=>"wartosc1","klucz2"=>"wartosc2",...)
	 * @param string $currentKey aktualnie wybrany klucz z elementow kontrolki np: "klucz1"
	 * @param string $cssClass nazwa klasy CSS stylujaca kontrolke
	 */
	public function showSelect($name, $title, $options, $currentKey, $width=100,$cssClass='jsfcSelect')
	{
		ob_start();
		$no=0;
		$idMenu=$name."Menu";
		$idInput=$name."Input";
		$idHidden=$name."Hidden";

		if (array_key_exists($currentKey, $options))
		$current=htmlspecialchars($options[$currentKey]);
		else
		{
			$current=$currentKey;
			$currentKey='';
		}

		
		$onclick="var m=document.getElementById('$idMenu'); if (m) { m.style.display='block'} if (menuActive) { menuActive.style.display='none'; } if (menuActive==m) menuActive=null; else menuActive=m;";
		$onclickelement="var m=document.getElementById('$idMenu'); if (m) { m.style.display='none'; menuActive=null; }";
		$onkeyup="getElementById('$idHidden').value=''; $onclickelement";

		echo "<div class=\"$cssClass\"><div style=\"z-index: $this->index; position: absolute; width: {$width}px; margin: 0px\" >\n";
		echo "<input type=\"text\" name=\"{$name}[value]\" value=\"$current\" title=\"$title\" id=\"$idInput\" class=\"jsfcInput\" onkeyup=\"$onkeyup\" onmousedown=\"$onclick\" autocomplete=\"off\" />\n";
		echo "<input type=\"hidden\" name=\"{$name}[key]\" value=\"".htmlspecialchars($currentKey)."\" id=\"$idHidden\" />\n";
		if (!empty($options))
		{
			echo "<div class=\"jsfcMenu\" id=\"$idMenu\" onclick=\"$onclickelement\">\n";
			foreach ($options as $key=>$value)
			{
				$no++;
				$idel=$name.intval($no);
				$onclick="var i=document.getElementById('$idInput'); var s=document.getElementById('$idel'); var h=document.getElementById('$idHidden'); var v=document.getElementById('value_$idel'); i.value=v.value;  h.value=s.value";
				echo "<input type=\"hidden\" value=\"".htmlspecialchars($key)."\" id=\"$idel\" name=\"$idel\" />\n";
				echo "<input type=\"hidden\" value=\"".htmlspecialchars($value)."\" id=\"value_$idel\" id=\"value_$idel\" />\n";
				echo "<a href=\"#\" class=\"jsfcElement\" onclick=\"$onclick\">".htmlspecialchars($value)."</a>\n";
			}
			echo "</div>\n";
		}
		echo "</div>\n</div>";
		$this->index--;
		ob_end_flush();
	}


}
?>