<?php
/**
* Utworz tabele z aktywnymi ikonkami dot. funkcji i sklepu i systemow platnosci
*
* @author  m@sote.pl
* @version $Id: set_icons.inc.php,v 1.2 2007-07-10 16:26:29 marek Exp $
* @package    admin_include
*/

class SetIcons {

    /**
    * Dodaj ikone do tablicy, jesli user posiada odpowiednie uprawnienia
    *
    * @param addr   $tab  tablica z ikonkami
    * @param string $img  nazwa pliku graf. ikonki
    * @param string $link link do ktorego prowadzi ikonka
    * @param string $text opis ikonki
    *
    * @return bool  true element zostal dodany do tablicy, false w p.w.
    */
    function add(&$tab,$img,$link,$text) {
        global $permf,$theme;

        // sprawdz uprawnienia uzytkwonika
        if (! $permf->check_link($link)) return;

        $icon=$theme->icon($img,$link,$text);
        array_push($tab,$icon);

        return true;
    } // end add()

    /**
    * Generuj tablice z zaktywnymi ikonkami glownymi panelu
    *
    * @return array tablica z kodem wyswietlania komorek zawierajacych ikonki
    */
    function main() {
        global $config,$lang,$theme;

        // wyswietl desktop z ikonkami
        $icons=array();         // tabela z ikonkami, ktore beda wyswietlane

        $this->add($icons,"edit.jpg","/go/_wysiwyg/index.php",$lang->icons['text']);
        $this->add($icons,"newsedit.jpg","/plugins/_newsedit/index.php",$lang->icons['newsedit']);
        $this->add($icons,"offline.jpg","/go/_offline/_main/index.php",$lang->icons['offline']);
        $this->add($icons,"opti.jpg","/go/_opt/index.php",$lang->icons['opt']);
        $this->add($icons,"clients.jpg","/go/_users/index.php",$lang->icons['customers']);
        $this->add($icons,"trans.jpg","/go/_order/index.php",$lang->icons['orders']);
        $this->add($icons,"deliver.jpg","/go/_options/_delivery/index.php",$lang->icons['delivery']);

        if (in_array("newsletter",$config->plugins)) {
            if($config->nccp=="0x01f4")
            $this->add($icons,"lang.jpg","/go/_lang_editor/index.php",$lang->icons["lang"]);
            else
            $this->add($icons,"lang.jpg","/plugins/_dictionary/index.php",$lang->icons["lang"]);
        }

        $this->add($icons,"aable.jpg","/go/_options/_available/index.php",$lang->icons['availability']);

        if (in_array("currency",$config->plugins)) {
            $this->add($icons,"course.jpg","/plugins/_currency/index.php",$lang->icons['currency']);
        }

        if (in_array("newsletter",$config->plugins)) {
            $this->add($icons,"news.jpg","/plugins/_newsletter/_users/index.php",$lang->icons['newsletter']);
        }

        if (in_array("discounts",$config->plugins)) {
            $this->add($icons,"discount.jpg","/plugins/_discounts/index.php",$lang->icons['discounts']);
        }

        $this->add($icons,"recommend.jpg","/plugins/_reviews/index.php",$lang->icons['reviews']);
        $this->add($icons,"partners.jpg","/plugins/_partners/index.php",$lang->icons['partners']);

        if (in_array("stats_pro",$config->plugins)) {
            $this->add($icons,"stats.jpg","/go/_report/index.php",$lang->icons['stats']);
        }

        if (in_array("main_keys",$config->plugins)) {
            $this->add($icons,"keys.jpg","/plugins/_main_keys/index.php",$lang->icons['main_keys']);
        }


        /**
         * @deprecated since 4.0
         *
        //  if (in_array("cd",$config->plugins)) {
        //    $this->add($icons,"cd.jpg","/plugins/_cd/index.php",$lang->icons['cd']);
        // }
        */


        //        $this->add($icons,"google.jpg","/go/_google/index.php",$lang->icons['google']);

        $this->add($icons,"theme.jpg","/plugins/_themes/index.php",$lang->icons['theme']);
        $this->add($icons,"config.jpg","/go/_main_configure/index.php",$lang->icons['config']);

        if (in_array("discounts",$config->plugins)) {
            $this->add($icons,"promo.jpg","/plugins/_promotions/index.php",$lang->icons['promotions']);

            // $this->add($icons,"help.jpg","/go/_help/index.php",$lang->icons['help']);
        }
        if ($config->admin_lang=="pl") {
            $this->add($icons,"pasaze.jpg","/plugins/_pasaz.wp.pl/index.php",$lang->icons['pasaze']);
            $this->add($icons,"porownywarki.jpg","/plugins/_PorownywarkiCen/_Ceneo/index.php",$lang->icons['porownywarki']);
            $this->add($icons,"allegro.jpg","/plugins/_allegro.pl/config.php",$lang->icons['allegro']);
        }

        $this->add($icons,"mapa_serwisu1.jpg","/go/_map_site/index.php",$lang->icons['map_site']);
        $this->add($icons,"update.jpg","/go/_upgrade/index.php",$lang->icons['upgrade']);

        return $icons;
    } // end main()

    /**
    * Generuj tablice z zaktywnymi ikonkami zwiazanymi z systemami platnosci, pasazami itp.
    *
    * @return array tablica z kodem wyswietlania komorek zawierajacych ikonki
    * @deprecated since 4.0RC10
    */
    function orders() {
        return array();

    } // end orders()

    /**
    * Ustaw ikonky dot. platnosci zagranicznych
    *
    * @return array tablica z danymi ikon
    */
    function ordersEn() {
        global $config,$lang,$theme,$permf;
        $icons=array();
        if (! $permf->check("all")) return $icons;
        if ((in_array("paypal",$config->plugins)) && ($config->admin_lang!="pl")) {
            $this->add($icons,"paypal_logo.png","/plugins/_pay/_paypal/index.php","PayPal.com");
        }
        return $icons;
    } // end ordersEn()

}  // end class SetIcons

?>
