<?php
/**
 *
 * Interfejs obiektow ktore beda implementowaly optymalizacje w sklepie
 * 
 * @author marcin.butlak@sote.pl
 * @package Optimalization
 * @subpackage OptimalizationInterface
 * @version $Id: OptimalizationInterface.inc.php,v 1.3 2007/04/13 16:01:52 marcin Exp $
 * @copyright sote 
 */
interface OptimalizationInterface {
    /**
     * Metoda liczaca wszystkie obiekty do przetworzenia
     * 
     * @return int
     */
    public function count();
    
    /**
     * Metoda zwracajaca ilosc przetworzonych obiektow podczas 1 przebiegu optymalizacji
     * 
     * @return int
     */
    public function processedCount();
    
    /**
     * Metoda zwracaja stan optymalizacji
     *      
     * @return bool true - jezeli optymalizacja dobiegla konca, false - optymalizacja niezakonczona 
     */
    public function finished();
    /**
     * Metoda wywolywana podczas 1 przebiegu optymalizacji
     *
     */
    public function optimize();
    /**
     * Metoda czysczaca zmienne sesyjne - wywolywana po zakoczeniu optymalizacji
     *
     */
    public function cleanSession();
    /**
     * Metoda zapamietujaca zmienne sesyjne - wywolywana po wykonaniu metody optimize()
     *
     */
    public function saveSession();
     /**
     * Metoda ladujaca zmienne sesyjne - wywolywana przed wykonaniem metody optimize()
     * 
     */   
    public function loadSession();
    /**
     * Metoda tworzaca plik z optymalizacja - wywolywana po zakonczeniu procesu optymalizacji
     *
     */
    public function saveToFile();
}
?>