<?php
/**
 * Klasa gwna od obsugi porownywarek cen.
 * 
 * @author michal.prochowski@sote.pl
 * @package SPorownywarkiCen
 * @subpackage SPorownywarkiCen
 * @version $Id: SPorownywarkiCen.inc.php,v 1.2 2007-10-09 18:44:23 michal Exp $
 * @copyright sote 
 */

/**
 * Includowanie potrzebnych klas 
 */
require_once('lib/SPorownywarkiCen/SPorownywarkiCen.interface.inc.php');
require_once('lib/SProgress/SProgressBar.inc.php');
require_once('include/ftp.inc.php');
require_once('lib/SDConvertText/class.SDConvertText.php');
require_once('lib/ConvertCharset/ConvertCharset.class.php');
require_once('include/image.inc');

/**
 * Klasa SPorownywarkiCen
 *
 */
class SPorownywarkiCen implements SProgressInterface {

	/**
	 * Obiekt sucy do konwersji tekstu np. zamiana & na &amp; , wycinania html'a z string'a
	 *
	 * @var object
	 */
	public $SDConvertText;
	
	/**
	 * Obiekt sucy do zmiany kodowanie tekstu
	 *
	 * @var object
	 */
	public $ConvertCharset;
	
	/**
     * Funkcja liczaca wszystkie jednostki ktore sa do przetworzenia
     * 
     * @return int
     */
    public function progressCountAll()
    {
    	/*
    	 * $this->progressCountAll musi by rwne iloci rekordw + 1
    	 */
    	return $this->getCountDatabase()+1;
    }
    
    /**
     * Funkcja liczaca ile jest jednostek w pojedynczym pakiecie
     * 
     * @return int
     */
    public function progressCountPackage()
    {	
    	return $this->getProgressCountPackage();
    }
    
    /**
     * Ostatni element, ktory byl przetworzony w poprzednim wywolaniu
     *      
     * @param int $last
     * @return int
     */
    public function progressNext( $last = 0 )
    {
    	global $lang;
    	global $config;
    	
		if ($last < $this->progressCountAll())
		{
			return $this->_saveFile( $last );
		} elseif ($last >= $this->progressCountAll())
		{
			$this->_saveFile( -1 );
			$this->_copyFile();

			$exception_text = $lang->SPorownywarkiCen['file'].$this->getModuleName().$lang->SPorownywarkiCen['generated']."<br />";
			$exception_text.= $lang->SPorownywarkiCen['file_url']."<br />http://".$config->www."/xml/".$this->getFileName()."<br />";
			$exception_text.= "<a href=\"http://".$config->www."/xml/".$this->getFileName()."\" target=\"_blank\">".$lang->SPorownywarkiCen['file_get']."</a>";
			throw new SProgressException($exception_text,1);
		} else {
			throw new SProgressException($lang->SPorownywarkiCen['fatal_error'],99);
		}
    }
		
    /**
     * Konstruktor
     *
     */
    public function __construct()
    {
    	/*
    	* Tworzenie obiektw
    	*/
    	$this->SDConvertText = new SDConvertText;
    	$this->ConvertCharset = new ConvertCharset;
    }

    /**
     * Funkcja zapisuje dane wejciowe do pliku w katalogu "admin/tmp", zwraca ona offset + 1
     * 
     * @param integer $offset
     * @return integer 
     */
	private function _saveFile( $offset )
	{
		global $DOCUMENT_ROOT;
		global $lang;
		
		$xml = "";
		$file = $this->getFileName();
		$filePath = $DOCUMENT_ROOT."/tmp/";
		
		if ( $offset == 0 )
		{
			/*
			* Sprawdzanie locka, jeli jest kasujemy wygenerowany plik i wywoujemu wyjtek
			*/
			if (!$this->_CheckLock())
			{
				if (file_exists($filePath.$file))
				{
					unlink($filePath.$file);
				}
				
				throw new SProgressException($lang->SPorownywarkiCen['lock']." ".$this->getModuleName().".", 6);
			}
			
			/*
			* Zakadanie locka
			*/
			$this->_Lock();
			
			/*
			* Generowanie nagwka xml'a
			*/
			$xml.= $this->fileHead();
		}
		if ( $offset >= 0 )
		{
			/*
			* Generowanie inforamcji o produkcie
			*/
			$this->getDatabase( $offset );
			$xml.= $this->fileBody();
		}
		if ( $offset == -1 )
		{
			/*
			* Zdejmowanie locka
			*/
			$this->_Unlock();
			
			/*
			* Generowanie stopki xml'a
			*/
			$xml.= $this->fileFoot();
		}
		
		/*
		* Zapisywanie xml'a do pliku w admin/tmp
		*/
		$fh = fopen( $filePath.$file, "a+" );
		if ( $fh )
		{
			fputs($fh, $xml);
			fclose( $fh );
		}
		
		/*
		* Zwracanie kolejnego numeru pakietu
		*/
		return $offset + $this->progressCountPackage();
	}
	/**
	 * Funkcja kopiuje plik z katalogu "admin/tmp" do "htdocs/"
	 *
	 * @return true
	 */
	private function _copyFile()
	{
		global $ftp;
        global $DOCUMENT_ROOT;
        global $config;
       
        $file = $this->getFileName();
        $filePath = $DOCUMENT_ROOT."/tmp/".$file;
        $fileTarget = $config->ftp_dir."/htdocs/xml/";
        
        /*
        * Wysyanie pliku do htdosc za pomoc FTP
        */
        $ftp->connect();
        $ftp->put( $filePath, $fileTarget, $file );
        $ftp->close();
        
        // Poprawka bledu na home.pl z $ftp->put();
        // unlink musi by !!
        @unlink($filePath);
        
        return true;
	}
		
	/**
	 * Dodanie locka do bazy danych
	 *
	 * @return true
	 */
	private function _Lock ()
	{
		global $mdbd;
		
		$text = "S".$this->getModuleName()."GenerateFile";
		
		$mdbd->insert("`lock`","name,value,date","'$text',1,UNIX_TIMESTAMP()");
		return true;
	}
	
	/**
	 * Usuwanie locka z bazy danych
	 *
	 * @return true
	 */
	private function _Unlock ()
	{
		global $mdbd;
		
		$text = "S".$this->getModuleName()."GenerateFile";
		
		$mdbd->delete("`lock`","name=?",array($text=>"text"));
		return true;
	}
	
	/**
	 * Sprawdzanie czy zosta waczony lock na generowanie pliku
	 *
	 * @return bool 
	 */
	private function _CheckLock ()
	{
		global $mdbd;
		
		$text = "S".$this->getModuleName()."GenerateFile";
		
		$lock = $mdbd->select("value,date","`lock`","name=?",array($text=>"text")," ORDER BY `id` DESC LIMIT 1");
		$time = time() - $lock['date'];
				
		if ($lock['value'] == 1 and $time < 900)
		{
			return false;
		} elseif ($lock['value'] == 1 and $time > 900) 
		{
			$this->_Unlock();
			return true;
		}
		return true;
	}
	
	/**
	 * Funkcja generujca link partnera
	 *
	 * @return string
	 */
	public function PartnerLink ()
	{
		global $mdbd;
		global $config;
		
		$data = $mdbd->select("partner_id, name","partners","name=?",array($this->getModuleName() => "string"));
		$partner_id = $data['partner_id'];
        $code = md5("partner_id.$partner_id.$config->salt");
        $link = "&amp;partner_id=".$partner_id."&amp;code=".$code;
        return $link;
	}
	
	/**
	 * Makieta funkcji fileHead
	 *
	 * @return true
	 */
	public function fileHead()
	{
		return true;
	}
	
	/**
	 * Makieta funkcji fileBody
	 *
	 * @return true
	 */
	public function fileBody()
	{
		return true;
	}
	
	/**
	 * Makieta funkcji fileFoot
	 *
	 * @return true
	 */
	public function fileFoot()
	{
		return true;
	}
	
	/**
	 * Makieta funkcji getModuleName
	 *
	 * @return true
	 */
	public function getModuleName()
	{
		return true;
	}
	
	/**
	 * Makieta funkcji getModuleName
	 *
	 * @return true
	 */
	public function getFileName()
	{
		return true;
	}
	
	/**
	 * Makieta funkcji getCountDatabase
	 *
	 * @return true
	 */
	public function getCountDatabase()
	{
		return true;	
	}
	
	/**
	 * Makieta funkcji getDatabase
	 *
	 * @return true
	 */
	public function getDatabase( $offset )
	{
		return true;	
	}
}

?>
