<?php
/**
 * Przykladowe wykorzystanie SProgressBara
 * 
 * @author lukasz.andrzejak@sote.pl
 * @package SProgressBar
 * @subpackage SProgressBarDemo
 * @version $Id: SProgress.example.php,v 1.3 2007/04/23 09:49:42 marcin Exp $
 * @copyright sote 
 */


$global_database=true;$__start_page=true;
$DOCUMENT_ROOT=$HTTP_SERVER_VARS['DOCUMENT_ROOT'];

include_once ("../../../include/head.inc");

require_once('lib/SProgress/SProgressBar.inc.php');
require_once('lib/SProgress/SProgressMessage.inc.php');

/**
 * Demo stworzenia klasy dajacej sie podpiac do SProgressBara
 * W tej klasie, jej rodzicach itd w zadnym wypadku nie mozna niczego printowac!!!
 * Jezeli wyprintujemy cos w xml'u ktorym komunikuje sie xajax to kicha.
 *
 */
class SProgressDemo extends SProgressMessage implements SProgressInterface {
    
    /**
     * Ile jest wierszy do przetworzenia
     *
     * @var int
     */
    private $_all=1000;
    
    /**
     * Ile wierszy jest przetwarzanych na jeden raz
     *
     * @var int
     */
    private $_perPackage=10;
    
    /**
     * Zwracamy ile jest wierszy do przetworzenia
     *
     * @return int
     */
    public function progressCountAll() {
        return $this->_all;
    }
    
    /**
     * Zwracamy ile wierszy jest przetwarzanych na raz
     *
     * @return int
     */
    public function progressCountPackage() {
        return $this->_perPackage;
    }
    
    /**
     * 'Przetwarzamy' ;) kolejne wiersze
     *
     * @param int $last
     * @return int
     * @throws SProgressException
     */
    public function progressNext($last=0) {
    	
    	
    	// zeby troszke urozmaicic podczas kolejnych przebiegow wyswietlamy co np. aktualnie robimy (ja sobie pokazuje aktualny czas ;-))
    	$this->setMessage("Pamietaj, ten komunikat aktualizowany jest tylko przy kolejnym przebiegu: ".date("H:m:s"));
        // tutaj cos robimy 
        $this->doSomething($last);
        // zwiekszamy aktualnie przetwarzany pakiet
        $next=$last+$this->_perPackage;
        // jezeli to juz koniec wyswietla komunikat koncowy (jezeli nie podamy komunikatu zostanie uzyty domyslny komunikat Progress bara)
        if ($next==$this->_all) $this->endMessage('Niesamowite skonczylem ;-)');
        else return $next;
        // jezeli nie wyrzucamy wyjatka i nie zwrocilismy jeszcze adresu nastepnego pakietu
        // do przetworzenia - to poszlo cos bardzo nie tak
        // dajemy sobie spokoj i wylaczamy sie (opcjonalnie mozemy podac numer wyjatku jako 2 parametr, co robia poszczegolne wyjatki mozna podejrzec w klasie SProgressBar.inc.php)
        $this->throwError('Zonk uciekamy');
    }
    
    /**
     * Cos tam sobie przetwarzamy
     * UWAGA!!! W calej klasie nie wolno niczego printowac - jedyny sposob na komunikacje ze swiatem to wyjatki
     *
     * @param int $last
     * @return void
     */
    function doSomething($last) {
//        print $last.'<br>';
        return (0);
    }
}

/**
 * Tutaj jest samo wywolanie na stronie
 * Wczesniej nalezy oczywiscie wywolac heada, porobic co tylko chcemy itd.
 * Nie nalezy jednak niczego wyswietlac na przegladarke - tym zajmie sie klasa progressbara
 */



// tworzymy nowy obiekt ktory bedzie nam przetwarzal dane
$demo=new SProgressDemo();

// tworzymy nowego progressBara
$progressBar=new SProgressBar($demo);

// ustawiamy komunikaty, langi itd w progressbarze (jest on w libach i nie ma swoich, domyslnie uzywa ogolnych langow panelu)
$progressBar->setMessages(@$lang->progress_messages);

// pozwalamy progressbarowi wykonac wymagane czynnosci
$progressBar->action();


?>