<?php
/**
 *
 * Klasa obslugi komunikatow obiektu SProgressBar
 * 
 * @author marcin.butlak@sote.pl
 * @package SProgressBar
 * @subpackage SProgressMessage
 * @version $Id: SProgressMessage.inc.php,v 1.6 2007/04/23 09:56:03 marcin Exp $
 * @copyright sote 
 */
require_once('lib/SProgress/SProgress.exceptions.inc.php');

abstract class SProgressMessage {
	
	private $message=''; // zmienna przechowujaca wiadomosc pokazywana po kazdym nowyn przebiegu 
	/**
	 * Wyrzuca wyjatek(blad) po stronie paska postepu
	 *
	 * @param string $message
	 * @param int $exception numer wyjatku
	 */
	protected function throwError($message, $exception=99)
	{
		throw new SProgressException($message,$exception);
	}
	/**
	 * Konczy wykonywanie paska postepu i pokazuje informacje
	 *
	 * @param string $message
	 */
	protected function endMessage($message)
	{
		throw new SProgressException($message,1);
	}
	/**
	 * Ustawia komunikat wyswietlany przy kolejnym przebiegu
	 *
	 * @param string $message komunikat
	 */
	protected function setMessage($message)
	{
		$this->message=$message;
	}
	/**
	 * zwraca komunikat ustwiony za pomoca setMessage
	 *
	 * @return string komunikat
	 */
	public function getMessage()
	{
		return $this->message;
	}
}
?>