<?php
/**
 * Klasa SCeneo
 * 
 * @author michal.prochowski@sote.pl
 * @package SPorownywarkiCen
 * @subpackage SCeneo
 * @version $Id: SCeneo.inc.php,v 1.2 2007-08-01 18:42:55 michal Exp $
 * @copyright sote 
 */

/**
 * Includowanie potrzebnych klas 
 */
require_once('lib/SPorownywarkiCen/SPorownywarkiCen.inc.php');

class SCeneo extends SPorownywarkiCen implements SPorownywarkiCenInterface {
	
	private $data;
	public $ModuleName = "Ceneo";
	public $fileName = "ceneo.xml";
	public $progressCountPackage = 100;
	
	public function getDatabase( $offset = 0 )
	{
		global $db, $mdbd;
		global $SDConvertText;
		global $config;
		global $image;
		
		$select = "m.id, m.user_id, m.name_L0, m.photo_uid, m.price_brutto, m.category1, m.category2, m.category3, m.category4, m.category5, m.producer, m.xml_description_L0, m.discount";
		
		$limit = "LIMIT ".$offset.", ".$this->getProgressCountPackage();
		$query = "SELECT $select FROM main m, porownywarki_cen pc WHERE pc.ceneo_export=1 AND m.active=1 AND m.user_id = pc.user_id ORDER BY m.id ASC ".$limit;
		
		$allow_html_tags = array("<br>","<li>","<p>","<ul>","<tr>");
		$PartnerLink = $this->PartnerLink();
		
		$this->data = array();
		$data = array();
		$prepared_query=$db->PrepareQuery($query);
		if ($prepared_query) {
			$result=$db->ExecuteQuery($prepared_query);
			if ($result!=0) {
				$num_rows=$db->NumberOfRows($result);
				if ($num_rows>0) {
					for ($i=0;$i<$num_rows;$i++) {
						$data[$i]['id']=$db->FetchResult($result,$i,"m.id");
						$data[$i]['user_id']=$db->FetchResult($result,$i,"m.user_id");
						$data[$i]['name']=$db->FetchResult($result,$i,"m.name_L0");
						$data[$i]['photo_uid']=$db->FetchResult($result,$i,"m.photo_uid");
						$data[$i]['price_brutto']=$db->FetchResult($result,$i,"m.price_brutto");
						$data[$i]['category1']=$db->FetchResult($result,$i,"m.category1");
						$data[$i]['category2']=$db->FetchResult($result,$i,"m.category2");
						$data[$i]['category3']=$db->FetchResult($result,$i,"m.category3");
						$data[$i]['category4']=$db->FetchResult($result,$i,"m.category4");
						$data[$i]['category5']=$db->FetchResult($result,$i,"m.category5");
						$data[$i]['producer']=$db->FetchResult($result,$i,"m.producer");
						$data[$i]['xml_description']=$db->FetchResult($result,$i,"m.xml_description_L0");
						$data[$i]['discount']=$db->FetchResult($result,$i,"m.discount");
						
						$data[$i]['name'] = htmlspecialchars($data[$i]['name']);
						$data[$i]['producer'] = htmlspecialchars($data[$i]['producer']);
						$data[$i]['category1'] = htmlspecialchars($data[$i]['category1']);
						$data[$i]['category2'] = htmlspecialchars($data[$i]['category2']);
						$data[$i]['category3'] = htmlspecialchars($data[$i]['category3']);
						$data[$i]['category4'] = htmlspecialchars($data[$i]['category4']);
						$data[$i]['category5'] = htmlspecialchars($data[$i]['category5']);
						$data[$i]['xml_description'] = $this->SDConvertText->dropHTML($data[$i]['xml_description'],$allow_html_tags);
						$data[$i]['xml_description'] = htmlspecialchars($data[$i]['xml_description']);
						$data[$i]['url'] = "http://".$config->www."/go/_info/?id=".$data[$i]['id'].$PartnerLink;
						$data[$i]['photo'] = $image->get_file($image->get_image_name(1, $data[$i]['photo_uid']), IMAGE_BIG, false, true);
						if ($data[$i]['discount'] > 0 && $data[$i]['discount'] < 100) 
            			{
            				$data[$i]['price_brutto'] = number_format($data[$i]['price_brutto'],2,",","");
                			$data[$i]['price_brutto'] = $data[$i]['price_brutto']-(($data[$i]['price_brutto']*$data[$i]['discount'])/100);
            			}
            			$data[$i]['price_brutto'] = number_format($data[$i]['price_brutto'],2,".","");
					}
				}
			} else die ($db->Error());
		} else die ($db->Error());
		
		$this->data = $data;
		return true;
	}
	
	public function getCountDatabase()
	{
		global $db;
		
		$result = $db->Query("SELECT count(m.id) as count FROM main m, porownywarki_cen pc WHERE pc.ceneo_export=1 AND m.active=1 AND m.user_id = pc.user_id");
		$count = $db->FetchResult($result, 0, 'count');
		
		return $count;
	}
	
	public function fileHead()
	{
		$xml = "<?xml version=\"1.0\" encoding=\"ISO-8859-2\"?>\n";
		$xml.= "<!DOCTYPE pasaz:Envelope SYSTEM \"loadOffers.dtd\">\n";
		$xml.= "<pasaz:Envelope xmlns:pasaz=\"http://schemas.xmlsoap.org/soap/envelope/\">\n";
		$xml.= "<pasaz:Body>\n";
		$xml.= "<loadOffers xmlns=\"urn:ExportB2B\">\n";
		$xml.= "<offers>\n";
		
		return $xml;
	}
	
	public function fileBody()
	{
		$xml = "";
		foreach ($this->data as $key => $value)
		{
			$xml.= "\t<offer>\n";
			$xml.= "\t\t<id>".$value['id']."</id>\n";
			$xml.= "\t\t<name>".$value['name']."</name>\n";
			$xml.= "\t\t<price>".$value['price_brutto']."</price>\n";
			$xml.= "\t\t<url>".$value['url']."</url>\n";
			$xml.= "\t\t<categoryId>".$value['category1'];
            if ( !empty( $value['category2'] ) ) $xml.= "/".$value['category2'];
            if ( !empty( $value['category3'] ) ) $xml.= "/".$value['category3'];
            if ( !empty( $value['category4'] ) ) $xml.= "/".$value['category4'];
            if ( !empty( $value['category5'] ) ) $xml.= "/".$value['category5'];
            $xml.= "</categoryId>\n";
//            $xml.= "\t\t<description>".$value['xml_description']."</description>\n";
            $xml.= "\t\t<image>".$value['photo']."</image>\n";

            $xml.= "\t\t<attributes>\n";
            $xml.= "\t\t\t<attribute>\n";
            $xml.= "\t\t\t\t<name>Producent</name>\n";
            $xml.= "\t\t\t\t<value>".$value['producer']."</value>\n";
            $xml.= "\t\t\t</attribute>\n";
            $xml.= "\t\t</attributes>\n";
			$xml.= "\t</offer>\n";
		}
	
		return $xml;
	}
	
	public function fileFoot()
	{
		$xml = "</offers>\n";
		$xml.= "</loadOffers>\n";
		$xml.= "</pasaz:Body>\n";
		$xml.= "</pasaz:Envelope>\n";
		
		return $xml;
	}
	
	public function getFileName()
	{
		return $this->fileName;
	}
	
	public function getProgressCountPackage()
	{
		return $this->progressCountPackage;
	}
	
	public function getModuleName()
	{
		return $this->ModuleName;
	}
}
?>
