<?php
/**
 * Klasa SInteria
 * 
 * @author michal.prochowski@sote.pl
 * @package SPorownywarkiCen
 * @subpackage SInteria
 * @version $Id: SInteria.inc.php,v 1.2 2007/05/29 07:15:46 michal Exp $
 * @copyright sote 
 */

/**
 * Includowanie potrzebnych klas 
 */
require_once('lib/SPorownywarkiCen/SPorownywarkiCen.inc.php');
require_once('config/auto_config/interia_config.inc.php');

class SInteria extends SPorownywarkiCen implements SPorownywarkiCenInterface {
	
	private $data;
	private $dataCategory;
	public $ModuleName = "Interia";
	public $fileName = "interia.xml";
	public $progressCountPackage = 100;
	
	public function getDatabase( $offset = 0 )
	{
		global $db, $mdbd;
		global $SDConvertText;
		global $config;
		global $image;
		
		$select = "m.id, m.user_id m.name_L0, m.price_brutto, m.id_category1, m.producer, m.discount";
		
		$limit = "LIMIT ".$offset.", ".$this->getProgressCountPackage();
		$query = "SELECT $select FROM main m, porownywarki_cen pc WHERE pc.interia_export=1 AND m.active=1 AND m.user_id = pc.user_id ORDER BY m.id ASC ".$limit;
		
		$PartnerLink = $this->PartnerLink();
		
		$this->data = array();
		$data = array();
		$prepared_query=$db->PrepareQuery($query);
		if ($prepared_query) {
			$result=$db->ExecuteQuery($prepared_query);
			if ($result!=0) {
				$num_rows=$db->NumberOfRows($result);
				if ($num_rows>0) {
					for ($i=0;$i<$num_rows;$i++) {
						$data[$i]['id']=$db->FetchResult($result,$i,"m.id");
						$data[$i]['user_id']=$db->FetchResult($result,$i,"m.user_id");
						$data[$i]['name']=$db->FetchResult($result,$i,"m.name_L0");
						$data[$i]['price_brutto']=$db->FetchResult($result,$i,"m.price_brutto");
						$data[$i]['id_category1']=$db->FetchResult($result,$i,"m.id_category1");
						$data[$i]['producer']=$db->FetchResult($result,$i,"m.producer");
						$data[$i]['discount']=$db->FetchResult($result,$i,"m.discount");
						
						$data[$i]['name'] = htmlspecialchars($data[$i]['name']);
						$data[$i]['producer'] = htmlspecialchars($data[$i]['producer']);
						if ($data[$i]['discount'] > 0 && $data[$i]['discount'] < 100) 
            			{
            				$data[$i]['price_brutto'] = number_format($data[$i]['price_brutto'],2,",","");
                			$data[$i]['price_brutto'] = $data[$i]['price_brutto']-(($data[$i]['price_brutto']*$data[$i]['discount'])/100);
            			}
            			$data[$i]['price_brutto'] = number_format($data[$i]['price_brutto'],2,".","");
					}
				}
			} else die ($db->Error());
		} else die ($db->Error());
		
		$this->data = $data;
		return true;
	}
	
	public function getCategory()
	{
		global $db;
		
		$query = "SELECT m.id, m.category1, m.id_category1 FROM main m, porownywarki_cen pc WHERE pc.interia_export=1 AND m.active=1 AND m.user_id = pc.user_id GROUP BY m.id_category1 ORDER BY m.id ASC";
		
		$prepared_query=$db->PrepareQuery($query);
		if ($prepared_query) {
			$result=$db->ExecuteQuery($prepared_query);
			if ($result!=0) {
				$num_rows=$db->NumberOfRows($result);
				if ($num_rows>0) {
					for ($i=0;$i<$num_rows;$i++) {
						$data[$i]['id']=$db->FetchResult($result,$i,"m.id");
						$data[$i]['id_category1']=$db->FetchResult($result,$i,"m.id_category1");
						$data[$i]['category1']=$db->FetchResult($result,$i,"m.category1");
						
						$data[$i]['category1'] = htmlspecialchars($data[$i]['category1']);
					}
				}
			} else die ($db->Error());
		} else die ($db->Error());
		
		
		$this->dataCategory = $data;
		return true;
	}
	
	public function getCountDatabase()
	{
		global $db;
		
		$result = $db->Query("SELECT count(m.id) as count FROM main m, porownywarki_cen pc WHERE pc.interia_export=1 AND m.active=1 AND m.user_id = pc.user_id");
		$count = $db->FetchResult($result, 0, 'count');
		
		return $count;
	}
	
	public function fileHead()
	{
		global $config, $interia_config;
		$this->getCategory();
		
		$xml = "<?xml version=\"1.0\" encoding=\"ISO-8859-2\"?>\n";
		$xml.= "<xmldata>\n";
		$xml.= "\t<version>10</version>\n";
		$xml.= "\t<header>\n";
		$xml.= "\t\t<name>".$interia_config->interia_shop_name."</name>\n";
		$xml.= "\t\t<shopid>".$interia_config->interia_shop_id."</shopid>\n";
		$xml.= "\t\t<www>".$config->www."</www>\n";
		$xml.= "\t\t<time>".date("Y-m-d")."</time>\n";
		$xml.= "\t</header>\n";
		$xml.= "\t<category>\n";
		if (is_array($this->dataCategory))
		{
			foreach ($this->dataCategory as $value)
			{
				$xml.= "\t\t<catitem>\n";
				$xml.= "\t\t\t<catid>".$value['id_category1']."</catid>\n";
				$xml.= "\t\t\t<catname>".$value['category1']."</catname>\n";
				$xml.= "\t\t</catitem>\n";
			}
		}
		$xml.= "\t</category>\n";
		$xml.= "\t<data>\n";
		
		return $xml;
	}
	
	public function fileBody()
	{
		$xml = "";
		foreach ($this->data as $key => $value)
		{
			$xml.= "\t\t<item>\n";
			$xml.= "\t\t\t<compid>".$value['user_id']."</compid>\n";
			$xml.= "\t\t\t<vendor>".$value['producer']."</vendor>\n";
			$xml.= "\t\t\t<desc>".$value['name']."</desc>\n";
			$xml.= "\t\t\t<price>".$value['price_brutto']."</price>\n";
			$xml.= "\t\t\t<catid>".$value['id_category1']."</catid>\n";
            $xml.= "\t\t</item>\n";
		}
		return $xml;
	}
	
	public function fileFoot()
	{
		$xml = "\t</data>\n";
		$xml.= "</xmldata>\n";
		
		return $xml;
	}
	
	public function getFileName()
	{
		return $this->fileName;
	}
	
	public function getProgressCountPackage()
	{
		return $this->progressCountPackage;
	}
	
	public function getModuleName()
	{
		return $this->ModuleName;
	}
}
?>
