<?php
/**
 * Klasa SOferciak
 * 
 * @author michal.prochowski@sote.pl
 * @package SPorownywarkiCen
 * @subpackage SOferciak
 * @version $Id: SOferciak.inc.php,v 1.1 2007/05/28 10:10:10 michal Exp $
 * @copyright sote 
 */

/**
 * Includowanie potrzebnych klas 
 */
require_once('lib/SPorownywarkiCen/SPorownywarkiCen.inc.php');

class SOferciak extends SPorownywarkiCen implements SPorownywarkiCenInterface {
	
	private $data;
	public $ModuleName = "Oferciak";
	public $fileName = "oferciak.csv";
	public $progressCountPackage = 100;
	
	public function getDatabase( $offset = 0 )
	{
		global $db, $mdbd;
		global $SDConvertText;
		global $config;
		global $image;
		
		$select = "m.id, m.user_id, m.name_L0, m.photo_uid, m.price_brutto, m.category1, m.category2, m.category3, m.category4, m.category5, m.xml_description_L0, m.discount";
		
		$limit = "LIMIT ".$offset.", ".$this->getProgressCountPackage();
		$query = "SELECT $select FROM main m, porownywarki_cen pc WHERE pc.oferciak_export=1 AND m.active=1 AND m.user_id = pc.user_id ORDER BY m.id ASC ".$limit;
		
		$PartnerLink = $this->PartnerLink();
		
		$this->data = array();
		$data = array();
		$prepared_query=$db->PrepareQuery($query);
		if ($prepared_query) {
			$result=$db->ExecuteQuery($prepared_query);
			if ($result!=0) {
				$num_rows=$db->NumberOfRows($result);
				if ($num_rows>0) {
					for ($i=0;$i<$num_rows;$i++) {
						$data[$i]['id']=$db->FetchResult($result,$i,"m.id");
						$data[$i]['user_id']=$db->FetchResult($result,$i,"m.user_id");
						$data[$i]['name']=$db->FetchResult($result,$i,"m.name_L0");
						$data[$i]['photo_uid']=$db->FetchResult($result,$i,"m.photo_uid");
						$data[$i]['price_brutto']=$db->FetchResult($result,$i,"m.price_brutto");
						$data[$i]['category1']=$db->FetchResult($result,$i,"m.category1");
						$data[$i]['category2']=$db->FetchResult($result,$i,"m.category2");
						$data[$i]['category3']=$db->FetchResult($result,$i,"m.category3");
						$data[$i]['category4']=$db->FetchResult($result,$i,"m.category4");
						$data[$i]['category5']=$db->FetchResult($result,$i,"m.category5");
						$data[$i]['xml_description']=$db->FetchResult($result,$i,"m.xml_description_L0");
						$data[$i]['discount']=$db->FetchResult($result,$i,"m.discount");
						
						$data[$i]['name'] = htmlspecialchars($data[$i]['name']);
						$data[$i]['category1'] = htmlspecialchars($data[$i]['category1']);
						$data[$i]['category2'] = htmlspecialchars($data[$i]['category2']);
						$data[$i]['category3'] = htmlspecialchars($data[$i]['category3']);
						$data[$i]['category4'] = htmlspecialchars($data[$i]['category4']);
						$data[$i]['category5'] = htmlspecialchars($data[$i]['category5']);
						$data[$i]['xml_description'] = strip_tags($data[$i]['xml_description']);
						$data[$i]['xml_description'] = htmlspecialchars($data[$i]['xml_description']);
						$data[$i]['xml_description'] = str_replace(array("\r\n", "\r", "\n"), " ", $data[$i]['xml_description']);
						$data[$i]['url'] = "http://".$config->www."/go/_info/?id=".$data[$i]['id'].$PartnerLink;
						$data[$i]['photo'] = $image->get_file($image->get_image_name(1, $data[$i]['photo_uid']), IMAGE_BIG, false, true);
						if ($data[$i]['discount'] > 0 && $data[$i]['discount'] < 100) 
            			{
            				$data[$i]['price_brutto'] = number_format($data[$i]['price_brutto'],2,",","");
                			$data[$i]['price_brutto'] = $data[$i]['price_brutto']-(($data[$i]['price_brutto']*$data[$i]['discount'])/100);
            			}
            			$data[$i]['price_brutto'] = number_format($data[$i]['price_brutto'],2,".","");
					}
				}
			} else die ($db->Error());
		} else die ($db->Error());
		
		$this->data = $data;
		return true;
	}
	
	public function getCountDatabase()
	{
		global $db;
		
		$result = $db->Query("SELECT count(m.id) as count FROM main m, porownywarki_cen pc WHERE pc.oferciak_export=1 AND m.active=1 AND m.user_id = pc.user_id");
		$count = $db->FetchResult($result, 0, 'count');
		
		return $count;
	}
	
	public function fileHead()
	{
		$csv = "";
		
		return $csv;
	}
	
	public function fileBody()
	{
		$csv = "";
		foreach ($this->data as $key => $value)
		{
			$csv.= "".$value['url']."|";
			$csv.= "".$value['name']."|";
			$csv.= "".$value['xml_description']."|";
			$csv.= "".$value['price_brutto']."|";
			$csv.= "".$value['photo']."|";
			$csv.= "".$value['category1'];
            if ( !empty( $value['category2'] ) ) $csv.= "/".$value['category2'];
            if ( !empty( $value['category3'] ) ) $csv.= "/".$value['category3'];
            if ( !empty( $value['category4'] ) ) $csv.= "/".$value['category4'];
            if ( !empty( $value['category5'] ) ) $csv.= "/".$value['category5'];
            $csv.= "\n";
		}
	
		return $csv;
	}
	
	public function fileFoot()
	{
		$csv = "";
		
		return $csv;
	}
	
	public function getFileName()
	{
		return $this->fileName;
	}
	
	public function getProgressCountPackage()
	{
		return $this->progressCountPackage;
	}
	
	public function getModuleName()
	{
		return $this->ModuleName;
	}
}
?>
