<?php
/**
 * Klasa SZakupomat
 * 
 * @author michal.prochowski@sote.pl
 * @package SPorownywarkiCen
 * @subpackage SZakupomat
 * @version $Id: SZakupomat.inc.php,v 1.3 2007/05/29 06:56:52 michal Exp $
 * @copyright sote 
 */

/**
 * Includowanie potrzebnych klas 
 */
require_once('lib/SPorownywarkiCen/SPorownywarkiCen.inc.php');

class SZakupomat extends SPorownywarkiCen implements SPorownywarkiCenInterface {
	
	private $data;
	public $ModuleName = "Zakupomat";
	public $fileName = "zakupomat.xml";
	public $progressCountPackage = 100;
	
	public function getDatabase( $offset = 0 )
	{
		global $db, $mdbd;
		global $SDConvertText;
		global $config;
		global $image;
		
		$select = "m.id, m.user_id, m.name_L0, m.photo_uid, m.price_brutto, m.category1, m.category2, m.category3, m.category4, m.category5, m.xml_description_L0, m.discount";
		
		$limit = "LIMIT ".$offset.", ".$this->getProgressCountPackage();
		$query = "SELECT $select FROM main m, porownywarki_cen pc WHERE pc.zakupomat_export=1 AND m.active=1 AND m.user_id = pc.user_id ORDER BY m.id ASC ".$limit;
		
		$PartnerLink = $this->PartnerLink();
		
		$this->data = array();
		$data = array();
		$prepared_query=$db->PrepareQuery($query);
		if ($prepared_query) {
			$result=$db->ExecuteQuery($prepared_query);
			if ($result!=0) {
				$num_rows=$db->NumberOfRows($result);
				if ($num_rows>0) {
					for ($i=0;$i<$num_rows;$i++) {
						$data[$i]['id']=$db->FetchResult($result,$i,"m.id");
						$data[$i]['user_id']=$db->FetchResult($result,$i,"m.user_id");
						$data[$i]['name']=$db->FetchResult($result,$i,"m.name_L0");
						$data[$i]['photo_uid']=$db->FetchResult($result,$i,"m.photo_uid");
						$data[$i]['price_brutto']=$db->FetchResult($result,$i,"m.price_brutto");
						$data[$i]['category1']=$db->FetchResult($result,$i,"m.category1");
						$data[$i]['category2']=$db->FetchResult($result,$i,"m.category2");
						$data[$i]['category3']=$db->FetchResult($result,$i,"m.category3");
						$data[$i]['category4']=$db->FetchResult($result,$i,"m.category4");
						$data[$i]['category5']=$db->FetchResult($result,$i,"m.category5");
						$data[$i]['xml_description']=$db->FetchResult($result,$i,"m.xml_description_L0");
						$data[$i]['discount']=$db->FetchResult($result,$i,"m.discount");
						
						$data[$i]['url'] = "http://".$config->www."/go/_info/?id=".$data[$i]['id'].$PartnerLink;
						$data[$i]['url'] = eregi_replace("&amp;","&",$data[$i]['url']);
						
						$data[$i]['photo'] = $image->get_file($image->get_image_name(1, $data[$i]['photo_uid']), IMAGE_BIG, false, true);
						if ($data[$i]['discount'] > 0 && $data[$i]['discount'] < 100) 
            			{
            				$data[$i]['price_brutto'] = number_format($data[$i]['price_brutto'],2,",","");
                			$data[$i]['price_brutto'] = $data[$i]['price_brutto']-(($data[$i]['price_brutto']*$data[$i]['discount'])/100);
            			}
            			$data[$i]['price_brutto'] = number_format($data[$i]['price_brutto'],2,".","");
					}
				}
			} else die ($db->Error());
		} else die ($db->Error());
		
		$this->data = $data;
		return true;
	}
	
	public function getCountDatabase()
	{
		global $db;
		
		$result = $db->Query("SELECT count(m.id) as count FROM main m, porownywarki_cen pc WHERE pc.zakupomat_export=1 AND m.active=1 AND m.user_id = pc.user_id");
		$count = $db->FetchResult($result, 0, 'count');
		
		return $count;
	}
	
	public function fileHead()
	{
		$xml = "<?xml version=\"1.0\" encoding=\"ISO-8859-2\"?>\n";
		$xml.= "<!DOCTYPE zakupomat SYSTEM \"http://zakupomat.pl/zakupomat.dtd\">\n";
		$xml.= "<zakupomat version=\"1\">\n";
		$xml.= "<meta>";
		$xml.= "\t<generator version=\"1.0\"><![CDATA[SOTEeSKLEP version 4.0]]></generator>";
		$xml.= "</meta>";
		
		return $xml;
	}
	
	public function fileBody()
	{
		$xml = "";
		foreach ($this->data as $key => $value)
		{
			$xml.= "\t<offer id=\"".$value['id']."\" available=\"yes\">\n";
			$xml.= "\t\t<name><![CDATA[".$value['name']."]]></name>\n";
			$xml.= "\t\t<description><![CDATA[".$value['xml_description']."]]></description>\n";
			$xml.= "\t\t<url><![CDATA[".$value['url']."]]></url>\n";
			$xml.= "\t\t<price><![CDATA[".$value['price_brutto']."]]></price>\n";
			$xml.= "\t\t<category><![CDATA[".$value['category1'];
            if ( !empty( $value['category2'] ) ) $xml.= "|".$value['category2'];
            if ( !empty( $value['category3'] ) ) $xml.= "|".$value['category3'];
            if ( !empty( $value['category4'] ) ) $xml.= "|".$value['category4'];
            if ( !empty( $value['category5'] ) ) $xml.= "|".$value['category5'];
            $xml.= "]]></category>\n";            
            $xml.= "\t\t<imageurl><![CDATA[".$value['photo']."]]></imageurl>\n";
			$xml.= "\t</offer>\n";
		}
	
		return $xml;
	}
	
	public function fileFoot()
	{
		$xml = "</zakupomat>\n";
		
		return $xml;
	}
	
	public function getFileName()
	{
		return $this->fileName;
	}
	
	public function getProgressCountPackage()
	{
		return $this->progressCountPackage;
	}
	
	public function getModuleName()
	{
		return $this->ModuleName;
	}
}
?>
