<?php
/**
 * Plik adujcy kategorie i parametry allegro i pokazujca pasek postpu za porednictwem ajaxa
 *
 * @author lukasz.andrzejak@sote.pl
 * @package SAllegro
 * @subpackage SAllegroAjax
 * @version $Id: SAllegroAjax.php,v 1.2 2007/01/26 10:59:40 lukasz Exp $
 * @copyright sote
 */

/**
 * Includujemy klase xajax ktra bdzie dla nas obsugiwaa zapytania i odpowiedzi ajaxowe
 */
require_once("lib/xajax/xajax.inc.php");

/**
 * adujemy parenta
 */
require_once("./include/allegro.inc.php");

/**
 * Klasa obsuguje ajaxa wykorzystywanego przy allegro, zasadniczo powinna poszerza SAllegro, ale nie moe z powodu statycznych wywoa metod
 *
 */
class SAllegroAjax extends SAllegro {

    /**
     * Obiekt xajaxa - do niego musza odwolywac sie lokalne metody i zewnetrzne skrypty
     *
     * @var object xajax
     */
    public $xajax=NULL;
    
    public $close_on_end=false;

    public $single=false;
    
    /**
     * Konstruktor, tutaj tworzymy now instancje obiektu xajax
     * i rejestrujemy obsugiwane przez klase metody
     * (oraz wywoujemy konstruktora rodzica - standard)
     *
     */
    public function __construct() {
        $this->xajax = new xajax();
        parent::__construct();
        $this->ajaxRegister();
    }
    
    /**
     * Closes the category download, and shows a 100% full progressbar
     *
     * @param object $response xajaxResponse
     * @return void
     */
    private function ajaxCloseCat($response) {
        $response->addAssign("pbar","className","Pbar_done");
        $response->addAssign("pbar_in","className","empty");
        $response->addAssign("pbar_out","className","empty");
        $response->addAssign("proc_div","innerHTML","100%");
        if ($this->close_on_end && $this->single) {
            $response->addAlert("Zakonczono pobieranie kategorii.");
            $response->addScript("window.close();");
        }
        return (0);
    }
    
    
    /**
     * Pobieranie kolejnej grupy kategorii na podstawie parametru
     *
     * @param int $offset
     * @return object class xajaxResponse
     */
    public function ajaxNextCat ($offset) {
        // rozmiar pakietu
        $this->setCategoryPackage(400);
        $start = microtime(true);
        $response= new xajaxResponse();
        // ile jest pakietw do przerobienia ?
        $num=$this->countCategory()/$this->getCategoryPackage();
        $max=$this->countCategory();
        $curr=$this->getCategoryPackage()*$offset;
        /**
         * Do testow:
         * wykomentowac
         * (powyzwsze) 3 linie i odkomentowac ponizsze 3
         * $num=1000;
         * $max=10000;
         * $curr=10*$offset;
         */
        
        /**
         * nie szalejmy, takie sytuacje mog mie miejsce jak obsugujemy dodatkowe
         * wartoci oprcz waciwych - np -1 dla pierwszego jaowego przebiegu,
         * i >max jeeli cao jest niepodzielna przez ilo pakietw
         */
        if ($num==0) $num=1;
        if ($curr<1) $curr=1;
        if ($curr>$max) $curr=$max;
        // na jakim procencie jestemy ?
        $proc=floor(($offset*100)/$num);
        if ($proc<1) $proc=1;
        if ($proc>100) $proc=100;
        $response->addAssign("proc_div","innerHTML","$proc%");
        $response->addAssign("debug","innerHTML","$curr/$max ($proc%)");
        // -1: dopiero zaczynamy. Pokazujemy cokolwiek ze dac znac userowi ze zaczelismy proces
        if ($offset == -1) {
                $response->addAssign("pbar","className","Pbar_began");
                $response->addScript("xajax_AllegroNextCat(0);");
        } else {
                $new_offset=$this->getCategory($offset);
                /**
                 * Do testow
                 * Zakomentowac powyzsza linie i odokomentowac ponizsza
                 * $new_offset=$offset+1; 
                 */
                
                // 92 to jest bezpieczny limit htmlowy zeby nic na siebie nie nachodzilo
                if ($proc > 92 ) $proc=92;
                // -9: skonczylismy pobieranie
                if ($new_offset==$offset) $response->addAssign('debug','innerHTML',print_r($this->getDebugMessages(),true));
                if ($new_offset==-9) {
                      $this->ajaxCloseCat($response);
                } else {
                    $response->addAssign("pbar","className","Pbar_began");
                    $response->addAssign("pbar_in","className","full");            
                    $response->addAssign("pbar_in","style.width","$proc%");
                    $response->addAssign("pbar_out","className","shadow");
                    $response->addScript("xajax_AllegroNextCat($new_offset);");
                }
        }
        $end=microtime(true);
        $diff = $end-$start;
        $response->addAssign("debug1","innerHTML","Czas: $diff");
        return $response;
    }
    
    /**
     * Pobieranie kolejnej grupy parametrw na podstawie offsetu
     *
     * @param int $offset
     * @return object class xajaxResponse
     */
    public function ajaxNextPar ($offset) {
        $this->setParametersPackage(250);
        $start = microtime(true);
        $response= new xajaxResponse();
        // ile jest pakietw do przerobienia ?
        $num=$this->countParameters()/$this->getParametersPackage();
        $max=$this->countParameters();
        $curr=$this->getParametersPackage()*$offset;
        /**
         * nie szalejmy, takie sytuacje mog mie miejsce jak obsugujemy dodatkowe
         * wartoci oprcz waciwych - np -1 dla pierwszego jaowego przebiegu,
         * i >max jeeli cao jest niepodzielna przez ilo pakietw
         */
        if ($num==0) $num=1;
        if ($curr<1) $curr=1;
        if ($curr>$max) $curr=$max;
        // na jakim procencie jestemy ?
        $proc=floor(($offset*100)/$num);
        if ($proc<1) $proc=1;
        if ($proc>100) $proc=100;
        $response->addAssign("proc_div2","innerHTML","$proc%");
        $response->addAssign("debug","innerHTML","$curr/$max ($proc%)");
        if ($offset == -1) {
                $response->addAssign("pbarPar","className","Pbar_began");
                $response->addScript("xajax_AllegroNextPar(0);");
        } else {
                $new_offset=$this->getParameters($offset);
                if ($new_offset==$offset) $response->addAssign('debug','innerHTML',print_r($this->getDebugMessages(),true));
                $response->addAssign("proc_div2","innerHTML","$proc%");
                if ($proc > 92 ) $proc=92;
                if ($new_offset==-9) {
                    $this->ajaxClosePar($response);
                } else {
                    $response->addAssign("pbarPar","className","Pbar_began");
                    $response->addAssign("pbar_inPar","className","full");            
                    $response->addAssign("pbar_inPar","style.width","$proc%");
                    $response->addAssign("pbar_outPar","className","shadow");
                    $response->addScript("xajax_AllegroNextPar($new_offset);");
                }
        }
        $end=microtime(true);
        $diff = $end-$start;
        $response->addAssign("debug1","innerHTML","Czas: $diff");
        return $response;
    }
    
    /**
     * Closes the category download, and shows a 100% full progressbar
     *
     * @param object $response xajaxResponse
     * @return void
     */
    private function ajaxClosePar($response) {
        $response->addAssign("pbarPar","className","Pbar_done");
        $response->addAssign("pbar_inPar","className","empty");
        $response->addAssign("pbar_outPar","className","empty");
        $response->addAssign("proc_div2","innerHTML","100%");
        if ($this->close_on_end && $this->single) {
            $response->addAlert("Zakonczono pobieranie kategorii.");
            $response->addScript("window.close();");
        }
        return (0);
    }
    
    
    /**
     * Tutaj rejestrujemy obiekty ajaxowe dla siebie
     *
     * @return void
     */
    private function ajaxRegister() {
        $this->xajax->registerFunction(array("AllegroNextCat",$this,"ajaxNextCat"));
        $this->xajax->registerFunction(array("AllegroNextPar",$this,"ajaxNextPar"));
        return (0);
    }
}
?>