<?php
include("plugins/_allegro.pl/include/allegro.inc.php");
include_once("lib/SProgress/SProgress.interface.inc.php");

class SAllegroGet extends SAllegro implements SProgressInterface {

	/**
     * Funkcja liczaca wszystkie jednostki ktore sa do przetworzenia
     * 
     * @return int
     */
    public function progressCountAll()
    {
        return ceil($this->_categoryCount/$this->_categoryPackageElement)+ceil($this->_parametersCount/$this->_parametersPackageElement);
    }
    
    /**
     * Funkcja liczaca ile jest jednostek w pojedynczym pakiecie
     * 
     * @return int
     */
    public function progressCountPackage()
    {
    	$this->countCategory();
    	$this->countParameters();
    	
    	if ($this->_lastOffset<ceil($this->_categoryCount/$this->_categoryPackageElement))
		{
    		return $this->_categoryPackageElement;
		} else {
			return $this->_parametersPackageElement;
		}
    }
    
    /**
     * Ostatni element, ktory byl przetworzony w poprzednim wywolaniu
     *      
     * @param int $last
     * @return int
     */
    public function progressNext($last=0)
    {
    	global $lang;
    	
    	$this->_lastOffset = $last;
    	
    	$this->countCategory();
    	$this->countParameters();

    	if ( $last == 0 )
    	{
    		$this->_unsetOffset();
    	} else {
    		$this->_restoreOffset();
    	}
    	
    	if ($last<ceil($this->_categoryCount/$this->_categoryPackageElement))
		{
    		$this->getCategory($this->_categoryOffset);
    		$this->setMessage($lang->allegro_get['category']);
    		$this->_categoryOffset++;
		} else {
			$this->getParameters($this->_parametersOffset);
			$this->setMessage($lang->allegro_get['parameters']);
			$this->_parametersOffset++;
		}
    	$next = $last+1;
    	$this->_saveOffset();
        if ($next>=(ceil($this->_categoryCount/$this->_categoryPackageElement)+ceil($this->_parametersCount/$this->_parametersPackageElement))) 
        {	
        	$this->_unsetOffset();
        	$this->endMessage($lang->allegro_get['end_ok']);
        }
    	else return $next;
    }
}

?>