<?php
/**
 * Konwersja zmiennej PHP na formularz i odwrotnie
 * 
 * @author m@sote.pl
 * @version $Id: var2form.inc.php,v 1.9 2007-07-16 16:18:07 marek Exp $
 * @package lang
 */
class Var2Form {

    /**
     * Maksymaly poziom zagniedzenia.
     * Zapobiega powieszeniu sie skryptu w przypadku wystpienia bdu
     * w rekurencji.
     * 
     * @var int
     */
    var $maxlevel=5;

    /**
     * Kodowanie tekstu
     *
     * @var string
     */
    var $_encoding='ISO-8859-2';

    /**
     * Jzyk
     * 
     * @var string 
     */
    var $_lang="pl";

    /**
     * Ustaw kodowanie
     * 
     * @param string $encoding
     */
    function setEncoding($encoding) {
        $this->_encoding=$encoding;
        return true;
    }

    /**
     * Ustaw Jzyk
     * 
     * @param string $lang
     */
    function setLang($lang) {
        $this->_lang=$lang;
        return true;
    }


    /**
    * Generuj formularz HTML
    *
    * @param array  $data    
    * @param string $action
    * @param string $method
    * @param string $name    
    * @param int    $form form=1 wyswietl inpput 0 - wyswietl text (print)
    * @return string HTML
    */
    function dumpVar2Form($data,$action="#",$method="POST",$name="VarForm",$form=1) {        
        $o='';
        if ($action!="#") $o="<form action=\"$action\" method=\"method\" name=\"$name\">\n";
        if (is_array($data)) {
            ksort($data); // posortuj tablice tak zeby po update pola byly w tej samej kolejnosci        
            foreach ($data as $key=>$val) {
                $o.=$this->_parsevar2form(array($key),$val,1,$form);
            }
        } else {
            if ($form==1) {
                $o.=$this->_input('lang',$data);
            } else $o.=$data."<br />\n";
        }
        if ($action!="#") $o.="</form>\n";
        return $o;
    }

    /**
    * Parsuj tablic PHP. Metoda rekurencyjna
    * 
    * @param array $key
    * @param array $val warto zmiennej PHP
    * @param int  $level
    * @param string $form 1- input 0 - print
    * 
    * @return string KOD HTML input reprezentujcy sump zmiennej PHP
    */   
    function _parsevar2form($key,$val,$level,$form=1) {
        if (empty($o)) $o='';
        if (! is_array($val)) {
            if ($form==1) $o.=$this->_input($key,$val); 
            else $o.=$val."<br />\n";
        }
        else {
            foreach ($val as $k=>$v) {
                $kt=$key;
                array_push($kt,$k);
                if (! is_array($val)) {
                    if ($form==1) $o.=$this->_input($key,$val,++$level);
                    else $o.=$val."<br />\n";
                }
                else {
                    $o.=$this->_parsevar2form($kt,$v,++$level);
                }
            }

        }
        return $o;
    }

    /**
    * Generuj element input odpowiadajacy zmiennej PHP
    * 
    * @param array $key
    * @param string $val
    * @return string HTML input
    */
    function _input($key,$val) {
        $sep=str_repeat("&nbsp",(sizeof($key)-1)*4);        
        
        $o="$sep<textarea cols=\"60\" rows=\"2\" name=item[value]";
        if (is_array($key)) {
            foreach ($key as $name) {
                $o.="[$name]";
            }
            $keyv=$key[0];
        }
        $o.=">".$this->decodeText($val,$this->_encoding)."</textarea><br />\n";
        if (! empty($keyv)) $o=$keyv."<br>".$o;
        return $o;
    }

    /**
     * Dekoduj tekst do wywietlenia na WWW
     *
     * @param string $text
     * @param string $encoding
     * @return string
     */
    function decodeText($text,$encoding) {
        global $enc;
        $text=$enc->Convert($text,$encoding,"UTF-8",0);
        return $text;
    }

    /**
     * Dekoduj wartosci z tablicy z kodowania $enc1 do $enc2
     * 
     * @param array $data
     * @param string $enc1
     * @param string $enc2
     * @return array
     */
    function convertArray($data,$enc1,$enc2) {
        global $enc;
                
        if (! is_array($data)) return $enc->Convert($data,$enc1,$enc2);
                      
        $array=array();
        foreach ($data as $key=>$val) {            
            if (is_array($val)) {
                $array[$key]=$this->convertArray($val,$enc1,$enc2);
            } else {                
                $array[$key]=$enc->Convert($val,$enc1,$enc2,0);                
            }
        }
        
        return $array;
    }

} // end class


/**
 * Pocz 2 tablice 
 * 
 * User Contributed Notes
 * array_merge_recursive
 * paha at paha dot hu
 * 12-Mar-2007 09:02
 * In this version the values are overwritten only if they are not an array.
 * If the value is an array, its elements will be merged/overwritten:
 * // array_merge_recursive which override value with next value.
 * // based on: http://www.php.net/manual/hu/function.array-merge-recursive.php 09-Dec-2006 03:38
 * 
 * @see http://pl2.php.net/manual/en/function.array-merge-recursive.php
 *
 * @param array $array0
 * @param array $array1
 * @return array
 */
function array_merge_recursive_unique($array0, $array1)
{
    $arrays = func_get_args();
    $remains = $arrays;

    // We walk through each arrays and put value in the results (without
    // considering previous value).
    $result = array();

    // loop available array
    foreach($arrays as $array) {

        // The first remaining array is $array. We are processing it. So
        // we remove it from remaing arrays.
        array_shift($remains);

        // We don't care non array param, like array_merge since PHP 5.0.
        if(is_array($array)) {
            // Loop values
            foreach($array as $key => $value) {
                if(is_array($value)) {
                    // we gather all remaining arrays that have such key available
                    $args = array();
                    foreach($remains as $remain) {
                        if(array_key_exists($key, $remain)) {
                            array_push($args, $remain[$key]);
                        }
                    }

                    if(count($args) > 2) {
                        // put the recursion
                        $result[$key] = call_user_func_array(__FUNCTION__, $args);
                    } else {
                        foreach($value as $vkey => $vval) {
                            $result[$key][$vkey] = $vval;
                        }
                    }
                } else {
                    // simply put the value
                    //                    $result[$key] = $value; // orig
                    if (! empty($value)) $result[$key] = $value; // m@sote.pl
                }
            }
        }
    }
    return $result;
}
?>