<?php
/**
* Wysylanie newslettera z wykorzystaniem ajax progressBara
*
* @author  lukasz.andrzejak@sote.pl
* @version $Id: send.inc.php,v 1.4 2007-09-20 13:57:01 marcin Exp $
* @uses SProgressBar
* @package    SNewsletter
* @subpackage SendToUsers
*/



require_once('include/lock.inc');

/**
 * Klasa newslettera, z interfejsem ajaxego progressbara w sklepie
 * @todo dodac locki zeby nie mozna bylo wywolywac dwoch newsletterow naraz
 * @todo dodac licznik ile maili wyslano (moze do progressBara dodac wyjatek pokazujacy licznik, komunikat usera w trakcie przesylania? jak ?)
 *
 */
class SNewsletter implements SProgressInterface {

	/**
     * Ile maili przerabiamy na raz
     *
     * @var int
     */
	private $_perPackage=10;

	/**
     * Ile czekamy miedzy wysyaniem kolejnych pakietw
     *
     * @var int
     */
	private $_wait=3;

	/**
     * Wynik formuowania where w zapytaniu
     *
     * @var unknown_type
     */
	private $_where='';

	/**
     * Dane z sesji - eby byy pod rk
     *
     * @var array
     */
	private $_data=array();


	/**
     * Ostatni przetwarzany pakiet
     *
     * @var int
     */
	private $_last=0;


	/**
     * Kostruktor - sprawdzamy czy wymagane rzeczy s w sesji
     *
     */
	public function __construct() {
		if (empty($_SESSION['newsletter'])) throw new Exception('Bdne wywoanie');
		$this->_data=$_SESSION['newsletter'];
	}

	/**
     * Zwracamy ile jest maili do wysania
     *
     * @return int
     */
	public function progressCountAll() {
		global $mdbd;
		return $mdbd->select('count(id)','newsletter','1=1 '.$this->_genSql());
	}

	/**
     * Zwracamy ile jest maili w pakiecie
     *
     * @return int
     */
	public function progressCountPackage() {
		return $this->_perPackage;
	}

	/**
     * Przechodzimy do kolejnego pakietu
     * 
     * @param int $last
     * @return int
     */
	public function progressNext($last=0) {
		$lock= new SLock();
		//        if (!$lock->setLock('newsletter')) throw new SProgressException('Ktos w sklepie juz wysyla newslettera!',6);
		//        $lock->updateLock('newsletter');
		$this->_last=$last;
		$this->_action($last);
		return $last+$this->progressCountPackage();
	}

	/**
     * Generujemy WHERE do sql'a
     * wykorzystujemy to w kilku miejscach wic zrobione na funkcje
     *
     * @param int $last
     * @return string
     */
	private function _genSql() {

		if (! empty($this->_data['groups'])) {
			$groups=$this->_data['groups'];
			$where=" AND (";
			foreach($groups as $value) {
				$value=addslashes($value);
				$where.=" groups LIKE '%:".$value.":%' OR";
			}
			$where=ereg_replace("OR$",")",$where);
		} else {
			$groups=false;
			$where=' AND groups is NULL';
		}

		if (! empty($this->_data['lang'])) {
			$lang_key=addslashes($this->_data['lang']);
			$where.=" AND lang='".$lang_key."' ";
		}
		return $where;
	}


	/**
     * Wykonujemy wymagane operacje, zaczynajac od rekordu $last z bazy danych
     *
     * @param int $last ostatni wiersz z bazy danych ktory zostal przetworzony
     * @throws SProgressException
     * @return void
     */
	public function _action($last=0) {
		global $db;
		global $lang;
		global $config;
		// obsluga generowania pliku konfiguracyjnego uzytkwonika
		require_once("lib/Mail/MyMail.php");
		/**
         * ustawiamy dane
         */
		$lang_key=addslashes($this->_data['lang']);
		if ($lang_key=='pl'){
			require_once("config/auto_config/newsletter/newsletter_config_L0.inc.php");
		}
		if ($lang_key=='en'){
			require_once("config/auto_config/newsletter/newsletter_config_L1.inc.php");
		}
		if ($lang_key=='de'){
			require_once("config/auto_config/newsletter/newsletter_config_L2.inc.php");
		}
		if ($lang_key=='cz'){
			require_once("config/auto_config/newsletter/newsletter_config_L3.inc.php");
		}
		if ($lang_key=='ru'){
			require_once("config/auto_config/newsletter/newsletter_config_L4.inc.php");
		}

		$send_mail=new MyMail;
		// ustalenie typu wysylanego maila do klienta
		if (!empty($config->email_HTML_client)) {
			$config->mail_type_path="html";
			$send_mail->allowHTML(true);
		} else {
			$config->mail_type_path="txt";
			$send_mail->allowHTML(false);
		}
		if (empty($this->_data['subject'])) {
			throw new SProgressException($lang->newsletter_no_subject,99);
		} else $subject=$this->_data['subject'];
		if (empty($this->_data['message'])) {
			throw new SProgressException($lang->newsleter_no_body,99);
		} else $message=$this->_data['message'];

		/**
     * tworzymy zapytanie i przechodzimy do wysyania
     */
		$query="SELECT email FROM newsletter WHERE active=1 AND status=1".$this->_genSql()." LIMIT $last,$this->_perPackage";
		$prepared_query=$db->PrepareQuery($query);
		$is_last=false;
		/**
     * sprawdzamy czy to jest ostatni pakiet
     */
		if ($last+$this->progressCountPackage()>=$this->progressCountAll()) $is_last=true;
		if ($prepared_query) {
			$result=$db->ExecuteQuery($prepared_query);
			if ($result!=0) {
				$num_rows=$db->NumberOfRows($result);
				if ($num_rows>0) {
					for ($i=0;$i<$num_rows;$i++) {
						//                    sleep($this->_wait);
						$email=$db->FetchResult($result,$i,'email');
						/**
                     * nowy bajer - sprawdzamy czy dana domena istnieje
                     * i wysyamy tylko jeeli istnieje. 
                     * to wyeliminuje nieistniejce domeny i strate czasu na prbe wysania emaila na nieistniejc
                     */
						$is_valid_email=$this->_validate_email($email);
						include ("./html/newsletter_info.html.php");
						$content='';
						$content.=$message."\n\n\n".$info;
						if ($is_valid_email) {
							/**
                         * prbujemy wysa i jeeli nie uda si - dodajemy emaila do listy bdnych
                         */

							if(!$send_mail->send($config_newsletter->newsletter_sender,$email,$subject,$content))
							$_SESSION['newsletter']['errors'][]=$lang->progress_bar['not_sent_to'].$email;

						}
						// uuu.... tutaj nie ma nawet takiej domeny :>
						else $_SESSION['newsletter']['errors'][]=$lang->progress_bar['not_sent_to'].$email.$lang->progress_bar['bad_domain'];
					}
					/**
                 * skoczylimy ? cool :)
                 */
					if ($is_last) {
						$errors='';
						/**
                     * jeeli byy jakie bdy do dodajemy je do komunikatu
                     */
						if (is_array(@$_SESSION['newsletter']['errors'])) {
							foreach ($_SESSION['newsletter']['errors'] as $value) $errors.=$value.'<br>';
						}
						/**
                     * wywalamy niepotrzebne zmienne z sesji
                     */
						$_SESSION['newsletter']=NULL;
						//                    $lock=new SLock();
						//                    $lock->unLock('newsletter');
						throw new SProgressException($lang->progress_bar['sent_ok'].$errors,1);
					}
				} else {
					throw new SProgressException($lang->progress_bar['no_users'],6);
				}
			} else throw new SProgressException($lang->progress_bar['system_halt'].$db->Error(),99);
		} else throw new SProgressException($lang->progress_bar['system_halt'].$db->Error(),99);

	}

	/**
     * Sprawdzamy czy istnieje dns dla danej domeny
     *
     * @param string $email adres email z ktrego zostanie wycita domena i sprawdzona czy istnieje
     * @return bool
     */
	private function _validate_email($email='') {
		if (empty($email)) return false;
		$domain=preg_replace('@.*\@(.*)@','\1',$email);
		if (empty($domain)) return false;
		$ip=checkdnsrr($domain,'A');
		if (empty($ip)) return false;
		return true;
	}
}
?>