<?php
/**
 * adowanie oferty do WP Pasa
 *
 * @author rdiak@sote.pl
 * @author michal@sote.pl
 * @version $Id: wp_load_offer_ajax.inc.php,v 1.2 2007-09-26 18:40:05 michal Exp $
 * @package pasaz.wp.pl
 */

/**
 * Includowanie potrzebnych klas 
 */
require_once("include/wp/wp.inc.php");
include_once("include/metabase.inc");
require_once("../../../include/head.inc");
require_once('lib/SProgress/SProgressBar.inc.php');
include_once("include/image.inc");

/**
 * Klasa WpLoadOffer 
 *
 * @package wp
 * @subpackage admin
 */
class WpLoadOffer extends WP implements SProgressInterface {

	var $data=array();			// produkty do eksportu
	var $data_add=array();
	var $data_update=array();
	var $data_delete=array();
	var $per_one = 10;
    
	/**
     * Funkcja liczaca wszystkie jednostki ktore sa do przetworzenia
     * 
     * @return int
     */
	function progressCountAll(){
		global $mdbd;
		$count_db = $mdbd->select("count(id)","main_param","wp_export=1");
		return ceil(($count_db/$this->per_one));
	}
    
    /**
     * Funkcja liczaca ile jest jednostek w pojedynczym pakiecie
     * 
     * @return int
     */
    function progressCountPackage(){
    	return $this->per_one;
    }
    
    /**
     * Ostatni element, ktory byl przetworzony w poprzednim wywolaniu
     *      
     * @param int $last
     * @return int
     */
    function progressNext($last=0){
    	global $db,$database;
    	global $lang;
    	if($last == 0) session_unregister("wp_export_messages");
		if ($last < $this->progressCountAll() ) {
			return $this->_send_products($last);
		} elseif ($last == $this->progressCountAll())
		{
			$message = $this->_get_export_message();
			
			throw new SProgressException($message,1);
		} else {
			throw new SProgressException($lang->wp_import['error'],99);
		}
    }
	/**
     * Konstruktor obiektu WpLoadOffer  
     *
     * @return boolean true/false
     */
	function WpLoadOffer() {
		// wywolaj konstruktor obiektu rodzica.
		$this->WP();
		return true;
	} // end WpLoadOffer

    /**
     * Funkcja glowna funkcja adujaca ofert do WP Pasa. 
     *
     * @return boolean true/false
     */
	function LoadOffer() {
		foreach($this->data as $key=>$value) {
			switch ($value['wp_status']) {
				case 1:
					// dodaj produkt to tablicy produktw dodawanych
					array_push($this->data_add,$this->data[$key]);
					break;
				case 2:
					// dodaj produkt to tablicy produktw aktualizowanych
					array_push($this->data_update,$this->data[$key]);
					break;
				case 3:
					// dodaj produkt to tablicy produktw usuwanych	
					array_push($this->data_delete,$this->data[$key]);
					break;
				default:
					break;
			}
		}
		if(!empty($this->data_add)) $this->_prepare_add_xml();
		if(!empty($this->data_delete)) $this->_prepare_del_xml();
		if(!empty($this->data_update)) $this->_prepare_upd_xml();
		return true;
	} // end LoadOffer

    /**
     * Funkcja pobiera dane z bazy danych i tworzy z nich gotow tablic
     * z produktami z ktrej mona utworzy komunikat SOAP. 
     *
     * @return boolean true/false
     */
//	function _wp_get_main() {
//		global $database;
//		global $config;
//		global $image;
//		
//		$records=array(
//						"id",
//						"name_L0",
//						"xml_description_L0",
//						"price_brutto",
//						"photo_uid",
//		);
//		// pobieramy dane w talicy main i laczymy tablice tak aby otrzymac w jednym rekordzie
//		// pelne informacje o produkcie
//		foreach($this->data as $key=>$value) {
//			$data=$database->sql_select_multi_array4($records,"main","user_id=".$value['user_id'],$option='');
//			// zmodyfikuj dostep do fotografi
////			$data[0]['photo']="http://".$config->www."/photo/".$data[0]['photo'];
//			$data[0]['photo'] = $image->get_file($image->get_image_name(1, $rec->data['photo_uid'], IMAGE_BIG, false, true));
//			// stworz url z ktorym bedzie sie wchodzilo do sklepu z wp
//			$data[0]['url']="http://".$config->www."/?id=".$value['user_id'].$this->_wp_prepare_url();
//			// pobierz pola Field1 i Field2 z bazy danych
//			$field=$this->_get_field12($value['wp_fields']);
//			// i przypisz je do odpowiednich pol w tablicy
//			$data[0]['wp_field1']=$field['field1'];
//			$data[0]['wp_field2']=$field['field2'];
//			$this->data[$key]['wp_valid']=preg_replace("/:0{2}$/i","",$this->data[$key]['wp_valid']);
//			$this->data[$key]=$this->data[$key]+$data[0];
//		}
//		return true;
//	} // end _wp_get_main

    /**
     * Funkcja pobiera z tablicy wp_fields dwa pola
     * odpowiednie do przekazanego argumentu cid
     *
     * @param int cid identyfikator dodatkowych kategorii
     *
     * @return array dwa pola field1 i field2
     */
//	function _get_field12($cid) {
//		global $mdbd;
//		$data=$mdbd->select("field1,field2","wp_fields","cid=?",array($cid=>"int"));	
//		return $data;
//	} // end _get_field12
	
	/**
     * Funkcja wyciaga produkty do eksportu z tablicy main_param
     * 
     * @return bool   true     dane pobrane, false w p.w.
     */
//	function _wp_get_main_param() {
//		global $database;
//		$records=array(
//						"user_id",
//						"wp_category",
//						"wp_status",
//						"wp_dictid",
//						"wp_valid",
//						"wp_producer",
//						"wp_dest",
//						"wp_advantages",
//						"wp_fields",
//						"wp_filters",
//						"wp_ptg",
//						"wp_ptg_desc",
//						"wp_ptg_days",
//						"wp_ptg_picurl",
//						"wp_delivery_cost",
//						"wp_delivery_time",
//						);
//		$this->data=$database->sql_select_multi_array4($records,"main_param","wp_export=1",$option='');
//		return true;
//	} // end _wp_get_main_param
	
	
	/**
	 * Funkcja wysyla wczesniej stworzony komunikat SOAP
	 * na serwer WP Pasa
	 *
	 * @return string url
	 */
	function _send_offer(& $offer,$action) {
		global $DOCUMENT_ROOT;
		global $lang;

		if($action == 'add') {
//			$file_name="wp_offer_add.xml";
			$info="AddProducts";
		} elseif($action == 'upd') {
//			$file_name="wp_offer_upd.xml";
			$info="UpdateProducts";
		} elseif($action == 'del') {	
//			$file_name="wp_offer_del.xml";
			$info="DeleteProducts";
		}
		if($offer) {
			
			 //Zapisywanie xml do plikow
			 	
//			  $file = $DOCUMENT_ROOT."/tmp/".$file_name;
//			  if ( $fd = @fopen( $file, "w+" ) )
//			  {
//			  		fwrite( $fd, $offer, strlen( $offer ) );
//			 		fclose( $fd );
//			  }
			
			//wyslij oferte na serwer
//			$content=$this->soap->send_soap_offer($offer); // stara powolna metoda poczenia z wp
			$content = $this->_send_soap($offer); // nowa napisana przez lukasza 

			// sparsuj odpowiedz serwera wp
			$this->_wp_send_request($content,'trans');
			// zapisz zwrotina informacje do bazy danych
			$this->_insert_info_db($info,'SRCID'); 
			$this->_insert_info_session($content);
			return true;
		} else {
			print "<br><center>".$lang->onet_load_offer['noprod']."<center>";
		}
		return true;
	} // end _send_add 
	
//	/**
//	 * Funkcja pokazuje informacje o statusie ladowania produktow.
//	 *
//	 * @return string url
//	 */
//	function _show_info($info) {
//		global $database;
//		//print_r($this->data_add);
//		if($info == "AddProducts") {
//			foreach($this->data_add as $key=>$value) {
//				$data=$database->sql_select_multi_array3(array("msg","order_id","res"),"wp_logs","order_id=".$value['user_id'],"AND show_info=1");
//				$str="Produkt <b>".$data['order_id']."</b>";
//
//				if($data['res'] == 0) {
//					$str.=" zaadowany poprawnie<br>"; 
//				} else {
//					$str.=" zaadowany niepoprawnie <font style='color:red; font-weight: bold;'><b>Bd: ". $data['msg']."</b></font><br>";	
//				}
//				print $str;
//			}
//		} elseif ($info == "UpdateProducts") {
//			foreach($this->data_update as $key=>$value) {
//				$data=$database->sql_select_multi_array3(array("msg","order_id","res"),"wp_logs","order_id=".$value['user_id'],"AND show_info=1");
//				$str="Produkt <b>".$data['order_id']."</b>";
//				if($data['res'] == 0) {
//					$str.=" zaktualizowany poprawnie<br>"; 
//				} else {
//					$str.=" zaktualizowany niepoprawnie <font style='color:red; font-weight: bold;'><b>Bd: ". $data['msg']."</b></font><br>";	
//				}
//				print $str;
//			}
//		} elseif ($info == "DeleteProducts") {
//			foreach($this->data_delete as $key=>$value) {
//				//print_r($this->data_delete);
//				$data=$database->sql_select_multi_array3(array("msg","order_id","res"),"wp_logs","order_id=".$value['user_id'],"AND show_info=1");
//				$str="Produkt <b>".$data['order_id']."</b>";
//				if($data['res'] == 0) {
//					$str.=" skasowany poprawnie<br>"; 
//				} else {
//					$str.=" skasowany niepoprawnie <font style='color:red; font-weight: bold;'><b>Bd: ". $data['msg']."</b></font><br>";	
//				}
//				print $str;
//			}
//		}
//		return true;
//	} // end _show_info
	
	/**
	 * Funkcja na podstawie tablicy $this->data_add tworzy komunikat
	 * SOAP dotyczacy dodawanych produktow i wysyla go do pasazu
	 *
	 * @return string url
	 */
	function _prepare_add_xml() {
		// naglowek komunikatu soap
		$str=$this->_wp_get_head();
		//tworzymy pelny komunikat soap zawierajacy dodawane produkty
		$str.=$this->_wp_record_add($this->data_add);
		// stopka komunikatu soap
		$str.=$this->_wp_get_foot();
		// wysylamy oferte na serwer;
		$this->_send_offer($str,"add");
		return true;
	} // end _prepare_add_xml
	
	/**
	 * Funkcja na podstawie tablicy $this->data_delete tworzy komunikat
	 * SOAP dotyczacy usuwanych produktow i wysyla go do pasazu
	 *
	 * @return string url
	 */
	function _prepare_del_xml() {
		// naglowek komunikatu soap
		$str=$this->_wp_get_head();
		//tworzymy pelny komunikat soap zawierajacy dodawane produkty
		$str.=$this->_wp_record_delete($this->data_delete);
		// stopka komunikatu soap
		$str.=$this->_wp_get_foot();
		// wysylamy oferte na serwer;
		$this->_send_offer($str,"del");
		return true;
	} // end _prepare_del_xml
	
	/**
	 * Funkcja na podstawie tablicy $this->data_delete tworzy komunikat
	 * SOAP dotyczacy usuwanych produktow i wysyla go do pasazu
	 *
	 * @return string url
	 */
	function _prepare_upd_xml() {
		// naglowek komunikatu soap
		$str=$this->_wp_get_head();
		//tworzymy pelny komunikat soap zawierajacy dodawane produkty
		$str.=$this->_wp_record_update($this->data_update);
		// stopka komunikatu soap
		$str.=$this->_wp_get_foot();
		// wysylamy oferte na serwer;
		$this->_send_offer($str,"upd");
		return true;
	} // end _prepare_upd_xml
	
	/**
	 * Funkcja zwraca url produktu .
	 *
	 * @access public
	 *
	 * @return string url
	 */
	function _wp_prepare_url() {
		global $mdbd;
		global $config;
		
		$data=$mdbd->select("partner_id,name","partners","name=?",array($this->_partner_name=>"string"));	
        $partner_id=$data['partner_id'];
		$code=md5("partner_id.$partner_id.$config->salt");                 // wygenerowanie kodu kontrolnego
        $link="&partner_id=".$partner_id."&code=".$code;    // budowanie linku
		$this->soap->chars_to_xml($link); 
        return $link;
	}
	
	/**
	 * Funkcja do wycigania danych o produktach z bazy danych
	 * Zastpuje _get_main i _get_main_param
	 *
	 * @return true
	 */
	function _get_database( $offset )
	{
		global $db,$mdbd;
		global $image;
		global $config;
		global $theme;
		
		$query = "SELECT mp.user_id, mp.wp_category, mp.wp_status, mp.wp_dictid, mp.wp_valid, mp.wp_producer, mp.wp_dest, mp.wp_advantages, mp.wp_fields,
				  mp.wp_filters, mp.wp_ptg, mp.wp_ptg_desc, mp.wp_ptg_days, mp.wp_ptg_picurl, mp.wp_delivery_cost, mp.wp_delivery_time, m.id, m.name_L0,
				  m.xml_description_L0, m.price_brutto, m.photo_uid FROM main_param mp, main m WHERE mp.wp_export=1 AND mp.user_id = m.user_id 
				  ORDER BY mp.wp_status, m.id ASC LIMIT ".($offset*$this->per_one).", ".$this->per_one;
		$this->data = array();
		$data = array();
		$prepared_query=$db->PrepareQuery($query);
		if ($prepared_query) {
			$result=$db->ExecuteQuery($prepared_query);
			if ($result!=0) {
				$num_rows=$db->NumberOfRows($result);
				if ($num_rows>0) {
					for ($i=0;$i<$num_rows;$i++) {
						$data[$i]['id']=$db->FetchResult($result,$i,"m.id");
						$data[$i]['name_L0']=$db->FetchResult($result,$i,"m.name_L0");
						$data[$i]['xml_description_L0']=$db->FetchResult($result,$i,"m.xml_description_L0");
						$data[$i]['price_brutto']=number_format($db->FetchResult($result,$i,"m.price_brutto"),"2",",","");
						$data[$i]['photo_uid']=$db->FetchResult($result,$i,"m.photo_uid");
						$data[$i]['user_id']=$db->FetchResult($result,$i,"mp.user_id");
						$data[$i]['wp_category']=$db->FetchResult($result,$i,"mp.wp_category");
						$data[$i]['wp_status']=$db->FetchResult($result,$i,"mp.wp_status");
						$data[$i]['wp_dictid']=$db->FetchResult($result,$i,"mp.wp_dictid");
						$data[$i]['wp_valid']=$db->FetchResult($result,$i,"mp.wp_valid");
						$data[$i]['wp_producer']=$db->FetchResult($result,$i,"mp.wp_producer");
						$data[$i]['wp_dest']=$db->FetchResult($result,$i,"mp.wp_dest");
						$data[$i]['wp_advantages']=$db->FetchResult($result,$i,"mp.wp_advantages");
						$data[$i]['wp_fields']=$db->FetchResult($result,$i,"mp.wp_fields");
						$data[$i]['wp_filters']=$db->FetchResult($result,$i,"mp.wp_filters");
						$data[$i]['wp_ptg']=$db->FetchResult($result,$i,"mp.wp_ptg");
						$data[$i]['wp_ptg_desc']=$db->FetchResult($result,$i,"mp.wp_ptg_desc");
						$data[$i]['wp_ptg_days']=$db->FetchResult($result,$i,"mp.wp_ptg_days");
						$data[$i]['wp_ptg_picurl']=$db->FetchResult($result,$i,"mp.wp_ptg_picurl");
						$data[$i]['wp_delivery_cost']=number_format($db->FetchResult($result,$i,"mp.wp_delivery_cost"),"2",",","");
						$data[$i]['wp_delivery_time']=$db->FetchResult($result,$i,"mp.wp_delivery_time");
						
						$data[$i]['url'] = "http://".$config->www."/?id=".$data[$i]['user_id'].$this->_wp_prepare_url();
						$data[$i]['photo'] = $image->get_file($image->get_image_name(1, $data[$i]['photo_uid']), IMAGE_PASAZ, false, true);
					} // end for
				}
			} else die ($db->Error());
		} else die ($db->Error());
		
		$this->data = $data;
		return true;
	}
	
	/**
	 * Funkcja do czenia z soapem WP.pl
	 *
	 * @param string $xml
	 * @return string
	 */
	function _send_soap($xml)
	{
		$server = "wymianadanych.wp.pl";
		$router = "/SOAPInterface/Zakupy/index.php";
		
		$req_headers="POST $router HTTP/1.0\r\n";
        $req_headers.="Host: $server\r\n";
        $req_headers.="Content-type: text/xml; charset=iso-8859-2\r\n";
        $req_headers.="Content-Length: ".strlen($xml)."\r\n\r\n";
        
		$connection=@fsockopen($server,80);
		
            if ($connection) {
                stream_set_timeout($connection,40);
                $connection_info=stream_get_meta_data($connection);
                fputs($connection,$req_headers.$xml);
                $data='';
                // barany sa niezgodni z http\1.0 i przed naglowkiem wysylaja newline
                // wiec sprawdzam czy wyslali conn:close i jezeli tak - to zaczynam na nastepnej lini body
                $header=true;
                while (!feof($connection)) {
                    $connection_info=stream_get_meta_data($connection);
                    $line=fgets($connection,1024);
                    if (trim($line)=='Connection: close') {
                        $line=fgets($connection,1024);
                        $line=fgets($connection,1024);
                        $header=false;
                    } 
                    //if (!$header) $data.=$line;
                    if (!$header) $data.=htmlspecialchars($line);
                }
              return trim($data)."\n";
            }
	}
	
	
	/**
	 * Wrapper do wysyania produktw do wp.pl
	 *
	 * @param integer $offset
	 * @return integer
	 */
	function _send_products( $offset )
	{
		$this->_get_database( $offset );
		$this->LoadOffer();
		return $offset+1;
	}
	
	function _get_export_message()
	{
		global $lang;
		
		$status_tab = $_SESSION['wp_export_status'];
		$error_tab = $_SESSION['wp_export_messages'];
		
		$str = '';
//		$str .= "<script type=\"javascript\">self.resizeTo(800,500);</script>";
		
		$str .= "<b>Status:</b> ".$status_tab['message']."<br><br>\n";
		
		$str .= "<center><div style=\"overflow: auto; width: 350px; height: 200px;\">\n";
		$str .= "<br><table cellspacing=\"0\" cellpadding=\"3\" class=\"photo_status_file\">";
		$str .= "<tr><td>".$lang->wp_load_offer['id_product']."</td><td>".$lang->wp_load_offer['message']."</td></tr>";
		
		foreach ($error_tab as $key => $value)
		{
			$str.= "<tr><td>".$value['user_id']."</td><td>".$value['message']."</td></tr>\n";
		}
		
		$str .= "</table>";
		$str .= "</div></center>";
		return $str;
	}
	
	function _insert_info_session( $xml )
	{
		global $lang;
		
		$tab = explode("\n",$xml);
		
		$i = 0;
		foreach ($tab as $key => $value)
		{
			if (eregi("<Result>",$value))
			{
				$result = trim($tab[$key]);
				$result = preg_replace("@<result>(.*)</result>@i",'\1',$result);
				
				switch ($result) {
					case -1:
						$message = $lang->wp_load_offer['msg_-1'];
						break;
					case 0:
						$message = $lang->wp_load_offer['msg_0'];
						break;
					case 1:
						$message = $lang->wp_load_offer['msg_1'];
						break;
					case 2:
						$message = $lang->wp_load_offer['msg_2'];
						break;
					case 3:
						$message = $lang->wp_load_offer['msg_3'];
						break;
					default:
						break;
				}
				$status_tab['code'] = $result;
				$status_tab['message'] = $message;
			}
			
			if (eregi("<row>",$value))
			{
				$user_id = trim($tab[$key+1]);
				$user_id = preg_replace("@<srcid>(.*)</srcid>@i",'\1',$user_id);
								
				if (preg_replace("@<res>(.*)</res>@i",'\1',$tab[$key+3]) == 0)
				{
					$message = $lang->wp_load_offer['product_add2wp'];
				} else {
					$message = trim($tab[$key+5]);
					$message = preg_replace("@<msg>(.*)</msg>@i",'\1',$message);
					$message = $this->_wp_utf8_to_8859_2($message);
				}
				
				$error_tab[$i]["user_id"] = $user_id;
				$error_tab[$i]["message"] = $message;
				$i++;
			}
		}
		session_register("wp_export_status");
		$_SESSION['wp_export_status'] = $status_tab;
		
		if (!isset($_SESSION['wp_export_messages'])) 
		{
			session_register("wp_export_messages");
			$_SESSION['wp_export_messages'] = $error_tab;
		} else {
			foreach ($error_tab as $key => $value)
			{
				array_push($_SESSION['wp_export_messages'],array("user_id" => $value['user_id'],"message" => $value['message']));
			}
		}
	}
	
} // end class WpLoadOffer
