<style type="text/css"> 
.tooltip 
{
/* WYGLD */
color: #000000;
font-family: Tahoma;
font-size: 11px;
font-weight: normal;
padding: 5px;
background-color: #FFFFFF;
border: 1px solid #cccccc; 
letter-spacing: 1px;

/* ROZMIESZCZENIE */
position: absolute;
text-align: left;
margin-top: 12px; /* odlego w pionie od kursora myszy */
margin-left: 12px;
/* max-width: 200px; */
} 
</style>

<?php
/**
 * Testowanie opcji PHP
 *
 * @author  m@sote.pl
 * @version $Id: test_php.inc.php,v 1.3 2007-06-26 18:21:49 marcin Exp $
 * @soteesklep
* @package    setup
 */
desktop::run_tooltip();

class TestPHP {
	var $version="436"; // wymagana wersja m.in. PHP-4.1.2
	var $version_print=">=4.3.6";
	var $installed="Yes:)";
	var $not_onstalled="No:(";
	var $next="Next";
	var $num=1;
	var $testall=true;
	var $gd_inf=false;

	/**
     * Rozpocznij testy opcji PHP
     *
     * \@global bool $this->testall true wszystko OK
     *
     * return none 
     */
	function test_start() {
		global $_ERROR;
		$_ERROR=false;
		print "<table align=\"center\" border=\"0\">\n";
		$this->test("PHP: ($this->version_print): ",$this->version());
		$this->test("PHP: MySQL",$this->mysql());
		$this->test("PHP: ftp",$this->ftp());
		$this->test("PHP: trans_sid",$this->trans_sid());
		$this->test("PHP: zlib",$this->zlib());
		$this->test("PHP: openssl",$this->openssl());
		$this->test("PHP: open_basedir (off)",$this->open_basedir());
		$this->test("PHP: memory(>8M)",$this->free_mem());
		$this->test("PHP: session_dir",$this->check_sessiondir());
	
		$this->test("PHP: GD",$this->check_gd());

		if ($this->gd_inf)
		{
			$this->check_gd_funk();
		}

		$this->test("PHP: SOAP",$this->soap());
		$this->test("APACHE: rewrite",$this->check_rewrite());
		print "</table>\n";
		@include ("./ignore");
		if (@$ignore_all) $_ERROR=false;
		return;
	} // end test_start()

	/**
    * Wywietl informacje o tym, czy dana opcja jest zainstalowana
    *
    * @param string $text nazwa/opis opjcji
    * @param bool   true  opcja jest zainstalowana/skonfigurowana
    * 
    * @return none
    */
	function test($text,$bool) {
		global $lang;

		print "<tr><td>$this->num. $text</td><td style=\"width:40px\">";
		if (is_string($bool))
		echo $bool;
		else
		if ($bool) print "<b style=\"color: green\">".$this->installed."</b>";
		else print "<b style=\"color: red\">".$this->not_installed."</b>";
		print "</td></tr>";
		$this->num++;
		if (!$bool) {
			global $_ERROR;
			$_ERROR=true;
		}
		if (! $bool) $this->testall=false;

		return;
	} // end test()

	/**
     * Sprawd obecno zlib
     *
     * @return bool true - OK, false - brak
     */
	function zlib() {
		if (function_exists('gzopen')) {
			return true;
		}
		return false;
	} // end zlib

	/**
     * Sprawd czy na serwerze jest wlaczone open_basedir
     *
     * @return bool true - OK, false - brak
     */
	function open_basedir() {
		$open_basedir=ini_get("open_basedir");
		if (empty($open_basedir)) {
			return true;
		}
		return false;
	} // end open_basedir

	/**
     * Sprawd ilosc pamieci dostepnej na serwerze
     *
     * @return bool true - OK, false - brak
     */
	function free_mem() {
		$memory=ini_get("memory_limit");
		if (empty($memory)) {
			return true;
		}
		$memory=substr($memory,0,-1);
		if ($memory<=8) return false;
		return true;
	} // end free_mem


	function check_gd() {
		global $lang;
		$msg='';
		if (function_exists('gd_info'))
		{
			$this->gd_inf=gd_info();
			$msg = '<p style="font-weight: bold; text-align: center">Obsuga moduu GD</p>';
			$msg .= '<table cellpadding="5" cellspacing="0" border="0" style="margin: 10px">';
			
			$warning=false;
			foreach($this->gd_inf as $k=>$v)
			{
				
				$sup='';
				$display=false;
				if (isset($lang->test_php[$k]))
				{
					$sup='<b>('.$lang->test_php[$k].')</b>';
					$display=true;
					if (!$v)
					$warning=true;
				}
	

				if ($display)
				{
					$msg .= '<tr><td style="text-align: right">';
					$msg .= "<b>$k:</b>";
					$msg .= '</td><td>';
					if (is_bool($v))
					$msg .= $v ? '<b style="color: green">OK</b>' : '<b style="color: orange">BRAK</b> '.$sup;
					else
					$msg .= "<b style=\"color: green\">$v</b>";
					$msg .= '</td></tr>';

				}
			}
			$msg .= '</table>';



			if ($warning) return '<b style="color: orange">OK <a style="color: red" href="#" title="'.htmlspecialchars($msg).'">(!)</a></b>';

			return true;
			
		}



		return false;
	}


	function check_gd_funk() {
		

	}

	/**
     * Sprawd obecno openssl
     *
     * @return bool true - OK, false - brak
     */
	function openssl() {
		if (function_exists('openssl_open')) {
			return true;
		}
		return false;
	} // end openssl

	/**
    * Weryfikuj wersje PHP
    *
    * @return bool true - wersja OK, false w p.w.
    */
	function version() {
		$php_version=phpversion();
		$php_version=preg_split('@\.@',$php_version);
		if ($php_version[0]>=$this->version[0]) {
			return true;
		}
		if ($php_version[1]>=$this->version[1]) {
			return true;
		}
		if ($php_version[2]>=$this->version[2]) {
			return true;
		}
		return false;
	} // end version

	/**
    * Sprawd, czy PHP zawiera obsuge MySQL
    *
    * @return bool true PHP zawiera obsuge MySQL, false w p.w.
    */
	function mysql() {
		if (function_exists('mysql_connect')) return true;
		else return false;
	} // end mysql()

	/**
    * Sprawd, czy PHP zawiera obsuge FTP (--enable-ftp)
    *    
    * @return bool true PHP zawiera obsuge FTP, false w p.
    */
	function ftp() {
		if (function_exists('ftp_login')) return true;
		else return false;
	} // end ftp()

	/**
    * Sprawd, czy PHP ma wczon opcj transparentnych sesji
    *
    * @return bool true PHP zawiera obsuge transparentnych sesji, false w p.
    */
	function trans_sid() {
		$trans_sid=ini_get("session.use_trans_sid");
		if ($trans_sid==1) return true;
		else return false;
	} // end ftp()
	
	/**
    * Sprawd, czy PHP zawiera obsuge SAOP (--enable-soap)
    *    
    * @return bool true PHP zawiera obsuge SOAP, false w p.
    */
	function soap() {
		if (class_exists('SoapClient')) return true;
		else return false;
	} // end ftp()
	
	function check_rewrite() {
		global $lang;
		if (!function_exists('apache_get_modules')) {
			$server=$this->getRdns();

			if ($server=='nazwa' || $server=='ogicom' || $server=='home') return $server;
			return false;
		}
		$check_apache=@apache_get_modules();
		$key=array_search('mod_rewrite',$check_apache);
		
		if (!empty($key)){
			return true;
		}else{
			return '<b style="color: orange">'.$this->not_installed.'<a style="color: red" href="#" title="'.htmlspecialchars($lang->test_php['mod_rewrite']).'">(!)</a></b>';
		}
		
	}// end check_rewrite

	private function getRdns() {
		$name=gethostbyaddr($_ENV['SERVER_ADDR']);
		if (ereg('ogicom',$name)) return 'ogicom';
		if (ereg('bazafirm',$name)) return 'ogicom';
		if (ereg('incenti',$name)) return 'ogicom';
		if (ereg('netart',$name)) return 'nazwa';
		if (ereg('home',$name)) return 'home';
		return 'unknown';
	}
	

	function check_sessiondir() {
	    global $DOCUMENT_ROOT;
	    global $config;
	    global $desktop;
	    global $_ERROR;
	    global $lang;
	    $sess_ok=false;
	    $sess_dir_perms=substr(sprintf('%o', fileperms($DOCUMENT_ROOT.'/../sessions/'.$config->salt.'/')), -3);
	    if($sess_dir_perms!=777) {
	        // w pewnych przypadkach - to moze zadzialac (jak rozpakowano sklep przez www)
	        $sess_ok=@chmod($DOCUMENT_ROOT.'/../sessions/'.$config->salt.'/',0777);
	        if (!$sess_ok) {
	            $_ERROR=true;
    	        return $lang->test_php['session_dir'];
	        }
	    } else $sess_ok=true;
	    return $sess_ok;
	}
	
} // end class TestPHP

$test_php =& new TestPHP;

$test_php->installed=$lang->installed;
$test_php->not_installed=$lang->not_installed;
$test_php->next=$lang->next;

?>