<?php
/**
 * Zarzdzanie ikonami z prawej strony obszaru Desktop.
 * 
 * @author m@sote.pl
 * @version $id$
 * @package themes
 */
class Icons {

    /**
     * Maksymalna iloc ikon na licie
     *
     * @var int
     */
    var $_max_icons=10;

    /**
     * Id zalogowanego uytkownika
     *
     * @var int
     */
    var $id_admin_users=0;

    var $_data=array(
    "/"=>"home.gif",    
    "/go/_wysiwyg/"=>"zmiana_tekstu.gif",
    "/plugins/_newsedit/"=>"nowosci.gif",
    "/go/_offline/_main/"=>"import_export.gif",
    "/go/_opt/"=>"optymalizacja.gif",
    "/go/_users/"=>"klienci.gif",
    "/go/_order/"=>"zamowienia.gif",
    "/go/_options/_delivery/"=>"dostawa.gif",
    "/plugins/_dictionary/"=>"jezyki.gif",
    "/go/_options/_available/"=>"dostepnosc_magazyn.gif",
    "/plugins/_currency/"=>"kursy_walut.gif",
    "/plugins/_newsletter/_users/"=>"newsletter.gif",
    "/plugins/_discounts/"=>"rabaty.gif",
    "/plugins/_reviews/"=>"recenzje.gif",
    "/plugins/_partners/"=>"partnerzy.gif",
    "/go/_report/"=>"raporty_statystyki.gif",
    "/plugins/_main_keys/"=>"edycja_kodow.gif",
    "/go/_google/"=>"indeksowanie_google.gif",
    "/plugins/_themes/"=>"edycja_wygladu.gif",
    "/go/_main_configure/"=>"konfiguracja.gif",
    "/plugins/_promotions/"=>"promocje.gif",
    "/go/_help/"=>"dokumentacja.gif",
    "/plugins/_pasaz.wp.pl/"=>"pasaze.gif",
    "/plugins/_PorownywarkiCen/_Ceneo/"=>"porownywarki.gif",
    "/plugins/_allegro.pl/"=>"allegro.gif",
    "/go/_upgrade/"=>"update.gif",
    "/go/_map_site/"=>"mapa_serwisu1.gif",
    );

    /**
     * Odczytaj jaka opcja zostaa wywietlona, odszukaj jej w licie ikon.
     */
    function __construct() {
        global $_SERVER,$_SESSION;
        if (! empty($_SESSION['__id_admin_users'])) {
            $this->id_admin_users=$_SESSION['__id_admin_users'];
        }
        $uri=dirname($_SERVER['REQUEST_URI'])."/";
                
        if (! empty($this->_data[$uri])) {
            $this->addIcon($uri,$this->_data[$uri]);
        }
    }

    /**
     * Dodaj ikone do listy i zapamietaj ja.
     * 
     * @param string $uri
     * @param string $icon (image)
     */
    function addIcon($uri,$icon) {
        global $db;

        // 1. sporawdzamy czy jest juz taka ikona na liscie
        $query="SELECT url,icon FROM icons WHERE (url=? OR icon=?) AND id_admin_users=? LIMIT 1 ";
        $prepared_query=$db->prepareQuery($query);
        if ($prepared_query) {
            $db->querySetText($prepared_query,1,$uri);
            $db->querySetText($prepared_query,2,$icon);
            $db->querySetText($prepared_query,3,$this->id_admin_users);
            $result=$db->executeQuery($prepared_query);
            if ($result!=0) {
                $num_rows=$db->numberOfRows($result);
                if ($num_rows>0) {
                    // 1.1 jest taka ikona, nic nie robimy
                    return;
                } else {
                    // 1.2 nie ma takiej ikony dodajmy ja do bazy
                    $this->_add($uri,$icon);
                    $this->_clean();
                }
            } else die ("1".$db->error());
        } else die ("2".$db->error());
    }

    /**
     * Wpisz do bazy ikone o danym URI
     *
     * @param string $uri
     * @param string $icon
     * @return true
     */
    function _add($uri,$icon) {
        global $db;
        $query="INSERT INTO icons (url,icon,id_admin_users) VALUES (?,?,?)";
        $prepared_query=$db->prepareQuery($query);
        if ($prepared_query) {
            $db->querySetText($prepared_query,1,$uri);
            $db->querySetText($prepared_query,2,$icon);         
            $db->querySetInteger($prepared_query,3,$this->id_admin_users);
            $result=$db->executeQuery($prepared_query);
            if ($result!=0) {
                return true;
            } else die ("3".$db->error());
        } else die ("4".$db->error());
    }

    /**
     * Usun stare wpisy z icons, zostaw tylko ostatnie $this->_max_iconcs
     */
    function _clean() {
        global $db;

        // ile jest ikon
        $query="SELECT id FROM icons WHERE id_admin_users=? ORDER BY id";
        $prepared_query=$db->prepareQuery($query);
        $db->querySetInteger($prepared_query,1,$this->id_admin_users);
        if ($prepared_query) {
            $result=$db->executeQuery($prepared_query);
            if ($result!=0) {
                $num_rows=$db->numberOfRows($result);
                if ($num_rows>$this->_max_icons) {
                    $del=$num_rows-$this->_max_icons-1;
                    for ($i=0;$i<=$del;$i++) {
                        $this->_del($db->fetchResult($result,$i,"id"));
                    }
                }
            } else die ("5".$db->error());
        } else die ("6".$db->error());
    }

    /**
     * Usu ikonke o wskazanym ID
     * 
     * @param int $id
     * @return true
     */
    function _del($id) {
        global $db;
        $query="DELETE FROM icons WHERE id=? AND id_admin_users=?";
        $prepared_query=$db->prepareQuery($query);
        if ($prepared_query) {
            $db->querySetInteger($prepared_query,1,$id);
            $db->querySetInteger($prepared_query,2,$this->id_admin_users);
            $result=$db->executeQuery($prepared_query);
            if ($result!=0) {
                return true;
            } else die ("7".$db->error());
        }
    }

    /**
     * Zwr kod HTML wywietlajcy ikony.
     * 
     * @return string
     */
    function html() {
        $o='';
        $o.=$this->_head();
        $o.=$this->_icons();
        $o.=$this->_foot();
        return $o;
    }

    /**
     * Nagwkowy kod HTML
     * 
     * @return string    
     */
    function _head() {
        return "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\"><tr><td>";
    }

    /**
     * Wywietl ikony
     *
     * @return string
     */
    function _icons() {
        global $theme, $db, $desktop,$lang,$config;

        $o='';
        
        // ikonka home na stale
        $o.="<a href=\"/\" title=\"";
        $o.=$desktop->hintr(1,$lang->hint_icons_right['home'],"right");
        $o.="\">";
        $o.="<img src=\"".$theme->img("_icons/_small/home.gif",IMG_STDOUT_FALSE)."\" alt=\"\"/ border=\"0\"></a><br>";
        
        // ikonka home na stale
        $o.="<a href=\"http://$config->www\" target=\"shop\" title=\"";
        $o.=$desktop->hintr(1,$lang->hint_icons_right['www'],"right");
        $o.="\">";
        $o.="<img src=\"".$theme->img("_icons/_small/www.gif",IMG_STDOUT_FALSE)."\" alt=\"\"/ border=\"0\"></a><br>";
  
        
        $query="SELECT id,icon,url FROM icons WHERE id_admin_users=? ORDER BY ctime DESC";
        $prepared_query=$db->prepareQuery($query);
        if ($prepared_query) {
            $db->querySetInteger($prepared_query,1,$this->id_admin_users);
            $result=$db->executeQuery($prepared_query);
            if ($result!=0) {
                $num_rows=$db->numberOfRows($result);
                for ($i=0;$i<$num_rows;$i++) {
                    $url=$db->fetchResult($result,$i,"url");
                    $icon=$db->fetchResult($result,$i,"icon");
                    $o.="<a href=\"$url\" title=\"";
                    $o.=$desktop->hintr(1,$lang->hint_icons_right[$url],"right");
                    $o.="\">";
                    $o.="<img src=\"".$theme->img("_icons/_small/$icon",IMG_STDOUT_FALSE)."\" alt=\"\"/ border=\"0\"></a><br>";
                }
            } else die ("8".$db->error());
        } else die ("9".$db->error());

        return $o;
    }

    /**
     * Zamkniecie tabeli HTML
     * @see _head()
     */
    function _foot() {
        return "</td></tr></table>";
    }
}
?>